# BandedMatrices.jl
A Julia package for representing banded matrices

[![Build Status](https://github.com/JuliaLinearAlgebra/BandedMatrices.jl/workflows/CI/badge.svg)](https://github.com/JuliaLinearAlgebra/BandedMatrices.jl/actions)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaLinearAlgebra.github.io/BandedMatrices.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaLinearAlgebra.github.io/BandedMatrices.jl/dev)
[![codecov](https://codecov.io/gh/JuliaLinearAlgebra/BandedMatrices.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaLinearAlgebra/BandedMatrices.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)
[![deps](https://juliahub.com/docs/General/BandedMatrices/stable/deps.svg)](https://juliahub.com/ui/Packages/General/BandedMatrices?t=2)
[![version](https://juliahub.com/docs/General/BandedMatrices/stable/version.svg)](https://juliahub.com/ui/Packages/General/BandedMatrices)
[![pkgeval](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/B/BandedMatrices.svg
)](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html)


This package supports representing banded matrices by only the entries on the
bands.

One can create banded matrices of type `BandedMatrix` as follows:

```julia
BandedMatrix(-1=> 1:5, 2=>1:3)     # creates a 6 x 6 banded matrix version of diagm(-1=> 1:5, 2=>1:3)
BandedMatrix((-1=> 1:5, 2=>1:3), (n,m))     # creates an n x m banded matrix with 1 sub-diagonals and u super-diagonals with the specified diagonals
BandedMatrix((-1=> 1:5, 2=>1:3), (n,m), (l,u))     # creates an n x m banded matrix with l sub-diagonals and u super-diagonals with the specified diagonals
BandedMatrix(FillArrays.Zeros(m,n), (l,u))    # creates a banded matrix of zeros, with l sub-diagonals and u super-diagonals
BandedMatrix(FillArrays.Ones(m,n), (l,u))     # creates a banded matrix of ones, with l sub-diagonals and u super-diagonals
BandedMatrix(FillArrays.Eye(n), (l,u))        # creates a banded  n x n identity matrix, with l sub-diagonals and u super-diagonals
brand(m,n,l,u)     # creates a random banded matrix, with l sub-diagonals and u super-diagonals
```
For more examples, see [the documentation](https://julialinearalgebra.github.io/BandedMatrices.jl/dev/#Creating-banded-matrices).

Specialized algebra routines are overriden, include `*` and `\`:

```julia
A = brand(10000,10000,4,3)  # creates a 10000 x 10000 matrix with 4 sub-diagonals
                            # and 3 super-diagonals
b = randn(10000)
A*b  #   Calls optimized matrix*vector routine
A*A  #   Calls optimized matrix*matrix routine
A\b  #   Calls optimized matrix\vector routine
```

module TestBandedQR

using BandedMatrices, ArrayLayouts, LinearAlgebra, Test, Random
import BandedMatrices: banded_qr!
Random.seed!(0)

@testset "QR tests" begin
    for T in (Float64,ComplexF64,Float32,ComplexF32)
        A=brand(T,10,10,3,2)
        Q,R = qr(A)
        @test Matrix(Q)*Matrix(R) ≈ A
        b=rand(T,10)
        @test mul!(similar(b),Q,mul!(similar(b),Q',b)) ≈ b
        for j=1:size(A,2)
            @test Q' * A[:,j] ≈ R[:,j]
        end
        A=brand(T,14,10,3,2)

        Q,R=qr(A)
        @test Matrix(Q)*Matrix(R) ≈ A

        for k=1:size(A,1),j=1:size(A,2)
            @test Q[k,j] ≈ Matrix(Q)[k,j]
        end

        A=brand(T,10,14,3,2)
        Q,R=qr(A)
        @test Matrix(Q)*Matrix(R) ≈ A

        for k=1:size(Q,1),j=1:size(Q,2)
            @test Q[k,j] ≈ Matrix(Q)[k,j]
        end

        A=brand(T,100,100,3,4)
        @test qr(A).factors ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).factors
        @test qr(A).τ ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).τ
        b=rand(T,100)
        @test qr(A)\b ≈ Matrix(A)\b
        b=rand(T,100,2)
        @test qr(A)\b ≈ Matrix(A)\b
        @test_throws DimensionMismatch qr(A) \ randn(3)
        @test_throws DimensionMismatch qr(A).Q'randn(3)

        A=brand(T,102,100,3,4)
        @test qr(A).factors ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).factors
        @test qr(A).τ ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).τ
        b=rand(T,102)
        @test qr(A)\b ≈ Matrix(A)\b
        b=rand(T,102,2)
        @test qr(A)\b ≈ Matrix(A)\b
        @test_throws DimensionMismatch qr(A) \ randn(3)
        @test_throws DimensionMismatch qr(A).Q'randn(3)

        A=brand(T,100,102,3,4)
        @test qr(A).factors ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).factors
        @test qr(A).τ ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).τ
        b=rand(T,100)
        @test_broken qr(A)\b ≈ Matrix(A)\b

        A = Tridiagonal(randn(T,99), randn(T,100), randn(T,99))
        @test qr(A).factors ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).factors
        @test qr(A).τ ≈ LinearAlgebra.qrfactUnblocked!(Matrix(A)).τ
        b=rand(T,100)
        @test qr(A)\b ≈ Matrix(A)\b
        b=rand(T,100,2)
        @test qr(A)\b ≈ Matrix(A)\b
        @test_throws DimensionMismatch qr(A) \ randn(3)
        @test_throws DimensionMismatch qr(A).Q'randn(3)
    end

    @testset "Mixed types" begin
        A=brand(10,10,3,2)
        b=rand(ComplexF64,10)
        Q,R=qr(A)
        @test R\(Q'*b) ≈ qr(A)\b ≈ Matrix(A)\b


        A=brand(ComplexF64,10,10,3,2)
        b=rand(10)
        Q,R=qr(A)
        @test R\(Q'*b) ≈ qr(A)\b ≈ Matrix(A)\b

        A = BandedMatrix{Int}(undef, (2,1), (4,4))
        A.data .= 1:length(A.data)
        Q, R = qr(A)
        @test Q*R ≈ A
    end

    @testset "banded Views" begin
        # this test adaptive QR essentially as implemented in InfiniteLinearAlgebra.jl
        A = brand(100,100,1,1)
        V = view(copy(A),1:5,1:6)
        @test qr(V) isa QR{Float64,<:BandedMatrix{Float64}}
        @test qr(V).R ≈ qr(Matrix(V)).R
        @test qr(V).τ ≈ LinearAlgebra.qrfactUnblocked!(Matrix(V)).τ
        @test Matrix(qr(V).Q) ≈ Matrix(qr(Matrix(V)).Q)
        @test Matrix(qr(V)) ≈ V
        B = BandedMatrix(A,(1,2)) # pad
        V = view(copy(B),1:5,1:6)
        @test qr!(V) isa QR{Float64,<:SubArray{Float64,2,<:BandedMatrix{Float64}}}
        τ = Array{Float64}(undef,100)
        B = BandedMatrix(A,(1,2)) # pad
        V = view(B,1:6,1:5)
        F1 = qr(V)
        F2 = banded_qr!(V, view(τ,1:size(V,2)))
        @test F1.factors ≈ F2.factors ≈ B[1:6,1:5]
        @test F1.τ ≈ F2.τ
        F = qr(A)
        @test τ[1:size(V,2)]  ≈ F.τ[1:5]

        lmul!(F1.Q', view(B,1:6,6:7))
        @test B[1:5,6:7] ≈ F.factors[1:5,6:7]
        banded_qr!(view(B,6:100,6:100), view(τ,6:100))
        τ[end] = 0
        @test B ≈ F.factors
        @test τ ≈ F.τ
    end

    @testset "banded_lmul! times degenerate" begin
        B = brand(10,10,1,1)
        Q,R = qr(B)
        @test lmul!(Q', BandedMatrix(B,(size(B,1),2))) ≈ Q'*B
        @test lmul!(Q', view(BandedMatrix(B,(size(B,1),2)),:,4:10)) ≈ Q'*B[:,4:10]
    end

    @testset "lmul!" begin
        for T in (Float64,ComplexF64,Float32,ComplexF32)
            A = brand(T,10,10,3,2)
            Q,R = qr(A)
            B = randn(T, 10, 2)
            @test  ArrayLayouts.lmul!(Q', copy(B)) == lmul!(Q', copy(B)) ≈ Q'B
            @test ArrayLayouts.lmul!(Q, copy(B)) == lmul!(Q, copy(B)) ≈ Q*B
        end
    end

    @testset "rmul!" begin
        for T in (Float64,ComplexF64,Float32,ComplexF32)
            A = brand(T,10,10,3,2)
            Q,R = qr(A)
            B = randn(T, 2, 10)
            @test  ArrayLayouts.rmul!(copy(B), Q') == rmul!(copy(B), Q') ≈ B*Q'
            @test ArrayLayouts.rmul!(copy(B), Q) == rmul!(copy(B), Q) ≈ B*Q
        end
    end

    @testset "lowerbanded B" begin
        n = 10
        c = sqrt.(2*(5:2:2n+4) ./ ((3:n+2) .* (4:n+3) ))
        s = sqrt.(((1:n) .* (2:n+1)) ./ ((3:n+2) .* (4:n+3) ))
        Q = BandedMatrices.QRPackedQ(BandedMatrix(-2 => -(s ./ (c .+ 1))), c .+ 1)
        @test Q'Q  ≈ Matrix(Q)'Matrix(Q) ≈ I
    end

    @testset "bandedsubbanded qr " begin
        A = brand(100,100,1,1)
        B = BandedMatrix(A,(1,2)) # pad
        b = randn(5)
        c = randn(5,3)
        @test lmul!(qr!(view(copy(B),1:5,1:6)).Q, copy(b)) ≈ qr(A[1:5,1:6]).Q * b
        @test lmul!(qr!(view(copy(B),1:5,1:6)).Q, copy(c)) ≈ qr(A[1:5,1:6]).Q * c
        @test lmul!(qr!(view(copy(B),1:5,1:6)).Q', copy(b)) ≈ qr(A[1:5,1:6]).Q' * b
        @test lmul!(qr!(view(copy(B),1:5,1:6)).Q', copy(c)) ≈ qr(A[1:5,1:6]).Q' * c
    end
end

end # module

module AquaTest

import BandedMatrices
import Aqua
using Test
using ArrayLayouts: AbstractBandedLayout, checkdimensions, DiagonalLayout,
                    BidiagonalLayout, TriangularLayout, AbstractTridiagonalLayout

@testset "Project quality" begin
    Aqua.test_all(BandedMatrices, ambiguities=false,
        piracies=(; treat_as_own=Union{Function, Type}[AbstractBandedLayout, checkdimensions, DiagonalLayout,
                    BidiagonalLayout, TriangularLayout, AbstractTridiagonalLayout], broken=true)
    )
end

end

module TestSymBanded

using ArrayLayouts
using BandedMatrices
import BandedMatrices: MemoryLayout, SymmetricLayout, HermitianLayout, BandedColumns, isbanded
using CliqueTrees: CliqueTrees
using FillArrays
using GenericLinearAlgebra
using LinearAlgebra
using Random
using Test

@testset "Symmetric" begin
    @testset "UnitRange" begin
        A = brand(100,100,3,2)
        S = Symmetric(A)
        @test S[3:10,4:11] == Symmetric(Matrix(A))[3:10,4:11]
    end

    @testset "Sym of degenerate bands" begin
        A = SymTridiagonal(zeros(8), fill(0.5,7))
        B = Symmetric(BandedMatrix(1 => fill(0.5,7)))
        @test A ≈ B
        @test BandedMatrices.inbands_getindex(B, 1, 1) == 0
        @test BandedMatrices.inbands_getindex(B, 1, 2) == BandedMatrices.inbands_getindex(B, 2, 1) == 0.5
    end

    A = Symmetric(brand(10,10,1,2))
    @test isbanded(A)
    @test BandedMatrix(A) == A
    @test bandwidth(A) == bandwidth(A,1) == bandwidth(A,2) ==  2
    @test bandwidths(A) == bandwidths(BandedMatrix(A)) == (2,2)
    @test MemoryLayout(typeof(A)) == SymmetricLayout{BandedColumns{DenseColumnMajor}}()

    @test A[1,2] == A[2,1]
    @test A[1,4] == 0
    x=rand(10)
    @test A*x ≈ Matrix(A)*x
    y = similar(x)
    @test all(A*x .=== muladd!(1.0,A,x,0.0,similar(x)) .===
                BLAS.sbmv!('U', 2, 1.0, parent(A).data, x, 0.0, similar(x)))

    @test A[2:10,1:9] isa BandedMatrix
    @test isempty(A[1:0,1:9])
    @test isempty(A[1:9,1:0])
    @test isempty(A[1:0,1:0])

    @test [A[k,j] for k=2:10, j=1:9] == A[2:10,1:9]
    A = Symmetric(brand(10,10,1,2),:L)
    @test isbanded(A)
    @test BandedMatrix(A) == A
    @test bandwidth(A) == bandwidth(A,1) == bandwidth(A,2) ==  1
    @test bandwidths(A) == bandwidths(BandedMatrix(A)) == (1,1)
    @test MemoryLayout(typeof(A)) == SymmetricLayout{BandedColumns{DenseColumnMajor}}()

    @test A[1,2] == A[2,1]
    @test A[1,3] == 0
    @test A[2:10,1:9] isa BandedMatrix
    @test [A[k,j] for k=2:10, j=1:9] == A[2:10,1:9]

    x=rand(10)
    @test A*x ≈ Matrix(A)*x
    y = similar(x)
    @test all(A*x .=== muladd!(1.0,A,x,0.0,y) .===
                BLAS.sbmv!('L', 1, 1.0, view(parent(A).data,3:4,:), x, 0.0, similar(x)))

    @test norm(A) ≈ norm(Matrix(A))
    @test cond(A) ≈ cond(Matrix(A))

    # (generalized) eigen & eigvals
    Random.seed!(0)

    @testset for T in (Float32, Float64)
        A = brand(T, 10, 10, 2, 4)
        std = eigvals(Symmetric(Matrix(A)))
        @test eigvals(Symmetric(A)) ≈ std
        @test eigvals(Symmetric(A), 2:4) ≈ std[2:4]
        @test eigvals(Symmetric(A), 1, 2) ≈ std[1 .<= std .<= 2]
        @test eigvals!(copy(Symmetric(A))) ≈ std
        @test eigvals!(copy(Symmetric(A)), 2:4) ≈ std[2:4]
        @test eigvals!(copy(Symmetric(A)), 1, 2) ≈ std[1 .<= std .<= 2]

        @test eigvals(Symmetric(A, :L)) ≈ eigvals(Symmetric(Matrix(A), :L))
    end

    A = brand(ComplexF64, 20, 20, 4, 0)
    @test Symmetric(A)[2:10,1:9] isa BandedMatrix
    @test Hermitian(A)[2:10,1:9] isa BandedMatrix
    @test isempty(Hermitian(A)[1:0,1:9])
    @test isempty(Hermitian(A)[1:0,1:0])
    @test isempty(Hermitian(A)[1:9,1:0])
    @test [Symmetric(A)[k,j] for k=2:10, j=1:9] == Symmetric(A)[2:10,1:9]
    @test [Hermitian(A)[k,j] for k=2:10, j=1:9] == Hermitian(A)[2:10,1:9]

    A = Symmetric(brand(Float64, 10, 10, 2, 4))
    F = eigen(A)
    Λ, Q = F
    @test Q'Matrix(A)*Q ≈ Diagonal(Λ)
    FD = convert(Eigen{Float64, Float64, Matrix{Float64}, Vector{Float64}}, F)
    @test FD.vectors'Matrix(A)*FD.vectors ≈ Diagonal(F.values)

    MQ = Matrix(Q)
    @test Q[axes(Q,1),1:3] ≈ MQ[axes(Q,1),1:3]
    @test Q[:,1:3] ≈ MQ[:,1:3]
    @test Q[:,3] ≈ MQ[:,3]
    @test Q[1,2] ≈ MQ[1,2]

    F = eigen(A, 2:4)
    Λ, Q = F
    QM = Matrix(Q)
    AM = Matrix(A)
    @test Q' * AM * Q ≈ Diagonal(Λ)
    # explicit mul tests
    @test AM * Q ≈ AM * QM
    @test transpose(Q) * AM ≈ transpose(QM) * AM
    @test adjoint(Q) * AM ≈ adjoint(QM) * AM

    F = eigen(A, 1, 2)
    Λ, Q = F
    @test Q' * AM * Q ≈ Diagonal(Λ)

    # contrived test with an empty Givens rotation vector
    B = BandedMatrices.BandedEigenvectors(LinearAlgebra.Givens{Float64}[], rand(4,4), zeros(4))
    x = rand(4)
    @test B' * x ≈ Matrix(B)' * x

    function An(T::Type, N::Int)
        A = Symmetric(BandedMatrix(Zeros{T}(N,N), (0, 2)))
        for n = 0:N-1
            parent(A).data[3,n+1] = T((n+1)*(n+2))
        end
        A
    end

    function Bn(T::Type, N::Int)
        B = Symmetric(BandedMatrix(Zeros{T}(N,N), (0, 2)))
        for n = 0:N-1
            parent(B).data[3,n+1] = T(2*(n+1)*(n+2))/T((2n+1)*(2n+5))
        end
        for n = 0:N-3
            parent(B).data[1,n+3] = -sqrt(T((n+1)*(n+2)*(n+3)*(n+4))/T((2n+3)*(2n+5)*(2n+5)*(2n+7)))
        end
        B
    end

    @testset for T in (Float32, Float64)
        A = An(T, 100)
        B = Bn(T, 100)

        AM = Matrix(A)

        λ = eigvals(A, B)
        @test λ ≈ eigvals(Symmetric(AM), Symmetric(Matrix(B)))

        err = λ*(T(2)/π)^2 ./ (1:length(λ)).^2 .- 1

        @test norm(err[1:40]) < 100eps(T)

        Λ, V = eigen(A, B)
        @test V'AM*V ≈ Diagonal(Λ)
        @test V'Matrix(B)*V ≈ I

        VM = Matrix(V)

        @testset "indexing" begin
            @test V[axes(V,1),1:3] ≈ VM[axes(V,1),1:3]
            @test V[:,1:3] ≈ VM[:,1:3]
            @test V[:,3] ≈ VM[:,3]
            @test V[axes(V,1),3] ≈ VM[axes(V,1),3]
            @test V[1,2] ≈ VM[1,2]
        end

        @testset "mul/div" begin
            @test AM * V ≈ AM * VM
            @test V * AM ≈ VM * AM
            x = rand(T, size(V,2))
            @test ldiv!(similar(x), V, x) ≈ ldiv!(similar(x), factorize(VM), x)

            z = OneElement{T}(4, size(V,2))
            @test V * z ≈ V * Vector(z)
        end
    end

    @testset "eigen with mismatched parent bandwidths" begin
        # A is diagonal
        function eigencheck(SA, SB)
            λS, VS = eigen(SA, SB)
            λ, V = eigen(Matrix(SA), Matrix(SB))
            @test λS ≈ λ ≈ eigvals(SA, SB)
            @test mapreduce((x,y) -> isapprox(abs.(x), abs.(y)), &, eachcol(V), eachcol(VS))
        end
        @testset for (A, uploA) in Any[
                    (BandedMatrix(0=>ones(5), 3=>ones(2)), :L),
                    (BandedMatrix(0=>ones(5), -3=>ones(2)), :U),
                ]
            SA = Symmetric(A, uploA)
            @testset for (B, uploB) in Any[
                        (BandedMatrix(-1=>ones(4), 0=>2ones(5)), :L),
                        (BandedMatrix(0=>2ones(5), 1=>ones(4)), :U),
                    ]
                SB = Symmetric(B, uploB)
                eigencheck(SA, SB)
            end
        end
        # A is non-diagonal. In this case, uplo must match
        @testset for uplo in [:L, :U]
            A = BandedMatrix(-1=>fill(0.1,3), 0=>4ones(5), 1=>fill(0.1,3))
            SA = Symmetric(A, uplo)
            B = BandedMatrix(0=>2ones(5), (uplo == :U ? 1 : -1)=>ones(4))
            SB = Symmetric(B, uplo)
            eigencheck(SA, SB)
        end
    end
end

@testset "Hermitian" begin
    T = ComplexF64
    A = Hermitian(brand(T,10,10,1,2))
    @test isbanded(A)
    @test BandedMatrix(A) == A
    @test bandwidth(A) == bandwidth(A,1) == bandwidth(A,2) ==  2
    @test bandwidths(A) == bandwidths(BandedMatrix(A)) == (2,2)
    @test MemoryLayout(typeof(A)) == HermitianLayout{BandedColumns{DenseColumnMajor}}()

    @test A[1,2] == conj(A[2,1])
    @test A[1,4] == 0
    x=rand(T,10)
    @test A*x ≈ Matrix(A)*x
    @test all(A*x .=== materialize!(MulAdd(one(T),A,x,zero(T),copy(x))) .===
                BLAS.hbmv!('U', 2, T(1.0), parent(A).data, x, T(0.0), similar(x)))

    A = Hermitian(brand(T,10,10,1,2),:L)
    @test isbanded(A)
    @test BandedMatrix(A) == A
    @test bandwidth(A) == bandwidth(A,1) == bandwidth(A,2) ==  1
    @test bandwidths(A) == bandwidths(BandedMatrix(A)) == (1,1)
    @test MemoryLayout(typeof(A)) == HermitianLayout{BandedColumns{DenseColumnMajor}}()

    @test A[1,2] == conj(A[2,1])
    @test A[1,3] == 0
    x=rand(T, 10)
    @test A*x ≈ Matrix(A)*x

    @test all(A*x .=== muladd!(one(T),A,x,zero(T),copy(x)) .===
                materialize!(MulAdd(one(T),A,x,zero(T),copy(x))) .===
                BLAS.hbmv!('L', 1, one(T), view(parent(A).data,3:4,:), x, zero(T), similar(x)))

    @testset "eigen" begin
        @testset for T in (Float32, Float64, ComplexF64, ComplexF32), uplo in (:L, :U)
            A = brand(T, 20, 20, 4, 2)
            std = eigvals(Hermitian(Matrix(A), uplo))
            @test eigvals(Hermitian(A, uplo)) ≈ std
            @test eigvals(Hermitian(A, uplo), 2:4) ≈ std[2:4]
            @test eigvals(Hermitian(A, uplo), 1, 2) ≈ std[1 .<= std .<= 2]
            @test eigvals(Hermitian(big.(A), uplo)) ≈ std
            @test eigvals!(copy(Hermitian(A, uplo))) ≈ std
            @test eigvals!(copy(Hermitian(A, uplo)), 2:4) ≈ std[2:4]
            @test eigvals!(copy(Hermitian(A, uplo)), 1, 2) ≈ std[1 .<= std .<= 2]
        end

        @testset for T in (Float32, Float64, ComplexF32, ComplexF64), uplo in (:L, :U)
            A = Hermitian(brand(T, 20, 20, 2, 4), uplo)
            MA = Hermitian(Matrix(A), uplo)
            λ1, v1 = eigen!(copy(A))
            λ2, v2 = eigen!(copy(MA))
            @test λ1 ≈ λ2
            @test v1' * MA * v1 ≈ Diagonal(λ1)

            λ3, v3 = eigen!(copy(A), 2:4)
            @test λ3 ≈ λ1[2:4]
            @test v3' * (MA * v3) ≈ Diagonal(λ3)

            λ4, v4 = eigen(A, 2:4)
            @test λ4 ≈ λ3
            @test v4' * (MA * v4) ≈ Diagonal(λ4)

            λ3, v3 = eigen!(copy(A), 1, 2)
            @test λ3 ≈ λ1[1 .<= λ1 .<= 2]
            @test v3' * (MA * v3) ≈ Diagonal(λ3)

            λ4, v4 = eigen!(copy(A), 1, 2)
            @test λ4 ≈ λ1[1 .<= λ1 .<= 2]
            @test v4' * (MA * v4) ≈ Diagonal(λ4)
        end
    end
end

@testset "LDLᵀ" begin
    for T in (Float16, Float32, Float64, BigFloat, Rational{BigInt})
        A = BandedMatrix{T}(undef,(10,10),(0,2))
        A[band(0)] .= 4
        A[band(1)] .= -one(T)/4
        A[band(2)] .= -one(T)/16
        SAU = Symmetric(A, :U)
        F = factorize(SAU)
        @test F isa LDLt
        b = collect(one(T):size(F, 1))
        x = Matrix(SAU)\b
        y = F\b
        @test x ≈ y
        A = BandedMatrix{T}(undef,(10,10),(2,0))
        A[band(0)] .= 4
        A[band(-1)] .= -one(T)/3
        A[band(-2)] .= -one(T)/9
        SAL = Symmetric(A, :L)
        x = Matrix(SAL)\b
        F = ldlt(SAL)
        y = F\b
        @test x ≈ y
        @test_throws DimensionMismatch F\[b;b]

        T ≠ Float16 && (@test det(F) ≈ det(SAL))
    end
    for T in (Int16, Int32, Int64, BigInt)
        A = BandedMatrix{T}(undef, (4,4), (1,1))
        A[band(0)] .= 3
        A[band(1)] .= 1
        F = ldlt(Symmetric(A))
        @test eltype(F) == float(T)
    end

    @testset "#175" begin
        A = BandedMatrix(0 => [1,2])
        F = ldlt(Symmetric(A))
        @test F.d == [1.,2.]
        @test F.D == Diagonal([1.,2.])
    end
end

@testset "Generalized eigenvalues" begin
    @testset "$W{$T}($Ua,$Ub)($n,$wa-$wb)" for (T,W) in (
                                        (Float32, Symmetric),
                                        (Float64, Symmetric),
                                        (Float32, Hermitian),
                                        (Float64, Hermitian),
                                        (ComplexF32, Hermitian),
                                        (ComplexF64, Hermitian),
                                       ),
        (Ua, Ub) in  ((:L,:L), (:U,:U)),
        (wa, wb) in ((2, 3), (3, 2)), n in (4,)
        #
        function sbmatrix(W, T, U, w, n)
            r = U == :L ? (0:-1:-w+1) : (0:w-1)
            band(k) = k => ones(T, n - abs(k)) * 2.0^-abs(k)
            W(BandedMatrix(band.(r)...), U)
        end
        A = sbmatrix(W, T, Ua, wa, n)
        B = sbmatrix(W, T, Ub, wb, n)
        AM, BM = Matrix.((A,B))
        @test eigvals(A, B) ≈ eigvals(AM, BM)
        
        Λ, V = eigen(A, B)
        VM = Matrix(V)
        Λ2, V2 = eigen(AM, BM)
        @test Λ ≈ Λ2
        @test VM' * AM * VM ≈ V2' * AM * V2
        @test VM' * AM * VM ≈ VM' * BM * VM * Diagonal(Λ)
    end
end

@testset "Cholesky" begin
    for T in (Float64, BigFloat)
        A = Symmetric(BandedMatrix(0 => one(T) ./ [12, 6, 6, 6, 12],
                                1 => ones(T,4) ./ 24))
        Ac = cholesky(A)

        @test Ac isa Cholesky{T,<:BandedMatrix{T}}
        @test Ac.U ≈ cholesky(Matrix(A)).U

        b = rand(T,size(A,1))
        @test Ac\b ≈ Matrix(A)\b
        @test Ac\b ≈ A\b
    end

    for T in (Float64, BigFloat)
        A = Symmetric(BandedMatrix(0 => one(T) ./ [12, 6, 6, 6, 12],
                                -1 => ones(T,4) ./ 24), :L)
        Ac = cholesky(A)

        @test Ac isa Cholesky{T,<:BandedMatrix{T}}
        @test Ac.L ≈ cholesky(Matrix(A)).L

        b = rand(T,size(A,1))
        @test Ac\b ≈ Matrix(A)\b
        @test Ac\b ≈ A\b
    end

    let T = ComplexF64
        A = Hermitian(BandedMatrix(0 => one(T) ./ [12, 6, 6, 6, 12],
                                   1 => ones(T,4) ./ 24))
        Ac = cholesky(A)

        @test Ac isa Cholesky{T,<:BandedMatrix{T}}
        @test Ac.U ≈ cholesky(Matrix(A)).U

        b = rand(T,size(A,1))
        @test Ac\b ≈ Matrix(A)\b
        @test Ac\b ≈ A\b
    end

    B = BandedMatrix(1=>Float64[1:4;], 0=>Float64[1:5;], -1=>Float64[1:4;])
    @test isposdef(B) == isposdef(Matrix(B)) == false
    B = BandedMatrix(1=>Float64[1:4;], 0=>Float64[2:2:10;], -1=>Float64[1:4;])
    @test isposdef(B) == isposdef(Matrix(B)) == true

    @testset "Issue #450: Cholesky of a BandedMatrix's view" begin
        L = brand(10, 10, 2, 0) 
        B = BandedMatrix(Symmetric(L * L'));
        Bv = Symmetric(view(B, :, :))
        chol = cholesky(Bv)
        @test MemoryLayout(chol.U) isa TriangularLayout{'U', 'N', typeof(MemoryLayout(B))}
        @test MemoryLayout(chol.L) isa TriangularLayout{'L', 'N', typeof(MemoryLayout(B'))}
        @test isbanded(chol.L)
        @test isbanded(chol.U)
        cc = LinearAlgebra.cholcopy(Bv)
        @test cc isa Symmetric{Float64, typeof(B)}
        @test chol.U ≈ cholesky(Matrix(B)).U
        @test cc == B
    end
end

@testset "symrcm" begin
    matrix = Int16[
        1 0 1 0 0 0 0 1 1
        0 1 1 0 0 1 1 1 0
        1 1 1 0 0 0 0 0 0
        0 0 0 1 0 0 0 1 1
        0 0 0 0 1 0 1 1 0
        0 1 0 0 0 1 1 0 0
        0 1 0 0 1 1 1 0 0
        1 1 0 1 1 0 0 1 0
        1 0 0 1 0 0 0 0 1
    ]

    bandedmatrix, perm, invp = symrcm(matrix)
    @test invp == invperm(perm)
    @test bandedmatrix == matrix[perm, perm]
    @test eltype(bandedmatrix) == eltype(matrix)

    # LFAT5
    matrix = Float32[
        0.608806    0.0          0.0         0.0       0.0        0.0       0.0         0.0        0.0       0.0          0.0      0.0        -0.304403   0.0
        0.0         1.57088      0.0       -94.2528    0.78544    0.0       0.0         0.0        0.0       0.0          0.0      0.0         0.0        0.0
        0.0         0.0      15080.4         0.0       0.0      -94.2528    0.0         0.0       94.2528    0.0      -7540.22     0.0         0.0        0.0
        0.0       -94.2528       0.0     15080.4       0.0       94.2528    0.0         0.0        0.0       0.0      -7540.22     0.0         0.0        0.0
        0.0         0.78544      0.0         0.0       3.14176    0.78544   0.0         0.0        0.0       0.0        -94.2528   0.0         0.0        0.0
        0.0         0.0        -94.2528     94.2528    0.78544    3.14176   0.0         0.0        0.0       0.78544      0.0      0.0         0.0        0.0
        0.0         0.0          0.0         0.0       0.0        0.0       1.25664f7   0.0        0.0       0.0          0.0     -6.2832f6    0.0       -6.2832f6
        0.0         0.0          0.0         0.0       0.0        0.0       0.0         0.608806   0.0       0.0          0.0      0.0        -0.304403   0.0
        0.0         0.0         94.2528      0.0       0.0        0.0       0.0         0.0        1.57088   0.78544      0.0      0.0         0.0        0.0
        0.0         0.0          0.0         0.0       0.0        0.78544   0.0         0.0        0.78544   3.14176     94.2528   0.0         0.0        0.0
        0.0         0.0      -7540.22    -7540.22    -94.2528     0.0       0.0         0.0        0.0      94.2528   15080.4      0.0         0.0        0.0
        0.0         0.0          0.0         0.0       0.0        0.0      -6.2832f6    0.0        0.0       0.0          0.0      1.25664f7   0.0        0.0
        -0.304403    0.0          0.0         0.0       0.0        0.0       0.0        -0.304403   0.0       0.0          0.0      0.0         0.608806   0.0
        0.0         0.0          0.0         0.0       0.0        0.0      -6.2832f6    0.0        0.0       0.0          0.0      0.0         0.0        1.25664f7
    ]

    bandedmatrix, perm, invp = symrcm(matrix)
    @test invp == invperm(perm)
    @test bandedmatrix == matrix[perm, perm]
    @test eltype(bandedmatrix) == eltype(matrix)
end

@testset "splitcholesky!" begin
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        A = Hermitian(brand(T, 20, 20, 2, 4) + 10I)
        S = BandedMatrices.splitcholesky!(A)
        if T <: Real
            @test transpose(S) ≡ S'
        else
            @test_throws ArgumentError transpose(S)
        end
    end
end

end # module

## Method definitions for generic eltypes - will make copies

# Direct and transposed algorithms

function materialize!(L::Ldiv{<:BandedColumnMajor})
    A, B = L.A, L.B
    checksquare(A)
    ldiv!(factorize(A), B)
end

function copyto!(dest::AbstractVecOrMat, L::Ldiv{<:BandedRowMajor})
    A, B = L.A, L.B
    copyto!(dest, Ldiv(transpose(factorize(transpose(A))), B))
end

function copyto!(dest::AbstractVecOrMat, L::Ldiv{<:ConjLayout{<:BandedRowMajor}})
    A, B = L.A, L.B
    copyto!(dest, Ldiv(factorize(A')', B))
end



# Direct and transposed algorithms
function ldiv!(A::BandedLU{T,<:BandedMatrix}, B::StridedVecOrMat{T}) where {T<:BlasFloat}
    m = size(A.factors,1)
    l,u = bandwidths(A.factors)
    data = bandeddata(A.factors)
    iszero(m) || LAPACK.gbtrs!('N', l, u-l, m, data, A.ipiv, B)
    B
end

function ldiv!(A::BandedLU{T}, B::AbstractVecOrMat{Complex{T}}) where T<:Real
    # c2r = reshape(transpose(reinterpret(T, reshape(B, (1, length(B))))), size(B, 1), 2*size(B, 2))
    a = real.(B)
    b = imag.(B)
    ldiv!(A, a)
    ldiv!(A, b)
    B .= a .+ im.*b
end

function ldiv!(transA::TransposeFact{T,<:BandedLU{T,<:BandedMatrix}}, B::StridedVecOrMat{T}) where {T<:BlasFloat}
    A = transA.parent
    m = size(A.factors,1)
    l,u = bandwidths(A.factors)
    data = bandeddata(A.factors)
    LAPACK.gbtrs!('T', l, u-l, m, data, A.ipiv, B)
end

function ldiv!(transA::TransposeFact{<:Any,<:BandedLU{<:Any,<:BandedMatrix}}, B::AbstractVecOrMat)
    A = transA.parent
    ldiv!(transpose(UnitLowerTriangular(A.factors)), ldiv!(transpose(UpperTriangular(A.factors)), B))
    _apply_inverse_ipiv_rows!(A, B)
end

ldiv!(adjF::AdjointFact{T,<:BandedLU{T,<:BandedMatrix}}, B::AbstractVecOrMat{T}) where {T<:Real} =
    (F = adjF.parent; ldiv!(transpose(F), B))
function ldiv!(adjA::AdjointFact{T,<:BandedLU{T,<:BandedMatrix}}, B::StridedVecOrMat{T}) where {T<:BlasComplex}
    A = adjA.parent
    m = size(A.factors,1)
    l,u = bandwidths(A.factors)
    data = bandeddata(A.factors)
    LAPACK.gbtrs!('C', l, u-l, m, data, A.ipiv, B)
end

function ldiv!(adjA::AdjointFact{<:Any,<:BandedLU{<:Any,<:BandedMatrix}}, B::AbstractVecOrMat)
    error("Implement")
    A = adjA.parent
    ldiv!(adjoint(UnitLowerTriangular(A.factors)), ldiv!(adjoint(UpperTriangular(A.factors)), B))
    _apply_inverse_ipiv!(A, B)
end

\(A::AdjointFact{<:Any,<:BandedLU}, B::Adjoint{<:Any,<:AbstractVecOrMat}) = A \ copy(B)
\(A::TransposeFact{<:Any,<:BandedLU}, B::Transpose{<:Any,<:AbstractVecOrMat}) = A \ copy(B)

_factorize(::AbstractBandedLayout, _, A) = size(A,1) == size(A,2) ? lu(A) : qr(A)

# The following routines multiply
#
#  C[:,j] = α*A*B[:,j] + β* C[:,j]
#
#  But are divided into cases to minimize the calculated
#  rows.  We use A is n x ν, B is ν x m



# Equivalent to
#
#  C[1:min(Cl+j,n),j] = α*A[1:min(Cl+j,n),1:min(Bl+j,ν)]*B[1:min(Bl+j,ν),j]
#                       + β*C[1:min(Cl+j,n),j]
#
@inline function A11_Btop_Ctop_gbmv!(α,β,
                               n,ν,m,j,
                               sz,
                               a,Al,Au,sta,
                               b,Bl,Bu,stb,
                               c,Cl,Cu,stc)
   # A=BandedMatrix(pointer_to_array(a,(Al+Au+1,ν)),n,Al,Au)
   # B=BandedMatrix(pointer_to_array(b,(Bl+Bu+1,m)),ν,Bl,Bu)
   # C=BandedMatrix(pointer_to_array(c,(Cl+Cu+1,m)),n,Cl,Cu)
   #
   # nr=1:min(Cl+j,n)
   # νr=1:min(Bl+j,ν)
   #
   # cj = α*A[nr,νr]*B[νr,j] + β*C[nr,j]
   #
   # for k in nr
   #     C[k,j]=cj[k-first(nr)+1]
   # end
   #
   # c

   gbmv!('N',min(Cl+j,n), min(Bl+j,ν),
          Al, Au,
          α,
          a, sta,
          b+sz*((j-1)*stb+Bu-j+1), 1, β,
          c+sz*((j-1)*stc+Cu-j+1), 1)
end


# Equivalent to
#
#  C[1:min(Cl+j,n),j] = α*A[1:min(Cl+j,n),p:min(p+Bl+Bu+1,ν)]*
#                               B[p:min(p+Bl+Bu+1,ν),j]
#                       + β*C[1:min(Cl+j,n),j]
# for p = j-B.u
#


@inline function Atop_Bmid_Ctop_gbmv!(α,β,
                               n,ν,m,j,
                               sz,
                               a,Al,Au,sta,
                               b,Bl,Bu,stb,
                               c,Cl,Cu,stc)
   # p=j-Bu

   # A=BandedMatrix(pointer_to_array(a,(Al+Au+1,ν)),n,Al,Au)
   # B=BandedMatrix(pointer_to_array(b,(Bl+Bu+1,m)),ν,Bl,Bu)
   # C=BandedMatrix(pointer_to_array(c,(Cl+Cu+1,m)),n,Cl,Cu)
   #
   # nr=1:min(Cl+j,n)
   # νr=p:min(p+Bl+Bu+1,ν)
   #
   # cj = α*A[nr,νr]*B[νr,j] + β*C[nr,j]
   #
   # for k in nr
   #     C[k,j]=cj[k-first(nr)+1]
   # end
   #
   # c

   gbmv!('N', min(Cl+j,n), min(Bl+Bu+1,ν-j+Bu+1),
           Al+j-Bu-1, Au-j+Bu+1,
           α,
           a+sz*(j-Bu-1)*sta, sta,
           b+sz*(j-1)*stb, 1, β,
           c+sz*((j-1)*stc+Cu-j+1), 1)
end


# Equivalent to
#
#  C[nr,j] = α*A[nr,νr]*B[νr,j] + β*C[nr,j]
#
# for p  = j-B.u
#     nr = p-Au : min(p+Al,n)
#     νr = p    : min(p+Bl+Bu+1,ν)
#
#

@inline function Amid_Bmid_Cmid_gbmv!(α,β,
                               n,ν,m,j,
                               sz,
                               a,Al,Au,sta,
                               b,Bl,Bu,stb,
                               c,Cl,Cu,stc)
   p = j-Bu
   # A = BandedMatrix(pointer_to_array(a,(Al+Au+1,ν)),n,Al,Au)
   # B = BandedMatrix(pointer_to_array(b,(Bl+Bu+1,m)),ν,Bl,Bu)
   # C = BandedMatrix(pointer_to_array(c,(Cl+Cu+1,m)),n,Cl,Cu)
   #
   # nr= j-Cu : min(j+Cl,n)
   # νr= p    : min(p+Bl+Bu+1,ν)
   # if !isempty(nr) && !isempty(νr)
   #     cj = α*A[nr,νr]*B[νr,j] + β*C[nr,j]
   #
   #     for k in nr
   #         C[k,j]=cj[k-first(nr)+1]
   #     end
   # end
   #
   # c
   gbmv!('N', min(Cl+Cu+1,n-j+Cu+1), min(Bl+Bu+1,ν-p+1),
           Al+Au, 0,
           α,
           a+sz*(j-Bu-1)*sta, sta,
           b+sz*(j-1)*stb, 1, β,
           c+sz*(j-1)*stc, 1)
end

# Equivalent to
#
#  C[nr,j] =  β*C[nr,j]
#
# for nr= max(1,j-Cu) : min(j+Cl,n)
#


@inline function Anon_Bnon_C_gbmv!(α,β,
                               n,ν,m,j,
                               sz,
                               a,Al,Au,sta,
                               b,Bl,Bu,stb,
                               c,Cl,Cu,stc)
   # C = BandedMatrix(pointer_to_array(c,(Cl+Cu+1,m)),n,Cl,Cu)
   #
   # nr= max(1,j-Cu) : min(j+Cl,n)
   #
   # if !isempty(nr)
   #     cj =  β*C[nr,j]
   #
   #     for k in nr
   #         C[k,j]=cj[k-first(nr)+1]
   #     end
   # end
   #
   # c

   BLAS.scal!(Cu+Cl+1,β,c+sz*(j-1)*stc,1)
end



# function Amid_Bbot_Cmid_gbmv!(α,β,
#                                n,ν,m,j,
#                                sz,
#                                a,Al,Au,sta,
#                                b,Bl,Bu,stb,
#                                c,Cl,Cu,stc)
#    gbmv!('N', Cl+Cu+1,
#            Al+Au, 0,
#            α,
#            a+sz*(j-Bu-1)*sta, ν-j+1, sta,
#            b+sz*(j-1)*stb, β,
#            c+sz*(j-1)*stc)
# end
#
#
# function Abot_Bbot_Cbot_gbmv!(α,β,
#                                n,ν,m,j,
#                                sz,
#                                a,Al,Au,sta,
#                                b,Bl,Bu,stb,
#                                c,Cl,Cu,stc)
#    gbmv!('N', n-j+C.u+1,
#            A.l+A.u, 0,
#            α,
#            a+sz*(j-B.u-1)*sta, B.l+B.u+1-(j-ν+B.l), sta,
#            b+sz*(j-1)*stb, β,
#            c+sz*(j-1)*stc)
# end

function _num_zeroband_u(A)
    Al, Au = bandwidths(A)
    for b = 0:Al+Au
        any(!iszero, view(A,band(Au-b))) && return b
    end
    return Al+Au+1
end

function _num_zeroband_l(A)
    Al, Au = bandwidths(A)
    for b = 0:Al+Au
        any(!iszero, view(A,band(-Al+b))) && return b
    end
    return Al+Au+1
end

function gbmm!(tA::Char, tB::Char, α::T, A::AbstractMatrix{T},
                B::AbstractMatrix{T}, β::T, C::AbstractMatrix{T},
                Czero=false) where {T<:BlasFloat}
    if tA ≠ 'N' || tB ≠ 'N'
        error("Only 'N' flag is supported.")
    end
    n,ν = size(A)
    m = size(B,2)

    Am, An = size(A)
    Bm, Bn = size(B)

    @assert n == size(C,1)
    @assert ν == size(B,1)
    @assert m == size(C,2)

    (n == 0 || m == 0) && return C

    Al, Au = bandwidths(A)
    Bl, Bu = bandwidths(B)
    C̃l, C̃u = bandwidths(C)
    Cl,Cu = min.(_bnds(C), (Al+Bl,Au+Bu))

    # prune zero bands
    if (-Al > Au) || (-Bl > Bu)   # A or B has empty bands
        Czero || fill!(C, zero(T))
        return C
    elseif Al < 0
        _fill_lmul!(β, @views(C[max(1,Bn+Al-1):Am, :]), Czero)
        gbmm!('N', 'N', α, view(A, :, 1-Al:An), view(B, 1-Al:An, :), β, C, Czero)
        return C
    elseif Au < 0
        _fill_lmul!(β, @views(C[1:-Au,:]), Czero)
        gbmm!('N', 'N', α, view(A, 1-Au:Am,:), B, β, view(C, 1-Au:Am,:), Czero)
        return C
    elseif Bl < 0
        _fill_lmul!(β, @views(C[:, 1:-Bl]), Czero)
        gbmm!('N', 'N', α, A, view(B, :, 1-Bl:Bn), β, view(C, :, 1-Bl:Bn), Czero)
        return C
    elseif Bu < 0
        _fill_lmul!(β, @views(C[:, max(1,Am+Bu-1):Bn]), Czero)
        gbmm!('N', 'N', α, view(A, :, 1-Bu:Bm), view(B, 1-Bu:Bm, :), β, C, Czero)
        return C
    elseif C̃u < Cu
        Au_r, Bu_r = _num_zeroband_u(A), _num_zeroband_u(B)
        C̃u ≥  Cu - Au_r - Bu_r || throw(BandError(C, Cu - Au_r - Bu_r))
        A_data = bandeddata(A)
        B_data = bandeddata(B)

        if Au-Au_r < -Al || Bu - Bu_r < -Bl
            _fill_lmul!(β, C, Czero)
            return C
        end

        Ã = _BandedMatrix(@views(A_data[Au_r+1:end,:]), n, Al, Au-Au_r)
        B̃ = _BandedMatrix(@views(B_data[Bu_r+1:end,:]), ν, Bl, Bu-Bu_r)
        gbmm!('N', 'N', α, Ã, B̃, β, C, Czero)
        return C
    elseif C̃l < Cl
        Al_r, Bl_r = _num_zeroband_l(A), _num_zeroband_l(B)
        C̃l ≥  Cl - Al_r - Bl_r || throw(BandError(C, Cl - Al_r - Bl_r))
        A_data = bandeddata(A)
        B_data = bandeddata(B)

        if Al-Al_r < -Au || Bl - Bl_r < -Bu
            _fill_lmul!(β, C, Czero)
            return C
        end

        Ã = _BandedMatrix(@views(A_data[1:end-Al_r,:]), n, Al-Al_r, Au)
        B̃ = _BandedMatrix(@views(B_data[1:end-Bl_r,:]), ν, Bl-Bl_r, Bu)
        gbmm!('N', 'N', α, Ã, B̃, β, C, Czero)
        return C
    end

    A_data = bandeddata(A)
    B_data = bandeddata(B)
    C̃_data = bandeddata(C)

    # scale extra bands
    _fill_lmul!(β, view(C̃_data, 1:min(C̃u-Cu,size(C̃_data,1)),:), Czero)
    _fill_lmul!(β, view(C̃_data, (C̃u+Cl+1)+1:size(C̃_data,1),:), Czero)
    C_data = view(C̃_data, (C̃u-Cu+1):(C̃u+Cl+1), :) # shift to bands we will write to
    _gbmm!(α, A_data, B_data, β, C_data, (n,ν,m), (Al, Au), (Bl, Bu), (Cl, Cu), Czero)

    C
end


function _gbmm!(α::T, A_data, B_data, β, C_data, (n,ν,m), (Al, Au), (Bl, Bu), (Cl, Cu), Czero) where T
    a = pointer(A_data)
    b = pointer(B_data)
    c = pointer(C_data)
    sta = stride(A_data,2)
    stb = stride(B_data,2)
    stc = stride(C_data,2)
    sz = sizeof(T)

    # Multiply columns j where B[1,j]≠0: A is at 1,1 and C[1,j]≠0
    for j = 1:min(m,1+Bu)
        A11_Btop_Ctop_gbmv!(α,β,
                            n,ν,m,j,
                            sz,
                            a,Al,Au,sta,
                            b,Bl,Bu,stb,
                            c,Cl,Cu,stc)
    end

    # Multiply columns j where B[k,j]=0 for k<p=(j-B.u-1), A is at 1,1+p and C[1,j]≠0
    # j ≤ ν + B.u since then 1+p ≤ ν, so inside the columns of A

    for j = 2+Bu:min(1+Cu,ν+Bu,m)
        Atop_Bmid_Ctop_gbmv!(α,β,
                            n,ν,m,j,
                            sz,
                            a,Al,Au,sta,
                            b,Bl,Bu,stb,
                            c,Cl,Cu,stc)
    end


    # multiply columns where A and B are mid and C is bottom
    for j = 2+Cu:min(m,ν+Bu,n+Cu)
        Amid_Bmid_Cmid_gbmv!(α,β,
                            n,ν,m,j,
                            sz,
                            a,Al,Au,sta,
                            b,Bl,Bu,stb,
                            c,Cl,Cu,stc)
    end

    # scale columns of C by β that aren't impacted by α*A*B
    _fill_lmul!(β, view(C_data, :, ν+Bu+1:min(m,n+Cu)), Czero)
end

module TestInterface

using BandedMatrices, LinearAlgebra, ArrayLayouts, FillArrays, Test, Random
import BandedMatrices: isbanded, AbstractBandedLayout, BandedStyle,
                        BandedColumns, bandeddata
import ArrayLayouts: OnesLayout, UnknownLayout
using InfiniteArrays, SparseArrays

struct PseudoBandedMatrix{T} <: AbstractMatrix{T}
    data::Array{T}
    l::Int
    u::Int
end

Base.size(A::PseudoBandedMatrix) = size(A.data)
function Base.getindex(A::PseudoBandedMatrix, j::Int, k::Int)
    l, u = bandwidths(A)
    if -l ≤ k-j ≤ u
        A.data[j, k]
    else
        zero(eltype(A.data))
    end
end
function Base.setindex!(A::PseudoBandedMatrix, v, j::Int, k::Int)
    l, u = bandwidths(A)
    if -l ≤ k-j ≤ u
        A.data[j, k] = v
    else
        error("out of band.")
    end
end

struct PseudoBandedLayout <: AbstractBandedLayout end
Base.BroadcastStyle(::Type{<:PseudoBandedMatrix}) = BandedStyle()
BandedMatrices.MemoryLayout(::Type{<:PseudoBandedMatrix}) = PseudoBandedLayout()
BandedMatrices.isbanded(::PseudoBandedMatrix) = true
BandedMatrices.bandwidths(A::PseudoBandedMatrix) = (A.l , A.u)
BandedMatrices.inbands_getindex(A::PseudoBandedMatrix, j::Int, k::Int) = A.data[j, k]
BandedMatrices.inbands_setindex!(A::PseudoBandedMatrix, v, j::Int, k::Int) = setindex!(A.data, v, j, k)
LinearAlgebra.fill!(A::PseudoBandedMatrix, v) = fill!(A.data,v)

@testset "banded matrix interface" begin
    @testset "Zeros" begin
        @test isbanded(Zeros(5,6))
        @test bandwidths(Zeros(5,6)) == (-40320,-40320)
        @test BandedMatrices.inbands_getindex(Zeros(5,6), 1,2) == 0
    end

    @testset "Eye" begin
        @test isbanded(Eye(5))
        @test bandwidths(Eye(5)) == (0,0)
        @test BandedMatrices.inbands_getindex(Eye(5), 1,1) == 1

        V = view(Eye(5),2:3,:)
        @test bandwidths(V) == (-1,1)
        @test MemoryLayout(typeof(V)) isa BandedColumns{OnesLayout}
        @test BandedMatrix(V) == [0 1 0 0 0; 0 0 1 0 0]

        B = brand(5,5,1,2)
        @test Eye(5) * B == B
        @test B * Eye(5) == B
        @test muladd!(2.0, Eye(5), B, 0.0, zeros(5,5)) == 2B
        @test muladd!(2.0, B, Eye(5), 0.0, zeros(5,5)) == 2B

        @test isbanded(2Eye(5,6))
        @test bandwidths(2Eye(5,6)) == (0,0)
        @test BandedMatrices.inbands_getindex(2Eye(5,6), 1,1) == 2
    end

    @testset "Diagonal" begin
        A = Diagonal(ones(5,5))
        @test isbanded(A)
        @test bandwidths(A) == (0,0)
        @test BandedMatrices.inbands_getindex(A, 1,1) == 1
        BandedMatrices.inbands_setindex!(A, 2, 1,1)
        @test A[1,1] == 2
        @test A[1,2] == 0
        @test BandedMatrices.@inbands(A[1,2]) == 2

        @test bandeddata(A) == bandeddata(Adjoint(A)) == bandeddata(Transpose(A)) == diag(A)'

        @test MemoryLayout(view(A, 1:3,2:4)) isa BandedColumns{DenseColumnMajor}
        @test MemoryLayout(view(A, [1,2,3],2:4)) isa UnknownLayout

        A[band(0)][1] = 3
        @test A[band(0)] == [2; ones(4)]

        B = Diagonal(Fill(1,5))
        @test @inferred(B[band(0)]) ≡ Fill(1,5)
        @test B[band(1)] ≡ B[band(-1)] ≡ Fill(0,4)
        @test B[band(2)] ≡ B[band(-2)] ≡ Fill(0,3)

        B = Diagonal(Ones(5))
        @test @inferred(B[band(0)]) ≡ Fill(1.0,5)
        @test B[band(1)] ≡ B[band(-1)] ≡ Fill(0.0,4)
        @test B[band(2)] ≡ B[band(-2)] ≡ Fill(0.0,3)

        B = Diagonal(1:∞)
        @test @inferred(B[Band(0)]) == 1:∞
    end

    @testset "SymTridiagonal" begin
        A = SymTridiagonal([1,2,3],[4,5])
        @test @inferred(A[Band(0)]) == [1,2,3]
        @test A[Band(1)] == A[Band(-1)] == [4,5]
        @test A[Band(2)] == A[Band(-2)] == [0]
        @test A[Band(3)] == A[Band(-3)] == Int[]
        @test isbanded(A)
        @test bandwidths(A) == (1,1)
        @test BandedMatrices.inbands_getindex(A, 1,1) == 1
        BandedMatrices.inbands_setindex!(A, 2, 1,1)
        @test A[1,1] == 2

        S = SymTridiagonal(1:∞, 1:∞)
        @test @inferred(S[Band(0)]) == S[Band(1)] == S[Band(-1)] == 1:∞

        B = SymTridiagonal(Fill(1,5), Fill(2,4))
        @test @inferred(B[band(0)]) ≡ Fill(1,5)
        @test B[band(1)] ≡ B[band(-1)] ≡ Fill(2,4)
        @test B[band(2)] ≡ B[band(-2)] ≡ Fill(0,3)

        B = SymTridiagonal(Ones(5), Ones(4))
        @test @inferred(B[band(0)]) ≡ Fill(1.0,5)
        @test B[band(1)] ≡ B[band(-1)] ≡ Fill(1.0,4)
        @test B[band(2)] ≡ B[band(-2)] ≡ Fill(0.0,3)
    end

    @testset "Tridiagonal" begin
        B = Tridiagonal([1:3;], [1:4;], [1:3;])
        @test @inferred(B[Band(0)]) == 1:4
        @test B[Band(1)] == B[Band(-1)] == 1:3
        @test B[Band(2)] == B[Band(-2)] == [0,0]
        @test B[Band(5)] == B[Band(-5)] == Int[]

        T = Tridiagonal(1:∞, 1:∞, 1:∞)
        @test @inferred(T[Band(0)]) == T[Band(1)] == T[Band(-1)] == 1:∞

        B = Tridiagonal(Fill(1,4), Fill(2,5), Fill(3,4))
        @test @inferred(B[band(0)]) ≡ Fill(2,5)
        @test B[band(1)] ≡ Fill(3,4)
        @test B[band(-1)] ≡ Fill(1,4)
        @test B[band(2)] ≡ B[band(-2)] ≡ Fill(0,3)
    end

    @testset "Bidiagonal" begin
        L = Bidiagonal([1:5;], [1:4;], :L)
        @test @inferred(L[Band(0)]) == 1:5
        @test L[Band(-1)] == 1:4
        @test L[Band(1)] == zeros(Int,4)

        L = Bidiagonal(1:∞, 1:∞, :L)
        @test @inferred(L[Band(0)]) == L[Band(-1)] == 1:∞

        L = Bidiagonal(Fill(2,5), Fill(1,4), :L)
        @test @inferred(L[band(0)]) ≡ Fill(2,5)
        @test L[band(1)] ≡ Fill(0,4)
        @test L[band(-1)] ≡ Fill(1,4)
        @test L[band(2)] ≡ L[band(-2)] ≡ Fill(0,3)
        @test BandedMatrix(L) == L

        U = Bidiagonal(Fill(2,5), Fill(1,4), :U)
        @test @inferred(U[band(0)]) ≡ Fill(2,5)
        @test U[band(1)] ≡ Fill(1,4)
        @test U[band(-1)] ≡ Fill(0,4)
        @test U[band(2)] ≡ U[band(-2)] ≡ Fill(0,3)
        @test BandedMatrix(U) == U
    end

    @testset "!Array" begin
        @test !BandedMatrices.isbanded(zeros(0,0))
    end

    A = PseudoBandedMatrix(rand(5, 4), 2, 2)
    B = rand(5, 4)
    C = copy(B)

    @test Matrix(B .= 2.0 .* A .+ B) ≈ 2*Matrix(A) + C

    A = PseudoBandedMatrix(rand(5, 4), 1, 2)
    B = (z -> exp(z)-1).(A)
    @test B isa BandedMatrix
    @test bandwidths(B) == bandwidths(A)
    @test B == (z -> exp(z)-1).(Matrix(A))

    A = PseudoBandedMatrix(rand(5, 4), 1, 2)
    B = A .* 2
    @test B isa BandedMatrix
    @test bandwidths(B) == bandwidths(A)
    @test B == 2Matrix(A) == (2 .* A)

    A = PseudoBandedMatrix(rand(5, 4), 1, 2)
    B = PseudoBandedMatrix(rand(5, 4), 2, 1)

    @test A .+ B isa BandedMatrix
    @test bandwidths(A .+ B) == (2,2)
    @test A .+ B == Matrix(A) + Matrix(B)

    A = PseudoBandedMatrix(rand(5, 4), 1, 2)
    B = PseudoBandedMatrix(rand(5, 4), 2, 3)
    C = deepcopy(B)
    @test Matrix(C .= 2.0 .* A .+ C) ≈ 2*Matrix(A) + B ≈ 2*A + Matrix(B) ≈ 2*Matrix(A) + Matrix(B) ≈ 2*A + B

    y = rand(4)
    z = zeros(5)
    muladd!(1.0, A, y, 0.0, z)
    @test z ≈ A*y ≈ Matrix(A)*y

    @test bandwidths(BandedMatrix(A)) ==
            bandwidths(BandedMatrix{Float64}(A)) ==
            bandwidths(BandedMatrix{Float64,Matrix{Float64}}(A)) ==
            bandwidths(convert(BandedMatrix{Float64}, A)) ==
            bandwidths(convert(BandedMatrix{Float64,Matrix{Float64}},A)) ==
            bandwidths(A)

    @testset "copymutable_oftype" begin
        A = PseudoBandedMatrix(rand(5, 4), 1, 2)
        @test ArrayLayouts.copymutable_oftype_layout(MemoryLayout(A), A, BigFloat) == A
        @test ArrayLayouts.copymutable_oftype_layout(MemoryLayout(A), A, BigFloat) isa BandedMatrix
    end
end

@testset "Bi/Tri/Diagonal" begin
    D = Diagonal(randn(5))
    @test bandwidths(D) == (0,0)

    A =  brand(5,5,1,1)
    @test D*A isa BandedMatrix
    @test D*A == D*Matrix(A)

    @test A*D isa BandedMatrix
    @test A*D == Matrix(A)*D

    M = MulAdd(2.0, A, D, 1.0, A)
    @test copyto!(similar(M), M) ≈ 2A*D + A
    M = MulAdd(2.0, D, A, 1.0, A)
    @test copyto!(similar(M), M) ≈ 2D*A + A

    D = Diagonal(rand(Int,10))
    B = brand(10,10,-1,2)
    J = SymTridiagonal(randn(10), randn(9))
    T = Tridiagonal(randn(9), randn(10), randn(9))
    Bl = Bidiagonal(randn(10), randn(9), :L)
    Bu = Bidiagonal(randn(10), randn(9), :U)

    @test bandwidths(D) == (0,0)
    @test bandwidths(J) == bandwidths(T) == (1,1)
    @test bandwidths(Bu) == (0,1)
    @test bandwidths(Bl) == (1,0)

    @test isbanded(D)
    @test isbanded(J)
    @test isbanded(T)
    @test isbanded(Bu)
    @test isbanded(Bl)

    @test BandedMatrix(J) == J
    @test BandedMatrix(T) == T
    @test BandedMatrix(Bu) == Bu
    @test BandedMatrix(Bl) == Bl

    @test Base.BroadcastStyle(Base.BroadcastStyle(typeof(B)), Base.BroadcastStyle(typeof(D))) ==
        Base.BroadcastStyle(Base.BroadcastStyle(typeof(D)), Base.BroadcastStyle(typeof(B))) ==
        Base.BroadcastStyle(Base.BroadcastStyle(typeof(B)), Base.BroadcastStyle(typeof(T))) ==
        Base.BroadcastStyle(Base.BroadcastStyle(typeof(T)), Base.BroadcastStyle(typeof(B))) ==
        Base.BroadcastStyle(Base.BroadcastStyle(typeof(B)), Base.BroadcastStyle(typeof(J))) ==
        Base.BroadcastStyle(Base.BroadcastStyle(typeof(J)), Base.BroadcastStyle(typeof(B))) ==
        Base.BroadcastStyle(Base.BroadcastStyle(typeof(Bl)), Base.BroadcastStyle(typeof(B))) ==
        Base.BroadcastStyle(Base.BroadcastStyle(typeof(Bu)), Base.BroadcastStyle(typeof(B))) ==
            BandedStyle()

    A = B .+ D
    Ã = D .+ B
    @test A isa BandedMatrix
    @test Ã isa BandedMatrix
    @test bandwidths(A) == bandwidths(Ã) == (0,2)
    @test Ã == A == Matrix(B) + Matrix(D)

    A = B .+ J
    Ã = J .+ B
    @test A isa BandedMatrix
    @test Ã isa BandedMatrix
    @test bandwidths(A) == bandwidths(Ã) == (1,2)
    @test Ã == A == Matrix(B) + Matrix(J)

    A = B .+ T
    Ã = T .+ B
    @test A isa BandedMatrix
    @test Ã isa BandedMatrix
    @test bandwidths(A) == bandwidths(Ã) == (1,2)
    @test Ã == A == Matrix(B) + Matrix(T)

    A = B .+ Bl
    Ã = Bl .+ B
    @test A isa BandedMatrix
    @test Ã isa BandedMatrix
    @test bandwidths(A) == bandwidths(Ã) == (1,2)
    @test Ã == A == Matrix(B) + Matrix(Bl)

    A = B .+ Bu
    Ã = Bu .+ B
    @test A isa BandedMatrix
    @test Ã isa BandedMatrix
    @test bandwidths(A) == bandwidths(Ã) == (0,2)
    @test Ã == A == Matrix(B) + Matrix(Bu)

    @test layout_getindex(D,1:10,1:10) isa BandedMatrix
    @test layout_getindex(B,1:10,1:10) isa BandedMatrix
    @test layout_getindex(Bu,1:10,1:10) isa BandedMatrix
    @test layout_getindex(J,1:10,1:10) isa BandedMatrix
    @test layout_getindex(T,1:10,1:10) isa BandedMatrix
end

@testset "OneElement" begin
    o = OneElement(1, 3, 5)
    @test bandwidths(o) == (2,-2)
    n,m = rand(1:10,2)
    o = OneElement(1, (rand(1:n),rand(1:m)), (n, m))
    @test bandwidths(o) == bandwidths(sparse(o))
    o = OneElement(1, (n+1,m+1), (n, m))
    @test bandwidths(o) == bandwidths(Zeros(o))
    o = OneElement(1, 6, 5)
    @test bandwidths(o) == bandwidths(Zeros(o))
end

@testset "rot180" begin
    A = brand(5,5,1,2)
    R = rot180(A)
    @test bandwidths(R) == (2,1)
    @test R == rot180(Matrix(A))

    A = brand(5,4,1,2)
    R = rot180(A)
    @test bandwidths(R) == (3,0)
    @test R == rot180(Matrix(A))

    A = brand(5,6,1,-1)
    R = rot180(A)
    @test bandwidths(R) == (-2,2)
    @test R == rot180(Matrix(A))

    A = brand(6,5,-1,1)
    R = rot180(A)
    @test bandwidths(R) == (2,-2)
    @test R == rot180(Matrix(A))
end


@testset "permutedims" begin
    A = brand(10,11,1,2)
    @test bandwidths(permutedims(A)) == (2,1)
    @test permutedims(A) == permutedims(Matrix(A))

    @test permutedims(A') == permutedims(transpose(A)) == A

    B = A + im*A
    @test bandwidths(permutedims(B)) == (2,1)
    @test permutedims(B) == permutedims(Matrix(B))
    @test permutedims(B') == permutedims(Matrix(B)')
    @test permutedims(transpose(B)) == B

    A = BandedMatrix{Matrix{Float64}}(undef, (10, 11), (1, 2))
    A.data .= Ref([1 2; 3 4])
    # TODO: properly support PermutedDimsArray
    @test bandwidths(permutedims(A)) == (2,1)

    S = Symmetric(brand(10,10,1,2))
    @test permutedims(S) ≡ S
end

end # module

module TestSubArray

using BandedMatrices, FillArrays, ArrayLayouts, Test, LinearAlgebra
import LinearAlgebra: axpy!
import BandedMatrices: BandedColumns, bandeddata, MemoryLayout, BandedSubBandedMatrix, _BandedMatrix, sub_materialize, isbanded

include("mymatrix.jl")

@testset "BandedMatrix SubArray" begin
    @testset "BandedMatrix SubArray interface" begin
        A = brand(10,10,1,2)
        V = view(A,2:4,3:6)
        @test isbanded(V)
        @test bandwidths(V) == (2,1)
        @test MemoryLayout(V) isa BandedColumns{DenseColumnMajor}
        @test all(Matrix(_BandedMatrix(bandeddata(V), size(V,1), bandwidths(V)...)) .===
                Matrix(V))

        @test sub_materialize(V) isa BandedMatrix
        @test sub_materialize(MemoryLayout(V), V, (Base.Slice(1:3), Base.OneTo(4))) isa BandedMatrix
        # if 2nd argument is not Base.OneTo, cannot convert to BandedMatrix so take adjoint
        @test sub_materialize(MemoryLayout(V), V, (Base.OneTo(3), Base.Slice(1:4))) isa Adjoint{<:Any,<:BandedMatrix}
        # if neither argument is Base.OneTo, we give up
        @test sub_materialize(MemoryLayout(V), V, (Base.Slice(1:3), Base.Slice(1:4))) isa Matrix
    end

    @testset "BandedMatrix SubArray arithmetic" begin
        let A = brand(10,10,1,2), B = brand(20,20,1,2)
            @test isa(view(B,1:10,1:10),BandedSubBandedMatrix{Float64})
            @test MemoryLayout(typeof(view(B,1:10,1:10))) isa BandedColumns{DenseColumnMajor}

            B2 = copy(B)
            @test B == B2
            @test (2.0A+B[1:10,1:10]) ≈ axpy!(2.0,A,view(B2,1:10,1:10))
            @test (2.0A+B[1:10,1:10]) ≈ B2[1:10,1:10]

            A2 = copy(A)
            @test (2.0B[1:10,1:10]+A) ≈ axpy!(2.0,view(B,1:10,1:10),A2)
            @test (2.0B[1:10,1:10]+A) ≈ A2
        end

        let A = brand(20,20,1,2), B = brand(20,20,1,2)
            @test isa(view(B,1:10,1:10),BandedSubBandedMatrix{Float64})

            B2 = copy(B)
            @test (2.0A[1:10,1:10]+B[1:10,1:10]) ≈ axpy!(2.0,view(A,1:10,1:10),view(B2,1:10,1:10))
            @test (2.0A[1:10,1:10]+B[1:10,1:10]) ≈ B2[1:10,1:10]

            B2 = copy(B)
            @test (2.0A[1:10,:]+B[1:10,:]) ≈ axpy!(2.0,view(A,1:10,:),view(B2,1:10,:))
            @test (2.0A[1:10,:]+B[1:10,:]) ≈ B2[1:10,:]

            B2 = copy(B)
            @test (2.0A[:,1:10]+B[:,1:10]) ≈ axpy!(2.0,view(A,:,1:10),view(B2,:,1:10))
            @test (2.0A[:,1:10]+B[:,1:10]) ≈ B2[:,1:10]


            B2 = copy(B)
            @test (2.0A[:,:]+B[:,:]) ≈ axpy!(2.0,view(A,:,:),view(B2,:,:))
            @test (2.0A[:,:]+B[:,:]) ≈ B2[:,:]
        end

        let A = brand(10,10,1,2), B = brand(20,10,1,2)
            B2 = copy(B)
            @test (2.0A+B[1:10,1:10]) ≈ axpy!(2.0,A,view(B2,1:10,:))
            @test (2.0A+B[1:10,1:10]) ≈ B2[1:10,1:10]

            A2 = copy(A)
            @test (2.0B[1:10,1:10]+A) ≈ axpy!(2.0,view(B,1:10,:),A2)
            @test (2.0B[1:10,1:10]+A) ≈ A2
        end

        let A = brand(10,10,1,2), B = brand(10,20,1,2)
            B2 = copy(B)
            @test (2.0A+B[1:10,1:10]) ≈ axpy!(2.0,A,view(B2,:,1:10))
            @test (2.0A+B[1:10,1:10]) ≈ B2[1:10,1:10]

            A2 = copy(A)
            @test (2.0B[1:10,1:10]+A) ≈ axpy!(2.0,view(B,:,1:10),A2)
            @test (2.0B[1:10,1:10]+A) ≈ A2
        end
    end

    @testset "BandedMatrix SubArray *" begin
        let A=brand(10,10,1,2), v=rand(20)
            @test A*view(v,1:10) ≈ Matrix(A)*v[1:10]
            @test A*view(v,1:2:20) ≈ Matrix(A)*v[1:2:20]

            M=rand(20,20)
            @test A*view(M,1:10,1:10) ≈ Matrix(A)*M[1:10,1:10]
            @test A*view(M,1:2:20,1:2:20) ≈ Matrix(A)*M[1:2:20,1:2:20]
        end

        let A=brand(10,10,1,2), B=brand(20,10,1,2), C=brand(10,20,1,2),
            D=brand(20,20,1,2), M=rand(10,10), V=view(rand(20,20),1:2:20,1:2:20)


            for S in (view(A,:,:),view(B,1:10,:),view(C,:,1:10),view(D,1:10,1:10),
                        view(D,2:11,1:10),view(D,1:10,2:11),view(D,11:20,11:20))
                @test A*S ≈ Matrix(A)*Matrix(S)
                @test S*A ≈ Matrix(S)*Matrix(A)
                @test S*S ≈ Matrix(S)*Matrix(S)

                @test M*S ≈ M*Matrix(S)
                @test S*M ≈ Matrix(S)*M

                @test V*S ≈ Matrix(V)*Matrix(S)
                @test S*V ≈ Matrix(S)*Matrix(V)
            end
        end
    end

    @testset "BandedMatrix SubArray conversion" begin
        @testset "Container $C" for C in (Matrix{Int32}, MyMatrix{Int32})
            matrix = convert(C, rand(Int32, 10, 12))
            T = eltype(matrix)

            banded = @inferred BandedMatrix{T, C}(matrix, (1, 1))
            indices = 2:8, 3:9, 5:9
            @testset "view $kr, $jr" for kr in indices, jr in indices
                bview = @inferred view(banded, kr, jr)
                @test bview isa BandedMatrices.BandedSubBandedMatrix{T, C}
                @test @inferred(convert(BandedMatrix, bview)) isa BandedMatrix{T, C}
                @test convert(BandedMatrix, bview) == banded[kr, jr]
            end
        end
    end
end

end # module

module TestIndexing

using BandedMatrices, LinearAlgebra, ArrayLayouts, Test

import BandedMatrices: rowstart, rowstop, colstart, colstop,
                       rowlength, collength, diaglength, BandedColumns,
                       rowsupport, colsupport

@testset "Indexing" begin
    @testset "BandedMatrix Indexing" begin
        let
            for n in (10,50), m in (12,50), Al in (0,1,2,30), Au in (0,1,2,30)
                A=brand(n,m,Al,Au)
                kr,jr=3:10,5:12
                @test Matrix(A[kr,jr]) ≈ Matrix(A)[kr,jr]
            end
        end
    end

    @testset "rowstart/rowstop" begin
        A = BandedMatrix(Ones(7, 5), (1, 2))
        # 1.0  1.0  1.0  0.0  0.0
        # 1.0  1.0  1.0  1.0  0.0
        # 0.0  1.0  1.0  1.0  1.0
        # 0.0  0.0  1.0  1.0  1.0
        # 0.0  0.0  0.0  1.0  1.0
        # 0.0  0.0  0.0  0.0  1.0
        # 0.0  0.0  0.0  0.0  0.0
        @test (rowstart(A, 1), rowstop(A, 1), rowlength(A, 1)) == (1, 3, 3)
        @test (rowstart(A, 2), rowstop(A, 2), rowlength(A, 2)) == (1, 4, 4)
        @test (rowstart(A, 3), rowstop(A, 3), rowlength(A, 3)) == (2, 5, 4)
        @test (rowstart(A, 4), rowstop(A, 4), rowlength(A, 4)) == (3, 5, 3)
        @test (rowstart(A, 5), rowstop(A, 5), rowlength(A, 5)) == (4, 5, 2)
        @test (rowstart(A, 6), rowstop(A, 6), rowlength(A, 6)) == (5, 5, 1)
        @test (rowstart(A, 7), rowstop(A, 7), rowlength(A, 7)) == (6, 5, 0) # zero length
        @test (colstart(A, 1), colstop(A, 1), collength(A, 1)) == (1, 2, 2)
        @test (colstart(A, 2), colstop(A, 2), collength(A, 2)) == (1, 3, 3)
        @test (colstart(A, 3), colstop(A, 3), collength(A, 3)) == (1, 4, 4)
        @test (colstart(A, 4), colstop(A, 4), collength(A, 4)) == (2, 5, 4)
        @test (colstart(A, 5), colstop(A, 5), collength(A, 5)) == (3, 6, 4)

        A = BandedMatrix(Ones(3, 6), (1, 2))
        # 1.0  1.0  1.0  0.0  0.0  0.0
        # 1.0  1.0  1.0  1.0  0.0  0.0
        # 0.0  1.0  1.0  1.0  1.0  0.0
        @test (rowstart(A, 1), rowstop(A, 1), rowlength(A, 1)) == (1, 3, 3)
        @test (rowstart(A, 2), rowstop(A, 2), rowlength(A, 2)) == (1, 4, 4)
        @test (rowstart(A, 3), rowstop(A, 3), rowlength(A, 3)) == (2, 5, 4)
        @test (colstart(A, 1), colstop(A, 1), collength(A, 1)) == (1, 2, 2)
        @test (colstart(A, 2), colstop(A, 2), collength(A, 2)) == (1, 3, 3)
        @test (colstart(A, 3), colstop(A, 3), collength(A, 3)) == (1, 3, 3)
        @test (colstart(A, 4), colstop(A, 4), collength(A, 4)) == (2, 3, 2)
        @test (colstart(A, 5), colstop(A, 5), collength(A, 5)) == (3, 3, 1)
        @test (colstart(A, 6), colstop(A, 6), collength(A, 6)) == (4, 3, 0) # zero length

        A = BandedMatrix(Ones(3, 4), (-1, 2))
        # 0.0  1.0  1.0  0.0
        # 0.0  0.0  1.0  1.0
        # 0.0  0.0  0.0  1.0
        @test rowrange(A,1) == rowsupport(A,1) == 2:3
        @test rowrange(A,2) == rowsupport(A,2) == 3:4
        @test rowrange(A,3) == rowsupport(A,3) == 4:4
        @test colrange(A,1) == colsupport(A,1) == 1:0
        @test colrange(A,2) == colsupport(A,2) == 1:1
        @test colrange(A,3) == colsupport(A,3) == 1:2
        @test colrange(A,4) == colsupport(A,4) == 2:3

        @test colsupport(A,1:0) == rowsupport(A,1:0) == 1:0
    end

    @testset "test length of diagonal" begin
        A = BandedMatrix(Ones(4, 6), (2, 3))
        # 4x6 BandedMatrices.BandedMatrix{Float64}:
        #  1.0  1.0  1.0  1.0
        #  1.0  1.0  1.0  1.0  1.0
        #  1.0  1.0  1.0  1.0  1.0  1.0
        #       1.0  1.0  1.0  1.0  1.0
        @test diaglength(A, -2) == 2
        @test diaglength(A, -1) == 3
        @test diaglength(A,  0) == 4
        @test diaglength(A,  1) == 4
        @test diaglength(A,  2) == 4
        @test diaglength(A,  3) == 3

        A = BandedMatrix(Ones(6, 5), (2, 1))
        # 6x5 BandedMatrices.BandedMatrix{Float64}:
        #  1.0  1.0
        #  1.0  1.0  1.0
        #  1.0  1.0  1.0  1.0
        #       1.0  1.0  1.0  1.0
        #            1.0  1.0  1.0
        #                 1.0  1.0
        @test diaglength(A, -2) == 4
        @test diaglength(A, -1) == 5
        @test diaglength(A,  0) == 5
        @test diaglength(A,  1) == 4

        A = BandedMatrix(Ones(4, 4), (1, 1))
        # 4x4 BandedMatrices.BandedMatrix{Float64}:
        #  1.0  1.0
        #  1.0  1.0  1.0
        #       1.0  1.0  1.0
        #            1.0  1.0
        @test diaglength(A, -1) == 3
        @test diaglength(A,  0) == 4
        @test diaglength(A,  1) == 3

        # test with Band type
        @test diaglength(A,  band(1)) == 3
    end

    @testset "_firstdiagrow/_firstdiagcol" begin
        A = BandedMatrix(Ones(6, 5), (2, 1))
        # 6x5 BandedMatrices.BandedMatrix{Float64}:
        #  1.0  1.0
        #  1.0  1.0  1.0
        #  1.0  1.0  1.0  1.0
        #       1.0  1.0  1.0  1.0
        #            1.0  1.0  1.0
        #                 1.0  1.0
        @test BandedMatrices._firstdiagrow(A, 1) == 2
        @test BandedMatrices._firstdiagrow(A, 2) == 2
        @test BandedMatrices._firstdiagrow(A, 3) == 2
        @test BandedMatrices._firstdiagrow(A, 4) == -3
        @test BandedMatrices._firstdiagrow(A, 5) == -3
        @test BandedMatrices._firstdiagrow(A, 6) == -3

        @test BandedMatrices._firstdiagcol(A, 1) == -3
        @test BandedMatrices._firstdiagcol(A, 2) == -3
        @test BandedMatrices._firstdiagcol(A, 3) == 2
        @test BandedMatrices._firstdiagcol(A, 4) == 2
        @test BandedMatrices._firstdiagcol(A, 5) == 2
    end


    @testset "scalar - integer - integer" begin
        a = BandedMatrix(Ones(5, 5), (1, 1))
        # 1.0  1.0  0.0  0.0  0.0
        # 1.0  1.0  1.0  0.0  0.0
        # 0.0  1.0  1.0  1.0  0.0
        # 0.0  0.0  1.0  1.0  1.0

        # in band
        a[1, 1] = 2
        @test a[1, 1] == 2

        # out of band
        @test_throws BandError a[1, 3] = 1
        @test_throws BandError a[3, 1] = 1

        # out of range
        @test_throws BoundsError a[0, 0] = 1
        @test_throws BoundsError a[0, 1] = 1
        @test_throws BoundsError a[1, 0] = 1
        @test_throws BoundsError a[5, 6] = 1
        @test_throws BoundsError a[6, 5] = 1
        @test_throws BoundsError a[6, 6] = 1

        a = BandedMatrix(Ones(5, 5), (-1, 1))
        a[1, 2] = 2
        @test a[1, 2] == 2
        @test_throws BandError a[1, 1] = 1
    end


    @testset "indexing along a column" begin
        @testset "scalar - BandRange/Colon - integer" begin
            a = BandedMatrix(Ones(5, 5), (1, 1))
            # 1.0  1.0  0.0  0.0  0.0
            # 1.0  1.0  1.0  0.0  0.0
            # 0.0  1.0  1.0  1.0  0.0
            # 0.0  0.0  1.0  1.0  1.0
            # 0.0  0.0  0.0  1.0  1.0

            # in band
            a[BandRange, 1] .= 2
            a[BandRange, 2] .= 3
            a[BandRange, 3] .= 4
            a[BandRange, 4] .= 5
            a[BandRange, 5] .= 6
            @test a ==  [2  3  0  0  0;
                         2  3  4  0  0;
                         0  3  4  5  0;
                         0  0  4  5  6;
                         0  0  0  5  6]

            @test a[BandRange, 1] == [2, 2]
            @test a[BandRange, 2] == [3, 3, 3]
            @test a[BandRange, 3] == [4, 4, 4]
            @test a[BandRange, 4] == [5, 5, 5]
            @test a[BandRange, 5] == [6, 6]

            @test_throws BoundsError a[:, 0] .= 1
            @test_throws BandError a[:, 1] .= 1
            @test_throws BoundsError a[BandRange, 0] .= 1
            @test_throws BoundsError a[BandRange, 6] .= 1

            a = BandedMatrix(Ones(3, 5), (-1, 2))
            @test isempty(a[BandRange,1])
            a[BandRange,2] = [1]
            a[BandRange,3] = [2, 2]
            a[BandRange,4] = [3, 3]
            a[BandRange,5] = [4]

            @test a ==   [0 1 2 0 0;
                          0 0 2 3 0;
                          0 0 0 3 4]
        end

        @testset "vector - BandRange/Colon - integer" begin
            a = BandedMatrix(Ones{Int}(5, 8), (2, 1))
            # 5x7 BandedMatrices.BandedMatrix{Float64}:
            #  1.0  1.0    0    0    0    0   0   0
            #  1.0  1.0  1.0    0    0    0   0   0
            #  1.0  1.0  1.0  1.0    0    0   0   0
            #    0  1.0  1.0  1.0  1.0    0   0   0
            #    0    0  1.0  1.0  1.0  1.0   0   0

            # in band
            a[BandRange, 1] = [1,   2,  3]
            a[BandRange, 2] = [4,   5,  6,  7]
            a[BandRange, 3] = [8,   9, 10, 11]
            a[BandRange, 4] = [12, 13, 14]
            a[BandRange, 5] = [15, 16]
            a[BandRange, 6] = [17]

            @test a == [ 1  4   0   0   0   0   0   0;
                         2  5   8   0   0   0   0   0;
                         3  6   9  12   0   0   0   0;
                         0  7  10  13  15   0   0   0;
                         0  0  11  14  16  17   0   0]

            @test a[BandRange, 1] == @view(a[BandRange, 1]) == [1,   2,  3]
            @test a[BandRange, 2] == @view(a[BandRange, 2]) == [4,   5,  6,  7]
            @test a[BandRange, 3] == @view(a[BandRange, 3]) == [8,   9, 10, 11]
            @test a[BandRange, 4] == @view(a[BandRange, 4]) == [12, 13, 14]
            @test a[BandRange, 5] == @view(a[BandRange, 5]) == [15, 16]
            @test a[BandRange, 6] == @view(a[BandRange, 6]) == [17]
            @test a[BandRange, 7] == @view(a[BandRange, 7]) == Int[]
            @test a[BandRange, 8] == @view(a[BandRange, 8]) == Int[]

            @test a[:, 1] == view(a, :, 1) == [1,2,3,0,0]
            @test a[:, 2] == view(a, :, 2) == [4,5,6,7,0]
            @test a[:, 3] == view(a, :, 3) == [0,8,9,10,11]
            @test a[:, 4] == view(a, :, 4) == [0,0,12,13,14]
            @test a[:, 5] == view(a, :, 5) == [0,0,0,15,16]
            @test a[:, 6] == view(a, :, 6) == [0,0,0,0,17]
            @test a[:, 7] == view(a, :, 7) == [0,0,0,0,0]
            @test a[:, 8] == view(a, :, 8) == [0,0,0,0,0]

            @test_throws BoundsError a[:, 0] = [1, 2, 3]
            @test_throws DimensionMismatch a[:, 1] = [1, 2, 3]
            @test_throws BoundsError a[BandRange, 0] = [1, 2, 3]
            @test_throws BoundsError a[BandRange, 9] = [1, 2, 3]
            @test_throws DimensionMismatch a[BandRange, 1] = [1, 2]
        end

        @testset "scalar integer - - BandRange/Colon" begin
            a = BandedMatrix(Ones(5, 5), (1, 1))
            # 1.0  1.0  0.0  0.0  0.0
            # 1.0  1.0  1.0  0.0  0.0
            # 0.0  1.0  1.0  1.0  0.0
            # 0.0  0.0  1.0  1.0  1.0
            # 0.0  0.0  0.0  1.0  1.0

            # in band
            a[1, BandRange] .= 2
            a[2, BandRange] .= 3
            a[3, BandRange] .= 4
            a[4, BandRange] .= 5
            a[5, BandRange] .= 6
            @test a ==  [2  2  0  0  0;
                         3  3  3  0  0;
                         0  4  4  4  0;
                         0  0  5  5  5;
                         0  0  0  6  6]

            @test a[1, BandRange] == [2, 2]
            @test a[2, BandRange] == [3, 3, 3]
            @test a[3, BandRange] == [4, 4, 4]
            @test a[4, BandRange] == [5, 5, 5]
            @test a[5, BandRange] == [6, 6]

            @test_throws BoundsError a[0, :] .= 1
            @test_throws BandError a[1, :] .= 1
            @test_throws BoundsError a[0, BandRange] .= 1
            @test_throws BoundsError a[6, BandRange] .= 1

            a = BandedMatrix(Ones(5, 3), (2, -1))
            @test isempty(a[1,BandRange])
            a[2,BandRange] = [1]
            a[3,BandRange] = [2, 2]
            a[4,BandRange] = [3, 3]
            a[5,BandRange] = [4]

            @test a ==   [0 0 0;
                          1 0 0;
                          2 2 0;
                          0 3 3;
                          0 0 4]
        end

        @testset "vector - integer - BandRange/Colon" begin
            a = BandedMatrix(Ones{Int}(8, 5), (1, 2))
            # 5x7 BandedMatrices.BandedMatrix{Float64}:
            #  1.0  1.0    0    0    0    0   0   0
            #  1.0  1.0  1.0    0    0    0   0   0
            #  1.0  1.0  1.0  1.0    0    0   0   0
            #    0  1.0  1.0  1.0  1.0    0   0   0
            #    0    0  1.0  1.0  1.0  1.0   0   0

            # in band
            a[1, BandRange] = [1,   2,  3]
            a[2, BandRange] = [4,   5,  6,  7]
            a[3, BandRange] = [8,   9, 10, 11]
            a[4, BandRange] = [12, 13, 14]
            a[5, BandRange] = [15, 16]
            a[6, BandRange] = [17]

            @test a == [ 1  4   0   0   0   0   0   0;
                         2  5   8   0   0   0   0   0;
                         3  6   9  12   0   0   0   0;
                         0  7  10  13  15   0   0   0;
                         0  0  11  14  16  17   0   0]'

            @test a[1, BandRange] == @view(a[1, BandRange]) == [1,   2,  3]
            @test a[2, BandRange] == @view(a[2, BandRange]) == [4,   5,  6,  7]
            @test a[3, BandRange] == @view(a[3, BandRange]) == [8,   9, 10, 11]
            @test a[4, BandRange] == @view(a[4, BandRange]) == [12, 13, 14]
            @test a[5, BandRange] == @view(a[5, BandRange]) == [15, 16]
            @test a[6, BandRange] == @view(a[6, BandRange]) == [17]
            @test a[7, BandRange] == @view(a[7, BandRange]) == Int[]
            @test a[8, BandRange] == @view(a[7, BandRange]) == Int[]

            @test a[1, :] == @view(a[1, :]) == [1,2,3,0,0]
            @test a[2, :] == @view(a[2, :]) == [4,5,6,7,0]
            @test a[3, :] == @view(a[3, :]) == [0,8,9,10,11]
            @test a[4, :] == @view(a[4, :]) == [0,0,12,13,14]
            @test a[5, :] == @view(a[5, :]) == [0,0,0,15,16]
            @test a[6, :] == @view(a[6, :]) == [0,0,0,0,17]
            @test a[7, :] == @view(a[7, :]) == [0,0,0,0,0]
            @test a[8, :] == @view(a[7, :]) == [0,0,0,0,0]

            @test_throws BoundsError a[0, :] = [1, 2, 3]
            @test_throws DimensionMismatch a[1, :] = [1, 2, 3]
            @test_throws BoundsError a[0, BandRange] = [1, 2, 3]
            @test_throws BoundsError a[9, BandRange] = [1, 2, 3]
            @test_throws DimensionMismatch a[1, BandRange] = [1, 2]

            a = BandedMatrix(ones(2, 5), (-2, 2))
            # 0.0 0.0 1.0 0.0 0.0
            # 0.0 0.0 0.0 1.0 0.0
            @test a[1,:] == [0, 0, 1, 0, 0]
            @test a[2,:] == [0, 0, 0, 1, 0]
        end


        # scalar - range - integer
        let
            a = BandedMatrix(Ones(3, 4), (2, 1))
            # 1.0  1.0  0.0  0.0
            # 1.0  1.0  1.0  0.0
            # 1.0  1.0  1.0  1.0

            # Matrix column span
            a[1:3, 1] .= 1
            a[1:3, 2] .= 2
            a[2:3, 3] .= 3
            a[3:3, 4] .= 4
            @test a == [ 1  2  0  0;
                         1  2  3  0;
                         1  2  3  4]

            # partial span
            a[1:1, 1] .= 3
            a[2:3, 2] .= 4
            a[3:3, 3] .= 5
            @test a == [ 3  2  0  0;
                         1  4  3  0;
                         1  4  5  4]

             a[:, 1] = [1, 1, 1]
             a[:, 2] = [2, 2, 2]
             a[:, 3] = [0, 3, 3]
             a[:, 4] = [0, 0, 4]

             @test a == [ 1  2  0  0;
                          1  2  3  0;
                          1  2  3  4]

            # wrong range input
            @test_throws BoundsError   a[0:1, 1] .= 3
            @test_throws BoundsError   a[1:4, 1] .= 3
            @test_throws BandError a[2:3, 4] .= 3
            @test_throws BoundsError   a[3:4, 4] .= 3
        end

        # vector - range - integer
        let
            a = BandedMatrix(Ones(5, 4), (1, 2))
            # 1.0  1.0  1.0  0.0
            # 1.0  1.0  1.0  1.0
            # 0.0  1.0  1.0  1.0
            # 0.0  0.0  1.0  1.0
            # 0.0  0.0  0.0  1.0
            # Matrix column span
            a[1:2, 1] = 1:2
            a[1:3, 2] = 3:5
            a[1:4, 3] = 6:9
            a[2:5, 4] = 10:13
            @test a == [1  3  6   0;
                        2  4  7  10;
                        0  5  8  11;
                        0  0  9  12;
                        0  0  0  13]

            # partial span
            a[1:1, 1] = [2]
            a[2:3, 2] = 1:2
            a[3:4, 3] = 3:4
            a[4:5, 4] = 3:4
            @test a == [2  3  6   0;
                        2  1  7  10;
                        0  2  3  11;
                        0  0  4   3;
                        0  0  0   4]

            # wrong range input
            @test_throws BoundsError a[1:2, 0] = 1:2
            @test_throws BoundsError a[0:1, 1] = 1:2
            @test_throws BoundsError a[1:8, 1] = 1:8
            @test_throws BoundsError a[2:6, 4] = 2:6
            @test_throws BoundsError a[3:4, 5] = 3:4

            a[:, 1] = [1,1,0,0,0]
            a[:, 2] = [2,2,2,0,0]
            a[:, 3] = [3,3,3,3,0]
            a[:, 4] = [0,4,4,4,4]

            @test a == [1  2  3   0;
                        1  2  3   4;
                        0  2  3   4;
                        0  0  3   4;
                        0  0  0   4]
        end
    end


    @testset "indexing along a row" begin
        # scalar - integer - BandRange/colon
        let
            a = BandedMatrix(Ones(5, 5), (1, 1))
            # 1.0  1.0  0.0  0.0  0.0
            # 1.0  1.0  1.0  0.0  0.0
            # 0.0  1.0  1.0  1.0  0.0
            # 0.0  0.0  1.0  1.0  1.0
            # 0.0  0.0  0.0  1.0  1.0

            # in band
            a[1, BandRange] .= 2
            a[2, BandRange] .= 3
            a[3, BandRange] .= 4
            a[4, BandRange] .= 5
            a[5, BandRange] .= 6

            @test a == [2  2  0  0  0;
                        3  3  3  0  0;
                        0  4  4  4  0;
                        0  0  5  5  5;
                        0  0  0  6  6]


            @test_throws BoundsError a[0, :] .= 1
            @test_throws BandError a[1, :] .= 1
            @test_throws BoundsError a[0, BandRange] .= 1
            @test_throws BoundsError a[6, BandRange] .= 1

            a[1, :] .= 0
            @test vec(a[1, :]) == [0, 0, 0, 0, 0]
        end



        # vector - integer - BandRange/colon
        let
            a = BandedMatrix(Ones(7, 5), (1, 2))
            # 7x5 BandedMatrices.BandedMatrix{Float64}:
            # 1.0  1.0  1.0  0.0  0.0
            # 1.0  1.0  1.0  1.0  0.0
            # 0.0  1.0  1.0  1.0  1.0
            # 0.0  0.0  1.0  1.0  1.0
            # 0.0  0.0  0.0  1.0  1.0
            # 0.0  0.0  0.0  0.0  1.0
            # 0.0  0.0  0.0  0.0  0.0

            # in band
            a[1, BandRange] = [1,   2,  3]
            a[2, BandRange] = [4,   5,  6,  7]
            a[3, BandRange] = [8,   9, 10, 11]
            a[4, BandRange] = [12, 13, 14]
            a[5, BandRange] = [15, 16]
            a[6, BandRange] = [17]

            @test a ==  [1  2   3   0   0;
                         4  5   6   7   0;
                         0  8   9  10  11;
                         0  0  12  13  14;
                         0  0   0  15  16;
                         0  0   0   0  17;
                         0  0   0   0   0]

            @test_throws BoundsError a[0, :] = [1, 2, 3]
            @test_throws DimensionMismatch a[1, :] = [1, 2, 3]
            @test_throws BoundsError a[0, BandRange] = [1, 2, 3]
            @test_throws BoundsError a[8, BandRange] = [1, 2, 3]
            @test_throws DimensionMismatch a[1, BandRange] = [1, 2]
            @test_throws DimensionMismatch a[7, BandRange] = [1, 2, 3]

            a[7, BandRange] .= 1
            @test a ==  [1  2   3   0   0;
                         4  5   6   7   0;
                         0  8   9  10  11;
                         0  0  12  13  14;
                         0  0   0  15  16;
                         0  0   0   0  17;
                         0  0   0   0   0]
        end


        # scalar - integer - range
        let
            a = BandedMatrix(Ones(7, 5), (1, 2))
            # 7x5 BandedMatrices.BandedMatrix{Float64}:
            # 1.0  1.0  1.0  0.0  0.0
            # 1.0  1.0  1.0  1.0  0.0
            # 0.0  1.0  1.0  1.0  1.0
            # 0.0  0.0  1.0  1.0  1.0
            # 0.0  0.0  0.0  1.0  1.0
            # 0.0  0.0  0.0  0.0  1.0
            # 0.0  0.0  0.0  0.0  0.0

            # in band
            a[1, 1:3] .= 2
            a[2, 1:4] .= 3
            a[3, 2:5] .= 4
            a[4, 3:5] .= 5
            a[5, 4:5] .= 6
            a[6, 5:5] .= 7

            @test a ==  [2  2  2  0  0;
                         3  3  3  3  0;
                         0  4  4  4  4;
                         0  0  5  5  5;
                         0  0  0  6  6;
                         0  0  0  0  7;
                         0  0  0  0  0]

            a[1, 1:4] .= 0

            @test a ==  [0  0  0  0  0;
                         3  3  3  3  0;
                         0  4  4  4  4;
                         0  0  5  5  5;
                         0  0  0  6  6;
                         0  0  0  0  7;
                         0  0  0  0  0]

            @test_throws BoundsError a[0, 1:3] .= 1
            @test_throws BoundsError a[8, 2:3] .= 1
            @test_throws BoundsError a[1, 0:3] .= 1
            @test_throws BoundsError a[4, 4:6] .= 1

            @test_throws BandError a[1, 1:4] .= 1
        end

        # vector - integer - range
        let
            a = BandedMatrix(Ones(7, 5), (1, 2))
            # 7x5 BandedMatrices.BandedMatrix{Float64}:
            # 1.0  1.0  1.0  0.0  0.0
            # 1.0  1.0  1.0  1.0  0.0
            # 0.0  1.0  1.0  1.0  1.0
            # 0.0  0.0  1.0  1.0  1.0
            # 0.0  0.0  0.0  1.0  1.0
            # 0.0  0.0  0.0  0.0  1.0
            # 0.0  0.0  0.0  0.0  0.0

            # in band
            a[1, 1:3] = [1, 2, 3]
            a[2, 1:4] = [1, 2, 3, 4]
            a[3, 2:5] = [1, 2, 3, 4]
            a[4, 3:5] = [1, 2, 3]
            a[5, 4:5] = [1, 2]
            a[6, 5:5] = [1]

            @test a ==  [1  2  3  0  0;
                         1  2  3  4  0;
                         0  1  2  3  4;
                         0  0  1  2  3;
                         0  0  0  1  2;
                         0  0  0  0  1;
                         0  0  0  0  0]

            @test_throws BoundsError a[0, 1:3] = [1, 2, 3]
            @test_throws BoundsError a[8, 2:3] = [1, 2]
            @test_throws BoundsError a[1, 0:3] = [1, 2, 3, 4]
            @test_throws BoundsError a[4, 4:6] = [2, 3]

            @test_throws BandError a[1, 1:4] = [1, 2, 3, 4]
            @test_throws BoundsError a[7, 6:7] = [1, 2]
            @test_throws DimensionMismatch a[1, 1:3] = [1, 2]
        end
    end

    @testset "indexing along a band" begin
        let
            a = BandedMatrix(Zeros(5, 4), (2, 1))
            # 5x4 BandedMatrices.BandedMatrix{Float64}:
            #  0.0  0.0
            #  0.0  0.0  0.0
            #  0.0  0.0  0.0  0.0
            #       0.0  0.0  0.0
            #            0.0  0.0
            a[band(-2)] .= 5
            a[band(-1)] .= 1
            a[band( 0)] .= 2
            a[band( 1)] .= 3

            @test Matrix(a) == [ 2  3  0  0;
                               1  2  3  0;
                               5  1  2  3;
                               0  5  1  2;
                               0  0  5  1]

            @test_throws BandError a[band(-3)] .= 1

            a[band(-2)] = [4, 4, 4]
            a[band(-1)] = [1, 2, 3, 4]
            a[band( 0)] = [5, 6, 7, 8]
            a[band( 1)] = [9, 10, 11]

            @test Matrix(a) == [ 5  9   0   0;
                               1  6  10   0;
                               4  2   7  11;
                               0  4   3   8;
                               0  0   4   4]

            @test a[band(-2)] == [4, 4, 4]
            @test a[band(-1)] == [1, 2, 3, 4]
            @test a[band( 0)] == [5, 6, 7, 8]
            @test a[band( 1)] == [9, 10, 11]


            @test_throws BandError a[band(-3)] = [1, 2, 3]
        end


        let
            a = BandedMatrix(Zeros(5, 4), (2, 2))
            # 5x4 BandedMatrices.BandedMatrix{Float64}:
            #  0.0  0.0  0.0
            #  0.0  0.0  0.0  0.0
            #  0.0  0.0  0.0  0.0
            #       0.0  0.0  0.0
            #            0.0  0.0
            a[band(-2)] .= 5
            a[band(-1)] .= 1
            a[band( 0)] .= 2
            a[band( 1)] .= 3
            a[band( 2)] .= 4

            @test Matrix(a) == [ 2  3  4  0;
                               1  2  3  4;
                               5  1  2  3;
                               0  5  1  2;
                               0  0  5  1]

            @test_throws BandError a[band(-3)] .= 1

            a[band(-2)] = [4,  4,  4]
            a[band(-1)] = [1,  2,  3, 4]
            a[band( 0)] = [5,  6,  7, 8]
            a[band( 1)] = [9,  10, 11]
            a[band( 2)] = [12, 13]

            @test Matrix(a) == [ 5  9   12  0;
                               1  6  10  13;
                               4  2   7  11;
                               0  4   3   8;
                               0  0   4   4]

            @test a[band(-2)] == [4, 4, 4]
            @test a[band(-1)] == [1, 2, 3, 4]
            @test a[band( 0)] == [5, 6, 7, 8]
            @test a[band( 1)] == [9, 10, 11]
            @test a[band( 2)] == [12, 13]


            @test_throws BandError a[band(-3)] = [1, 2, 3]
        end
    end

    @testset "views of band views" begin
        A = BandedMatrix(0=>1:4, 1=>(1:3) .+ 5, -1=>(1:3) .+ 10)
        v = @view A[band(1)]
        w = view(v, 2:3)
        @test w == [7,8]
        @test parentindices(w) isa Tuple{AbstractRange}
    end

    @testset "other special indexing" begin
        @testset "all elements" begin
            a = BandedMatrix(Ones(3, 3), (1, 1))
            a[:] .= 0
            @test a == [0 0 0;
                        0 0 0;
                        0 0 0]

            # all rows/cols
            a.data .= 2
            @test a == [2 2 0;
                        2 2 2;
                        0 2 2]

            a[:, :] = [3 3 0;
                        3 3 3;
                        0 3 3]
            @test a == [3 3 0;
                        3 3 3;
                        0 3 3]

            @test_throws BandError a[:] .= 1
            @test_throws BandError a[:,:] .= 1
            @test_throws BandError a[:,:] = ones(3,3)
        end

        @testset "replace a block in the band" begin
            a = BandedMatrix(Zeros(5, 4), (2, 1))
            # 5x4 BandedMatrices.BandedMatrix{Float64}:
            #  0.0  0.0
            #  0.0  0.0  0.0
            #  0.0  0.0  0.0  0.0
            #       0.0  0.0  0.0
            #            0.0  0.0
            a[1:3, 1:2] .= 2
            a[3:5, 3:4] = [1 2;
                           3 4;
                           5 6]
            @test Matrix(a) == [2  2  0 0;
                              2  2  0 0;
                              2  2  1 2;
                              0  0  3 4;
                              0  0  5 6]

            @test_throws BoundsError a[0:3, 1:2] .= 2
            @test_throws BoundsError a[3:6, 3:4] .= 2
            @test_throws BoundsError a[1:3, 0:2] .= 2
            @test_throws BoundsError a[3:5, 3:5] .= 2
            @test_throws BoundsError a[0:3, 1:2] = [1 2; 3 4]
            @test_throws BoundsError a[3:6, 3:4] = [1 2; 3 4]
            @test_throws BoundsError a[1:3, 0:2] = [1 2; 3 4]
            @test_throws BoundsError a[3:5, 3:5] = [1 2; 3 4]

            @test_throws BandError a[1:3, 1:3] .= 2
            @test_throws BandError a[1:3, 1:3] = rand(3, 3)

            @test_throws DimensionMismatch a[1:3, 1:2] = rand(3, 3)

            s = BandedMatrix(view(a,1:3,1:2))
            @test isa(s,BandedMatrix)
            @test Matrix(s) == a[1:3,1:2]
        end

        @testset "tests bug" begin
            a = BandedMatrix(Zeros(1,1), (3,-1))
            @test a[band(-2)] == Float64[]
        end

        @testset "band views" begin
            for AA in (rand(11,10), brand(11,10,2,3), brand(Float32, 11,10,2,3),
                         brand(ComplexF64, 11,10,2,3))
                for A in (AA, view(AA, 1:size(AA,1)-1, 1:size(AA,2)-2))
                    for k = -5:5
                        V = view(A, band(k))
                        bs = BandedMatrices.parentindices(V)[1] # a bandslice
                        @test bs.indices == diagind(A, k)
                        @test bs.band == Band(k)
                        @test collect(bs) == collect(diagind(A, k))
                        @test view(bs, 1:length(bs)) === view(diagind(A, k), 1:length(bs))
                        @test Vector{eltype(A)}(V) == collect(V) == A[diagind(A,k)] == A[band(k)]
                        @test Vector{ComplexF64}(V) == Vector{ComplexF64}(A[diagind(A,k)]) ==
                                convert(AbstractVector{ComplexF64}, V) == convert(AbstractArray{ComplexF64}, V)
                        @test V ≡ convert(AbstractArray, V) ≡ convert(AbstractArray{eltype(A)}, V) ≡
                                convert(AbstractArray, V) ≡ convert(AbstractVector, V)

                        V .= 0
                        @test all(iszero, A[band(k)])
                    end
                end
            end
            A = BandedMatrix(0=>1:4, 1=>5:7, -1=>8:10)
            B = view(A, 2:4, 1:3)
            @test B[band(0)] == A[band(-1)]
            @test B[band(1)] == A[band(0)][2:3]
            @test_throws BoundsError view(B, band(-1))[3]
        end
    end

    @testset "Sub-banded views" begin
        A = brand(10,10,2,1)
        for V in (view(A,Base.OneTo(5),Base.OneTo(6)), view(A,1:5,1:6))
            @test MemoryLayout(typeof(V)) == BandedColumns{DenseColumnMajor}()
            @test V isa BandedMatrices.BandedSubBandedMatrix
            @test V[3,3] == BandedMatrices.inbands_getindex(V,3,3) == A[3,3]
            V[3,3] = 2
            @test V[3,3] == BandedMatrices.inbands_getindex(V,3,3) == A[3,3] == 2
            BandedMatrices.inbands_setindex!(V,5,3,3)
            @test V[3,3] == BandedMatrices.inbands_getindex(V,3,3) == A[3,3] == 5
        end

        @test A[Base.OneTo(5),Base.OneTo(6)] isa BandedMatrix
        @test A[2:5,Base.OneTo(6)] isa BandedMatrix
        @test A[2:2:5,Base.OneTo(6)] isa Matrix
    end
end

end # module

"""
    Band(i)

Index selector for the diagonal at offset `i` of a banded matrix. `Band(0)` selects the
main diagonal, positive offsets select superdiagonals, and negative offsets select
subdiagonals.

# Fields

- `i::Int`: Diagonal offset from the main diagonal.

# Arguments

- `i::Int`: Diagonal offset to select.

# Examples

```jldoctest
julia> A = BandedMatrix(0 => 1:3, 1 => 4:5);

julia> A[Band(0)] == [1, 2, 3]
true

julia> A[Band(1)] == [4, 5]
true
```
"""
struct Band
    i::Int
end

show(io::IO, r::Band) = print(io, "Band(", r.i, ")")

"""
    band(i)

Represents the `i`-th band of a banded matrix.

```jldoctest
julia> using BandedMatrices

julia> A = BandedMatrix(0=>1:4, 1=>5:7, -1=>8:10)
4×4 BandedMatrix{Int64} with bandwidths (1, 1):
 1  5   ⋅  ⋅
 8  2   6  ⋅
 ⋅  9   3  7
 ⋅  ⋅  10  4

julia> A[band(1)]
3-element Vector{Int64}:
 5
 6
 7

julia> A[band(0)]
4-element Vector{Int64}:
 1
 2
 3
 4

julia> A[band(-1)]
3-element Vector{Int64}:
  8
  9
 10
```
"""
band(i::Int) = Band(i)


struct BandRangeType end
"""
    BandRange

Represents the entries in a row/column inside the bands.

```jldoctest
julia> using BandedMatrices

julia> A = BandedMatrix(0=>1:4, 1=>5:7, -1=>8:10)
4×4 BandedMatrix{Int64} with bandwidths (1, 1):
 1  5   ⋅  ⋅
 8  2   6  ⋅
 ⋅  9   3  7
 ⋅  ⋅  10  4

julia> A[2, BandRange]
3-element Vector{Int64}:
 8
 2
 6
```
"""
const BandRange = BandRangeType()

to_indices(A::AbstractArray, (_, j)::Tuple{BandRangeType,Integer}) = (colrange(A, j), j)
to_indices(A::AbstractArray, (k, _)::Tuple{Integer,BandRangeType}) = (k, rowrange(A, k))

"""
    BandError(A, i)
    BandError(A, (k, j))
    BandError(A)

Exception thrown when an operation accesses diagonal offset `i` outside the stored lower
and upper bandwidths of `A`.

# Fields

- `A::AbstractMatrix`: Matrix whose band structure rejects the access.
- `i::Int`: Requested diagonal offset, with positive offsets above and negative offsets
  below the main diagonal.

# Arguments

- `A::AbstractMatrix`: Matrix whose band structure is being accessed.
- `i::Int`: Requested diagonal offset.
- `(k, j)::Tuple{Int, Int}`: Matrix coordinates from which the diagonal offset `j - k` is
  computed.

# Examples

```jldoctest
julia> A = BandedMatrix(0 => 1:3);

julia> BandError(A, 1) isa BandError
true
```
"""
struct BandError <: Exception
    A::AbstractMatrix
    i::Int
end

# shorthand to specify k and j without calculating band
BandError(A::AbstractMatrix, (k, j)::Tuple{Int,Int}) = BandError(A, j-k)
BandError(A::AbstractMatrix) = BandError(A, max(size(A)...)-1)

function showerror(io::IO, e::BandError)
    A, i = e.A, e.i
    print(io, "BandError: attempt to access $(typeof(A)) with bandwidths " *
              "($(bandwidth(A, 1)), $(bandwidth(A, 2))) at band $i")
end


# length of diagonal
@inline diaglength(A::AbstractMatrix, b::Band) = diaglength(A, b.i)
@inline function diaglength(A::AbstractMatrix, i::Integer)
    max(min(size(A, 2), size(A, 1)+i) - max(0, i), 0)
end


# check indices fall in the band
checkband(A::AbstractMatrix, i::Integer) =
    (-bandwidth(A, 1) ≤ i ≤ bandwidth(A, 2) || throw(BandError(A, i)))

checkband(A::AbstractMatrix, b::Band) = checkband(A, b.i)

checkband(A::AbstractMatrix, k::Integer, j::Integer) = checkband(A, j-k)

checkband(A::AbstractMatrix, kr::AbstractRange, j::Integer) =
    (checkband(A, first(kr), j); checkband(A,  last(kr), j))

checkband(A::AbstractMatrix, k::Integer, jr::AbstractRange) =
    (checkband(A, k, first(jr)); checkband(A, k,  last(jr)))

checkband(A::AbstractMatrix, kr::AbstractRange, jr::AbstractRange) =
    (checkband(A, kr, first(jr)); checkband(A, kr,  last(jr)))


# checks if the bands match A
function checkbandmatch(A::AbstractMatrix{T}, V::AbstractVector, ::Colon, j::Integer) where {T}
    for k = 1:colstart(A,j)-1
        if V[k] ≠ zero(T)
            throw(BandError(A, (k,j)))
        end
    end
    for k = colstop(A,j)+1:size(A,1)
        if V[k] ≠ zero(T)
            throw(BandError(A, (k,j)))
        end
    end
end

function checkbandmatch(A::AbstractMatrix{T}, V::AbstractVector, kr::AbstractRange, j::Integer) where {T}
    a = colstart(A, j)
    b = colstop(A, j)
    i = 0
    for v in V
        k = kr[i+=1]
        if (k < a || k > b) && v ≠ zero(T)
            throw(BandError(A, (k,j)))
        end
    end
end

function checkbandmatch(A::AbstractMatrix{T}, V::AbstractVector, k::Integer, ::Colon) where {T}
    for j = 1:rowstart(A,k)-1
        if V[j] ≠ zero(T)
            throw(BandError(A, (k,j)))
        end
    end
    for j = rowstop(A,k)+1:size(A,2)
        if V[j] ≠ zero(T)
            throw(BandError(A, (k,j)))
        end
    end
end

function checkbandmatch(A::AbstractMatrix{T}, V::AbstractVector, k::Integer, jr::AbstractRange) where {T}
    a = rowstart(A, k)
    b = rowstop(A, k)
    i = 0
    for v in V
        j = jr[i+=1]
        if (j < a || j > b) && v ≠ zero(T)
            throw(BandError(A, (k,j)))
        end
    end
end

function checkbandmatch(A::AbstractMatrix{T}, V::AbstractMatrix, kr::AbstractRange, jr::AbstractRange) where {T}
    l, u = bandwidths(A)
    jj = 1
    for j in jr
        kk = 1
        for k in kr
            if !(-l ≤ j - k ≤ u) && V[kk, jj] ≠ zero(T)
                # we index V manually in column-major order
                throw(BandError(A, (k,j)))
            end
            kk += 1
        end
        jj += 1
    end
end

checkbandmatch(A::AbstractMatrix, V::AbstractMatrix, ::Colon, ::Colon) =
    checkbandmatch(A, V, 1:size(A,1), 1:size(A,2))

"""
    BandSlice(band::Band, indices)

Represent a range of indices corresponding to a band.

Upon calling `to_indices`, `Band`s are converted to `BandSlice` objects to represent
the indices over which the `Band` spans.

This mimics the relationship between `Colon` and `Base.Slice`.

# Example
```jldoctest
julia> B = BandedMatrix(0 => 1:4, 1=>1:3);

julia> bs = to_indices(B, (Band(1),))[1];

julia> bs isa BandedMatrices.BandSlice
true

julia> using LinearAlgebra

julia> bs == diagind(B, 1)
true
```
"""
struct BandSlice{T, R<:AbstractRange{T}} <: AbstractRange{T}
    band::Band
    indices::R
end

for f in (:indices, :unsafe_indices, :axes1, :first, :last, :size, :length,
          :unsafe_length, :start, :step)
    @eval $f(S::BandSlice) = $f(S.indices)
end

@propagate_inbounds getindex(S::BandSlice, i::Union{Int, AbstractRange{<:Integer}}) = getindex(S.indices, i)
@propagate_inbounds view(S::BandSlice, i::AbstractRange{<:Integer}) = view(S.indices, i)
show(io::IO, r::BandSlice) = print(io, BandSlice, "(", r.band, ", ", r.indices, ")")

to_index(::Band) = throw(ArgumentError("Block must be converted by to_indices(...)"))

"""
" the following is designed to supported infinite baned arrays
"""

band_to_indices(A, _, b) = (BandSlice(b, diagind(A, b.i)),)
@inline to_indices(A, I::Tuple{Band}) = band_to_indices(A, axes(A), I[1])
view(A::AbstractArray, I::Band) = view(A, to_indices(A, (I,))...)

###########
# This gives an example of Gauss–Seidel
#
# It is _much_ more efficient to use BlockBandedMatrices.jl
###########


using BandedMatrices, LazyBandedMatrices, LazyArrays, LinearAlgebra

function finitedifference_2d(n)
    h = 1/n
    D² = BandedMatrix(0 => Fill(-2,n), 1 => Fill(1,n-1), -1 => Fill(1,n-1))/h^2
    D_xx = kron(D², Eye(n))
    D_yy = kron(Eye(n), D²)
    D_xx + D_yy
end

function gaussseidel(L, U, b, x=copy(b), M=5)
    for _=1:M
        @view(x[1:end-1]) .= Mul(U , @view(x[2:end]))
        x[end] = 0
        x .= b .- x
        x .= Ldiv(L, x)
    end
    x
end

n = 400
Δt = (1/n^2)/4; Δ = finitedifference_2d(n); A = I - Δt*Δ  # 160k x 160k discretization

L = LowerTriangular(A)
U = UpperTriangular(@view A[1:end-1,2:end])

b = randn(size(A,1));
@time u = A\b; # 6s
x = copy(b)
@time gaussseidel(L,U, b, x, 20) # 1.6s
norm(x - u) # 6*10^(-10)

module TestDot

using BandedMatrices, LinearAlgebra, FillArrays, Test
import BandedMatrices: _BandedMatrix
using Random

@testset "dot(x, A::BandedMatrix, y)" begin
    Random.seed!(0)
    @testset "Single, constant diagonal" begin
        for (m,n,l) in [(100,15,5),(15,100,-5)]
            S = _BandedMatrix(0.1Ones{Int}(1,n), Base.OneTo(m), l, -l)
            MS = Matrix(S)

            a = rand(ComplexF64, m)
            b = rand(ComplexF64, n)

            v = dot(a, MS, b)
            ref = dot(a, S, b)
            @test v ≈ ref rtol=1e-14
        end
    end

    @testset "Multiple, random diagonals" begin
        for cols in [2000,500]
            for (l,u) in [(3,-1), (1,1), (-1,3)]
                S = _BandedMatrix(rand(3,cols), Base.OneTo(1000), l, u)
                MS = Matrix(S)
                m,n = size(S)

                a = rand(ComplexF64, m)
                b = rand(ComplexF64, n)

                v = dot(a, S, b)
                ref = dot(a, MS, b)

                @test v ≈ ref rtol=1e-14
            end
        end
    end
end

end # module

bandwidths(M::Union{MulAdd, Lmul, Rmul, ArrayLayouts.Mul}) = min.(_bnds(M), prodbandwidths(M.A,M.B))

similar(M::MulAdd{<:DiagonalLayout,<:AbstractBandedLayout}, ::Type{T}, axes::NTuple{2,OneTo{Int}}) where T =
    BandedMatrix{T}(undef, axes, bandwidths(M))
similar(M::MulAdd{<:AbstractBandedLayout,<:AbstractBandedLayout}, ::Type{T}, axes::NTuple{2,OneTo{Int}}) where T =
    BandedMatrix{T}(undef, axes, bandwidths(M))
similar(M::MulAdd{<:AbstractBandedLayout,<:DiagonalLayout}, ::Type{T}, axes::NTuple{2,OneTo{Int}}) where T =
    BandedMatrix{T}(undef, axes, bandwidths(M))
similar(M::MulAdd{<:SymmetricLayout{<:AbstractBandedLayout},<:AbstractBandedLayout}, ::Type{T}, axes::NTuple{2,OneTo{Int}}) where T =
    BandedMatrix{T}(undef, axes, bandwidths(M))
similar(M::MulAdd{<:HermitianLayout{<:AbstractBandedLayout},<:AbstractBandedLayout}, ::Type{T}, axes::NTuple{2,OneTo{Int}}) where T =
    BandedMatrix{T}(undef, axes, bandwidths(M))
similar(M::MulAdd{<:TriangularLayout{uplo,trans,<:AbstractBandedLayout},<:AbstractBandedLayout}, ::Type{T}, axes::NTuple{2,OneTo{Int}}) where {uplo,trans,T} =
    BandedMatrix{T}(undef, axes, bandwidths(M))
##
# BLAS routines
##

# make copy to make sure always works

banded_gbmv!(tA, α, A, x, β, y) =
    BLAS.gbmv!(tA, size(A,1), bandwidth(A,1), bandwidth(A,2),
                α, bandeddata(A), x, β, y)


@inline function _banded_gbmv!(tA, α, A, x, β, y, yzero=false)
    #= Some BLAS implementations throw warnings
    with zero-sized arrays, so we handle
    these cases separately.
    =#
    length(y) == 0 && return y
    if length(x) == 0
        _fill_rmul!(y, β, yzero)
    else
        xc = Base.unalias(y, x)
        banded_gbmv!(tA, α, A, xc, β, y)
    end
    return y
end

function _banded_muladd!(α, A, x::AbstractVector, β, y, yzero)
    m, n = size(A)
    l, u = bandwidths(A)
    if -l > u # no bands
        _fill_rmul!(y, β, yzero)
    elseif l < 0 # with u >= -l > 0, that is, all bands lie above the diagonal
        # E.g. (l,u) = (-1,2)
        # set lview = 0 and uview = u + l >= 0
        _banded_gbmv!('N', α, view(A, :, 1-l:n), view(x, 1-l:n), β, y, yzero)
    elseif u < 0 # with -l <= u < 0, that is, all bands lie below the diagnoal.
        # E.g. (l,u) = (2,-1)
        # set lview = l + u >= 0 and uview = 0
        _fill_rmul!(@view(y[1:-u]), β, yzero)
        _banded_gbmv!('N', α, view(A, 1-u:m, :), x, β, view(y, 1-u:m), yzero)
        y
    else
        _banded_gbmv!('N', α, A, x, β, y, yzero)
    end
end

function materialize!(M::BlasMatMulVecAdd{<:BandedColumnMajor,<:AbstractStridedLayout,<:AbstractStridedLayout,<:BlasFloat})
    checkdimensions(M)
    _banded_muladd!(M.α, M.A, M.B, M.β, M.C, M.Czero)
end

function _banded_muladd_row!(tA, α, At, x, β, y, yzero=false)
    n, m = size(At)
    u, l = bandwidths(At)
    if -l > u # no bands
        _fill_rmul!(y, β, yzero)
    elseif l < 0
        _banded_gbmv!(tA, α, view(At, 1-l:n, :,), view(x, 1-l:n), β, y, yzero)
    elseif u < 0
        _fill_rmul!(@view(y[1:-u]), β, yzero)
        _banded_gbmv!(tA, α, view(At, :, 1-u:m), x, β, view(y, 1-u:m), yzero)
        y
    else
        _banded_gbmv!(tA, α, At, x, β, y, yzero)
    end
end

function materialize!(M::BlasMatMulVecAdd{<:BandedRowMajor,<:AbstractStridedLayout,<:AbstractStridedLayout,<:BlasFloat})
    checkdimensions(M)
    α, A, x, β, y, yzero = M.α, M.A, M.B, M.β, M.C, M.Czero
    _banded_muladd_row!('T', α, transpose(A), x, β, y, yzero)
end

function materialize!(M::BlasMatMulVecAdd{<:ConjLayout{<:BandedRowMajor},<:AbstractStridedLayout,<:AbstractStridedLayout,<:BlasComplex})
    checkdimensions(M)
    α, A, x, β, y, yzero = M.α, M.A, M.B, M.β, M.C, M.Czero
    _banded_muladd_row!('C', α, A', x, β, y, yzero)
end



##
# Non-BLAS mat vec
##

@inline function materialize!(M::MatMulVecAdd{<:AbstractBandedLayout})
    checkdimensions(M)
    α,A,B,β,C = M.α,M.A,M.B,M.β,M.C
    _fill_rmul!(M, β)
    @inbounds for j = intersect(rowsupport(A), colsupport(B))
        for k = colrange(A,j)
            C[k] += inbands_getindex(A,k,j) * B[j] * α
        end
    end
    C
end

@inline function materialize!(M::MatMulVecAdd{<:BandedRowMajor})
    checkdimensions(M)
    α,At,B,β,C = M.α,M.A,M.B,M.β,M.C
    A = transpose(At)
    _fill_rmul!(M, β)

    @inbounds for j = rowsupport(A)
        for k = intersect(colrange(A,j), colsupport(B))
            C[j] +=  transpose(inbands_getindex(A,k,j)) * B[k] * α
        end
    end
    C
end

@inline function materialize!(M::MatMulVecAdd{<:ConjLayout{<:BandedRowMajor}})
    checkdimensions(M)
    α,Ac,B,β,C = M.α,M.A,M.B,M.β,M.C
    A = Ac'
    _fill_rmul!(M, β)
    @inbounds for j = rowsupport(A)
        for k = intersect(colrange(A,j), colsupport(B))
            C[j] += inbands_getindex(A,k,j)' * B[k] * α
        end
    end
    C
end


####
# Matrix * Matrix
####
function banded_mul!(C::AbstractMatrix{T}, A::AbstractMatrix, B::AbstractMatrix) where T
    Am, An = size(A)
    Bm, Bn = size(B)
    Al, Au = bandwidths(A)
    Bl, Bu = bandwidths(B)
    Cl,Cu = prodbandwidths(A, B)
    size(C) == (Am,Bn) || throw(DimensionMismatch())
    C̃l,C̃u = bandwidths(C)
    # set extra bands to zero
    @inbounds for j = 1:Bn
        for k = max(j - C̃u,1):min(j-Cu-1,Am)
            inbands_setindex!(C,zero(T),k,j)
        end
        for k = max(j + Cl+1,1):min(j+C̃l,Am)
            inbands_setindex!(C,zero(T),k,j)
        end
    end

    @inbounds for j = 1:Bn, k = max(j-Cu, 1):min(j+Cl, Am)
        νmin = max(1,k-Al,j-Bu)
        νmax = min(An,k+Au,j+Bl)

        tmp = zero(T)
        for ν=νmin:νmax
            tmp = tmp + inbands_getindex(A,k,ν) * inbands_getindex(B,ν,j)
        end
        setindex!(C,tmp,k,j)
    end
    C
end

const ConjOrBandedLayout = Union{AbstractBandedLayout,ConjLayout{<:AbstractBandedLayout}}
const ConjOrBandedColumnMajor = Union{<:BandedColumnMajor,ConjLayout{<:BandedColumnMajor}}

function _banded_muladd!(α::T, A, B::AbstractMatrix, β, C, Czero=false) where T
    gbmm!('N', 'N', α, A, B, β, C, Czero)
    C
end

materialize!(M::BlasMatMulMatAdd{<:AbstractBandedLayout,<:AbstractBandedLayout,<:BandedColumnMajor}) =
    materialize!(MulAdd(M.α, convert(DefaultBandedMatrix,M.A), convert(DefaultBandedMatrix,M.B),
        M.β, M.C; Czero = M.Czero))

function materialize!(M::BlasMatMulMatAdd{<:BandedColumnMajor,<:BandedColumnMajor,<:BandedColumnMajor})
    checkdimensions(M)
    _banded_muladd!(M.α, M.A, M.B, M.β, M.C, M.Czero)
end


# function generally_banded_matmatmul!(C::AbstractMatrix{T}, tA::Val, tB::Val, A::AbstractMatrix{U}, B::AbstractMatrix{V}) where {T, U, V}
#     Am, An = _size(tA, A)
#     Bm, Bn = _size(tB, B)
#     if An != Bm || size(C, 1) != Am || size(C, 2) != Bn
#         throw(DimensionMismatch("*"))
#     end
#     # TODO: checkbandmatch
#
#     Al, Au = _bandwidths(tA, A)
#     Bl, Bu = _bandwidths(tB, B)
#
#     if (-Al > Au) || (-Bl > Bu)   # A or B has empty bands
#         fill!(C, zero(T))
#     elseif Al < 0
#         C[max(1,Bn+Al-1):Am, :] .= zero(T)
#         banded_matmatmul!(C, tA, tB, _view(tA, A, :, 1-Al:An), _view(tB, B, 1-Al:An, :))
#     elseif Au < 0
#         C[1:-Au,:] .= zero(T)
#         banded_matmatmul!(view(C, 1-Au:Am,:), tA, tB, _view(tA, A, 1-Au:Am,:), B)
#     elseif Bl < 0
#         C[:, 1:-Bl] .= zero(T)
#         banded_matmatmul!(view(C, :, 1-Bl:Bn), tA, tB, A, _view(tB, B, :, 1-Bl:Bn))
#     elseif Bu < 0
#         C[:, max(1,Am+Bu-1):Bn] .= zero(T)
#         banded_matmatmul!(C, tA, tB, _view(tA, A, :, 1-Bu:Bm), _view(tB, B, 1-Bu:Bm, :))
#     else
#         positively_banded_matmatmul!(C, tA, tB, A, B)
#     end
#     C
# end



###
# Special Fill Diagonal
####

function materialize!(M::MatMulMatAdd{<:DiagonalLayout{<:AbstractFillLayout},<:AbstractBandedLayout})
    checkdimensions(M)
    M.C .= getindex_value(M.A.diag) .* M.B .* M.α .+ M.C .* M.β
    M.C
end

function materialize!(M::MatMulMatAdd{<:AbstractBandedLayout,<:DiagonalLayout{<:AbstractFillLayout}})
    checkdimensions(M)
    M.C .= M.A .* getindex_value(M.B.diag) .* M.α .+ M.C .* M.β
    M.C
end

### BandedMatrix * dense matrix

function materialize!(M::MatMulMatAdd{<:BandedColumns, <:AbstractStridedLayout, <:AbstractStridedLayout})
    checkdimensions(M)
    α, β, A, B, C = M.α, M.β, M.A, M.B, M.C

    if iszero(α)
        _fill_rmul!(M, β)
    else
        for (colC, colB) in zip(eachcol(C), eachcol(B))
            mul!(colC, A, colB, α, β)
        end
    end

    return C
end

function materialize!(M::MatMulMatAdd{<:AbstractStridedLayout, <:BandedColumns, <:AbstractStridedLayout})
    checkdimensions(M)
    α, β, A, B, C = M.α, M.β, M.A, M.B, M.C

    if iszero(α)
        _fill_rmul!(M, β)
    else
        for (rowC, rowA) in zip(eachrow(C), eachrow(A))
            mul!(rowC, transpose(B), rowA, α, β)
        end
    end

    return C
end

####
# Matrix memory layout traits
#
# if MemoryLayout(A) returns BandedColumnMajor, you must override
# pointer and leadingdimension
# in addition to the banded matrix interface
####

struct BandedLayout <: AbstractBandedLayout end
struct BandedColumns{ML} <: AbstractBandedLayout end
struct BandedRows{ML} <: AbstractBandedLayout end

const BandedColumnMajor = BandedColumns{<:AbstractColumnMajor}
const BandedRowMajor = BandedRows{<:AbstractColumnMajor}
BandedColumnMajor() = BandedColumns{DenseColumnMajor}()
BandedRowMajor() = BandedRows{DenseRowMajor}()

transposelayout(M::BandedColumns{ML}) where ML = BandedRows{ML}()
transposelayout(M::BandedRows{ML}) where ML = BandedColumns{ML}()
conjlayout(::Type{<:Complex}, ::M) where M<:AbstractBandedLayout = ConjLayout{M}()

# bandedrowsdata(Ac::Adjoint) = bandeddata(parent(Ac))'
# bandedrowsdata(Ac::Transpose) = transpose(bandeddata(parent(Ac)))
# bandedrowsdata(A) = bandedrowsdata(MemoryLayout(A), A)


# Here we override broadcasting for banded matrices.
# The design is to to exploit the broadcast machinery so that
# banded matrices that conform to the banded matrix interface but are not
# <: AbstractBandedMatrix can get access to fast copyto!, lmul!, rmul!, axpy!, etc.
# using broadcast variants (B .= A, B .= 2.0 .* A, etc.)



struct BandedStyle <: AbstractArrayStyle{2} end
BandedStyle(::Val{2}) = BandedStyle()
BroadcastStyle(::Type{<:AbstractBandedMatrix}) = BandedStyle()
BroadcastStyle(::Type{<:Adjoint{<:Any,Mat}}) where Mat<:AbstractBandedMatrix = BroadcastStyle(Mat)
BroadcastStyle(::Type{<:Transpose{<:Any,Mat}}) where Mat<:AbstractBandedMatrix = BroadcastStyle(Mat)
BroadcastStyle(::Type{<:SubArray{<:Any,2,<:AbstractBandedMatrix,<:NTuple{2,AbstractUnitRange{Int}}}}) = BandedStyle()
BroadcastStyle(::DefaultArrayStyle{2}, ::BandedStyle) = BandedStyle()
BroadcastStyle(::BandedStyle, ::DefaultArrayStyle{2}) = BandedStyle()


size(bc::Broadcasted{BandedStyle}) = length.(axes(bc))
isbanded(bc::Broadcasted{BandedStyle}) = true

####
# Default to standard Array broadcast
#
# This is because, for example, exp.(B) is not banded
####


copyto!(dest::AbstractArray, bc::Broadcasted{BandedStyle}) =
   copyto!(dest, Broadcasted{DefaultArrayStyle{2}}(bc.f, bc.args, bc.axes))
##
# copyto!
##

_copyto!(dest_L::AbstractBandedLayout, src_L::AbstractBandedLayout, dest::AbstractMatrix, src::AbstractMatrix) =
    _banded_broadcast!(dest, identity, src, dest_L, src_L)


function checkbroadcastband(dest, sizesrc, bndssrc)
    size(dest) == sizesrc || throw(DimensionMismatch())
    min(sizesrc[1],bndssrc[1]+1) ≤ min(bandwidth(dest,1)+1,size(dest,1))  &&
        min(sizesrc[2],bndssrc[2]+1) ≤ min(bandwidth(dest,2)+2,size(dest,2)) || throw(BandError(dest,size(dest,2)-1))
end

###########
# matrix broadcast
###########

function checkzerobands(dest, f, A::AbstractMatrix)
    m,n = size(A)
    d_l, d_u = bandwidths(dest)
    l, u = bandwidths(A)

    if !(d_l >= l && d_u >= u)
        if d_l >= l
            for j = rowsupport(A)
                for k = max(1,j-u) : min(j-d_u-1,m)
                    iszero(f(A[k,j])) || throw(BandError(dest,j-k))
                end
            end
        elseif d_u >= u
            for j = rowsupport(A)
                for k = max(1,j+d_l+1) : min(j+l,m)
                    iszero(f(A[k,j])) || throw(BandError(dest,j-k))
                end
            end
        else
            for j = rowsupport(A)
                for k = max(1,j-u) : min(j-d_u-1,m)
                    iszero(f(A[k,j])) || throw(BandError(dest,j-k))
                end
                for k = max(1,j+d_l+1) : min(j+l,m)
                    iszero(f(A[k,j])) || throw(BandError(dest,j-k))
                end
            end
        end
    end
end

function _banded_broadcast!(dest::AbstractMatrix, f, src::AbstractMatrix{T}, _1, _2) where T
    z = f(zero(T))
    iszero(z) || checkbroadcastband(dest, size(src), bandwidths(broadcasted(f, src)))
    m,n = size(dest)
    m == n == 0 && return dest

    d_l, d_u = bandwidths(dest)
    s_l, s_u = bandwidths(src)

    checkzerobands(dest, f, src)

    _banded_broadcast_anylayout!(dest, src, f, z, (s_l, s_u), (d_l, d_u), m)

    dest
end

# columns to the left (start) and right (stop) of the non-zero columns _nzcols
@inline _startzcols((m,n), (l,u)) = 1:-l
@inline _nzcols((m,n), (l,u)) = max(1-l,1):min(m+u,n)
@inline _stopzcols((m,n), (l,u)) = m+u+1:n

# columns in the "start up", bulk and "stop
@inline _startcols((m,n), (l,u)) = max(1-l,1):min(u,n)
@inline _bulkcols((m,n), (l,u)) = max(u+1,1):min(m-l,n)
@inline _stopcols((m,n), (l,u)) = max(m-l+1,u+1,1):min(m+u,n)

# the non-zero rows in the data in column j
@inline _startcolrange((m,n), (l,u), j) = u-j+2:min(u+m+1-j,l+u+1)
@inline _bulkcolrange((m,n), (l,u), j) = 1:l+u+1
@inline _stopcolrange((m,n), (l,u), j) = 1:u+m+1-j

# how many rows we shift down
@inline _bulkshift((l,u), j) = j-u-1

@inline _startzcols(A) = _startzcols(size(A), bandwidths(A))
@inline _nzcols(A) = _nzcols(size(A), bandwidths(A))
@inline _stopzcols(A) = _stopzcols(size(A), bandwidths(A))
@inline _startcols(A) = _startcols(size(A), bandwidths(A))
@inline _bulkcols(A) = _bulkcols(size(A), bandwidths(A))
@inline _stopcols(A) = _stopcols(size(A), bandwidths(A))
@inline _startcolrange(A, j) = _startcolrange(size(A), bandwidths(A), j)
@inline _bulkcolrange(A, j) = _bulkcolrange(size(A), bandwidths(A), j)
@inline _stopcolrange(A, j) = _stopcolrange(size(A), bandwidths(A), j)
@inline _colrange(A, j) = _colrange(size(A), bandwidths(A), j)
@inline _colshift(A::AbstractMatrix, j) = _colshift(bandwidths(A), j)
@inline _bulkshift(A::AbstractMatrix, j) = _bulkshift(bandwidths(A), j)

@inline function _colrange((m,n), (l,u), j)
    j ≤ u && return _startcolrange((m,n), (l,u), j)
    j ≤ m-l && return _bulkcolrange((m,n), (l,u), j)
    return _stopcolrange((m,n), (l,u), j)
end
@inline function _colshift((l,u), j)
    j ≤ u && return 0
    _bulkshift((l,u),j)
end


function _intersectcolrange(kr_A,kr_d,sh)
    if sh ≤ 0
        kr_dA = first(kr_d):min(last(kr_d),first(kr_d)+length(kr_A)+sh-1)
        kr_Ad = range(first(kr_A)-sh; length=length(kr_dA))
    else
        kr_dA = first(kr_d)+sh:min(last(kr_d),first(kr_d)+length(kr_A)+sh-1)
        kr_Ad = range(first(kr_A); length=length(kr_dA))
    end
    kr_dA, kr_Ad
end

function _banded_broadcast!(dest::AbstractMatrix, f, A::AbstractMatrix{T}, ::BandedColumns, ::BandedColumns) where T
    z = f(zero(T))
    iszero(z) || checkbroadcastband(dest, size(A), bandwidths(broadcasted(f, A)))

    m,n = size(dest)
    (m == 0 || n == 0) && return dest
    data_d,data_A = bandeddata(dest), bandeddata(A)

    checkzerobands(dest, f, A)
    # copy top left entries
    jr = _bulkcols(A) ∩ _bulkcols(dest)
    for j = last(_startzcols(dest))+1:min(first(jr)-1,n)
        # don't bother optimising
        kr_A = _colrange(A,j)
        kr_d = _colrange(dest,j)
        sh = _colshift(A,j)-_colshift(dest,j)
        kr_dA,kr_Ad = _intersectcolrange(kr_A,kr_d,sh)
        if isempty(kr_Ad)
            data_d[kr_d,j] .= z
        else
            data_d[first(kr_d):first(kr_dA)-1,j] .= z
            data_d[kr_dA,j] .= f.(view(data_A,kr_Ad,j))
            data_d[last(kr_dA)+1:last(kr_d),j] .= z
        end
    end

    # the bulk
    kr_A = _bulkcolrange(A,first(jr))
    kr_d = _bulkcolrange(dest,first(jr))
    sh = _bulkshift(A,first(jr))-_bulkshift(dest,first(jr))
    kr_dA,kr_Ad = _intersectcolrange(kr_A,kr_d,sh)
    if isempty(kr_Ad)
        data_d[kr_d,jr] .= z
    else
        data_d[first(kr_d):first(kr_dA)-1,jr] .= z
        data_d[kr_dA,jr] .= f.(view(data_A,kr_Ad,jr))
        data_d[last(kr_dA)+1:last(kr_d),jr] .= z
    end

    # bottom right
    for j = last(jr)+1:min(last(_stopcols(dest)),n)
        kr_A = _colrange(A,j)
        kr_d = _colrange(dest,j)
        sh = _colshift(A,j)-_colshift(dest,j)
        kr_dA,kr_Ad = _intersectcolrange(kr_A,kr_d,sh)
        if isempty(kr_Ad)
            data_d[kr_d,j] .= z
        else
            data_d[first(kr_d):first(kr_dA)-1,j] .= z
            data_d[kr_dA,j] .= f.(view(data_A,kr_Ad,j))
            data_d[last(kr_dA)+1:last(kr_d),j] .= z
        end
    end

    dest
end

function copyto!(dest::AbstractArray, bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{AbstractMatrix}})
    (A,) = bc.args
    _banded_broadcast!(dest, bc.f, A, MemoryLayout(typeof(dest)), MemoryLayout(typeof(A)))
end


###########
# matrix-number broadcast
###########

@inline function _banded_broadcast_loop_overlap!(dest, src, f::F, (min_sl_dl, min_su_du), m, j) where {F}
    for k = max(1,j-min_su_du):min(j+min_sl_dl,m)
        src_kj = inbands_getindex(src, k, j)
        v = f(src_kj)
        inbands_setindex!(dest, v, k, j)
    end
end

@inline function _banded_broadcast_loop!(dest, src, f, s_l_s_u, m)
    for j = rowsupport(dest)
        _banded_broadcast_loop_overlap!(dest, src, f, s_l_s_u, m, j)
    end
end

@inline function _banded_broadcast_loop!(dest, src, f, z, (s_l, s_u), (d_l, d_u), m)
    min_su_du = min(s_u, d_u)
    min_sl_dl = min(s_l, d_l)
    for j = rowsupport(dest)
        # if s_u < d_u, set extra bands in dest above the diagonal to zero
        for k = max(1,j-d_u):min(j+min(d_l, -(s_u+1)),m)
            inbands_setindex!(dest, z, k, j)
        end

        _banded_broadcast_loop_overlap!(dest, src, f, (min_sl_dl, min_su_du), m, j)

        # if s_l < d_l, set extra bands in dest below the diagonal to zero
        for k = max(1,j+max(s_l+1, -d_u)):min(j+d_l,m)
            inbands_setindex!(dest, z, k, j)
        end
    end
end

@inline function _banded_broadcast_anylayout!(dest, src, f, z, (s_l, s_u), (d_l, d_u), m)
    if d_l == s_l && d_u == s_u
        _banded_broadcast_loop!(dest, src, f, (s_l, s_u), m)
    else
        _banded_broadcast_loop!(dest, src, f, z, (s_l, s_u), (d_l, d_u), m)
    end
end

function _banded_broadcast!(dest::AbstractMatrix, f, (src,x)::Tuple{AbstractMatrix{T},Number}, _1, _2) where {T}
    z = f(zero(T), x)
    iszero(z) || checkbroadcastband(dest, size(src), bandwidths(broadcasted(f, src,x)))
    m,n = size(dest)
    m == n == 0 && return dest

    f_x = Base.Fix2(f, x)

    # if dest has fewer bands (either above or below the diagonal) than dest,
    # then f.(x, dest) must be zero in these bands
    checkzerobands(dest, f_x, src)

    d_l, d_u = bandwidths(dest)
    s_l, s_u = bandwidths(src)

    _banded_broadcast_anylayout!(dest, src, f_x, z, (s_l, s_u), (d_l, d_u), m)

    dest
end

function _banded_broadcast!(dest::AbstractMatrix, f, (x,src)::Tuple{Number,AbstractMatrix{T}}, _1, _2) where T
    z = f(x, zero(T))
    iszero(z) || checkbroadcastband(dest, size(src), bandwidths(broadcasted(f, x,src)))
    m,n = size(dest)
    m == n == 0 && return dest

    f_x = Base.Fix1(f, x)

    # if dest has fewer bands (either above or below the diagonal) than dest,
    # then f.(x, src) must be zero in these bands
    checkzerobands(dest, f_x, src)

    d_l, d_u = bandwidths(dest)
    s_l, s_u = bandwidths(src)

    _banded_broadcast_anylayout!(dest, src, f_x, z, (s_l, s_u), (d_l, d_u), m)

    dest
end

function _banded_broadcast_BandedColumn!(dest, f, src, z)
    l,u = bandwidths(src)
    λ,μ = bandwidths(dest)
    m,n = size(src)
    data_d,data_s = bandeddata(dest), bandeddata(src)
    d_m, d_n = size(data_d)

    if (l,u) == (λ,μ)
        data_d .= f.(data_s)
    elseif μ > u && λ > l
        fill!(view(data_d,1:min(μ-u,d_m),:), z)
        fill!(view(data_d,μ+l+2:μ+λ+1,:), z)
        view(data_d,μ-u+1:μ+l+1,:) .= f.(data_s)
    elseif μ > u
        fill!(view(data_d,1:min(μ-u,d_m),:), z)
        for b = λ+1:l
            any(!iszero, view(data_s,u+b+1,1:min(m-b,n))) && throw(BandError(dest,b))
        end
        view(data_d,μ-u+1:μ+λ+1,:) .= f.(view(data_s,1:u+λ+1,:))
    elseif λ > l
        for b = μ+1:u
            any(!iszero, view(data_s,u-b+1,b+1:n)) && throw(BandError(dest,b))
        end
        fill!(view(data_d,μ+l+2:μ+λ+1,:), z)
        view(data_d,1:μ+l+1,:) .= f.(view(data_s,u-μ+1:u+l+1,:))
    else # μ < u && λ < l
        for b = μ+1:u
            any(!iszero, view(data_s,u-b+1,b+1:n)) && throw(BandError(dest,b))
        end
        for b = λ+1:l
            any(!iszero, view(data_s,u+b+1,1:min(m-b,n))) && throw(BandError(dest,b))
        end
        data_d .= f.(view(data_s,u-μ+1:u+λ+1,:))
    end
    dest
end

function _banded_broadcast!(dest::AbstractMatrix, f, (src,x)::Tuple{AbstractMatrix{T},Number}, ::BandedColumns, ::BandedColumns) where T
    isprimitivetype(T) || return _banded_broadcast!(dest, f, (src, x), BandedLayout(), BandedLayout())
    z = f(zero(T),x)
    iszero(z) || checkbroadcastband(dest, size(src), bandwidths(broadcasted(f, src,x)))

    f_x = Base.Fix2(f, x)
    _banded_broadcast_BandedColumn!(dest, f_x, src, z)

    dest
end

function _banded_broadcast!(dest::AbstractMatrix, f, (x, src)::Tuple{Number,AbstractMatrix{T}}, ::BandedColumns, ::BandedColumns) where T
    isprimitivetype(T) || return _banded_broadcast!(dest, f, (x, src), BandedLayout(), BandedLayout())

    z = f(x, zero(T))
    iszero(z) || checkbroadcastband(dest, size(src), bandwidths(broadcasted(f, x,src)))

    f_x = Base.Fix1(f, x)
    _banded_broadcast_BandedColumn!(dest, f_x, src, z)

    dest
end

function copyto!(dest::AbstractArray, bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{AbstractMatrix,Number}})
    (A,x) = bc.args
    _banded_broadcast!(dest, bc.f, (A, x), MemoryLayout(typeof(dest)), MemoryLayout(typeof(A)))
end

function copyto!(dest::AbstractArray, bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{Number,AbstractMatrix}})
    (x,A) = bc.args
    _banded_broadcast!(dest, bc.f, (x,A), MemoryLayout(typeof(dest)), MemoryLayout(typeof(A)))
end

###############
# matrix-vector broadcast
###############

_banded_broadcast!(dest::AbstractMatrix, f, (A,B)::Tuple{AbstractVector{T},AbstractMatrix{V}}, _1, _2) where {T,V} =
    _left_colvec_banded_broadcast!(dest, f, (A,B), _1, _2)

function _left_colvec_banded_broadcast!(dest::AbstractMatrix, f, (A,B)::Tuple{AbstractVecOrMat{T},AbstractMatrix{V}}, _1, _2) where {T,V}
    z = f(zero(T), zero(V))
    bc = broadcasted(f, A, B)
    l, u = bandwidths(bc)
    iszero(z) || checkbroadcastband(dest, size(bc), (l,u))
    m,n = size(dest)

    d_l, d_u = bandwidths(dest)
    A_l, A_u = _broadcast_bandwidths((m-1,n-1),A)
    @assert A_u == n-1
    B_l, B_u = bandwidths(B)
    (d_l ≥ min(l,m-1) && d_u ≥ min(u,n-1)) || throw(BandError(dest))

    if d_l == B_l == l && d_u == B_u == u
        for j=rowsupport(dest)
            for k = max(1,j-u):min(j+min(A_l,l),m)
                inbands_setindex!(dest, f(A[k], inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j-u,j+A_l+1):min(j+l,m)
                inbands_setindex!(dest, f(zero(T), inbands_getindex(B, k, j)), k, j)
            end
        end
    else
        for j=rowsupport(dest)
            for k = max(1,j-d_u):min(j-u-1,m)
                inbands_setindex!(dest, z, k, j)
            end
            for k = max(1,j-d_u):min(j-B_u-1,j+d_l,m)
                inbands_setindex!(dest, f(A[k], zero(V)), k, j)
            end
            for k = max(1,j-B_u):min(j+min(A_l,B_l),m)
                inbands_setindex!(dest, f(A[k], inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j-d_u,j+B_l+1):min(j+A_l,j+d_l,m)
                inbands_setindex!(dest, f(A[k], zero(V)), k, j)
            end
            for k = max(1,j-d_u,j+A_l+1):min(j+B_l,j+d_l,m)
                inbands_setindex!(dest, f(zero(T), inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j+l+1):min(j+d_l,m)
                inbands_setindex!(dest, z, k, j)
            end
        end
    end
    dest
end

_banded_broadcast!(dest::AbstractMatrix, f, (A,B)::Tuple{AbstractMatrix{T},AbstractVector{V}}, _1, _2) where {T,V} =
    _right_colvec_banded_broadcast!(dest, f, (A,B), _1, _2)

function _right_colvec_banded_broadcast!(dest::AbstractMatrix, f, (A,B)::Tuple{AbstractMatrix{T},AbstractVecOrMat{V}}, _1, _2) where {T,V}
    z = f(zero(T), zero(V))
    bc = broadcasted(f, A, B)
    l, u = bandwidths(bc)
    iszero(z) || checkbroadcastband(dest, size(bc), (l,u))
    m,n = size(dest)

    d_l, d_u = bandwidths(dest)
    A_l, A_u = bandwidths(A)
    B_l, B_u = _broadcast_bandwidths((m-1,n-1),B)
    @assert B_u == n-1
    (d_l ≥ min(l,m-1) && d_u ≥ min(u,n-1)) || throw(BandError(dest))

    if d_l == A_l == l && d_u == A_u == u
        for j=rowsupport(dest)
            for k = max(1,j-u):min(j+min(l,B_l),m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), B[k]), k, j)
            end
            for k = max(1,j-u,j+B_l+1):min(j+l,m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), zero(V)), k, j)
            end
        end
    else
        for j=rowsupport(dest)
            for k = max(1,j-d_u):min(j-u-1,m)
                inbands_setindex!(dest, z, k, j)
            end
            for k = max(1,j-d_u):min(j-A_u-1,j+d_l,m)
                inbands_setindex!(dest, f(zero(T), B[k]), k, j)
            end
            for k = max(1,j-A_u):min(j+min(A_l,B_l),m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), B[k]), k, j)
            end
            for k = max(1,j-d_u,j+B_l+1):min(j+A_l,j+d_l,m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), zero(V)), k, j)
            end
            for k = max(1,j-d_u,j+A_l+1):min(j+B_l,j+d_l,m)
                inbands_setindex!(dest, f(zero(T), B[k]), k, j)
            end
            for k = max(1,j+l+1):min(j+d_l,m)
                inbands_setindex!(dest, z, k, j)
            end
        end
    end
    dest
end

function __left_rowvec_banded_broadcast!(dest, f, (A,B),
        ::BandedColumns,
        ::Tuple{Union{DenseColumnMajor, DualLayout{ArrayLayouts.DenseRowMajor}}, BandedColumns},
        (l, u), (A_l,A_u), (m,n))

    D = bandeddata(dest)
    Bd = bandeddata(B)
    D .= f.(A, Bd)
    return nothing
end

function __left_rowvec_banded_broadcast!(dest, f, (A,B), _1, _2, (l, u), (A_l,A_u), (m,n))
    for j=rowsupport(dest)
        for k = max(1,j-u):min(j-A_u-1,j+l,m)
            inbands_setindex!(dest, f(zero(eltype(A)), inbands_getindex(B, k, j)), k, j)
        end
        for k = max(1,j-min(A_u,u)):min(j+l,m)
            inbands_setindex!(dest, f(A[j], inbands_getindex(B, k, j)), k, j)
        end
    end
end

function _left_rowvec_banded_broadcast!(dest::AbstractMatrix, f, (A,B)::Tuple{AbstractMatrix{T},AbstractMatrix{V}}, _1, _2) where {T,V}
    @assert size(A,1) == 1
    z = f(zero(T), zero(V))
    bc = broadcasted(f, A, B)
    l, u = bandwidths(bc)
    iszero(z) || checkbroadcastband(dest, size(bc), (l,u))
    m,n = size(dest)

    d_l, d_u = bandwidths(dest)
    A_l, A_u = _broadcast_bandwidths((m-1,n-1),A)
    @assert A_l == m-1
    B_l, B_u = bandwidths(B)
    (d_l ≥ min(l,m-1) && d_u ≥ min(u,n-1)) || throw(BandError(dest))

    if d_l == B_l == l && d_u == B_u == u
        __left_rowvec_banded_broadcast!(dest, f, (A,B), _1, _2,
                (l, u), (A_l,A_u), (m,n))
    else
        for j=rowsupport(dest)
            for k = max(1,j-d_u):min(j-u-1,m)
                inbands_setindex!(dest, z, k, j)
            end
            for k = max(1,j-d_u,j-A_u):min(j-B_u-1,j+d_l,m)
                inbands_setindex!(dest, f(A[j], zero(V)), k, j)
            end
            for k = max(1,j-d_u,j-B_u):min(j-A_u-1,j+d_l,m)
                inbands_setindex!(dest, f(zero(T), inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j-min(A_u,B_u)):min(j+min(A_l,B_l),m)
                inbands_setindex!(dest, f(A[j], inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j-d_u,j+B_l+1):min(j+d_l,m)
                inbands_setindex!(dest, f(A[j], zero(V)), k, j)
            end
            for k = max(1,j+l+1):min(j+d_l,m)
                inbands_setindex!(dest, z, k, j)
            end
        end
    end
    dest
end

function __right_rowvec_banded_broadcast!(dest, f, (A,B),
        ::BandedColumns,
        ::Tuple{BandedColumns, Union{DualLayout{ArrayLayouts.DenseRowMajor}, DenseColumnMajor}},
        (l, u), (B_l,B_u), (m,n))

    D = bandeddata(dest)
    Ad = bandeddata(A)
    D .= f.(Ad, B)
    return nothing
end

function __right_rowvec_banded_broadcast!(dest, f, (A,B), _1, _2, (l, u), (B_l,B_u), (m,n))
    for j=rowsupport(dest)
        for k = max(1,j-u):min(j-B_u-1,j+l,m)
            inbands_setindex!(dest, f(inbands_getindex(A, k, j), zero(eltype(B))), k, j)
        end
        for k = max(1,j-min(u,B_u)):min(j+l,m)
            inbands_setindex!(dest, f(inbands_getindex(A, k, j), B[j]), k, j)
        end
    end
end

function _right_rowvec_banded_broadcast!(dest::AbstractMatrix, f, (A,B)::Tuple{AbstractMatrix{T},AbstractMatrix{V}}, _1, _2) where {T,V}
    @assert size(B,1) == 1
    z = f(zero(T), zero(V))
    bc = broadcasted(f, A, B)
    l, u = bandwidths(bc)
    iszero(z) || checkbroadcastband(dest, size(bc), (l,u))
    m,n = size(dest)

    d_l, d_u = bandwidths(dest)
    A_l, A_u = bandwidths(A)
    B_l, B_u = _broadcast_bandwidths((m-1,n-1),B)
    @assert B_l ==  m-1
    (d_l ≥ min(l,m-1) && d_u ≥ min(u,n-1)) || throw(BandError(dest))

    if d_l == A_l == l && d_u == A_u == u
        __right_rowvec_banded_broadcast!(dest, f, (A,B), _1, _2,
                (l, u), (B_l,B_u), (m,n))
    else
        for j=rowsupport(dest)
            for k = max(1,j-d_u):min(j-u-1,m)
                inbands_setindex!(dest, z, k, j)
            end
            for k = max(1,j-d_u,j-A_u):min(j-B_u-1,j+d_l,m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), zero(V)), k, j)
            end
            for k = max(1,j-d_u,j-B_u):min(j-A_u-1,j+d_l,m)
                inbands_setindex!(dest, f(zero(T), B[j]), k, j)
            end
            for k = max(1,j-min(A_u,B_u)):min(j+A_l,m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), B[j]), k, j)
            end
            for k = max(1,j-d_u,j+A_l+1):min(j+d_l,m)
                inbands_setindex!(dest, f(zero(T), B[j]), k, j)
            end
            for k = max(1,j+l+1):min(j+d_l,m)
                inbands_setindex!(dest, z, k, j)
            end
        end
    end
    dest
end


copyto!(dest::AbstractArray, bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{AbstractVector,AbstractMatrix}}) =
    _banded_broadcast!(dest, bc.f, bc.args, MemoryLayout(dest), MemoryLayout.(bc.args))


copyto!(dest::AbstractArray, bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{AbstractMatrix,AbstractVector}}) =
    _banded_broadcast!(dest, bc.f, bc.args, MemoryLayout(dest), MemoryLayout.(bc.args))


################
# matrix-matrix broadcast
################

function _banded_broadcast!(dest::AbstractMatrix, f, (A,B)::NTuple{2,AbstractMatrix}, _1, _2)
    __banded_broadcast!(dest, f, (A,B), _1, _2)
end
function __banded_broadcast!(dest::AbstractMatrix, f, (A,B)::Tuple{AbstractMatrix{T},AbstractMatrix{V}}, _1, _2) where {T,V}
    z = f(zero(T), zero(V))
    bc = broadcasted(f, A, B)
    l, u = bandwidths(bc)
    iszero(z) || checkbroadcastband(dest, size(bc), (l,u))
    m,n = size(dest)
    if size(A) ≠ (m,n)
        size(A,2) == 1 && return _left_colvec_banded_broadcast!(dest, f, (A,B), _1, _2)
        return _left_rowvec_banded_broadcast!(dest, f, (A,B), _1, _2)
    end
    if size(B) ≠ (m,n)
        size(B,2) == 1 && return _right_colvec_banded_broadcast!(dest, f, (A,B), _1, _2)
        return _right_rowvec_banded_broadcast!(dest, f, (A,B), _1, _2)
    end

    d_l, d_u = bandwidths(dest)
    A_l, A_u = bandwidths(A)
    B_l, B_u = bandwidths(B)
    (d_l ≥ min(l,m-1) && d_u ≥ min(u,n-1)) || throw(BandError(dest))

    if (d_l,d_u) == (A_l,A_u) == (B_l,B_u) == (l,u)
        for j=rowsupport(dest)
            for k = max(1,j-u):min(j+l,m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), inbands_getindex(B, k, j)), k, j)
            end
        end
    else
        for j=rowsupport(dest)
            for k = max(1,j-d_u):min(j-u-1,j+d_l,m)
                inbands_setindex!(dest, z, k, j)
            end
            for k = max(1,j-min(A_u,d_u)):min(j-B_u-1,j+min(A_l,d_l),m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), zero(V)), k, j)
            end
            for k = max(1, j+A_l+1, j-d_u):min(j-B_u-1,j+d_l,m)
                # This is hit in A+B with bandwidth(A) == (-2,2) && bandwidth(B) == (0,0)
                # The result has a bandwidth (2,0). This sets dest[band(1)] to zero
                inbands_setindex!(dest, z, k, j)
            end
            for k = max(1,j-min(B_u,d_u)):min(j-A_u-1,j+min(B_l,d_l),m)
                inbands_setindex!(dest, f(zero(T), inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j-min(A_u,B_u,d_u)):min(j+min(A_l,B_l,d_l),m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j+B_l+1,j-min(A_u,d_u)):min(j+min(A_l,d_l),m)
                inbands_setindex!(dest, f(inbands_getindex(A, k, j), zero(V)), k, j)
            end
            for k = max(1, j+B_l+1, j-d_u):min(j-A_u-1,j+d_l,m)
                # This is hit in A + B with bandwidth(A) == (2,-2) && bandwidth(B) == (0,0)
                # The result has a bandwidth (2,0). This sets dest[band(-1)] to zero
                inbands_setindex!(dest, z, k, j)
            end
            for k = max(1,j+A_l+1,j-min(d_u, B_u)):min(j+min(B_l,d_l),m)
                inbands_setindex!(dest, f(zero(T), inbands_getindex(B, k, j)), k, j)
            end
            for k = max(1,j-d_u,j+l+1):min(j+d_l,m)
                inbands_setindex!(dest, z, k, j)
            end
        end
    end
    dest
end

function checkzerobands(dest, f, (A,B)::NTuple{2,AbstractMatrix})
    m,n = size(A)
    d_l, d_u = bandwidths(dest)
    A_l, A_u = bandwidths(A)
    B_l, B_u = bandwidths(B)
    l, u = max(A_l,B_l), max(A_u,B_u)

    rspA = rowsupport(A)
    rspB = rowsupport(B)
    # if the dest has more bands both above and below the diagonal, no checks are necessary
    if !(u <= d_u && l <= d_l)
        if u <= d_u # the dest has more bands above the diagonal, so we only check below
            for j = min(first(rspA), first(rspB)):max(last(rspA), last(rspB))
                for k = max(1,j+d_l+1) : min(j+l,m)
                    iszero(f(A[k,j], B[k,j])) || throw(BandError(dest,j-k))
                end
            end
        elseif l <= d_l # the dest has more bands below the diagonal, so we only check above
            for j = min(first(rspA), first(rspB)):max(last(rspA), last(rspB))
                for k = max(1,j-u) : min(j-d_u-1,m)
                    iszero(f(A[k,j], B[k,j])) || throw(BandError(dest,j-k))
                end
            end
        else # check both above and below the diagonal
            for j = min(first(rspA), first(rspB)):max(last(rspA), last(rspB))
                for k = max(1,j-u) : min(j-d_u-1,m)
                    iszero(f(A[k,j], B[k,j])) || throw(BandError(dest,j-k))
                end
                for k = max(1,j+d_l+1) : min(j+l,m)
                    iszero(f(A[k,j], B[k,j])) || throw(BandError(dest,j-k))
                end
            end
        end
    end
end


function _banded_broadcast!(dest::AbstractMatrix, f, (A,B)::NTuple{2,AbstractMatrix}, Mdest::BandedColumns, MAB::NTuple{2,BandedColumns})
    z = f(zero(eltype(A)), zero(eltype(B)))
    bc = broadcasted(f, A, B)
    l, u = bandwidths(bc)
    (-u ≥ size(dest,1) || -l ≥ size(dest,2)) && return fill!(dest, z)
    iszero(z) || checkbroadcastband(dest, size(bc), (l,u))

    if size(A) ≠ size(dest) || size(B) ≠ size(dest)
        # special broadcast
        return __banded_broadcast!(dest, f, (A,B), Mdest, MAB)
    end

    A_l,A_u = bandwidths(A)
    B_l,B_u = bandwidths(B)
    -A_l > A_u && return broadcast!(f, dest, zero(eltype(A)), B)
    -B_l > B_u && return broadcast!(f, dest, A, zero(eltype(B)))
    d_l,d_u = bandwidths(dest)
    m,n = size(A)
    data_d,data_A, data_B = bandeddata(dest), bandeddata(A), bandeddata(B)

    if (d_l,d_u) == (A_l,A_u) == (B_l,B_u)
        data_d .= f.(data_A,data_B)
    else
        checkzerobands(dest, f, (A,B))
        min_l,min_u = min(A_l,B_l,d_l),min(A_u,B_u,d_u)

        # fill extra bands in dest
        fill!(view(data_d,1:d_u-max(A_u,B_u),:), z)
        fill!(view(data_d,d_u+max(A_l,B_l)+2:size(data_d,1),:), z)
        # between A and B if non-overlapping
        bs = max(-d_u,B_l+1):min(-A_u-1,d_l)
        fill!(view(data_d, bs .+ d_u .+ 1, :), z)
        bs = max(-d_u,A_l+1):min(-B_u-1,d_l)
        fill!(view(data_d, bs .+ d_u .+ 1, :), z)

        # construct where B upper is zero
        # this is from band A_u:B_u+1
        bs = max(-d_u,-A_u):min(-1-B_u,A_l,d_l)
        data_d_u_A = view(data_d, bs .+ d_u .+ 1, :)
        data_A_u_A = view(data_A, bs .+ A_u .+ 1, :)
        data_d_u_A .= f.(data_A_u_A, zero(eltype(B)))

        # construct where A upper is zero
        # this is from band B_u:min(A_u+1,-B_l)
        bs = max(-d_u,-B_u):min(-1-A_u,B_l,d_l)
        data_d_u_B = view(data_d, bs .+ d_u .+ 1, :)
        data_B_u_B = view(data_B, bs .+ B_u .+ 1, :)
        data_d_u_B .= f.(zero(eltype(A)), data_B_u_B)

        # construct where A and B are non-zero
        data_d̃ = view(data_d, d_u-min_u+1 : d_u+min_l+1, :)
        data_Ã = view(data_A, A_u-min_u+1 : A_u+min_l+1, :)
        data_B̃ = view(data_B, B_u-min_u+1 : B_u+min_l+1, :)
        data_d̃ .= f.(data_Ã,data_B̃)

        # construct where A lower is zero
        bs = max(A_l+1,-B_u,-d_u):min(B_l,d_l)
        data_d_l_B = view(data_d, bs .+ d_u .+ 1, :)
        data_B_l_B = view(data_B, bs .+ B_u .+ 1, :)
        data_d_l_B .= f.(zero(eltype(A)), data_B_l_B)

        # construct where B lower is zero
        bs = max(B_l+1,-A_u,-d_u):min(A_l,d_l)
        data_d_l_A = view(data_d, bs .+ d_u .+ 1, :)
        data_A_l_A = view(data_A, bs .+ A_u .+ 1, :)
        data_d_l_A .= f.(data_A_l_A, zero(eltype(B)))
    end

    dest
end


copyto!(dest::AbstractArray, bc::Broadcasted{BandedStyle, <:Any, <:Any, <:NTuple{2,AbstractMatrix}}) =
    _banded_broadcast!(dest, bc.f, bc.args, MemoryLayout(typeof(dest)), map(MemoryLayout,bc.args))

# override copy in case data has special broadcast
_default_banded_broadcast(bc::Broadcasted{Style}, _) where Style = Base.invoke(copy, Tuple{Broadcasted{Style}}, bc)
_default_banded_broadcast(bc::Broadcasted) = _default_banded_broadcast(bc, axes(bc))

_banded_broadcast(f, args::Tuple, _...) = _default_banded_broadcast(broadcasted(f, args...))
_banded_broadcast(f, arg, _...) = _default_banded_broadcast(broadcasted(f, arg))

function _banded_broadcast(f, A::AbstractMatrix{T}, ::BandedColumns) where T
    iszero(f(zero(T))) || return _default_banded_broadcast(broadcasted(f, A))
    Bdata = bandeddata(A)
    Bdata_new = reshape(f.(vec(Bdata)), size(Bdata))
    _BandedMatrix(Bdata_new, axes(A,1), bandwidths(A)...)
end
function _banded_broadcast(f, (src,x)::Tuple{AbstractMatrix{T},Number}, ::BandedColumns) where T
    isprimitivetype(T) || return _banded_broadcast(f, (src,x), BandedLayout())
    iszero(f(zero(T),x)) || return _default_banded_broadcast(broadcasted(f, src,x))
    Bdata = bandeddata(src)
    Bdata_new = reshape(f.(vec(Bdata), x), size(Bdata))
    _BandedMatrix(Bdata_new, axes(src,1), bandwidths(src)...)
end
function _banded_broadcast(f, (x, src)::Tuple{Number,AbstractMatrix{T}}, ::BandedColumns) where T
    isprimitivetype(T) || return _banded_broadcast(f, (x,src), BandedLayout())
    iszero(f(x, zero(T))) || return _default_banded_broadcast(broadcasted(f, x,src))
    Bdata = bandeddata(src)
    Bdata_new = reshape(f.(x, vec(Bdata)), size(Bdata))
    _BandedMatrix(Bdata_new, axes(src,1), bandwidths(src)...)
end

function copy(bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{AbstractMatrix}})
    (A,) = bc.args
    _banded_broadcast(bc.f, A, MemoryLayout(typeof(A)))
end

function copy(bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{AbstractMatrix,Number}})
    (A,x) = bc.args
    _banded_broadcast(bc.f, (A, x), MemoryLayout(typeof(A)))
end


function copy(bc::Broadcasted{BandedStyle, <:Any, <:Any, <:Tuple{Number,AbstractMatrix}})
    (x,A) = bc.args
    _banded_broadcast(bc.f, (x,A), MemoryLayout(typeof(A)))
end


function copy(bc::Broadcasted{BandedStyle, <:Any, <:Any, <:NTuple{2,AbstractMatrix}})
    _banded_broadcast(bc.f, bc.args, MemoryLayout.(typeof.(bc.args)))
end

###
# broadcast bandwidths
###


_bcsize(A) = size(A)


_broadcast_bandwidths(bnds) = bnds
_broadcast_bandwidths(bnds, _) = bnds
_broadcast_bandwidths((l,u), a::AbstractVector) = (bandwidth(a,1),u)
function __broadcast_bandwidths((l,u), A)
    sz = _bcsize(A)
    (length(sz) == 1 || sz[2] == 1) && return (bandwidth(A,1),u)
    sz[1] == 1 && return (l, bandwidth(A,2))
    bandwidths(A) # need to special case vector broadcasting
end
_broadcast_bandwidths((l,u), A::AbstractArray) = __broadcast_bandwidths((l,u), A)
_broadcast_bandwidths((l,u), A::Broadcasted) = __broadcast_bandwidths((l,u), A)


_band_eval_args() = ()
_band_eval_args(a, b...) = (a, _band_eval_args(b...)...)
_band_eval_args(::Base.RefValue{Type{T}}, b...) where T = (T, _band_eval_args(b...)...)
_band_eval_args(a::AbstractMatrix{T}, b...) where T = (zero(T), _band_eval_args(b...)...)
_band_eval_args(a::AbstractVector{T}, b...) where T = (one(T), _band_eval_args(b...)...)
_band_eval_args(a::Broadcasted, b...) = (zero(Base.Broadcast.combine_eltypes(a.f, a.args)), _band_eval_args(b...)...)


# zero dominates. Take the minimum bandwidth. Always treat like matrix.
__bnds(m, n) = (m-1, n-1)
__bnds(m) = (m-1, 0)
_bnds(bc) = __bnds(size(bc)...)

bandwidths(bc::Broadcasted{<:Union{Nothing,BroadcastStyle},<:Any,typeof(*)}) =
    min.(_broadcast_bandwidths.(Ref(_bnds(bc)), bc.args)...)

bandwidths(bc::Broadcasted{<:Union{Nothing,BroadcastStyle},<:Any,typeof(/)}) = _broadcast_bandwidths(_bnds(bc), first(bc.args))
bandwidths(bc::Broadcasted{<:Union{Nothing,BroadcastStyle},<:Any,typeof(\)}) = _broadcast_bandwidths(_bnds(bc), last(bc.args))


# zero is preserved. Take the maximum bandwidth
_isweakzero(f, args...) =  iszero(f(_band_eval_args(args...)...))


function bandwidths(bc::Broadcasted)
    sz = _bcsize(bc)
    a,b = length(sz) == 1 ? (sz[1],1) : sz
    bnds = (a-1,b-1)
    _isweakzero(bc.f, bc.args...) && return min.(bnds, max.(_broadcast_bandwidths.(Ref(bnds), bc.args)...))
    bnds
end

banded_similar(T, sz, bnds) = BandedMatrix{T}(undef, sz, bnds)
similar(bc::Broadcasted{BandedStyle}, ::Type{T}) where T = banded_similar(T, size(bc), bandwidths(bc))



##
# lmul!/rmul!
##

function _banded_lmul!(α, A::AbstractMatrix, _)
    for j = rowsupport(A), k = colsupport(A,j)
        inbands_setindex!(A, α*inbands_getindex(A,k,j), k,j)
    end
    A
end

function _banded_rmul!(A::AbstractMatrix, α, _)
    for j = rowsupport(A), k = colsupport(A,j)
        inbands_setindex!(A, inbands_getindex(A,k,j)*α, k,j)
    end
    A
end


function _banded_lmul!(α::Number, A::AbstractMatrix, ::BandedColumns)
    if !isprimitivetype(eltype(A))
        _banded_lmul!(α, A, BandedLayout()) # avoid undefined
    else
        lmul!(α, bandeddata(A))
    end
    A
end

function _banded_rmul!(A::AbstractMatrix, α::Number, ::BandedColumns)
    if !isprimitivetype(eltype(A))
        _banded_rmul!(A, α, BandedLayout()) # avoid undefined
    else
        rmul!(bandeddata(A), α)
    end
    A
end

banded_lmul!(α::Number, A::AbstractMatrix) = _banded_lmul!(α, A, MemoryLayout(typeof(A)))
banded_rmul!(A::AbstractMatrix, α::Number) = _banded_rmul!(A, α, MemoryLayout(typeof(A)))

materialize!(L::Lmul{ScalarLayout,<:AbstractBandedLayout}) = banded_lmul!(L.A, L.B)
materialize!(L::Rmul{<:AbstractBandedLayout,ScalarLayout}) = banded_rmul!(L.A, L.B)

##
# axpy!
##

# these are the routines of the banded interface of other AbstractMatrices
banded_axpy!(a::Number, X::AbstractMatrix, Y::AbstractMatrix) = _banded_axpy!(a, X, Y, MemoryLayout(typeof(X)), MemoryLayout(typeof(Y)))
_banded_axpy!(a::Number, X::AbstractMatrix, Y::AbstractMatrix, ::BandedColumns, ::BandedColumns) =
    banded_generic_axpy!(a, X, Y)
_banded_axpy!(a::Number, X::AbstractMatrix, Y::AbstractMatrix, notbandedX, notbandedY) =
    banded_dense_axpy!(a, X, Y)

# additions and subtractions
function banded_generic_axpy!(a::Number, X::AbstractMatrix, Y::AbstractMatrix)
    n,m = size(X)
    ny,my = size(Y)
    if (n,m) ≠ (ny,my)
        throw(DimensionMismatch("X has size $((n,m)) but $Y has size $((ny,my))"))
    end
    Xl, Xu = bandwidths(X)
    Yl, Yu = bandwidths(Y)

    if -Xl > Xu #= no bands in X =#
        return Y
    end

    if Xl > Yl
        # test that all entries are zero in extra bands below the diagonal
        @inbounds for j=rowsupport(X),k=max(1,j+Yl+1):min(j+Xl,n)
            if inbands_getindex(X, k, j) ≠ 0
                throw(BandError(Y, (k,j)))
            end
        end
    end
    if Xu > Yu
        # test that all entries are zero in extra bands above the diagonal
        @inbounds for j=rowsupport(X),k=max(1,j-Xu):min(j-Yu-1,n)
            if inbands_getindex(X, k, j) ≠ 0
                throw(BandError(Y, (k,j)))
            end
        end
    end

    if -Yl > Yu #= no bands in Y =#
        return Y
    end

    # only fill overlapping bands
    l = min(Xl,Yl)
    u = min(Xu,Yu)

    @inbounds for j=rowsupport(X), k=max(1,j-u):min(n,j+l)
        inbands_setindex!(Y, a*inbands_getindex(X,k,j) + inbands_getindex(Y,k,j) ,k, j)
    end
    Y
end

function banded_dense_axpy!(a::Number, X::AbstractMatrix, Y::AbstractMatrix)
    n,m = size(X)
    ny,my = size(Y)
    if (n,m) ≠ (ny,my)
        throw(DimensionMismatch("X has size $((n,m)) but $Y has size $((ny,my))"))
    end
    @inbounds for j=rowsupport(X), k=colrange(X,j)
        Y[k,j] += a*inbands_getindex(X,k,j)
    end
    Y
end

##
# special cases to hack tests where 2.0 .* A .+ B can be constructed in different ways depending on REPL or in a function.
# Should be made more general.
##
function copyto!(dest::AbstractArray{T}, bc::Broadcasted{BandedStyle, <:Any, typeof(+),
            <:Tuple{
                Broadcasted{BandedStyle,<:Any,typeof(*),<:Tuple{Number,AbstractMatrix}},
                AbstractMatrix}}) where T
    αA,B = bc.args
    α,A = αA.args
    dest ≡ B || (dest .= B)
    banded_axpy!(α, A, dest)
end

function similar(bc::Broadcasted{BandedStyle, <:Any, typeof(+),
            <:Tuple{
                Broadcasted{BandedStyle,<:Any,typeof(*),<:Tuple{Number,AbstractMatrix}},
                AbstractMatrix}}, ::Type{T}) where T
    αA,B = bc.args
    α,A = αA.args
    n,m = size(A)
    (n,m) == size(B) || throw(DimensionMismatch())
    Al,Au = bandwidths(A)
    Bl,Bu = bandwidths(B)
    similar(A, T, n, m, max(Al,Bl), max(Au,Bu))
end

axpy!(α, A::AbstractBandedMatrix, dest::AbstractMatrix) = banded_axpy!(α, A, dest)


###
# Fill
###

for op in (:*, :/)
    @eval begin
        broadcasted(::BandedStyle, ::typeof($op), a::Zeros, b::AbstractArray) = _broadcasted_zeros($op, a, b)
        function broadcasted(::BandedStyle, ::typeof($op), a::AbstractArray{T}, b::Ones{V}) where {T,V}
            Base.Broadcast.combine_axes(a, b) # dimension check
            _copy_oftype(a, promote_op(*, T, V))
        end
    end
end

for op in (:*, :\)
    @eval begin
        broadcasted(::BandedStyle, ::typeof($op), a::AbstractArray, b::Zeros) = _broadcasted_zeros($op, a, b)
        function broadcasted(::BandedStyle, ::typeof($op), a::Ones{T}, b::AbstractArray{V}) where {T,V}
            Base.Broadcast.combine_axes(a, b) # dimension check
            _copy_oftype(b, promote_op(*, T, V))
        end
    end
end

## Banded LDLᵀ decomposition

@inline bandwidth(A::LDLt{T,Symmetric{T,M}}, k) where {T,M<:BandedMatrix{T}} = bandwidth(A.data, k)

LinearAlgebra._factorize(S::Symmetric{<:Any,<:BandedMatrix}; check=false) = ldlt(S)
ArrayLayouts._factorize(::SymmetricLayout{<:BandedColumns}, ::NTuple{2,Base.OneTo{Int}}, S) = ldlt(S)

function ldlt!(F::Symmetric{T,M}) where {T,M<:BandedMatrix{T}}
    A = F.data
    n = size(A, 1)
    b = bandwidth(F)
    if F.uplo == 'L'
        @inbounds for j = 1:n
            @simd for k = max(1,j-b-1):j-1
                A[j,j] -= abs2(A[j,k])*A[k,k]
            end
            for i = j+1:min(n,j+b)
                @simd for k = max(1,j-b-1):j-1
                    A[i,j] -= A[i,k]*A[j,k]*A[k,k]
                end
                A[i,j] /= A[j,j]
            end
        end
    elseif F.uplo == 'U'
        @inbounds for j = 1:n
            @simd for k = max(1,j-b-1):j-1
                A[j,j] -= abs2(A[k,j])*A[k,k]
            end
            for i = j+1:min(n,j+b)
                @simd for k = max(1,j-b-1):j-1
                    A[j,i] -= A[k,i]*A[k,j]*A[k,k]
                end
                A[j,i] /= A[j,j]
            end
        end
    end
    return LDLt{T,Symmetric{T,M}}(F)
end

function ldlt(A::Symmetric{T,M}) where {T,M<:BandedMatrix{T}}
    S = typeof(zero(T)/one(T))
    uplo = A.uplo == 'U' ? :U : :L
    return S == T ? ldlt!(copy(A)) : ldlt!(Symmetric(BandedMatrix{S}(A), uplo))
end


function ldiv!(S::LDLt{T,Symmetric{T,M}}, B::AbstractVecOrMat{T}) where {T,M<:BandedMatrix{T}}
    require_one_based_indexing(B)
    n, nrhs = size(B, 1), size(B, 2)
    if size(S, 1) != n
        throw(DimensionMismatch("Matrix has dimensions $(size(S)) but right hand side has first dimension $n"))
    end
    A = S.data
    b = bandwidth(A, 1)
    @inbounds for l = 1:nrhs
        for j = 1:n
            @simd for k = max(1,j-b-1):j-1
                B[j,l] -= A[j,k]*B[k,l]
            end
        end
        @simd for j = 1:n
            B[j,l] /= A[j,j]
        end
        for j = n:-1:1
            @simd for k = j+1:min(n,j+b)
                B[j,l] -= A[k,j]*B[k,l]
            end
        end
    end
    B
end

function logabsdet(F::LDLt{T,Symmetric{T,M}}) where {T,M<:BandedMatrix{T}}
    it = (F.data[i,i] for i in 1:size(F, 1))
    return sum(log∘abs, it), prod(sign, it)
end

function getproperty(F::LDLt{<:Any,<:Symmetric{<:Any,<:AbstractBandedMatrix}}, d::Symbol)
    Fdata = getfield(F, :data)
    if d === :d
        return diag(Fdata)
    elseif d === :D
        return Diagonal(diag(Fdata))
    elseif d === :L
        return UnitLowerTriangular(Fdata)
    elseif d === :Lt
        return UnitUpperTriangular(Fdata)
    else
        return getfield(F, d)
    end
end

#
# Represent a symmetric banded matrix
# [ a_11 a_12 a_13
#   a_12 a_22 a_23 a_24
#   a_13 a_23 a_33 a_34
#        a_24 a_34 a_44  ]
# ordering the data like  (columns first)
#       [ *      *      a_13   a_24
#         *      a_12   a_23   a_34
#         a_11   a_22   a_33   a_44 ]
###




@inline function inbands_getindex(A::Symmetric{T, <:BandedMatrix}, k::Integer, j::Integer) where T
    P = parent(A)
    l,u = bandwidths(P)
    if -l ≤ abs(k-j) ≤ u
        parent(A).data[bandwidth(A) - abs(k-j) + 1, max(k,j)]
    else
        zero(T)
    end
end

# this is a hack but is much faster than default
function getindex(S::Symmetric{<:Any, <:BandedMatrix}, kr::AbstractUnitRange, jr::AbstractUnitRange)
    A = parent(S)
    m = max(last(kr), last(jr))
    B = if S.uplo == 'U'
        BandedMatrix(A[1:m,1:m],(0, bandwidth(A,2)))
    else
        BandedMatrix(A[1:m,1:m],(bandwidth(A,1),0))
    end
    ret = B + transpose(B)
    rdiv!(view(ret, band(0)), 2)
    ret[kr, jr]
end

symmetriclayout(::ML) where ML<:BandedColumns = SymmetricLayout{ML}()
symmetriclayout(::ML) where ML<:BandedRows = SymmetricLayout{ML}()

hermitianlayout(::Type{<:Complex}, ::ML) where ML<:BandedColumns = HermitianLayout{ML}()
hermitianlayout(::Type{<:Real}, ::ML) where ML<:BandedColumns = SymmetricLayout{ML}()
hermitianlayout(::Type{<:Complex}, ::ML) where ML<:BandedRows = HermitianLayout{ML}()
hermitianlayout(::Type{<:Real}, ::ML) where ML<:BandedRows = SymmetricLayout{ML}()

sublayout(::SymmetricLayout{<:AbstractBandedLayout}, ::Type{<:NTuple{2,AbstractUnitRange}}) = BandedLayout()
sublayout(::HermitianLayout{<:AbstractBandedLayout}, ::Type{<:NTuple{2,AbstractUnitRange}}) = BandedLayout()


isbanded(A::HermOrSym) = isbanded(parent(A))

bandwidth(A::HermOrSym) = ifelse(symmetricuplo(A) == 'U', bandwidth(parent(A),2), bandwidth(parent(A),1))
bandwidths(A::HermOrSym) = (bandwidth(A), bandwidth(A))


for (f,g) in [(:symbandeddata, :symmetricdata), (:hermbandeddata, :hermitiandata)]
    @eval function $f(A)
        B = $g(A)
        l,u = bandwidths(B)
        D = bandeddata(B)
        if symmetricuplo(A) == 'U'
            view(D, 1:u+1, :)
        else
            m = size(D,1)
            view(D, u+1:u+l+1, :)
        end
    end
end

banded_sbmv!(uplo, α::T, A::AbstractMatrix{T}, x::AbstractVector{T}, β::T, y::AbstractVector{T}) where {T<:BlasFloat} =
    BLAS.sbmv!(uplo, bandwidth(A), α, symbandeddata(A), x, β, y)


@inline function _banded_sbmv!(tA, α, A, x, β, y)
    if x ≡ y
        banded_sbmv!(tA, α, A, copy(x), β, y)
    else
        banded_sbmv!(tA, α, A, x, β, y)
    end
end


function materialize!(M::BlasMatMulVecAdd{<:SymmetricLayout{<:BandedColumnMajor},<:AbstractStridedLayout,<:AbstractStridedLayout})
    α, A, x, β, y = M.α, M.A, M.B, M.β, M.C
    m, n = size(A)
    m == n || throw(DimensionMismatch("matrix is not square"))
    (length(y) ≠ m || length(x) ≠ n) && throw(DimensionMismatch("*"))
    l = bandwidth(A)
    l ≥ 0 || return lmul!(β, y)
    _banded_sbmv!(symmetricuplo(A), α, A, x, β, y)
end

banded_hbmv!(uplo, α::T, A::AbstractMatrix{T}, x::AbstractVector{T}, β::T, y::AbstractVector{T}) where {T<:BlasFloat} =
    BLAS.hbmv!(uplo, bandwidth(A), α, hermbandeddata(A), x, β, y)


@inline function _banded_hbmv!(tA, α, A, x, β, y)
    if x ≡ y
        banded_hbmv!(tA, α, A, copy(x), β, y)
    else
        banded_hbmv!(tA, α, A, x, β, y)
    end
end

function materialize!(M::BlasMatMulVecAdd{<:HermitianLayout{<:BandedColumnMajor},<:AbstractStridedLayout,<:AbstractStridedLayout})
    α, A, x, β, y = M.α, M.A, M.B, M.β, M.C
    m, n = size(A)
    m == n || throw(DimensionMismatch("matrix is not square"))
    (length(y) ≠ m || length(x) ≠ n) && throw(DimensionMismatch("*"))
    l = bandwidth(A)
    l ≥ 0 || return lmul!(β, y)
    _banded_hbmv!(symmetricuplo(A), α, A, x, β, y)
end

## eigvals routine

function copyto!(A::Symmetric{<:Number,<:BandedMatrix}, B::Symmetric{<:Number,<:BandedMatrix})
    size(A) == size(B) || throw(ArgumentError("sizes of A and B must match"))
    bandwidth(A) >= bandwidth(B) || throw(ArgumentError("bandwidth of A must exceed that of B"))
    A .= zero(eltype(A))
    SAuplo = symmetricuplo(A)
    SBuplo = symmetricuplo(B)
    if SAuplo == SBuplo
        ASdata = symbandeddata(A)
        BSdata = symbandeddata(B)
        if SAuplo == 'L'
            ASdata[axes(BSdata)...] = BSdata
        else
            nrowsskip = size(ASdata,1) - size(BSdata,1)
            ASdata[axes(BSdata,1) .+ nrowsskip, axes(BSdata,2)] = BSdata
        end
    else
        Ap = parent(A)
        Bp = parent(B)
        if SAuplo == 'L'
            LowerTriangular(Ap) .= LowerTriangular(transpose(Bp))
        else
            UpperTriangular(Ap) .= UpperTriangular(transpose(Bp))
        end
    end
    return A
end

"""
    symrcm(matrix[, alg::Algorithm])

Use the Reverse Cuthill-Mckee algorithm to reduce the bandwith of a matrix.

# Examples
```julia
julia> using BandedMatrices, CliqueTrees

julia> matrix = [
           1 0 1 0 0 0 0 1 1
           0 1 1 0 0 1 1 1 0
           1 1 1 0 0 0 0 0 0
           0 0 0 1 0 0 0 1 1
           0 0 0 0 1 0 1 1 0
           0 1 0 0 0 1 1 0 0
           0 1 0 0 1 1 1 0 0
           1 1 0 1 1 0 0 1 0
           1 0 0 1 0 0 0 0 1
       ];

julia> bandedmatrix, perm, invp = symrcm(matrix);

julia> bandedmatrix
9×9 LinearAlgebra.Symmetric{Int64, BandedMatrix{Int64, Matrix{Int64}, Base.OneTo{Int64}}}:
 1  1  1  0  ⋅  ⋅  ⋅  ⋅  ⋅
 1  1  1  1  0  ⋅  ⋅  ⋅  ⋅
 1  1  1  0  1  1  ⋅  ⋅  ⋅
 0  1  0  1  0  1  0  ⋅  ⋅
 ⋅  0  1  0  1  0  1  0  ⋅
 ⋅  ⋅  1  1  0  1  1  1  0
 ⋅  ⋅  ⋅  0  1  1  1  0  1
 ⋅  ⋅  ⋅  ⋅  0  1  0  1  1
 ⋅  ⋅  ⋅  ⋅  ⋅  0  1  1  1

julia> bandedmatrix == matrix[perm, perm]
true
```
"""
function symrcm(matrix::AbstractMatrix)
    symrcm(matrix, Base.Sort.DEFAULT_UNSTABLE)
end

module TestBanded

using ArrayLayouts
using BandedMatrices
using BandedMatrices: _BandedMatrix, resize
using FillArrays
using LinearAlgebra
using SparseArrays
using Test

include("mymatrix.jl")

@testset "BandedMatrix" begin
    @testset "Undef BandedMatrix" begin
        @test typeof(BandedMatrix{Float64}(undef,(10,10),(1,1))) ==
            typeof(BandedMatrix{Float64,Matrix{Float64}}(undef,(10,10),(1,1))) ==
            typeof(BandedMatrix{Float64,Matrix{Float64},Base.OneTo{Int}}(undef,(10,10),(1,1)))
        @test typeof(BandedMatrix{Int}(undef,(10,10),(1,1))) ==
            typeof(BandedMatrix{Int,Matrix{Int}}(undef,(10,10),(1,1))) ==
            typeof(BandedMatrix{Int,Matrix{Int},Base.OneTo{Int}}(undef,(10,10),(1,1)))
        @test typeof(BandedMatrix{Vector{Int}}(undef,(10,10),(1,1))) ==
            typeof(BandedMatrix{Vector{Int},Matrix{Vector{Int}}}(undef,(10,10),(1,1))) ==
            typeof(BandedMatrix{Vector{Int},Matrix{Vector{Int}},Base.OneTo{Int}}(undef,(10,10),(1,1)))
    end

    @testset "Creating BandedMatrix" begin
        @test BandedMatrix(Zeros(5,5), (1,1)) == _BandedMatrix(zeros(3,5), 5, 1, 1)
        @test BandedMatrix(Zeros{Int32}(5,5), (1,1)) isa BandedMatrix{Int32, Matrix{Int32}}
        @test BandedMatrix(Zeros{Int}(5,5), (1,1)) == _BandedMatrix(zeros(Int,3,5), 5, 1, 1)
        @test BandedMatrix{Int}(Zeros(5,5), (1,1)) == _BandedMatrix(zeros(Int,3,5), 5, 1, 1)
        @test Matrix(BandedMatrix(Ones(5,5), (1,1))) == Matrix(BandedMatrix(Fill(1.0,(5,5)), (1,1))) ==
                                                        Matrix(SymTridiagonal(ones(5), ones(4)))

        @test all(BandedMatrix(0 => 1:5, 2=> 2:3, -3=> 1:7) .=== diagm(0 => 1:5, 2=> 2:3, -3=> 1:7))
        @test all(BandedMatrix{Float64}(0 => 1:5, 2=> 2:3, -3=> 1:7) .=== Matrix{Float64}(diagm(0 => 1:5, 2=> 2:3, -3=> 1:7)))
        @test all(BandedMatrix((0 => 1:5, 2=> 2:3, -3=> 1:7),(10,10)) .=== Matrix{Int}(diagm(0 => 1:5, 2=> 2:3, -3=> 1:7)))
        @test all(BandedMatrix{Float64}((0 => 1:5, 2=> 2:3, -3=> 1:7),(10,10)) .=== Matrix{Float64}(diagm(0 => 1:5, 2=> 2:3, -3=> 1:7)))
        @test all(BandedMatrix((0 => 1:5, 2=> 2:3, -3=> 1:7),(10,10),(4,3)) .=== Matrix{Int}(diagm(0 => 1:5, 2=> 2:3, -3=> 1:7)))
        @test all(BandedMatrix{Float64}((0 => 1:5, 2=> 2:3, -3=> 1:7),(10,10),(4,3)) .=== Matrix{Float64}(diagm(0 => 1:5, 2=> 2:3, -3=> 1:7)))

        matrix = MyMatrix(ones(Int64,5,5))
        @test !(matrix isa Matrix)
        @test BandedMatrix(matrix) isa BandedMatrix{Int64, Matrix{Int64}}
        @test BandedMatrix(matrix).data isa Matrix{Int64}
        @test BandedMatrix{Int64, typeof(matrix)}(matrix, (1, 1)) isa BandedMatrix{Int64, typeof(matrix)}
        @test BandedMatrix{Int64, typeof(matrix)}(matrix, (1, 1)).data isa typeof(matrix)
        @test_throws UndefRefError BandedMatrix{Vector{Float64}}(undef, (5,5), (1,1))[1,1]

        @testset "parent" begin
            A = zeros(3,5)
            B = _BandedMatrix(A, 5, 1, 1)
            @test parent(B) === A
        end

        @testset "Construction from Diagonal" begin
            D = Diagonal(1:4)
            B1 = BandedMatrix(D)
            @test B1 isa BandedMatrix{Int}
            @test B1 == D
            B2 = BandedMatrix{Float64}(D)
            @test B2 isa BandedMatrix{Float64}
            @test B2 == D
            B3 = BandedMatrix{Float32,Matrix{Float32}}(D)
            @test B3 isa BandedMatrix{Float32,Matrix{Float32}}
            @test B3 == D
        end
    end

    @testset "BandedMatrix arithmetic" begin
        let A = brand(10,12,2,3),B = brand(10,12,3,4)
            @test Matrix(sparse(A)) ≈ Matrix(A)

            @test Matrix(A') ≈ Matrix(A)'
            @test Matrix(transpose(A)) ≈ copy(transpose(A)) ≈ transpose(Matrix(A))
            @test Matrix((A+im*A)') ≈ (Matrix(A)+im*Matrix(A))'
            @test Matrix(transpose(A+im*A)) ≈ transpose(Matrix(A)+im*Matrix(A))

            @test Matrix(A+B) ≈ (Matrix(A)+Matrix(B))
            @test Matrix(A-B) ≈ (Matrix(A)-Matrix(B))

            @test Matrix(A.*B) ≈ (Matrix(A).*Matrix(B))
        end

        @testset "UniformScaling" begin
            A = brand(10,10,1,2)
            @test A+I isa BandedMatrix
            @test bandwidths(A+I) == (1,2)
            @test Matrix(A+I) ≈ Matrix(A)+I
            @test Matrix(I-A) ≈ I-Matrix(A)


            # number
            @test Matrix(A/2) ≈ Matrix(A)/2
        end
    end

    @testset "BandedMatrix * Vector" begin
        let v=rand(12), w=rand(10)
            for (l,u) in ((2,3), (-2,2), (2,-2), (2,-3))
                A=brand(length(w),length(v),l,u)
                @test A*v ≈ Matrix(A)*v
                # the left-side uses BLAS, while the right doesn't
                @test mul!(ones(size(A,1)), A, v, 1.0, 2.0) ≈ mul!(ones(size(A,1)), A, v, 1, 2)
                @test A'*w ≈ Matrix(A)'*w
                @test mul!(ones(size(A,2)), A', w, 1.0, 2.0) ≈ mul!(ones(size(A,2)), A', w, 1, 2)
                # explicitly test materialize!
                @test materialize!(MulAdd(1.0, A', w, 2.0, ones(size(A,2)))) ≈ materialize!(MulAdd(1, A', w, 2, ones(size(A,2))))
            end
        end

        let A=brand(Float64,5,3,2,2), v=rand(ComplexF64,3), w=rand(ComplexF64,5)
            @test A*v ≈ Matrix(A)*v
            @test mul!(ones(ComplexF64,size(A,1)), A, v, 1.0, 2.0) ≈ mul!(ones(ComplexF64,size(A,1)), A, v, 1, 2)
            @test A'*w ≈ Matrix(A)'*w
            @test mul!(ones(ComplexF64,size(A,2)), A', w, 1.0, 2.0) ≈ mul!(ones(ComplexF64,size(A,2)), A', w, 1, 2)
        end

        let A=brand(ComplexF64,5,3,2,2), v=rand(ComplexF64,3), w=rand(ComplexF64,5)
            @test A*v ≈ Matrix(A)*v
            @test mul!(ones(ComplexF64,size(A,1)), A, v, 1.0, 2.0) ≈ mul!(ones(ComplexF64,size(A,1)), A, v, 1, 2)
            @test A'*w ≈ Matrix(A)'*w
            @test mul!(ones(ComplexF64,size(A,2)), A', w, 1.0, 2.0) ≈ mul!(ones(ComplexF64,size(A,2)), A', w, 1, 2)
        end

        let A=brand(ComplexF64,5,3,2,2), v=rand(Float64,3), w=rand(Float64,5)
            @test A*v ≈ Matrix(A)*v
            @test mul!(ones(ComplexF64,size(A,1)), A, v, 1.0, 2.0) ≈ mul!(ones(ComplexF64,size(A,1)), A, v, 1, 2)
            @test A'*w ≈ Matrix(A)'*w
            @test mul!(ones(ComplexF64,size(A,2)), A', w, 1.0, 2.0) ≈ mul!(ones(ComplexF64,size(A,2)), A', w, 1, 2)
        end

        @testset "empty" begin
            let B=BandedMatrix((0=>ones(0),), (10,0)), v = ones(size(B,2))
                @test B * v == zeros(size(B,1))
            end
            let B=BandedMatrix((0=>ones(0),), (0,10)), v = ones(size(B,2))
                @test B * v == zeros(size(B,1))
            end
        end
    end

    @testset "Banded * Dense" begin
        @testset "big banded * dense" begin
            A=brand(1000,1000,200,300)
            B=rand(1000,1000)
            @test A*B ≈ Matrix(A)*B
            @test B*A ≈ B*Matrix(A)
        end
        # gbmm! not yet implemented
        # @test A'*B ≈ Matrix(A)'*B
        # @test A*B' ≈ Matrix(A)*B'
        # @test A'*B' ≈ Matrix(A)'*B'

        let
            A=brand(1200,1000,200,300); B=rand(1000,1000); C=rand(1200,1200)
            @test A*B ≈ Matrix(A)*B
            @test C*A ≈ C*Matrix(A)
        end
        # gbmm! not yet implemented
        # @test A'*C ≈ Matrix(A)'*C
        # @test A*B' ≈ Matrix(A)*B'
        # @test A'*C' ≈ Matrix(A)'*C'
    end

    @testset "Banded * Banded" begin
        for n in (1,5), ν in (1,5), m in (1,5), Al in (0,1,3), Au in (0,1,3),
                Bl in (0,1,3), Bu in (0,1,3)
            A = brand(n, ν, Al, Au); B = brand(ν, m, Bl, Bu)
            C = brand(ν, n, Al, Bu); D = brand(m, ν, Al, Bu)
            @test Matrix(A*B) ≈ Matrix(A)*Matrix(B)
            @test Matrix(C'*B) ≈ Matrix(C)'*Matrix(B)
            @test Matrix(A*D') ≈ Matrix(A)*Matrix(D)'
            @test Matrix(C'*D') ≈ Matrix(C)'*Matrix(D)'
        end

        let A = brand(ComplexF64, 5, 4, 2, 3), B = brand(ComplexF64, 4, 6, 3, 1),
            C = brand(ComplexF64, 4, 5, 1, 1), D = brand(ComplexF64, 6, 4, 0, 3)
            @test Matrix(A*B) ≈ Matrix(A)*Matrix(B)
            @test Matrix(C'*B) ≈ Matrix(C)'*Matrix(B)
            @test Matrix(A*D') ≈ Matrix(A)*Matrix(D)'
            @test Matrix(C'*D') ≈ Matrix(C)'*Matrix(D)'
        end

        let A = brand(ComplexF64, 5, 4, 2, 3), B = brand(4, 6, 3, 1), C = brand(4, 5, 1, 1),
                D = brand(ComplexF64, 6, 4, 0, 3)
            @test Matrix(A*B) ≈ Matrix(A)*Matrix(B)
            @test Matrix(C'*B) ≈ Matrix(C)'*Matrix(B)
            @test Matrix(A*D') ≈ Matrix(A)*Matrix(D)'
            @test Matrix(C'*D') ≈ Matrix(C)'*Matrix(D)'
        end

        @testset "BigFloat" begin
            let A = brand(5, 5, 1, 2), B = BandedMatrix(Zeros{BigFloat}(5,5),(2,3)), D = rand(5, 5)
                for j = 1:size(B,2), k = colrange(B,j)
                    B[k,j]=randn()
                end

                x = BigFloat[1:size(B,1)...]

                @test Matrix(A)*Matrix(B) ≈ A*B
                @test Matrix(B)*Matrix(A) ≈ B*A
                @test Matrix(B)*x ≈ B*x
                @test Matrix(B*B) ≈ Matrix(B)*Matrix(B)
                @test Matrix(A)*Matrix(D) ≈ A*D
                @test Matrix(D)*Matrix(A) ≈ D*A
            end
        end

        @testset "Negative bands" begin
            for A in (brand(3,4,-1,2),brand(5,4,-1,2),
                        brand(3,4,2,-1),brand(5,4,2,-1))
                b = rand(size(A,2))
                c = rand(size(A,1))
                @test A*b ≈ Matrix(A)*b
                @test A'*c ≈ Matrix(A)'*c
            end

            let C = brand(4, 5, -1, 3), D = rand(4, 4)
                for A in (brand(3,4,1,2),brand(3,4,-1,2),brand(3,4,2,-1)),
                    B in (brand(4,5,1,2),brand(4,5,-1,2),brand(4,5,2,-1))
                    @test A*B ≈ Matrix(A)*Matrix(B)
                    @test B*C' ≈ Matrix(B)*Matrix(C)'
                    @test B'*C ≈ Matrix(B)'*Matrix(C)
                    @test B'*A' ≈ Matrix(B)'*Matrix(A)'
                end

                for A in (brand(5,4,-1,2),brand(5,4,2,-1),brand(3,4,-1,2),brand(3,4,2,-1))
                    @test A*D ≈ Matrix(A)*Matrix(D)
                end

                for B in (brand(4,3,-1,2),brand(4,3,2,-1),brand(4,5,-1,2),brand(4,5,2,-1))
                    @test D*B ≈ Matrix(D)*Matrix(B)
                end
            end
        end

        @testset "zero" begin
            let b = rand(4)
                for A in (brand(3,4,-1,0),brand(3,4,0,-1),brand(3,4,-1,-1)),
                    B in (brand(4,3,1,2),brand(4,3,-1,0),brand(4,3,-1,-1))
                    @test Matrix(A) == zeros(3,4)
                    @test A*B == zeros(3,3)
                    @test A*b == zeros(3)
                end
            end
        end

        @testset "errors in collect" begin
           let B = brand(10,10,0,4)
               @test B*[collect(1.0:10) collect(1.0:10)] ≈ Matrix(B)*[collect(1.0:10) collect(1.0:10)]
           end
        end
    end

    @testset "BandedMatrix interface" begin
        @testset "check that col/rowstop is ≥ 0" begin
            let A = brand(3,4,-2,2)
                @test BandedMatrices.colstop(A, 1) == BandedMatrices.colstop(A, 2) == 0
                @test BandedMatrices.colstop(A, 3) == 1
            end

            let A = brand(3,4,2,-2)
                @test BandedMatrices.rowstop(A, 1) == BandedMatrices.rowstop(A, 2) == 0
                @test BandedMatrices.rowstop(A, 3) == 1
            end
        end

        @testset "fill!" begin
            let B = brand(10,10,1,4)
                @test_throws BandError fill!(B, 1.0)
                @test_throws BandError fill!(B, 1)
                fill!(B, 0)
                @test Matrix(B) == zeros(10,10)
            end

            let B = brand(2,3,1,4)
                fill!(B, 1)
                @test Matrix(B) == ones(2,3)
            end
        end
    end


    @testset "Conversions" begin
        @testset "banded -> some matrix" begin
            banded = brand(Int32, 10,12,2,3)

            matrix = Matrix(banded)
            @test matrix isa Matrix{Int32}
            for i in 1:length(matrix)
                @test matrix[i] == banded[i]
            end

            matrix = convert(Matrix, banded)
            @test matrix isa Matrix{Int32}
            for i in 1:length(matrix)
                @test matrix[i] == banded[i]
            end

            matrix = convert(Matrix{Int64}, banded)
            @test matrix isa Matrix{Int64}
            for i in 1:length(matrix)
                @test matrix[i] == banded[i]
            end

            matrix = convert(BandedMatrix, banded)
            @test matrix === banded

            matrix = convert(BandedMatrix{Int64}, banded)
            @test matrix isa BandedMatrix{Int64, Matrix{Int64}}
            for i in 1:length(matrix)
                @test matrix[i] == banded[i]
            end
        end

        @testset "some matrix -> banded" begin
            matrix = rand(Int32, 10, 12)

            types = Dict(BandedMatrix => Matrix{Int32},
                         BandedMatrix{Int64} => Matrix{Int64},
                         BandedMatrix{Int64, MyMatrix{Int64}} => MyMatrix{Int64})
            @testset "Matrix to $Final via $Step" for (Step, Final) in types
                banded = @inferred convert(Step, matrix)
                @test banded isa BandedMatrix{eltype(Final), Final}
                @test banded == matrix
                @test @inferred(convert(BandedMatrix, banded)) === banded
            end

            # Note: @inferred convert(MyMatrix, matrix) throws
            banded = convert(BandedMatrix{Int64, MyMatrix}, matrix)
            @test banded isa BandedMatrix{Int64, MyMatrix{Int64}}
            @test banded == matrix

            banded = convert(BandedMatrix{<:, MyMatrix}, matrix)
            @test banded isa BandedMatrix{Int32, MyMatrix{Int32}}
            @test banded == matrix

            jlarray = convert(MyMatrix, rand(Int32, 10, 12))
            types = Dict(BandedMatrix => MyMatrix{Int32},
                         BandedMatrix{Int64} => MyMatrix{Int64},
                         BandedMatrix{Int64, Matrix} => Matrix{Int64},
                         BandedMatrix{<:, Matrix} => Matrix{Int32},
                         BandedMatrix{<:, Matrix{Int32}} => Matrix{Int32},
                         BandedMatrix{<:, Matrix{Int64}} => Matrix{Int64},
                         BandedMatrix{Int64, Matrix{Int64}} => Matrix{Int64})
            @testset "MyMatrix to $Final via $Step" for (Step, Final) in types
                banded = @inferred convert(Step, jlarray)
                @test banded isa BandedMatrix{eltype(Final), Final}
                @test banded == jlarray
            end

            banded[5, 5] = typemax(Int32)
            @test_throws InexactError convert(BandedMatrix{Int16}, matrix)
            @test_throws InexactError convert(BandedMatrix{Int16, MyMatrix}, matrix)
            @test_throws InexactError convert(BandedMatrix{Int16, MyMatrix{Int16}}, matrix)

            banded = @inferred BandedMatrix{eltype(jlarray), typeof(jlarray)}(jlarray, (1, 1))
            types = [BandedMatrix, BandedMatrix{Int32},
                     BandedMatrix{<:, MyMatrix},
                     BandedMatrix{<:, MyMatrix{Int32}}]
            @testset "no-op banded to banded via $Step" for Step in types
                @test @inferred(convert(Step, banded)) === banded
            end

            types = Dict(BandedMatrix{Int64} => MyMatrix{Int64},
                         BandedMatrix{Int64, Matrix} => Matrix{Int64},
                         BandedMatrix{<:, MyMatrix{Int64}} => MyMatrix{Int64},
                         BandedMatrix{<:, Matrix} => Matrix{Int32},
                         BandedMatrix{<:, Matrix{Int32}} => Matrix{Int32},
                         BandedMatrix{<:, Matrix{Int64}} => Matrix{Int64},
                         BandedMatrix{Int64, Matrix{Int64}} => Matrix{Int64})
            @testset "banded to banded $Final via $Step" for (Step, Final) in types
                newbanded = @inferred convert(Step, banded)
                @test newbanded isa BandedMatrix{eltype(Final), Final}
                @test newbanded == banded
            end

            @testset "banded to banded" begin
                A = BandedMatrix{Int}(undef, (5,5), (1,1)); A.data[:] .= 1:length(A.data)
                @test convert(BandedMatrix, A) === convert(BandedMatrix{Int}, A) ===
                    convert(BandedMatrix{Int,Matrix{Int}}, A) === convert(BandedMatrix{Int,Matrix{Int},Base.OneTo{Int}}, A) === A
                @test convert(BandedMatrix{Float64}, A) ==
                    convert(BandedMatrix{Float64,Matrix{Float64}}, A) == convert(BandedMatrix{Float64,Matrix{Float64},Base.OneTo{Int}}, A) == A
            end
        end

        @testset "similar" begin
            banded = brand(Int32, 10, 12, 1, 2)
            @test @inferred(similar(banded)) isa BandedMatrix{Int32, Matrix{Int32}}
            @test size(similar(banded)) == size(banded)
            @test similar(banded).l == banded.l
            @test similar(banded).u == banded.u
            @test @inferred(similar(banded,(5,5))) isa BandedMatrix{Int32, Matrix{Int32}}
            @test @inferred(similar(banded,5,5)) isa BandedMatrix{Int32, Matrix{Int32}}
            @test @inferred(similar(banded,5,5,1,1)) isa BandedMatrix{Int32, Matrix{Int32}}


            banded = convert(BandedMatrix{<:, MyMatrix}, brand(Int32, 10, 12, 1, 2))
            @test banded isa BandedMatrix{Int32, MyMatrix{Int32}}
            @test @inferred(similar(banded)) isa BandedMatrix{Int32, MyMatrix{Int32}}
            @test size(similar(banded)) == size(banded)
            @test similar(banded).l == banded.l
            @test similar(banded).u == banded.u

            banded = convert(BandedMatrix{<:, MyMatrix}, brand(Int32, 10, 12, 1, 2))
            @test @inferred(similar(banded, Int64)) isa BandedMatrix{Int64, MyMatrix{Int64}}
            @test size(similar(banded, Int64)) == size(banded)
            @test similar(banded, Int64).l == banded.l
            @test similar(banded, Int64).u == banded.u

            bview = @view banded[1:5, 1:5]
            expected = convert(BandedMatrix, bview)
            @test @inferred(similar(bview)) isa BandedMatrix{Int32, MyMatrix{Int32}}
            @test @inferred(similar(bview, Int64)) isa BandedMatrix{Int64, MyMatrix{Int64}}
            @test size(similar(bview, Int64)) == size(expected)
            @test bandwidth(similar(bview, Int64), 1) == bandwidth(expected, 1)
            @test bandwidth(similar(bview, Int64), 2) == bandwidth(expected, 2)

            bview = @view banded[1:5, 6:8]
            expected = convert(BandedMatrix, bview)
            @test size(similar(bview, Int64)) == size(expected)
            @test bandwidth(similar(bview, Int64), 1) == bandwidth(expected, 1)
            @test bandwidth(similar(bview, Int64), 2) == bandwidth(expected, 2)

            bview = @view banded[6:8, 1:5]
            expected = convert(BandedMatrix, bview)
            @test size(similar(bview, Int64)) == size(expected)
            @test bandwidth(similar(bview, Int64), 1) == bandwidth(expected, 1)
            @test bandwidth(similar(bview, Int64), 2) == bandwidth(expected, 2)
        end

        @testset "banded -> sparse" begin
            B = brand(5,5,1,1)
            @test Matrix(sparse(B)) == Matrix(B)
        end

        @testset "abstract ambiguity" begin
            B = brand(5,5,1,1)
            @test convert(AbstractArray{Float64}, B) ≡ B
        end
    end

    @testset "real-imag" begin
        B = brand(ComplexF64,5,5,1,1)
        @test real(B) isa BandedMatrix
        @test imag(B) isa BandedMatrix
        @test bandwidths(real(B)) == bandwidths(imag(B)) == bandwidths(B)
        @test real(B) + im*imag(B) == B
    end

    @testset "induced norm" begin
        for T in (Float32, Float64, Complex{Float32}, Complex{Float64})
            A = brand(T, 12, 10, 2, 3)
            B = Matrix(A)
    	    @test opnorm(A) ≈ opnorm(B)
    	    @test cond(A) ≈ cond(B)
        end
    end

    @testset "triu/tril" begin
        n = 20; A = brand(n,n,2,3); B = Matrix(A);
        @test triu(A) == triu(B)
        @test tril(A) == tril(B)
        for j = -5:5
            @test triu(A,j) == triu(B,j)
            @test tril(A,j) == tril(B,j)
        end
    end

    @testset "BandedMatrix{Any}" begin
        A = BandedMatrix{Any}(undef, (10,10), (1,1))
        @test A[1,3] === nothing
    end

    @testset "negative bands + (#164)" begin
        A,B = BandedMatrix(-3 => 1:5) , BandedMatrix(3 => 1:5)
        @test A + B == A .+ B == B + A == B .+ A == Matrix(A) + Matrix(B)
        @test A - B == A .- B == Matrix(A) - Matrix(B)
        @test B - A == B .- A == Matrix(B) - Matrix(A)
    end

    @testset "summary" begin
        A = BandedMatrix{Float64}(undef, (5, 5), (1,2))
        @test summary(A) == "5×5 BandedMatrix{Float64} with bandwidths (1, 2)"
        A = _BandedMatrix(Fill(1,1,5), 4, 1, -1)
        @test summary(A) == "4×5 BandedMatrix{$Int} with bandwidths (1, -1) with data 1×5 Fill{$Int}"
        A = _BandedMatrix(Fill(1,1,5), Base.Slice(1:4), 1, -1)
        @test summary(A) == "4×5 BandedMatrix{$Int} with bandwidths (1, -1) with data 1×5 Fill{$Int} with indices 1:4×Base.OneTo(5)"
    end

    @testset "setindex" begin
        @testset "setindex! with ranges (#348)" begin
            n = 10;
            X1 = brand(n,n,1,1)
            B = BandedMatrix(Zeros(2n,2n), (3,3))
            B[1:2:end,1:2:end] = X1
            A = zeros(2n,2n)
            A[1:2:end,1:2:end] = X1
            @test A == B
        end
        @testset "vector - integer - colon" begin
            B = BandedMatrix(0=>1:4, 1=>5:7)
            B[1, :] = [10, 20, 0, 0]
            @test B[1, 1:2] == [10,20]
            B[3, :] = [0, 0, -10, -20]
            @test B[3, 3:4] == [-10, -20]
        end
    end


    @testset "copy band to offset vector" begin
        B = BandedMatrix(2=>2:3)
        # test that a BandedMatrix and a Matrix behave identically
        p = zeros(3)
        v = view(p, Base.IdentityUnitRange(2:3))
        for M in (B, Matrix(B))
            p .= 0
            copyto!(v, diag(M, 2))
            @test p[1] == 0
            @test @view(p[2:3]) == 2:3
            copyto!(v, diag(M, 10))
            @test p[1] == 0
            @test @view(p[2:3]) == 2:3
        end
    end

    if isdefined(LinearAlgebra, :copymutable_oftype)
        @testset "copymutable_oftype" begin
            B = _BandedMatrix((2:5)', 4, -2, 2)
            @test LinearAlgebra.copymutable_oftype(B, Float64) == B
            @test LinearAlgebra.copymutable_oftype(B, Float64) isa BandedMatrix{Float64}
            @test LinearAlgebra.copymutable_oftype(B', Float64) == B'
            @test LinearAlgebra.copymutable_oftype(B', Float64) isa Adjoint{Float64,<:BandedMatrix{Float64}}
            @test LinearAlgebra.copymutable_oftype(transpose(B), Float64) == transpose(B)
            @test LinearAlgebra.copymutable_oftype(transpose(B), Float64) isa Transpose{Float64,<:BandedMatrix{Float64}}

            @test LinearAlgebra.copymutable_oftype(UpperTriangular(B), Float64) == B
        end
    end

    @testset "sparse" begin
        B = BandedMatrix(1 => [1:4;])
        B2 = copy(B)
        S = sparse(B) .* 2
        copyto!(B, S)
        @test B == 2B2
        B .= 0
        copyto!(view(B, :, :), S)
        @test B == 2B2
    end

    @testset "offset views" begin
        B = BandedMatrix(0=>1:4)
        for A in (view(B, Base.IdentityUnitRange(2:4), 1:4), view(B, 1:4, Base.IdentityUnitRange(2:4)), view(B, Base.IdentityUnitRange(2:4), Base.IdentityUnitRange(2:4)))
            @test A[2,2] == B[2,2] == 2 # indexing matches
            @test bandwidths(A) == bandwidths(B) == (0,0) # therefore bandwidths are unchanged
            if 1 ∉ parentindices(A)[1]
                @test !any(in(axes(A,1)), BandedMatrices.colrange(A, 1))
            end
            @test BandedMatrices.colrange(A, 2) == 2:2
            @test BandedMatrices.colrange(A, 3) == 3:3
            @test BandedMatrices.colrange(A, 4) == 4:4
            @test BandedMatrices.rowrange(A, 2) == 2:2
            @test BandedMatrices.rowrange(A, 3) == 3:3
            @test BandedMatrices.rowrange(A, 4) == 4:4
        end
    end

    @testset "resize" begin
        B = brand(5,6,2,1)
        B̃ = resize(B, 10,7)
        @test size(B̃) == (10,7)
        @test bandwidths(B̃) == (2,1)
        @test B̃[1:5,1:6] == B

        C = resize(view(B,1:4,1:5), 10, 7)
        @test size(C) == (10,7)
        @test bandwidths(C) == (2,1)
        @test C[1:4,1:5] == B[1:4,1:5]

        A = brand(4,5,1,1)
        @test resize(A,6,5)[1:4,1:5] == A
        @test resize(view(A,2:3,2:5),5,5) isa BandedMatrix
        @test resize(view(A,2:3,2:5),5,5)[1:2,1:4] == A[2:3,2:5]
    end

    @testset "UniformScaling" begin
        @test BandedMatrix(I, (3,4)) == BandedMatrix{Int}(I, (3,4)) == BandedMatrix{Int,Matrix{Int}}(I, (3,4))  == BandedMatrix{Int,Matrix{Int},Base.OneTo{Int}}(I, (3,4)) == Matrix(I,(3,4))
        @test eltype(BandedMatrix(I, (3,4))) == Bool
        @test eltype(BandedMatrix{Int}(I, (3,4))) == Int
        @test bandwidths(BandedMatrix(I, (3,4))) == (0,0)
        @test bandwidths(BandedMatrix(I, (3,4), (1,2))) == (1,2)
        @test_throws BoundsError BandedMatrix(I, (3,4), (-1,2))
    end


    @testset "one" begin
        @test_throws DimensionMismatch one(brand(4,5,1,1))
        Q = one(brand(5,5,1,1))
        @test bandwidths(Q) == (0,0)
        @test Q == I(5)
        @test eltype(Q) == Float64
    end

    @testset "unaliascopy" begin
        B = BandedMatrices._BandedMatrix(view(randn(1, 5),:,:), 5, 0, 0)
        B2 = Base.unaliascopy(B)
        @test B2 == B
        @test typeof(B2) == typeof(B)
    end

    @testset "_BandedMatrix(::BandedRows)" begin
        A = brand(5, 5, 2, 1)
        for B in (A', transpose(A))
            @test BandedMatrices._BandedMatrix(MemoryLayout(B), B) == B
            @test BandedMatrix(B) == B
            @test BandedMatrix(B) !== B
            @test BandedMatrices.bandeddata(BandedMatrix(B)) !== BandedMatrices.bandeddata(A)

            @test BandedMatrix(view(B,2:4, 3:5)) == B[2:4,3:5] == [B[k,j] for k=2:4,j=3:5]
        end

        for V in (view(BandedMatrix((1 => ones(4),), (10, 10))', 1:5, 1:4),
                  view(BandedMatrix((1 => ones(4),), (10, 10))', 1:3, 1:5),
                  view(BandedMatrix((-1 => ones(4),), (10, 10))', 1:5, 1:4),
                  view(BandedMatrix((-1 => ones(4),), (10, 10))', 1:3, 1:5),
                  view(BandedMatrix((-1 => ones(4), 1 => ones(9)), (10, 10))', 1:3, 1:5))
            @test BandedMatrix(V) == V
        end

        @test BandedMatrices.bandedrowsdata(A') isa Transpose
        @test BandedMatrices.bandedrowsdata(transpose(A)) isa Transpose
        @test BandedMatrices.bandedrowsdata(view(A', 1:2, 1:2)) isa Transpose
    end
end

end # module

module BandedMatricesSparseArraysExt

using BandedMatrices
using BandedMatrices: _banded_rowval, _banded_colval, _banded_nzval
using SparseArrays, FillArrays
import SparseArrays: sparse

function sparse(B::BandedMatrix)
	sparse(_banded_rowval(B), _banded_colval(B), _banded_nzval(B), size(B)...)
end

function BandedMatrices.bandwidths(A::SparseMatrixCSC)
    l = u = -max(size(A,1),size(A,2))
    n = size(A)[2]
    rows = rowvals(A)
    vals = nonzeros(A)

    if isempty(vals)
        return bandwidths(Zeros(1))
    end

    for j = 1:n
        for ind in nzrange(A, j)
            i = rows[ind]
            # We skip non-structural zeros when computing the
            # bandwidths.
            iszero(vals[ind]) && continue
            u = max(u, j-i)
            l = max(l, i-j)
        end
    end

    l,u
end

#Treat as n x 1 matrix
function BandedMatrices.bandwidths(A::SparseVector)
    l = u = -size(A,1)
    rows = rowvals(A)

    if isempty(rows)
        return bandwidths(Zeros(1))
    end

    for i in rows
        iszero(i) && continue
        u = max(u, 1-i)
        l = max(l, i-1)
    end
    
    l,u
end

end

# used to test general matrix backends
struct MyMatrix{T} <: AbstractMatrix{T}
    A::Matrix{T}
end

MyMatrix{T}(::UndefInitializer, n::Int, m::Int) where T = MyMatrix{T}(Array{T}(undef, n, m))
MyMatrix(A::AbstractMatrix{T}) where T = MyMatrix{T}(Matrix{T}(A))
Base.convert(::Type{MyMatrix{T}}, A::MyMatrix{T}) where T = A
Base.convert(::Type{MyMatrix{T}}, A::MyMatrix) where T = MyMatrix(convert(AbstractArray{T}, A.A))
Base.convert(::Type{MyMatrix}, A::MyMatrix)= A
Base.convert(::Type{AbstractArray{T}}, A::MyMatrix) where T = MyMatrix(convert(AbstractArray{T}, A.A))
Base.convert(::Type{AbstractMatrix{T}}, A::MyMatrix) where T = MyMatrix(convert(AbstractArray{T}, A.A))
Base.convert(::Type{MyMatrix{T}}, A::AbstractArray{T}) where T = MyMatrix{T}(A)
Base.convert(::Type{MyMatrix{T}}, A::AbstractArray) where T = MyMatrix{T}(convert(AbstractArray{T}, A))
Base.convert(::Type{MyMatrix}, A::AbstractArray{T}) where T = MyMatrix{T}(A)
Base.getindex(A::MyMatrix, kj...) = A.A[kj...]
Base.getindex(A::MyMatrix, ::Colon, j::AbstractVector) = MyMatrix(A.A[:,j])
Base.setindex!(A::MyMatrix, v, kj...) = setindex!(A.A, v, kj...)
Base.size(A::MyMatrix) = size(A.A)
Base.similar(::Type{MyMatrix{T}}, m::Int, n::Int) where T = MyMatrix{T}(undef, m, n)
Base.similar(::MyMatrix{T}, m::Int, n::Int) where T = MyMatrix{T}(undef, m, n)
Base.similar(::MyMatrix, ::Type{T}, m::Int, n::Int) where T = MyMatrix{T}(undef, m, n)

using BandedMatrices
using LinearAlgebra

function diffs(a, b)
    n = length(a)
    d = Float64.(abs.(a - b))
    a1 = sum(d) / n
    r1 = sum(d ./ abs.(a)) / n
    a2 = sqrt(sum(d .* d) / n)
    r2 = sqrt(sum(d .* d ./ abs2.(a)) / n)
    a0 = maximum(d)
    r0 = maximum(d ./ abs.(a))
    a1, a2, a0, r1, r2, r0
end

function evaluate(n::Integer, T=Float64)

    M = BandedMatrix(0 => 6ones(n), 1 => -4ones(n-1), 2 => 1ones(n-2));
    MC = BandedMatrix(0 => 6ones(n), 1 => -4ones(n-1) .+ 0.1im, 2 => 1ones(n-2));
    M = T.(M)
    MC = Complex{T}.(MC)

    println("evaluation times with 5-banded test matrixes of dimension $n")
    println("LAPACK $T")
    Mb = @btime BandedMatrices.tridiagonalize!((Symmetric(copy($M))));

    println("generic $T")
    Mt = @btime tridiagonalize(Hermitian($M));

    println("generic with LinearAlgebra.givensAlgorithm $T")
    MtGA = @btime BandedMatrices.tridiagonalizeGA(Hermitian($M));

    println("generic Complex{$T}")
    Mtc = @btime tridiagonalize(Hermitian($MC));

    println("generic with LinearAlgebra.givensAlgorithm Complex{$T}")
    MtcGA = @btime BandedMatrices.tridiagonalizeGA(Hermitian($MC));


    println("generic BigFloat($(precision(BigFloat)))")
    Mbig = @time tridiagonalize(Hermitian(big.(M)));
    println("generic complex BigFloat($(precision(BigFloat)))")
    MCbig = @time tridiagonalize(Hermitian(big.(MC)));

    et = eigvals(Mt);
    etGA = eigvals(MtGA);
    etc = eigvals(Mtc);
    etcGA = eigvals(MtcGA);
    eb = eigvals(Mb);
    ebib = eigvals(Mbig);
    ebig = ebib;
    eCbig = eigvals(MCbig);

    println("absolute and relative errors")
    println("(mean / square-mean / max ) * (abs / rel)")

    println("LAPACK $T")
    println(diffs(eb, ebig))
    println("generic $T")
    println(diffs(et, ebig))
    println("generic with LinearAlgebra.givensAlgorithm $T")
    println(diffs(etGA, ebig))
    println("generic Complex{$T}")
    println(diffs(etc, eCbig))
    println("generic with LinearAlgebra.givensAlgorithm Complex{$T}")
    println(diffs(etcGA, eCbig))
end

evaluate( 1000);

################################
# split-Cholesky Factorization #
################################

#
# A split-Cholesky factorization of an SPD banded matrix A is:
#
#   S = [ U    ]
#       [ M  L ],
#
# where U and M are upper-triangular and L is lower-triangular so that S' * S = A.
# For a real A, the matrix S is also real, and S' == transpose(S)
#
# S has the same bandwidth as A
#
# If n = size(A, 1), n == size(A, 2) and kd = bandwidth(A), then if m = (n+b)÷2,
#
# size(U) == (m, m),  size(L) == (n-m, n-m),  and size(M) == (n-m, m).
#

struct SplitCholesky{T,M<:AbstractMatrix{T}} <: Factorization{T}
    factors::M
    uplo::Char

    function SplitCholesky{T,M}(factors, uplo) where {T,M<:AbstractMatrix}
        require_one_based_indexing(factors)
        new{T,M}(factors, uplo)
    end
end

SplitCholesky(factors::AbstractMatrix{T}, uplo::Char) where T = SplitCholesky{T,typeof(factors)}(factors, uplo)

size(S::SplitCholesky) = size(S.factors)
size(S::SplitCholesky, i::Integer) = size(S.factors, i)

function splitcholesky!(A::HermOrSym{T,<:BandedMatrix{T}}) where T
    splitcholesky!(A, A.uplo == 'U' ? UpperTriangular : LowerTriangular)
end
function splitcholesky!(A::HermOrSym{T,<:BandedMatrix{T}}, Tr) where {T}
    splitcholesky!(MemoryLayout(typeof(A)), A, Tr)
end

function splitcholesky!(::SymmetricLayout{<:BandedColumnMajor},
                       A::AbstractMatrix{T}, ::Type{LU}) where {T<:BlasFloat, LU}
    uplo = LU == UpperTriangular ? 'U' : 'L'
    pbstf!(uplo, size(A, 1), bandwidth(A,2), symbandeddata(A))
    SplitCholesky(A, A.uplo)
end

function splitcholesky!(::HermitianLayout{<:BandedColumnMajor},
                       A::AbstractMatrix{T}, ::Type{LU}) where {T<:BlasFloat, LU}
    uplo = LU == UpperTriangular ? 'U' : 'L'
    pbstf!(uplo, size(A, 1), bandwidth(A,2), hermbandeddata(A))
    SplitCholesky(A, A.uplo)
end

transpose(S::SplitCholesky{<:Real}) = S'
transpose(::SplitCholesky) =
    throw(ArgumentError("transpose of SplitCholesky decomposition is not supported, consider using adjoint"))

function lmul!(S::SplitCholesky{T,<:HermOrSym{T,M}}, B::AbstractVecOrMat{T}) where {T<:Real,M<:BandedMatrix{T}}
    require_one_based_indexing(B)
    n, nrhs = size(B, 1), size(B, 2)
    if size(S, 1) != n
        throw(DimensionMismatch("Matrix has dimensions $(size(S)) but right hand side has first dimension $n"))
    end
    A = S.factors
    b = bandwidth(A, 1)
    m = (n+b)÷2
    @inbounds for l = 1:nrhs
        for j = n:-1:m+1
            t = zero(T)
            @simd for k = j-b:j
                t += A[j,k]*B[k,l]
            end
            B[j,l] = t
        end
        for j = 1:m
            t = zero(T)
            @simd for k = j:min(j+b,m)
                t += A[j,k]*B[k,l]
            end
            B[j,l] = t
        end
    end
    B
end

function ldiv!(S::SplitCholesky{T,<:HermOrSym{T,M}}, B::AbstractVecOrMat{T}) where {T<:Real,M<:BandedMatrix{T}}
    require_one_based_indexing(B)
    n, nrhs = size(B, 1), size(B, 2)
    if size(S, 1) != n
        throw(DimensionMismatch("Matrix has dimensions $(size(S)) but right hand side has first dimension $n"))
    end
    A = S.factors
    b = bandwidth(A, 1)
    m = (n+b)÷2
    @inbounds for l = 1:nrhs
        for j = m:-1:1
            t = zero(T)
            @simd for k = j+1:min(j+b,m)
                t += A[j,k]*B[k,l]
            end
            B[j,l] = (B[j,l]-t)/A[j,j]
        end
        for j = m+1:n
            t = zero(T)
            @simd for k = j-b:j-1
                t += A[j,k]*B[k,l]
            end
            B[j,l] = (B[j,l]-t)/A[j,j]
        end
    end
    B
end

function lmul!(S::AdjointFact{T,<:SplitCholesky{T,<:HermOrSym{T,M}}}, B::AbstractVecOrMat{T}) where {T<:Real,M<:BandedMatrix{T}}
    require_one_based_indexing(B)
    n, nrhs = size(B, 1), size(B, 2)
    if size(S, 1) != n
        throw(DimensionMismatch("Matrix has dimensions $(size(S)) but right hand side has first dimension $n"))
    end
    A = S.parent.factors
    b = bandwidth(A, 1)
    m = (n+b)÷2
    @inbounds for l = 1:nrhs
        for j = m:-1:1
            t = zero(T)
            @simd for k = max(1,j-b):j
                t += A[k,j]*B[k,l]
            end
            B[j,l] = t
        end
        for j = m-b+1:m
            t = zero(T)
            @simd for k = m+1:j+b
                t += A[k,j]*B[k,l]
            end
            B[j,l] += t
        end
        for j = m+1:n
            t = zero(T)
            @simd for k = j:min(j+b,n)
                t += A[k,j]*B[k,l]
            end
            B[j,l] = t
        end
    end
    B
end

function ldiv!(S::AdjointFact{T,<:SplitCholesky{T,<:HermOrSym{T,M}}}, B::AbstractVecOrMat{T}) where {T<:Real,M<:BandedMatrix{T}}
    require_one_based_indexing(B)
    n, nrhs = size(B, 1), size(B, 2)
    if size(S, 1) != n
        throw(DimensionMismatch("Matrix has dimensions $(size(S)) but right hand side has first dimension $n"))
    end
    A = S.parent.factors
    b = bandwidth(A, 1)
    m = (n+b)÷2
    @inbounds for l = 1:nrhs
        for j = n:-1:m+1
            t = zero(T)
            @simd for k = j+1:min(j+b,n)
                t += A[k,j]*B[k,l]
            end
            B[j,l] = (B[j,l]-t)/A[j,j]
        end
        for j = m:-1:m-b+1
            t = zero(T)
            @simd for k = m+1:j+b
                t += A[k,j]*B[k,l]
            end
            B[j,l] -= t
        end
        for j = 1:m
            t = zero(T)
            @simd for k = max(1,j-b):j-1
                t += A[k,j]*B[k,l]
            end
            B[j,l] = (B[j,l]-t)/A[j,j]
        end
    end
    B
end

module TestBroadcasting

using BandedMatrices, LinearAlgebra, ArrayLayouts, FillArrays, Random, Test
import Base: BroadcastStyle
import Base.Broadcast: broadcasted
import BandedMatrices: BandedStyle, BandedRows, BandError

Random.seed!(0)

@testset "broadcasting" begin
    @testset "general" begin
        n = 1000
        for (l,u) in ((1,1), (0,0), (1,0), (0,1), (2,-1), (-1,2), (-2,2), (-2,1))
            A = brand(n,n,l,u)
            B = Matrix{Float64}(undef, n,n)
            B .= exp.(A)
            @test B == exp.(Matrix(A)) == exp.(A)

            @test exp.(A) isa BandedMatrix
            @test bandwidths(exp.(A)) == (n-1,n-1)

            C = similar(A)
            @test_throws BandError C .= exp.(A)

            @test identity.(A) == A
            @test identity.(A) isa BandedMatrix
            @test bandwidths(identity.(A)) == bandwidths(A)

            @test (z -> exp(z)-1).(A) ≈ (z -> exp(z)-1).(Matrix(A)) # for some reason == is breaking on Mac CI
            @test (z -> exp(z)-1).(A) isa BandedMatrix
            @test bandwidths((z -> exp(z)-1).(A)) == bandwidths(A)

            @test A .+ 1 == Matrix(A) .+ 1
            @test A .+ 1 isa BandedMatrix
            @test (A .+ 1) == Matrix(A) .+ 1

            @test A ./ 1 == Matrix(A) ./ 1
            @test A ./ 1 isa BandedMatrix
            @test bandwidths(A ./ 1) == bandwidths(A)

            @test 1 .+ A == 1 .+ Matrix(A)
            @test 1 .+ A isa BandedMatrix
            @test (1 .+ A) == 1 .+ Matrix(A)
            @test 1 .\ A == 1 .\ Matrix(A)
            @test 1 .\ A isa BandedMatrix
            @test bandwidths(1 .\ A) == bandwidths(A)
            
            A = brand(10,1,l,u)
            @test A[:,1] isa Vector
            @test norm(A .- A[:,1]) == 0
            @test A ≈ A[:,1]
        end

        @testset "checkzerobands" begin
            A = brand(10,10, 2,2)
            B = brand(10,10, 1,1)
            for (l,u) in ((0,0), (0,1), (1,0))
                dest = brand(size(A)..., l,u)
                @test_throws BandError dest .= A .+ A
                @test_throws BandError dest .= A .+ B
                @test_throws BandError dest .= A
            end
        end
    end

    function test_empty(f!)
        # the function f! must not set the RHS to zero for the error check to work
        @testset "empty dest" begin
            D = brand(4, 4, -2, 1) # empty
            B = brand(size(D)...,1,2) # non-empty and non-zero bands
            @test_throws BandError f!(D, B)
            f!(D, zero(B))
            @test all(iszero, D)
        end
    end

    @testset "identity" begin
        n = 100
        A = brand(n,n,2,2)
        A.data[1,1] = NaN
        B = brand(n,n,2,2)
        B.data[1,1] = NaN
        A .= B
        @test A == B
        B = brand(n,n,1,1)
        B.data[1,1] = NaN
        A .= B
        B = brand(n,n,3,3)
        B[band(3)] .= 0
        B[band(-3)] .= 0
        B.data[1,1] = NaN
        B.data[end,end] = NaN
        A .= B
        @test A == B

        B = brand(n,n,0,3)
        B[band(3)] .= 0
        B.data[1,1] = NaN
        A .= B
        @test A == B

        B = brand(n,n,3,0)
        B[band(-3)] .= 0
        B.data[end,end] = NaN
        A .= B
        @test A == B

        B = brand(n,n,-1,1)
        A .= B
        @test A == B

        B = brand(n,n,1,-1)
        A .= B
        @test A == B

        B = brand(1,4,0,1)
        C = brand(size(B)...,0,0)
        @test_throws BandError C .= B
        @test_throws BandError C' .= B'

        @testset "empty dest" begin
            test_empty((D,B) -> D .= B)
        end

        @testset "adjtrans" begin
            @testset "empty dest" begin
                test_empty((D,B) -> D' .= B')
            end
        end
    end

    @testset "lmul!/rmul!" begin
        n = 1000
        @testset for (l,u) in ((1,1), (0,0), (1,0), (0,1), (2,-1), (-1,2), (-2,2), (-2,1))
            A = brand(n,n,l,u)
            B = brand(n,n,l+1,u+1)
            B .= (-).(A)
            @test -A isa BandedMatrix
            @test (-).(A) isa BandedMatrix
            @test bandwidths(A) == bandwidths(-A) == bandwidths((-).(A))
            @test B == -A == (-).(A)
            @test A-I isa BandedMatrix
            @test I-A isa BandedMatrix
            @test bandwidths(A-I) == bandwidths(I-A)
            @test A-I == Matrix(A) - I
            @test I-A == I - Matrix(A)
            if all(>=(0), bandwidths(A))
                @test bandwidths(A) == bandwidths(A-I)
            end
            if (l,u) == (-2,2)
                @test all(iszero, (A-I)[band(1)])
                @test all(iszero, (I-A)[band(1)])
            end

            B .= 2.0.*A
            @test norm(B-2A) == 0
            @test B == 2A == 2.0.*A
            @test 2A isa BandedMatrix
            @test 2.0.*A isa BandedMatrix
            @test bandwidths(2A) == bandwidths(2.0.*A) == bandwidths(A)

            A .= 2.0.*A
            @test A == B

            B .= A .* 2.0
            @test B ==  A*2 == A.*2.0
            @test A*2 isa BandedMatrix
            @test A .* 2.0 isa BandedMatrix
            @test bandwidths(A*2) == bandwidths(A.*2.0) == bandwidths(A)
            A .= A.*2.0
            @test A == B

            B .= A ./ 2.0
            @test B == A/2 == A ./ 2.0
            @test A/2 isa BandedMatrix
            @test A ./ 2.0 isa BandedMatrix
            @test bandwidths(A/2) == bandwidths(A ./ 2.0) == bandwidths(A)

            B .= 2.0 .\ A
            @test B == A/2 == A ./ 2.0
            @test 2\A isa BandedMatrix
            @test 2.0 .\ A isa BandedMatrix
            @test bandwidths(2\A) == bandwidths(2.0 .\ A) == bandwidths(A)

            if -l <= u
                # This doesn't work for now if there are no bands,
                # although ideally, the matrix should be all NaN
                A.data .= NaN
                lmul!(0.0,A)
                @test isnan(norm(A)) == isnan(norm(lmul!(0.0,[NaN])))
                lmul!(false,A)
                @test norm(A) == 0.0

                A.data .= NaN
                rmul!(A,0.0)
                @test isnan(norm(A)) == isnan(norm(rmul!([NaN],0.0)))
                rmul!(A,false)
                @test norm(A) == 0.0
            end
        end

        n = 100
        A = brand(n,n,2,2)
        B = brand(n,n,1,1)
        A[band(2)] .= A[band(-2)] .= 0
        B .= A ./ 2.0
        @test B == A / 2.0 == Matrix(A)/2.0

        B .= 2.0 .\ A
        @test B == 2.0 \ A == 2.0 \ Matrix(A)

        n = 100
        A = brand(n,n,2,2)
        B = brand(n,n,1,3)
        A[band(-2)] .= 0
        B .= A ./ 2.0
        @test B == A / 2.0 == Matrix(A)/2.0

        B .= 2.0 .\ A
        @test B == 2.0 \ A == 2.0 \ Matrix(A)

        A = brand(n,n,2,2)
        B = brand(n,n,3,1)
        A[band(2)] .= 0
        B .= A ./ 2.0
        @test B == A / 2.0 == Matrix(A)/2.0

        B .= 2.0 .\ A
        @test B == 2.0 \ A == 2.0 \ Matrix(A)

        @testset "empty dest" begin
            test_empty((D,B) -> D .= 2 .* B)
            test_empty((D,B) -> D .= B .* 2)
        end

        @testset "trans-adj" begin
            A = brand(5,5,1,1)
            Ã = copy(A)

            lmul!(2.0, A')
            @test A == 2Ã
            lmul!(2.0, transpose(A))
            @test A == 4Ã
            lmul!(2.0, Symmetric(A))
            @test A == 8Ã
            lmul!(2.0, Hermitian(A))
            @test A == 16Ã
            rmul!(Hermitian(A), 1/2)
            @test A == 8Ã
            rmul!(Symmetric(A), 1/2)
            @test A == 4Ã
            rmul!(transpose(A), 1/2)
            @test A == 2Ã
            rmul!(A', 1/2)
            @test A == Ã

            @testset "empty dest" begin
                test_empty((D,B) -> D' .= 2 .* B')
                test_empty((D,B) -> D' .= B' .* 2)
                test_empty((D,B) -> D' .= 2 .* B' .* 2)
                test_empty((D,B) -> D' .= 2 .* B)
                test_empty((D,B) -> D' .= B .* 2)
                test_empty((D,B) -> D' .= 2 .* B .* 2)
            end
        end
    end

    @testset "axpy!" begin
        n = 100
        A = brand(n,n,1,1)
        B = brand(n,n,2,2)
        C = brand(n,n,3,3)
        C .= A .+ B
        @test C == A + B == A .+ B  == Matrix(A) + Matrix(B)
        @test A + B isa BandedMatrix
        @test A .+ B isa BandedMatrix
        @test bandwidths(A+B) == bandwidths(A.+B) == (2,2)
        B .= A .+ B
        @test B == C

        A = brand(n,n,1,1)
        B = brand(n,n,2,2)
        C = brand(n,n,3,3)
        C .= A .* B
        @test C == A .* B  == Matrix(A) .* Matrix(B)
        @test A .* B isa BandedMatrix
        @test bandwidths(A.*B) == (1,1)
        @time B .= A .* B
        @test B == C

        n = 100
        A = brand(n,n,1,1)
        B = brand(n,n,2,2)
        B[band(2)] .= B[band(-2)] .= 0
        C = brand(n,n,1,1)
        C .= A .+ B
        @test C == A + B == A .+ B == Matrix(A) + Matrix(B)

        n = 100
        A = brand(n,n,1,1)
        B = brand(n,n,2,2)
        B[band(-2)] .= 0
        C = brand(n,n,1,2)
        C .= A .+ B
        @test C == A + B == A .+ B == Matrix(A) + Matrix(B)

        n = 100
        A = brand(n,n,1,1)
        B = brand(n,n,2,2)
        B[band(2)] .= 0
        C = brand(n,n,2,1)
        C .= A .+ B
        @test C == A + B == A .+ B == Matrix(A) + Matrix(B)

        n = 100
        A = brand(n,n,1,1)
        B = brand(n,n,2,2)
        C = brand(n,n,3,3)

        C .= 2.0 .* A .+ B
        @test C == 2A+B == 2.0.*A .+ B
        @test all(axpy!(2.0, A, copy(B)) .=== C)

        @test 2A + B isa BandedMatrix
        @test 2.0.*A .+ B isa BandedMatrix
        @test bandwidths(2A+B) == bandwidths(2.0.*A .+ B) == (2,2)
        B .= 2.0 .* A .+ B
        @test B == C

        # test with identical bandwidth
        @test axpy!(3, A, copy(A)) ≈ 4A

        @testset "trivial cases" begin
            B = brand(2,4,-1,0) # no bands in B
            B2 = brand(2,4,0,-1) # no bands in B2
            C = brand(size(B)...,1,1)
            D = copy(C)
            axpy!(0.1, B, C) # no bands in src
            @test C == D
            @test_throws BandError axpy!(0.1, C, B)
            @test_throws BandError axpy!(0.1, C, B2)
            D = copy(B)
            C .= 0
            axpy!(0.1, C, B) # no bands in dest, but src is zero
            @test B == D
        end

        @test_throws DimensionMismatch axpy!(2, brand(2,2,1,1), brand(3,3,1,1))
        @test_throws DimensionMismatch axpy!(2, brand(2,2,1,1), brand(3,3,2,2))
        @test_throws DimensionMismatch axpy!(2, brand(2,2,1,1), zeros(3,3))
    end

    @testset "gbmv!" begin
        n = 100
        x = randn(n)
        y = similar(x)
        z = similar(y)
        @testset for (l,u) in ((1,1), (-1,1), (1,-1), (-2,1), (0,1), (1,0), (0,0))
            A = brand(n,n,l,u)
            mul!(y,A,x)
            @test Matrix(A)*x ≈ y
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('N', n, l, u, 1.0, A.data, x, 0.0, copy(y)) .===
                        ArrayLayouts.materialize!(MulAdd(1.0,A,x,0.0,similar(y))) .=== y)
            end

            z .= MulAdd(2.0,A,x,3.0,y)
            @test 2Matrix(A)*x + 3y ≈ z
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('N', n, l, u, 2.0, A.data, x, 3.0, copy(y)) .=== z)
            end

            @test MemoryLayout(typeof(A')) == BandedRows{DenseColumnMajor}()

            mul!(y,A',x)
            @test Matrix(A')*x ≈ Matrix(A)'*x ≈ y
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('T', n, l, u, 1.0, A.data, x, 0.0, copy(y)) .=== y)
            end

            z .= MulAdd(2.0,A',x,3.0,y)
            @test 2Matrix(A')*x + 3y ≈ z
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('T', n, l, u, 2.0, A.data, x, 3.0, copy(y)) .=== z)
            end

            @test MemoryLayout(typeof(transpose(A))) == BandedRows{DenseColumnMajor}()

            muladd!(1.0,transpose(A),x,0.0,y)
            @test Matrix(A')*x ≈ Matrix(A)'*x ≈ y
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('T', n, l, u, 1.0, A.data, x, 0.0, copy(y)) .=== y)
            end
        end

        n = 100
        x = randn(ComplexF64,n)
        y = similar(x)
        yc = similar(x)
        z = similar(y)
        @testset for (l,u) in ((1,1), (-1,1), (1,-1), (-2,1), (0,1), (1,0), (0,0))
            A = brand(ComplexF64,n,n,l,u)

            mul!(y,A,x)
            @test Matrix(A)*x ≈ y
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('N', n, l, u, 1.0+0.0im, A.data, x, 0.0+0.0im, copy(y)) .=== y)
            end

            @test MemoryLayout(typeof(A')) == ConjLayout{BandedRows{DenseColumnMajor}}()

            z .= MulAdd(2.0+0.0im,A,x,3.0+0.0im,y)
            @test 2Matrix(A)*x + 3y ≈ z
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('N', n, l, u, 2.0+0.0im, A.data, x, 3.0+0.0im, copy(y)) .=== z)
            end

            mul!(y,A',x)
            @test Matrix(A')*x ≈ Matrix(A)'*x ≈ y
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('C', n, l, u, 1.0+0.0im, A.data, x, 0.0+0.0im, copy(y)) .=== y)
            end

            @test MemoryLayout(typeof(transpose(A))) == BandedRows{DenseColumnMajor}()

            mul!(y,transpose(A),x)
            @test Matrix(transpose(A))*x ≈ transpose(Matrix(A))*x ≈ y
            if l >= 0 && u >= 0
                @test all(BLAS.gbmv!('T', n, l, u, 1.0+0.0im, A.data, x, 0.0+0.0im, copy(y)) .=== y)
            end
        end
    end

    @testset "non-blas matvec" begin
        n = 10
        A = brand(Int,n,n,1,1)
        x = rand(Int,n)
        y = similar(x)
        mul!(y,A,x)
        @test y == Matrix(A)*x
        mul!(y,A',x)
        @test y == Matrix(A')*x
        mul!(y,transpose(A),x)
        @test y == Matrix(transpose(A))*x

        A = brand(Int,n,n,1,1) + im*brand(Int,n,n,1,1)
        x = rand(eltype(A),n)
        y = similar(x)
        mul!(y,A,x)
        @test y == Matrix(A)*x
        mul!(y,A',x)
        @test y == Matrix(A')*x
        mul!(y,transpose(A),x)
        @test y == Matrix(transpose(A))*x
    end

    @testset "gbmm!" begin
        n = 10
        A = brand(n,n,1,1)
        B = brand(n,n,2,2)
        C = brand(n,n,3,3)
        mul!(C,A,B)
        @test Matrix(C) ≈ Matrix(A)*Matrix(B)
        mul!(C,A',B)
        @test Matrix(C) ≈ Matrix(A')*Matrix(B)
        mul!(C,A,B')
        @test Matrix(C) ≈ Matrix(A)*Matrix(B')
        C = brand(n,n,4,4)
        mul!(C,A,B)
        @test Matrix(C) ≈ Matrix(A)*Matrix(B)
        B = randn(n,n)
        C = similar(B)

        mul!(C,A,B)
        @test C ≈ Matrix(A)*Matrix(B)
        mul!(C,B,A)
        @test C ≈ Matrix(B)*Matrix(A)
    end

    @testset "Subarray" begin
        n = 10
        A = brand(n,n,1,1)
        B = view(brand(2n,2n,2,0),Base.OneTo(n),1:n)
        @test BroadcastStyle(typeof(B)) == BandedStyle()

        @test A .+ B isa BandedMatrix
        @test A + B isa BandedMatrix
        @test bandwidths(A .+ B) == (2,1)
        @test A .+ B == Matrix(A) + Matrix(B)
    end

    @testset "adjtrans" begin
        n = 10
        A = brand(n,n,1,1)

        @test BroadcastStyle(typeof(A')) isa BandedStyle
        @test BroadcastStyle(typeof(transpose(A))) isa BandedStyle

        @test A' .+ A isa BandedMatrix
        @test transpose(A) .+ A isa BandedMatrix
        @test A' .+ A == transpose(A) .+ A == Matrix(A)' .+ A
    end

    @testset "vector and matrix broadcastring" begin
        n = 10
        A = brand(n,n,1,2)
        b = rand(n) .+ 0.1 # avoid zero
        Bb = BandedMatrix(b')'
        Bb2 = BandedMatrix(b', (0,3))'

        @testset "implicit dest" begin
            for A_ in (A, A'), b_ in (b, Bb, Bb2)
                @test b_ .* A_ == b_ .* Matrix(A_)
                @test b_ .* A_ isa BandedMatrix
                @test bandwidths(b_ .* A_) == bandwidths(A_)

                @test b_' .* A_ == b_' .* Matrix(A_)
                @test b_' .* A_ isa BandedMatrix
                @test bandwidths(b_' .* A_) == bandwidths(A_)

                @test permutedims(b_) .* A_ == permutedims(b_) .* Matrix(A_)
                @test permutedims(b_) .* A_ isa BandedMatrix
                @test bandwidths(permutedims(b_) .* A_) == bandwidths(A_)

                @test A_ .* b_ == Matrix(A_) .* b_
                @test A_ .* b_ isa BandedMatrix
                @test bandwidths(A_ .* b_) == bandwidths(A_)

                @test A_ .* b_' == Matrix(A_) .* b_'
                @test A_ .* b_' isa BandedMatrix
                @test bandwidths(A_ .* b_') == bandwidths(A_)

                @test A_ .* permutedims(b_) == Matrix(A_) .* permutedims(b_)
                @test A_ .* permutedims(b_) isa BandedMatrix
                @test bandwidths(A_ .* permutedims(b_)) == bandwidths(A_)
            end

            # division tests currently don't deal with Inf/NaN correctly,
            # so we don't divide by zero
            for A_ in (A, A'), b_ in (b, Bb)
                @test b_ .\ A_ == b_ .\ Matrix(A_)
                @test b_ .\ A_ isa BandedMatrix
                @test bandwidths(b_ .\ A_) == bandwidths(A_)
                @test A_ ./ b_ == Matrix(A_) ./ b_
                @test A_ ./ b_ isa BandedMatrix
                @test bandwidths(A_ ./ b_) == bandwidths(A_)
            end

            @test bandwidths(Broadcast.broadcasted(/, b, A)) == (9,9)
            @test isinf((b ./ A)[4,1])
            @test bandwidths(Broadcast.broadcasted(\, A,b)) == (9,9)
            @test isinf((A .\ b)[4,1])

            @test reshape(b,10,1) .* A isa BandedMatrix
            @test reshape(b,10,1) .* A == A .* reshape(b,10,1) == A .* b
            @test bandwidths(reshape(b,10,1) .* A) == bandwidths(A)
            @test bandwidths(A .* reshape(b,10,1)) == bandwidths(A)

            @test b .+ A == b .+ Matrix(A) == A .+ b

            @test bandwidths(broadcasted(+, A, b')) == (9,9)
            @test A .+ b' == b' .+ A == Matrix(A) .+ b'
            @test bandwidths(A .+ b') == bandwidths(b' .+ A)  == (9,9)

            @testset "nested broadcast" begin
                @test bandwidths((b ./ 2) .* A) == (1,2)
                @test (b ./ 2) .* A == (b ./ 2) .* Matrix(A)
            end
        end

        @testset "explicit dest" begin
            D = brand(size(A)..., (bandwidths(A) .+ 1)...)
            D .= 0

            for (A_, D_) in ((A,D), (A', D')), b_ in (b, Bb, Bb2)
                D_ .= b_ .* A_
                @test D_ == b_ .* A_

                D_ .= b_' .* A_
                @test D_ == b_' .* A_

                D_ .= permutedims(b_) .* A_
                @test D_ == permutedims(b_) .* A_

                D_ .= A_ .* b_
                @test D_ == A_ .* b_

                D_ .= A_ .* b_'
                @test D_ == A_ .* b_'

                D_ .= A_ .* permutedims(b_)
                @test D_ == A_ .* permutedims(b_)
            end
        end
    end

    @testset "views" begin
        A = BandedMatrix(Ones(10,10),(1,1))
        B = 2A
        view(A,8:10,:) .= view(B,8:10,:)
        @test A[1,1] == 1.0
        @test A[6,7] == 1.0
        @test A[7,7] == 1.0
        @test A[8,7] == 2.0

        A = BandedMatrix{Int}(undef,(10,10),(2,2));  vec(A.data) .= (1:length(A.data));
        B = BandedMatrix{Int}(undef,(10,10),(1,1));  vec(B.data) .= (1:length(B.data));
        Ã = Matrix(A); B̃ = Matrix(B)
        view(A,5:10,:) .= view(B,5:10,:)
        view(Ã,5:10,:) .= view(B̃,5:10,:)
        @test Ã == A

        A = BandedMatrix{Int}(undef,(10,10),(2,1));  vec(A.data) .= (1:length(A.data));
        B = BandedMatrix{Int}(undef,(10,10),(1,2));  vec(B.data) .= (1:length(B.data));
        @test_throws BandError view(A,5:10,:) .= view(B,5:10,:)

        A = BandedMatrix{Int}(undef,(10,10),(1,2));  vec(A.data) .= (1:length(A.data));
        B = BandedMatrix{Int}(undef,(10,10),(2,1));  vec(B.data) .= (1:length(B.data));
        @test_throws BandError view(A,5:10,:) .= view(B,5:10,:)

        A = BandedMatrix{Int}(undef,(10,10),(1,2));  vec(A.data) .= (1:length(A.data));
        B = BandedMatrix{Int}(undef,(10,10),(2,1));  vec(B.data) .= (1:length(B.data));
        view(A,3:4,2:6) .= view(B,8:9,1:5)
        @test A[3:4,2:6] == zeros(Int,2,5)
        @test A[5,4] == 16

        A = BandedMatrix{Int}(undef,(10,10),(1,2));  vec(A.data) .= (1:length(A.data));
        B = BandedMatrix{Int}(undef,(10,10),(2,1));  vec(B.data) .= (1:length(B.data));
        view(A,3:4,2:6) .= view(B,1:2,4:8)
        @test A[3:4,:] == zeros(Int,2,10)

        A = BandedMatrix{Int}(undef,(1,1),(1,1)); vec(A.data) .= 2*(1:length(A.data));
        B = BandedMatrix{Int}(undef,(1,1),(1,1)); vec(B.data) .= (1:length(B.data));
        view(A,2:1,2:1) .= view(B,2:1,2:1)
        @test A[1,1] == 4
    end

    @testset "special broasdcast" begin
        A = brand(5,5,1,1)
        b = brand(5,1,1,1)
        B = brand(1,5,1,1)
        @test A .+ b == b .+ A == Matrix(A) .+ Matrix(b)
        @test A .+ B' == B' .+ A == Matrix(A) .+ Matrix(B)'
        @test A .+ b' == b' .+ A == Matrix(A) .+ Matrix(b)'
        @test A .+ B == B .+ A == Matrix(A) .+ Matrix(B)

        @test bandwidths(A .* b) == bandwidths(A .* b') == bandwidths(b .* A) == bandwidths(b' .* A) == (1,1)
        @test A .* b == b .* A == Matrix(A) .* Matrix(b)
        @test A .* b' == b' .* A == Matrix(A) .* Matrix(b')
        @test A .* B == B .* A == Matrix(A) .* Matrix(B)
    end

    @testset "broadcast with Int (#154)" begin
        b = BandedMatrix(8Ones(10,10), (2,1))
        @test BandedMatrices._isweakzero(round,Int,b)
        @test round.(Int, b) == round.(Int,Matrix(b))
    end

    @testset "degnerate bands" begin
		A = BandedMatrix(Zeros(1,1), (0,-3))
		C = BandedMatrix(Ones(1,1), (0,0))
		C .= 0.0 .- A
		@test C == zeros(1,1)
		C .= A .- 0.0
        @test C == zeros(1,1)

        A = BandedMatrix(Eye(3,4))
        B = randn(3,4)
        bc = broadcasted(*, A, B)

        @test copyto!(similar(bc, Float64), bc) == A .* B == B .* A ==
            BandedMatrix(B, (0,0)) == Matrix(A) .* B
    end

    @testset "adding degenerate" begin
        A = BandedMatrix(1 => 1:9)
        B = BandedMatrix(-1 => 1:9)
        C = BandedMatrix(Fill(-1,10,10),(1,1))
        C .= A .+ B
        @test diag(C) == Zeros{Int}(10)
        C = BandedMatrix(Fill(-1,10,10),(1,1))
        C .= A .+ B
        @test diag(C) == Zeros{Int}(10)
    end

    @testset "nested broadcast" begin
        A = brand(5,4,2,1)
        x = randn(5)
        B = Base.Broadcast.broadcasted(*, Base.Broadcast.broadcasted(+, 2, x), A)
        @test bandwidths(B) == bandwidths(A) == bandwidths(Broadcast.materialize(B)) == (2,1)
        @test Broadcast.materialize(B) == (2 .+ x) .* Matrix(A)

        B = Base.Broadcast.broadcasted(+, Base.Broadcast.broadcasted(+, A, A), A)
        @test bandwidths(B) == bandwidths(A)
        @test (A .+ A) .+ A == 3A
    end

    @testset "ones special case" begin
        A = brand(5,4,2,1)
        @test Ones(5) .* A == A
        @test Ones(5,4) .* A == A
        @test Ones(5) .\ A == A
        @test Ones(5,4) .\ A == A
        @test Ones(5) ./ A == inv.(A)
        @test_throws DimensionMismatch Ones(3) .* A
        @test_throws DimensionMismatch Ones(3,4) .* A

        @test A .* Ones(5) == A
        @test A .* Ones(5,4) == A
        @test A ./ Ones(5) == A
        @test A ./ Ones(5,4) == A
        @test A .\ Ones(5) == inv.(A)
        @test_throws DimensionMismatch A .* Ones(3)
        @test_throws DimensionMismatch A .* Ones(3,4)
    end

    @testset "degenerate bands" begin
        A = BandedMatrix{Float64}(undef, (5, 5), (1,-1)); A.data .= NaN
        B = BandedMatrix{Float64}(undef, (5, 5), (-1,1)); B.data .= NaN
        Z = Diagonal(Zeros(5))
        copyto!(A, Z)
        copyto!(B, Z)
        @test A == B == zeros(5,5)

        a = BandedMatrix(Zeros(0,4), (-1,1))
        b = BandedMatrix(Zeros(0,4), (-1,2))
        @test a-b == a
    end

    @testset "zeros broadcasting" begin
        A = brand(5,4,2,1)
        Z = Zeros(5,4)
        @test Z .* A ≡ Z
        @test A .* Z ≡ Z
    end

    @testset "broadcasting to a band" begin
        B = brand(Int8, 6, 6, -2, 2)
        B[band(2)] .= 10
        @test all(==(10), diag(B, 2))
        @test all(==(10), B[band(2)])

        B = BandedMatrix{Int}(1=>1:4, -1=>2:5)
        B[band(1)] .= 2 .* view(B, band(-1)) .+ 4
        @test B[band(1)] == 2 .* (2:5) .+ 4

        B = brand(Int8, 2, 4, 1, 1)
        B[band(-1)] .= 2
        B[band(0)] .= 3
        B[band(1)] .= 4
        B[band(2)] .= 0
        @test B == [3 4 0 0; 2 3 4 0]

        B[band(-1)] .= 3:3
        @test all(==(3), @view B[band(-1)])
        B[band(0)] .= 4:5
        @test (@view B[band(0)]) == 4:5
        B[band(1)] .= 3:4
        @test (@view B[band(1)]) == 3:4
        B[band(1)] .= [3,4] .* 2 .+ 4
        @test (@view B[band(1)]) == [10,12]
        B[band(2)] .= [0,0]
        @test all(iszero, @view B[band(2)])
        B[band(2)] .= [0,0] .* 2
        @test all(iszero, @view B[band(2)])

        @test_throws BandError B[band(100)] .= 10
        @test_throws BandError B[band(-100)] .= 10
    end

    @testset "BigFloat l/rmul!" begin
        A = BandedMatrices._BandedMatrix(Matrix{BigFloat}(undef, 3, 5), 5, 1, 1)
        for j = axes(A,2), k = colsupport(A,j)
            A[k,j] = 1
        end
        B = 2A
        @test B == A*2
        lmul!(2, A)
        @test A == B
        rmul!(A, 2)
        @test A == 2B
    end
end

end # module

####################
# This example demonstrates a BandedMatrix on the GPU using CLArrays
# We construct the Matrix on the CPU first for now as this is currently
# slow when tried to do directly on the GPU.
####################

using GPUArrays, CLArrays, FillArrays, BandedMatrices
import BandedMatrices: _BandedMatrix

function finitedifference(::Type{T}, n, Δt) where T
    Δx = 2/n
    data = Array{eltype(Δt)}(3, n)
    data[2,:] = 1-2*Δt/Δx^2
    data[[1,3],:] = Δt/Δx^2
    _BandedMatrix(convert(T, data), n, 1, 1)
end


function expliciteuler(L, u₀, n)
    u = copy(u₀)
    v = copy(u)
    for _ = 1:n
        mul!(v, L, u)
        u,v = v,u
    end
    u
end

####
# 32 bit
####
nₓ = 20_000
Δx = 2f0/nₓ
Δt = Δx^2/8f0
T = 1f0 / 1_000
n_t = floor(Int, T/Δt)
L = finitedifference(CLArray, nₓ, Δt)

x= range(-1, stop=1, length=nₓ)
u₀ = CLArray{Float32}(exp.(-10x.^2));


@time begin
    u = expliciteuler(L, u₀, n_t);
    GPUArrays.synchronize(u)
end # 25s


L̃ = BandedMatrix{Float32,Matrix{Float32}}(L)
ũ₀ = Vector{Float32}(u₀)
@time ũ = expliciteuler(L̃, ũ₀, n_t); # 44s

maximum(abs, Array(u)-ũ)  # 3E-3


####
# 64 bit
####
nₓ = 20_000
Δx = 2/nₓ
Δt = Δx^2/8
T = 1f0 / 1_000
n_t = floor(Int, T/Δt)
L = finitedifference(CLArray, nₓ, Δt)

x= range(-1, stop=1, length=nₓ)
u₀ = CLArray(exp.(-10x.^2));


@time begin
    u = expliciteuler(L, u₀, n_t);
    GPUArrays.synchronize(u)
end # 30s

L̃ = BandedMatrix{Float64,Matrix{Float64}}(L)
ũ₀ = Vector{Float64}(u₀)
@time ũ = expliciteuler(L̃, ũ₀, n_t); # 45s

maximum(abs, Array(u)-ũ)  # 1.72E-13

##
# Sparse BroadcastStyle
##

for Typ in (:Diagonal, :SymTridiagonal, :Tridiagonal, :Bidiagonal)
    @eval begin
        BroadcastStyle(::StructuredMatrixStyle{<:$Typ}, ::BandedStyle) =
            BandedStyle()
        BroadcastStyle(::BandedStyle, ::StructuredMatrixStyle{<:$Typ}) =
            BandedStyle()
    end
end

# Here we implement the banded matrix interface for some key examples
isbanded(::Zeros) = true
bandwidths(::Zeros) = (-40320,-40320) # 40320 == prod(1:8), used for special cases involving gcd
inbands_getindex(::Zeros{T}, k::Integer, j::Integer) where T = zero(T)

isbanded(::RectDiagonal) = true
bandwidths(::RectDiagonal) = (0,0)
inbands_getindex(E::RectDiagonal, k::Integer, j::Integer) = E.diag[k]

isbanded(::Diagonal) = true
bandwidths(::Diagonal) = (0,0)
inbands_getindex(D::Diagonal, k::Integer, j::Integer) = D.diag[k]
inbands_setindex!(D::Diagonal, v, k::Integer, j::Integer) = (D.diag[k] = v)
function bandeddata(D::Union{Diagonal, Transpose{<:Any, <:Diagonal}, Adjoint{<:Any,<:Diagonal}})
    permutedims(diagonaldata(D))
end

#TODO: PermutedDimsArray(bandeddata(parent(Ac)), (2, 1))
bandedrowsdata(Ac::Transpose{<:Number}) = Transpose(bandeddata(parent(Ac)))
bandedrowsdata(Ac::Adjoint{<:Real}) = Transpose(bandeddata(parent(Ac)))
bandedrowsdata(V::SubArray{<:Number}) = Transpose(bandeddata(view(parent(parent(V)), reverse(parentindices(V))...)))

# treat subinds as banded
sublayout(::DiagonalLayout{L}, inds::Type) where L = sublayout(bandedcolumns(L()), inds)
sublayout(::DiagonalLayout{L}, inds::Type{<:NTuple{2,AbstractUnitRange{Int}}}) where L = sublayout(bandedcolumns(L()), inds)

# bandeddata(V::SubArray{<:Any,2,<:Diagonal}) = view(bandeddata(parent(V)), :, parentindices(V)[2])

isbanded(::Bidiagonal) = true
bandwidths(A::Bidiagonal) = A.uplo == 'U' ? (0,1) : (1,0)

sublayout(::BidiagonalLayout, ::Type{<:Tuple{AbstractUnitRange{Int},AbstractUnitRange{Int}}}) =
    BandedLayout()


isbanded(::SymTridiagonal) = true
bandwidths(::SymTridiagonal) = (1,1)
inbands_getindex(J::SymTridiagonal, k::Integer, j::Integer) =
    k == j ? J.dv[k] : J.ev[min(k,j)]
inbands_setindex!(J::SymTridiagonal, v, k::Integer, j::Integer) =
    k == j ? (J.dv[k] = v) : (J.ev[min(k,j)] = v)

isbanded(::Tridiagonal) = true
bandwidths(::Tridiagonal) = (1,1)

sublayout(::AbstractTridiagonalLayout, ::Type{<:Tuple{AbstractUnitRange{Int},AbstractUnitRange{Int}}}) =
    BandedLayout()

#Implement bandwidths for OneElement structure
function bandwidths(o::OneElementVector)
    k = FillArrays.nzind(o)[1] # index of non-zero
    n = length(o)
    if k > n || k < 1
        bandwidths(Zeros(o))
    else
        (k-1, 1-k)
    end
end

function bandwidths(o::OneElementMatrix)
    n,m = size(o)
    k,j = Tuple(FillArrays.nzind(o))  # indices of non-zero entries
    if k > n || j > m || k < 1 || j < 1
        bandwidths(Zeros(o))
    else
        (k-j,j-k)
    end
end

###
# rot180
###

function rot180(A::AbstractBandedMatrix)
    m,n = size(A)
    sh = m-n
    l,u = bandwidths(A)
    _BandedMatrix(bandeddata(A)[end:-1:1,end:-1:1], m, u+sh,l-sh)
end

for MT in (:Diagonal, :SymTridiagonal, :Tridiagonal, :Bidiagonal)
    @eval getindex(D::$MT{T,<:AbstractFill{T,1}}, b::Band) where {T<:Number} = diag(D, b.i)
end

function getindex(D::Diagonal{T,V}, b::Band) where {T,V}
    iszero(b.i) && return copy(D.diag)
    convert(V, Zeros{T}(size(D,1)-abs(b.i)))
end

function getindex(D::Tridiagonal{T,V}, b::Band) where {T,V}
    b.i == -1 && return copy(D.dl)
    iszero(b.i) && return copy(D.d)
    b.i == 1 && return copy(D.du)
    convert(V, Zeros{T}(size(D,1)-abs(b.i)))
end

function getindex(D::SymTridiagonal{T,V}, b::Band) where {T,V}
    iszero(b.i) && return copy(D.dv)
    abs(b.i) == 1 && return copy(D.ev)
    convert(V, Zeros{T}(size(D,1)-abs(b.i)))
end

function getindex(D::Bidiagonal{T,V}, b::Band) where {T,V}
    iszero(b.i) && return copy(D.dv)
    D.uplo == 'L' && b.i == -1 && return copy(D.ev)
    D.uplo == 'U' && b.i == 1 && return copy(D.ev)
    convert(V, Zeros{T}(size(D,1)-abs(b.i)))
end


Base.vcat(x::Union{OneElement, ZerosMatrix, AdjOrTrans{<:Any,<:ZerosVector}, AbstractBandedMatrix}...) = vcat(BandedMatrix.(x)...)

function banded_chol!(::BandedColumns{DenseColumnMajor},
                       A::AbstractMatrix{T}, ::Type{UpperTriangular}) where T<:BlasFloat
    _, info = pbtrf!('U', size(A, 1), bandwidth(A,2), bandeddata(A))
    UpperTriangular(A), info
end

function banded_chol!(::BandedColumns{DenseColumnMajor},
                      A::AbstractMatrix{T}, ::Type{LowerTriangular}) where T<:BlasFloat
    _, info = pbtrf!('L', size(A, 1), bandwidth(A,1), bandeddata(A))
    LowerTriangular(A), info
end

## Non BLAS/LAPACK element types (generic)
function banded_chol!(_, A::AbstractMatrix, ::Type{UpperTriangular})
    require_one_based_indexing(A)
    n = checksquare(A)
    u = bandwidth(A,2)
    @inbounds begin
        for k = 1:n
            for i = max(1,k-u):k - 1
                A[k,k] -= A[i,k]'A[i,k]
            end
            Akk, info = _chol!(A[k,k], UpperTriangular)
            if info != 0
                return UpperTriangular(A), info
            end
            A[k,k] = Akk
            AkkInv = inv(copy(Akk'))
            for j = k + 1:min(k+u,n)
                for i = max(1,j-u):k - 1
                    A[k,j] -= A[i,k]'A[i,j]
                end
                A[k,j] = AkkInv*A[k,j]
            end
        end
    end
    return UpperTriangular(A), convert(BlasInt, 0)
end
function banded_chol!(_, A::AbstractMatrix, ::Type{LowerTriangular})
    require_one_based_indexing(A)
    n = checksquare(A)
    l = bandwidth(A,1)
    @inbounds begin
        for k = 1:n
            for i = max(1,k-l):k - 1
                A[k,k] -= A[k,i]*A[k,i]'
            end
            Akk, info = _chol!(A[k,k], LowerTriangular)
            if info != 0
                return LowerTriangular(A), info
            end
            A[k,k] = Akk
            AkkInv = inv(Akk)
            for j = max(1,k-l):k - 1
                @simd for i = k + 1:min(n,j+l)
                    A[i,k] -= A[i,j]*A[k,j]'
                end
            end
            for i = k + 1:min(n,k+l)
                A[i,k] *= AkkInv'
            end
        end
     end
    return LowerTriangular(A), convert(BlasInt, 0)
end

banded_chol!(A, ::Type{T}) where T = banded_chol!(MemoryLayout(typeof(A)), A, T)
_chol!(A::AbstractBandedMatrix, ::Type{UpperTriangular}) = banded_chol!(A, UpperTriangular)
_chol!(A::AbstractBandedMatrix, ::Type{LowerTriangular}) = banded_chol!(A, LowerTriangular)

function _ldiv!(::BandedColumns{DenseColumnMajor}, ::AbstractStridedLayout,
                A::Cholesky{T}, B::AbstractVecOrMat{T}) where T<:BlasFloat
    if A.uplo == 'U'
        pbtrs!('U', size(A, 1), bandwidth(A.factors,2), bandeddata(A.factors), B)
    else
        pbtrs!('L', size(A, 1), bandwidth(A.factors,1), bandeddata(A.factors), B)
    end
    B
end

function _ldiv!(::AbstractBandedLayout, _, C::Cholesky, B::AbstractMatrix)
    if C.uplo == 'L'
        return ldiv!(adjoint(LowerTriangular(C.factors)), ldiv!(LowerTriangular(C.factors), B))
    else
        return ldiv!(UpperTriangular(C.factors), ldiv!(adjoint(UpperTriangular(C.factors)), B))
    end
end

ldiv!(A::Cholesky{T,<:AbstractBandedMatrix}, B::StridedVecOrMat{T}) where T<:BlasFloat =
    _ldiv!(MemoryLayout(typeof(A.factors)), MemoryLayout(typeof(B)), A, B)



# For some bizarre reason this isnt in LinearAlgebra
ArrayLayouts._cholesky(::Union{SymmetricLayout{<:AbstractBandedLayout},HermitianLayout{<:AbstractBandedLayout}}, ax, A, ::Val{false}=Val(false); check::Bool = true) =
    cholesky!(cholcopy(A); check = check)

cholcopy(A::RealHermSymComplexHerm{<:Any,<:BandedMatrix}) =
    copyto!(similar(A, LinearAlgebra.choltype(A)), A)
cholcopy(A::RealHermSymComplexHerm{<:Any,<:SubArray{<:Number, 2, <:BandedMatrix}}) =
    copyto!(similar(A, LinearAlgebra.choltype(A)), A)
# cholesky(A::Hermitian{T,<:BandedMatrix{T}},
#     ::Val{false}=Val(false); check::Bool = true) where T = cholesky!(cholcopy(A); check = check)

"Check that vect is correctly specified"
function chkvect(vect::AbstractChar)
    if !(vect == 'N' || vect == 'U' || vect == 'V')
        throw(ArgumentError("vect argument must be 'N' (X is not returned), or 'U' or 'V' (X is returned)"))
    end
    vect
end

for (fname, elty) in ((:dlargv_,:Float64),
                      (:slargv_,:Float32),
                      (:zlargv_,:ComplexF64),
                      (:clargv_,:ComplexF32))
    @eval begin
        #       SUBROUTINE DLARGV( N, X, INCX, Y, INCY, C, INCC )
        #       .. Scalar Arguments ..
        #       INTEGER INCC, INCX, INCY, N
        #       .. Array Arguments ..
        #       DOUBLE PRECISION C( * ), X( * ), Y( * )
        function largv!(n::Int, x::Ptr{$elty}, incx::Int, y::Ptr{$elty}, incy::Int, c::Ptr{$elty}, incc::Int)
            ccall((@blasfunc($fname), liblapack), Nothing, (Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}), n, x, incx, y, incy, c, incc)
        end
    end
end

for (fname, elty) in ((:dlartv_,:Float64),
                      (:slartv_,:Float32),
                      (:zlartv_,:ComplexF64),
                      (:clartv_,:ComplexF32))
    @eval begin
        #       SUBROUTINE DLARTV( N, X, INCX, Y, INCY, C, S, INCC )
        #       .. Scalar Arguments ..
        #       INTEGER INCC, INCX, INCY, N
        #       .. Array Arguments ..
        #       DOUBLE PRECISION C( * ), S( * ), X( * ), Y( * )
        function lartv!(n::Int, x::Ptr{$elty}, incx::Int, y::Ptr{$elty}, incy::Int, c::Ptr{$elty}, s::Ptr{$elty}, incc::Int)
            ccall((@blasfunc($fname), liblapack), Nothing, (Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}), n, x, incx, y, incy, c, s, incc)
        end
    end
end

for (fname, elty) in ((:drot_,:Float64),
                      (:srot_,:Float32),
                      (:zrot_,:ComplexF64),
                      (:crot_,:ComplexF32))
    @eval begin
        #       SUBROUTINE DROT(N,DX,INCX,DY,INCY,C,S)
        #       .. Scalar Arguments ..
        #       DOUBLE PRECISION C,S
        #       INTEGER INCX,INCY,N
        #       .. Array Arguments ..
        #       DOUBLE PRECISION DX(*),DY(*)
        function rot!(n::Int, x::Ptr{$elty}, incx::Int, y::Ptr{$elty}, incy::Int, c::$elty, s::$elty)
            ccall((@blasfunc($fname), libblas), Nothing, (Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ref{$elty}, Ref{$elty}), n, x, incx, y, incy, c, s)
        end
    end
end

for (fname, elty) in ((:dlartg_,:Float64),
                      (:slartg_,:Float32),
                      (:zlartg_,:ComplexF64),
                      (:clartg_,:ComplexF32))
    @eval begin
        #       SUBROUTINE DLARTG( F, G, CS, SN, R )
        #       .. Scalar Arguments ..
        #       DOUBLE PRECISION CS, F, G, R, SN
        function lartg!(f::$elty, g::$elty, cs::Ref{$elty}, sn::Ref{$elty}, r::Ref{$elty})
            ccall((@blasfunc($fname), liblapack), Nothing, (Ref{$elty}, Ref{$elty}, Ref{$elty}, Ref{$elty}, Ref{$elty}), f, g, cs, sn, r)
        end
    end
end

for (fname, elty) in ((:dlar2v_,:Float64),
                      (:slar2v_,:Float32),
                      (:zlar2v_,:ComplexF64),
                      (:clar2v_,:ComplexF32))
    @eval begin
        #       SUBROUTINE DLAR2V( N, X, Y, Z, INCX, C, S, INCC )
        #       .. Scalar Arguments ..
        #       INTEGER INCC, INCX, N
        #       .. Array Arguments ..
        #       DOUBLE PRECISION C( * ), S( * ), X( * ), Y( * ), Z( * )
        function lar2v!(n::Int, x::Ptr{$elty}, y::Ptr{$elty}, z::Ptr{$elty}, incx::Int, c::Ptr{$elty}, s::Ptr{$elty}, incc::Int)
            ccall((@blasfunc($fname), liblapack), Nothing, (Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}), n, x, y, z, incx, c, s, incc)
        end
    end
end

## Symmetric tridiagonalization
for (fname, elty) in ((:dsbtrd_,:Float64),
                      (:ssbtrd_,:Float32))
    @eval begin
        function sbtrd!(vect::Char, uplo::Char,
                        m::Int, k::Int, A::AbstractMatrix{$elty},
                        d::AbstractVector{$elty}, e::AbstractVector{$elty}, Q::AbstractMatrix{$elty},
                        work::AbstractVector{$elty})
            require_one_based_indexing(A)
            chkstride1(A)
            chkuplo(uplo)
            chkvect(vect)
            info = Ref{BlasInt}()
            n    = size(A,2)
            n ≠ m && throw(ArgumentError("Matrix must be square"))
            size(A,1) < k+1 && throw(ArgumentError("Not enough bands"))
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{UInt8},
                 Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{BlasInt}),
                 vect, uplo,
                 n, k, A, max(1,stride(A,2)),
                 d, e, Q, max(1,stride(Q,2)), work, info)
            LAPACK.chklapackerror(info[])
            d, e, Q
        end
    end
end

for (fname, elty) in ((:zhbtrd_,:ComplexF64),
                      (:chbtrd_,:ComplexF32))
    @eval begin
        local Relty = real($elty)
        function hbtrd!(vect::Char, uplo::Char,
                        m::Int, k::Int, A::AbstractMatrix{$elty},
                        d::AbstractVector{Relty}, e::AbstractVector{Relty}, Q::AbstractMatrix{$elty},
                        work::AbstractVector{$elty})
            require_one_based_indexing(A)
            chkstride1(A)
            chkuplo(uplo)
            chkvect(vect)
            info = Ref{BlasInt}()
            n    = size(A,2)
            n ≠ m && throw(ArgumentError("Matrix must be square"))
            size(A,1) < k+1 && throw(ArgumentError("Not enough bands"))
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (
                    Ref{UInt8},
                    Ref{UInt8},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{Relty},
                    Ptr{Relty},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ptr{BlasInt},
                ),
                 vect,
                 uplo,
                 n,
                 k,
                 A,
                 max(1,stride(A,2)),
                 d,
                 e,
                 Q,
                 max(1,stride(Q,2)),
                 work,
                 info
            )
            LAPACK.chklapackerror(info[])
            d, e, Q
        end
    end
end

## Bidiagonalization
for (fname, elty) in ((:dgbbrd_,:Float64),
                      (:sgbbrd_,:Float32))
    @eval begin
        function gbbrd!(vect::Char, m::Int, n::Int, ncc::Int,
                        kl::Int, ku::Int, ab::AbstractMatrix{$elty},
                        d::AbstractVector{$elty}, e::AbstractVector{$elty}, Q::AbstractMatrix{$elty},
                        Pt::AbstractMatrix{$elty}, C::AbstractMatrix{$elty}, work::AbstractVector{$elty})
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                 Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{BlasInt}),
                 vect, m, n, ncc,
                 kl, ku, ab, max(1,stride(ab,2)),
                 d, e, Q, max(1,stride(Q,2)),
                 Pt, max(1,stride(Pt,2)), C, max(1,stride(C,2)), work, info)
            LAPACK.chklapackerror(info[])
            d, e, Q, Pt, C
        end
    end
end

for (fname, elty) in ((:zgbbrd_,:ComplexF64),
                      (:cgbbrd_,:ComplexF32))
    @eval begin
        local Relty = real($elty)
        function gbbrd!(vect::Char, m::Int, n::Int, ncc::Int,
                        kl::Int, ku::Int, ab::AbstractMatrix{$elty},
                        d::AbstractVector{Relty}, e::AbstractVector{Relty}, Q::AbstractMatrix{$elty},
                        Pt::AbstractMatrix{$elty}, C::AbstractMatrix{$elty}, work::AbstractVector{$elty},
                        rwork::AbstractVector{Relty})
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                 Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{Relty}, Ptr{Relty}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{Relty}, Ptr{BlasInt}),
                 vect, m, n, ncc,
                 kl, ku, ab, max(1,stride(ab,2)),
                 d, e, Q, max(1,stride(Q,2)),
                 Pt, max(1,stride(Pt,2)), C, max(1,stride(C,2)), work, rwork, info)
            LAPACK.chklapackerror(info[])
            d, e, Q, Pt, C
        end
    end
end

# All the eigenvalues and, optionally, eigenvectors of a real symmetric band matrix A.
for (fname, elty) in ((:dsbev_,:Float64),
                      (:ssbev_,:Float32))
    @eval begin
                # SUBROUTINE       SUBROUTINE DSBEV( JOBZ, UPLO, N, KD, AB, LDAB, W, Z, LDZ, WORK,
                #     $                  INFO )
                # CHARACTER          JOBZ, UPLO
                # INTEGER            INFO, KD, LDAB, LDZ, N
                # DOUBLE PRECISION   AB( LDAB, * ), W( * ), WORK( * ), Z( LDZ, * )

        function sbev!(jobz::Char, uplo::Char, n::Int, kd::Int, AB::AbstractMatrix{$elty},
                       w::AbstractVector{$elty}, Z::AbstractMatrix{$elty}, work::AbstractVector{$elty})
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty},
                 Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{BlasInt}),
                 jobz, uplo, n, kd, AB, max(stride(AB,2),1), w, Z, max(stride(Z,2),1), work, info)
            LAPACK.chklapackerror(info[])
            w, Z
        end
    end
end

# All the generalized eigenvalues and, optionally, eigenvectors of a real symmetric-definite pencil (A,B).
for (fname, elty) in ((:dsbgv_,:Float64),
                      (:ssbgv_,:Float32))
    @eval begin
                # SUBROUTINE       DSBGV( JOBZ, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, W, Z,
                #     $                  LDZ, WORK, INFO )
                # CHARACTER          JOBZ, UPLO
                # INTEGER            INFO, KA, KB, LDAB, LDBB, LDZ, N
                # DOUBLE PRECISION   AB( LDAB, * ), BB( LDBB, * ), W( * ), WORK( * ), Z( LDZ, * )

        function sbgv!(jobz::Char, uplo::Char, n::Int, ka::Int, kb::Int, AB::AbstractMatrix{$elty},
                       BB::AbstractMatrix{$elty}, w::AbstractVector{$elty}, Z::AbstractMatrix{$elty}, work::AbstractVector{$elty})
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{BlasInt}),
                 jobz, uplo, n, ka, kb, AB, max(stride(AB,2),1), BB, max(stride(BB,2),1), w, Z, max(stride(Z,2),1), work, info)
            LAPACK.chklapackerror(info[])
            w, Z
        end
    end
end



# Symmetric/Hermitian Positive Definite banded Cholesky factorization
for (fname, elty) in ((:dpbtrf_,:Float64),
                      (:spbtrf_,:Float32),
                      (:zpbtrf_,:ComplexF64),
                      (:cpbtrf_,:ComplexF32))
    @eval begin
                # SUBROUTINE DPBTRF( UPLO, N, KD, AB, LDAB, INFO )
                # CHARACTER          UPLO
                # INTEGER            INFO, KD, LDAB, N
                # DOUBLE PRECISION   AB( LDAB, * )

        function pbtrf!(uplo::Char, m::Int, kd::Int, A::AbstractMatrix{$elty})
            require_one_based_indexing(A)
            chkstride1(A)
            chkuplo(uplo)
            info = Ref{BlasInt}()
            n    = size(A,2)
            n ≠ m && throw(ArgumentError("Matrix must be square"))
            size(A,1) < kd+1 && throw(ArgumentError("Not enough bands"))
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}),
                 uplo, n, kd,
                 A, max(1,stride(A,2)), info)
            LAPACK.chkargsok(info[])
            A, info[]
        end
    end
end

# Symmetric/Hermitian Positive Definite banded Cholesky solver
for (fname, elty) in ((:dpbtrs_,:Float64),
                      (:spbtrs_,:Float32),
                      (:zpbtrs_,:ComplexF64),
                      (:cpbtrs_,:ComplexF32))
    @eval begin
                # SUBROUTINE DPBTRS( UPLO, N, KD, NRHS, AB, LDAB, B, LDB, INFO )
                # CHARACTER          UPLO
                # INTEGER            INFO, KD, LDAB, LDB, N
                # DOUBLE PRECISION   AB( LDAB, * ), B( LDB, * )

        function pbtrs!(uplo::Char, m::Int, kd::Int, A::AbstractMatrix{$elty},
                        B::AbstractVecOrMat{$elty})
            require_one_based_indexing(A)
            chkstride1(A)
            chkuplo(uplo)
            info = Ref{BlasInt}()
            n    = size(A,2)
            if m != n || m != size(B,1)
                throw(DimensionMismatch("matrix A has dimensions $(size(A)), but right hand side matrix B has dimensions $(size(B))"))
            end
            size(A,1) < kd+1 && throw(ArgumentError("Not enough bands"))
            ccall((@blasfunc($fname), liblapack), Nothing,
                  (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                   Ptr{$elty}, Ref{BlasInt},
                   Ptr{$elty}, Ref{BlasInt},
                   Ptr{BlasInt}),
                  uplo, n, kd, size(B,2),
                  A, max(1,stride(A,2)),
                  B, max(1,stride(B,2)),
                  info)
            LAPACK.chklapackerror(info[])
            B
        end
    end
end

# Symmetric/Hermitian Positive Definite split-Cholesky factorization
for (fname, elty) in ((:dpbstf_,:Float64),
                      (:spbstf_,:Float32),
                      (:zpbstf_,:ComplexF64),
                      (:cpbstf_,:ComplexF32))
    @eval begin
                # SUBROUTINE DPBSTF( UPLO, N, KD, AB, LDAB, INFO )
                # CHARACTER          UPLO
                # INTEGER            INFO, KD, LDAB, N
                # DOUBLE PRECISION   AB( LDAB, * )

        function pbstf!(uplo::Char, m::Int, kd::Int, A::AbstractMatrix{$elty})
            require_one_based_indexing(A)
            chkstride1(A)
            chkuplo(uplo)
            info = Ref{BlasInt}()
            n    = size(A,2)
            n ≠ m && throw(ArgumentError("Matrix must be square"))
            size(A,1) < kd+1 && throw(ArgumentError("Not enough bands"))
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}),
                 uplo, n, kd,
                 A, max(1,stride(A,2)), info)
            LAPACK.chklapackerror(info[])
            A
        end
    end
end

# Convert Symmetric Positive Definite generalized eigenvalue problem
# to a symmetric eigenvalue problem assuming B has been processed by
# a split-Cholesky factorization.
for (fname, elty) in ((:dsbgst_,:Float64),
                      (:ssbgst_,:Float32))
    @eval begin
                # SUBROUTINE DSBGST( VECT, UPLO, N, KA, KB, AB, LDAB,
                # BB, LDBB, X, LDX, WORK, INFO )
                # CHARACTER          UPLO, VECT
                # INTEGER            INFO, KA, KB, LDAB, LDBB, LDX, N
                # DOUBLE PRECISION   AB( LDAB, * ), BB( LDBB, * ), WORK( * ),
                # X( LDX, * )

        function sbgst!(vect::Char, uplo::Char, n::Int, ka::Int, kb::Int,
                         AB::AbstractMatrix{$elty}, BB::AbstractMatrix{$elty},
                         X::AbstractVecOrMat{$elty}, work::AbstractVector{$elty})
            require_one_based_indexing(AB, BB, X, work)
            chkstride1(AB, BB)
            chkuplo(uplo)
            chkvect(vect)
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                 Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                 Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty},
                 Ptr{BlasInt}),
                 vect, uplo, n, ka,
                 kb, AB, max(stride(AB,2),1), BB,
                 max(stride(BB,2),1), X, max(1,stride(X,2)), work,
                 info)
            LAPACK.chklapackerror(info[])
            AB
        end
    end
end

# Convert a complex Hermitian Positive Definite generalized eigenvalue problem
# to a symmetric eigenvalue problem assuming B has been processed by
# a split-Cholesky factorization.
for (fname, elty) in ((:zhbgst_, :ComplexF64),
                      (:chbgst_, :ComplexF32))
    @eval begin
        #=
        subroutine zhbgst   (
        character   VECT,
        character   UPLO,
        integer     N,
        integer     KA,
        integer     KB,
        complex*16, dimension( ldab, * )    AB,
        integer     LDAB,
        complex*16, dimension( ldbb, * )    BB,
        integer     LDBB,
        complex*16, dimension( ldx, * )     X,
        integer     LDX,
        complex*16, dimension( * )      WORK,
        double precision, dimension( * )    RWORK,
        integer     INFO
        )
        =#
        local Relty = real($elty)
        function hbgst!(vect::Char, uplo::Char, n::Int, ka::Int, kb::Int,
                         AB::StridedMatrix{$elty}, BB::StridedMatrix{$elty},
                         X::StridedMatrix{$elty}, work::StridedVector{$elty},
                         rwork::StridedVector{Relty})
            require_one_based_indexing(AB, BB, X, work)
            chkstride1(AB, BB)
            chkuplo(uplo)
            chkvect(vect)
            info  = Ref{BlasInt}()
            ccall((@blasfunc($fname), liblapack), Nothing,
                (
                    Ref{UInt8},
                    Ref{UInt8},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ptr{Relty},
                    Ref{BlasInt},
                ),
                vect,
                uplo,
                n,
                ka,
                kb,
                AB,
                max(stride(AB,2),1),
                BB,
                max(stride(BB,2),1),
                X,
                max(stride(X,2),1),
                work,
                rwork,
                info,
                )

            LAPACK.chklapackerror(info[])
            AB
        end
    end
end

"""
    tridiagonalize(A, d::Integer=0)

The symmetric real or Hermitian input matrix `A` is transformed to a real
`SymTridiagonal` matrix.
For general matrices only `d` superdiagonals are processed.
Works efficiently for `BandedMatrices`.
"""
function tridiagonalize(A::Union{Symmetric{<:Real},Hermitian}, d::Integer=0)
    m, n = size(A)
    m == n || throw(DimensionMismatch("matrix is not square: dimensions are $((m, n))"))
    dmax = bandwidth(A) + 1
    if d == 0
        d = min(n, dmax)
    end

    0 < d <= dmax || throw(ArgumentError("number of diagonals $d not in 1:$dmax"))

    B = copybands(A, d)
    td = _tridiag_algorithm!(B)
    dv = [real(B[1,i]) for i in 1:n]
    ev = d > 1 ? [-abs(B[2,i]) for i = 2:n] : zeros(real(eltype(A)), n-1)
    SymTridiagonal(dv, ev)
end

# B[1:q,1:n] has the bands of a (2q-1)-banded hermitian nxn-matrix.
# superdiagonal i valid in B[i,i+1:n]. B is completely overwritten.
# The result is in B[1:2,1:nvens2]
function _tridiag_algorithm!(B)
    d, n = size(B)
    0 < d <= n || throw(ArgumentError("number of diagonals $d not in 1:$n"))

    @inbounds for bm = d-1:-1:2
        for k = 1:n-bm
            kp = k
            apiv = B[bm+1,bm+kp]
            iszero(apiv) && continue
            for i = bm+k-1:bm:n-1
                b = B[ i-kp+1,i]
                c, s, r = LinearAlgebra.givensAlgorithm(b, apiv)
                u, v = B[1,i], B[1,i+1]
                upx = (u + v) / 2
                B[1,i] = (u - v) / 2
                B[i-kp+1,i] = r
                for j = kp+1:i
                    u = B[i-j+1,i]
                    v = B[i-j+2,i+1]
                    B[i-j+1,i], B[i-j+2,i+1] = u * c + v * s, -u * s' + v * c
                end
                B[1,i+1] = -(B[1,i])'
                ip = i + bm
                for j = i+1:min(ip, n)
                    u = B[j-i+1,j]
                    v = B[j-i,j]
                    B[j-i+1,j], B[j-i,j] = u * c + v * s', -u * s + v * c
                end
                w = real(B[1,i+1])
                B[1,i] = upx - w
                B[1,i+1] = upx + w
                if ip < n
                    v = B[ip-i+1,ip+1]
                    apiv, B[ip-i+1,ip+1] = v * s', v * c
                end
                kp = i
            end
        end
    end
    B
end

# generalization of method for symmetric BandedMatrices
bandwidth(A::AbstractMatrix) = min(size(A)...) - 1

function copybands(A::AbstractMatrix{T}, d::Integer) where T
    n = min(size(A)...)
    d = min(d, n)
    B = Matrix{T}(undef, d, n)
    for i = 1:d
        B[i,1:i-1] .= zero(T)
        for j = i:n
            B[i,j] = A[j-i+1,j]
        end
    end
    B
end

function _tridiagonalize!(A::AbstractMatrix{T}, ::SymmetricLayout{<:BandedColumnMajor}) where T<:BlasReal
    n=size(A, 1)
    d = Vector{T}(undef,n)
    e = Vector{T}(undef,n-1)
    Q = Matrix{T}(undef,0,0)
    work = Vector{T}(undef,n)
    sbtrd!('N', symmetricuplo(A), size(A,1), bandwidth(A), symbandeddata(A), d, e, Q, work)
    SymTridiagonal(d,e)
end

function _tridiagonalize!(A::AbstractMatrix{T}, ::HermitianLayout{<:BandedColumnMajor}) where T<:BlasComplex
    n=size(A, 1)
    d = Vector{real(T)}(undef,n)
    e = Vector{real(T)}(undef,n-1)
    Q = Matrix{T}(undef,0,0)
    work = Vector{T}(undef,n)
    hbtrd!('N', symmetricuplo(A), size(A,1), bandwidth(A), hermbandeddata(A), d, e, Q, work)
    SymTridiagonal(d,e)
end

tridiagonalize!(A::AbstractMatrix{<:BlasFloat}) = _tridiagonalize!(A, MemoryLayout(typeof(A)))

module TestTriBanded

using BandedMatrices, LinearAlgebra, ArrayLayouts, Test
import BandedMatrices: BandedColumns, BandedRows, isbanded


@testset "Triangular" begin
    @testset "Upper" begin
        for (t, ud) in ((UpperTriangular, 'N'), (UnitUpperTriangular, 'U'))
            A = t(brand(10,10,1,2))
            @test isbanded(A)
            @test MemoryLayout(typeof(A)) == TriangularLayout{'U',ud,BandedColumns{DenseColumnMajor}}()
            @test bandwidths(A) == bandwidths(BandedMatrix(A)) == (0,2)
            @test bandwidth(A,2) == 2
            @test BandedMatrix(A) == A
            @test A[2,1] == 0
            if( ud == 'U' )
                @test A[2,2] == 1
            end
            x=rand(10)
            @test A*x ≈ BandedMatrix(A)*x ≈ Matrix(A)*x
            @test transpose(A)*x ≈ transpose(BandedMatrix(A))*x ≈ transpose(Matrix(A))*x
            @test all(A*x .≈ lmul!(A, copy(x)) .=== lmul(A,x) .===
                        BandedMatrices.tbmv!('U', 'N', ud, 10, 2, parent(A).data, copy(x)))
            @test_throws DimensionMismatch BandedMatrices.tbmv('U', 'N', ud, 10, 2, parent(A).data, rand(9))

            @test A\x ≈ Matrix(A) \ x ≈ BandedMatrix(A) \ x
            @test all((A \ x) .=== ldiv!(A, copy(x)) .=== copyto!(similar(x), Ldiv(A, x)) .=== (similar(x) .= Ldiv(A, x)) .===
                        BandedMatrices.tbsv!('U', 'N', ud, 10, 2, parent(A).data, copy(x)))
            @test_throws DimensionMismatch BandedMatrices.tbsv('U', 'N', ud, 10, 2, parent(A).data, rand(9))
        end
    end
    @testset "Lower" begin
        for (t, ud) in ((LowerTriangular, 'N'), (UnitLowerTriangular, 'U'))
            A = t(brand(10,10,1,2))
            @test isbanded(A)
            @test MemoryLayout(typeof(A)) == TriangularLayout{'L', ud,BandedColumns{DenseColumnMajor}}()
            @test bandwidths(A) == bandwidths(BandedMatrix(A)) == (1,0)
            @test bandwidth(A,2) == 0
            @test BandedMatrix(A) == A
            @test A[1,2] == 0
            if( ud == 'U' )
                @test A[2,2] == 1
            end

            x=rand(10)
            @test A*x ≈ Matrix(A)*x
            @test transpose(A)*x ≈ transpose(BandedMatrix(A))*x ≈ transpose(Matrix(A))*x
            @test all(A*x .≈ lmul!(A, copy(x)) .=== lmul(A,x) .===
                        BandedMatrices.tbmv!('L', 'N', ud, 10, 1, view(parent(A).data, 3:4,:), copy(x)))
            @test_throws DimensionMismatch BandedMatrices.tbmv('L', 'N', ud, 10, 1, view(parent(A).data, 3:4,:), rand(9))

            @test A\x ≈ Matrix(A) \ x ≈ BandedMatrix(A) \ x
            @test all((A \ x) .=== ldiv!(A, copy(x)) .=== copyto!(similar(x), Ldiv(A, x)) .=== (similar(x) .= Ldiv(A, x)) .===
                        BandedMatrices.tbsv!('L', 'N', ud, 10, 1, view(parent(A).data, 3:4,:), copy(x)))
            @test_throws DimensionMismatch BandedMatrices.tbsv('L', 'N', ud, 10, 1, view(parent(A).data, 3:4,:), rand(9))
        end
    end

    @testset "subarray" begin
        A = brand(6,6,2,1)
        L = LowerTriangular(A)
        U = UpperTriangular(A)
        V = view(L,2:4,1:3)
        @test MemoryLayout(V) isa BandedColumns{DenseColumnMajor}
        @test L[2:4,1:3] == BandedMatrix(V) == LowerTriangular(Matrix(A))[2:4,1:3]
        @test L[2:4,1:3] isa BandedMatrix
        @test bandwidths(L[2:4,1:3]) == bandwidths(V) == (1,1)
        @test U[2:4,1:3] == UpperTriangular(Matrix(A))[2:4,1:3]
        @test U[2:4,1:3] isa BandedMatrix
        @test bandwidths(U[2:4,1:3]) == (-1,2)
    end

    @testset "row major" begin
        A = brand(5,5,2,1)
        b = randn(5)
        U = UpperTriangular(A')
        L = LowerTriangular(A')
        Ũ = LowerTriangular(A)'
        L̃ = UpperTriangular(A)'
        @test MemoryLayout(U) isa TriangularLayout{'U','N',BandedRows{DenseColumnMajor}}
        @test U*b ≈ ArrayLayouts.lmul!(U,copy(b)) ≈ Matrix(U)*b
        @test L*b ≈ ArrayLayouts.lmul!(L,copy(b)) ≈ Matrix(L)*b
        @test ldiv!(U,copy(b)) ≈ ArrayLayouts.ldiv!(U,copy(b)) ≈ U\b ≈ Matrix(U)\b
        @test ldiv!(L,copy(b)) ≈ ArrayLayouts.ldiv!(L,copy(b)) ≈ L\b ≈ Matrix(L)\b
        @test ldiv!(Ũ,copy(b)) ≈ ArrayLayouts.ldiv!(Ũ,copy(b)) ≈ Ũ\b ≈ Matrix(Ũ)\b
        @test ldiv!(L̃,copy(b)) ≈ ArrayLayouts.ldiv!(L̃,copy(b)) ≈ L̃\b ≈ Matrix(L̃)\b

        B = randn(5,5)

        @test U*B ≈ ArrayLayouts.lmul!(U,copy(B)) ≈ Matrix(U)*B
        @test L*B ≈ ArrayLayouts.lmul!(L,copy(B)) ≈ Matrix(L)*B
        @test B*U ≈ ArrayLayouts.rmul!(copy(B),U) ≈ B*Matrix(U)
        @test B*L ≈ ArrayLayouts.rmul!(copy(B),L) ≈ B*Matrix(L)

        @test U \ B ≈ Matrix(U) \ B
        @test B / U ≈ B / Matrix(U)
        @test L \ B ≈ Matrix(L) \ B
        @test B / L ≈ B / Matrix(L)
        @test Ũ \ B ≈ Matrix(Ũ) \ B
        @test B / Ũ ≈ B / Matrix(Ũ)
        @test L̃ \ B ≈ Matrix(L̃) \ B
        @test B / L̃ ≈ B / Matrix(L̃)
    end

    @testset "rot180" begin
        B = brand(5,5,2,1)
        @test rot180(UpperTriangular(B)) isa LowerTriangular{<:Any,<:BandedMatrix}
        @test rot180(UnitUpperTriangular(B)) isa UnitLowerTriangular{<:Any,<:BandedMatrix}
        @test rot180(LowerTriangular(B)) isa UpperTriangular{<:Any,<:BandedMatrix}
        @test rot180(UnitLowerTriangular(B)) isa UnitUpperTriangular{<:Any,<:BandedMatrix}
        @test rot180(UpperTriangular(B)) == rot180(Matrix(UpperTriangular(B)))
        @test rot180(UnitUpperTriangular(B)) == rot180(Matrix(UnitUpperTriangular(B)))
        @test rot180(LowerTriangular(B)) == rot180(Matrix(LowerTriangular(B)))
        @test rot180(UnitLowerTriangular(B)) == rot180(Matrix(UnitLowerTriangular(B)))
    end

    @testset "empty uppertriangular" begin
        B = brand(0,0,2,1)
        @test UpperTriangular(B) \ Float64[] == Float64[]
    end
end

end # module

_qr(::AbstractBandedLayout, ax, A) = _banded_qr(ax, A)
_banded_qr(_, A) = qr!(BandedMatrix{float(eltype(A))}(A, (bandwidth(A,1),bandwidth(A,1)+bandwidth(A,2))))

qr(A::Tridiagonal{T}) where T = qr!(BandedMatrix{float(T)}(A, (1,2)))
_qr!(::AbstractBandedLayout, _, A) = banded_qr!(A)


function _banded_qr!(R::AbstractMatrix{T}, τ) where T
    m,n=size(R)
    _banded_qr!(R, τ, min(m - 1 + !(T<:Real), n))
end

function _banded_qr!(R::AbstractMatrix, τ, ncols)
    D = bandeddata(R)
    l,u = bandwidths(R)
    ν = l+u+1
    m,n=size(R)

    for k = 1:ncols
        x = view(D,u+1:min(ν,m-k+u+1), k)
        τk = reflector!(x)
        τ[k] = τk
        for j = 1:min(u,n-k)
            reflectorApply!(x, τk, view(D, u+1-j:min(ν-j,m-k-j+u+1), k+j:k+j))
        end
    end
    R, τ
end

function banded_qr!(R::AbstractMatrix{T}, τ) where T
   _banded_qr!(R, τ)
   QR(R, convert(Vector{T},τ)) # TODO: remove convert
end

banded_qr!(R::AbstractMatrix{T}) where T = banded_qr!(R, zeros(T, min(size(R)...)))


function banded_qr_lmul!(A, B)
    require_one_based_indexing(B)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if mA != mB
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    l,u = bandwidths(Afactors)
    D = bandeddata(Afactors)
    @inbounds begin
        for k = min(mA,nA,last(colsupport(B)),length(A.τ)):-1:1
            for j = 1:nB
                vBj = B[k,j]
                for i = k+max(1,-u):min(k+l,mB)
                    vBj += conj(D[i-k+u+1,k])*B[i,j]
                end
                vBj = A.τ[k]*vBj
                B[k,j] -= vBj
                for i = k+max(1,-u):min(k+l,mB)
                    B[i,j] -= D[i-k+u+1,k]*vBj
                end
            end
        end
    end
    B
end

function banded_qr_lmul!(adjA::AdjointQ, B)
    require_one_based_indexing(B)
    A = parent(adjA)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if mA != mB
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    l,u = bandwidths(Afactors)
    D = bandeddata(Afactors)
    @inbounds begin
        for j = 1:nB
            cs = colsupport(B,j)
            for k = max(1,minimum(cs)):min(mA,nA,maximum(cs)+l,length(A.τ))
                vBj = B[k,j]
                for i = k+max(1,-u):min(k+l,mB)
                    vBj += conj(D[i-k+u+1,k])*B[i,j]
                end
                vBj = conj(A.τ[k])*vBj
                B[k,j] -= vBj
                for i = k+max(1,-u):min(k+l,mB)
                    B[i,j] -= D[i-k+u+1,k]*vBj
                end
            end
        end
    end
    B
end

function banded_qr_rmul!(A, Q)
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != mQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($mQ, $nQ)"))
    end
    Qfactors = Q.factors
    l,u = bandwidths(Qfactors)
    D = bandeddata(Qfactors)
    @inbounds begin
        for k = 1:min(mQ,nQ)
            for i = 1:mA
                vAi = A[i,k]
                for j = k+1:min(k+l,mQ)
                    vAi += A[i,j]*D[j-k+u+1,k]
                end
                vAi = vAi*Q.τ[k]
                A[i,k] -= vAi
                for j = k+1:min(k+l,nA)
                    A[i,j] -= vAi*conj(D[j-k+u+1,k])
                end
            end
        end
    end
    A
end
function banded_qr_rmul!(A, adjQ::AdjointQ)
    Q = parent(adjQ)
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != mQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($mQ, $nQ)"))
    end
    Qfactors = Q.factors
    l,u = bandwidths(Qfactors)
    D = bandeddata(Qfactors)
    @inbounds begin
        for k = min(mQ,nQ):-1:1
            for i = 1:mA
                vAi = A[i,k]
                for j = k+1:min(k+l,mQ)
                    vAi += A[i,j]*D[j-k+u+1,k]
                end
                vAi = vAi*conj(Q.τ[k])
                A[i,k] -= vAi
                for j = k+1:min(k+l,nA)
                    A[i,j] -= vAi*conj(D[j-k+u+1,k])
                end
            end
        end
    end
    A
end

banded_lmul!(A::QRPackedQ, B::AbstractVecOrMat) = banded_qr_lmul!(A, B)
banded_lmul!(adjA::AdjointQ{<:Any,<:QRPackedQ}, B::AbstractVecOrMat) = banded_qr_lmul!(adjA, B)
banded_rmul!(A::AbstractMatrix, Q::QRPackedQ) = banded_qr_rmul!(A, Q)
banded_rmul!(A::AbstractMatrix, adjQ::AdjointQ{<:Any,<:QRPackedQ}) = banded_qr_rmul!(A, adjQ)

lmul!(A::QRPackedQ{<:Any,<:AbstractBandedMatrix}, B::AbstractVector) = banded_lmul!(A,B)
lmul!(A::QRPackedQ{<:Any,<:AbstractBandedMatrix}, B::AbstractMatrix) = banded_lmul!(A,B)
lmul!(adjA::AdjointQ{<:Any,<:QRPackedQ{<:Any,<:AbstractBandedMatrix}}, B::AbstractVector) = banded_lmul!(adjA,B)
lmul!(adjA::AdjointQ{<:Any,<:QRPackedQ{<:Any,<:AbstractBandedMatrix}}, B::AbstractMatrix) = banded_lmul!(adjA,B)
lmul!(adjA::AdjointQ{<:Any,<:QRPackedQ{<:Any,<:AbstractBandedMatrix}}, B::LayoutVecOrMats) = banded_lmul!(adjA,B)
lmul!(A::QRPackedQ{<:Any,<:BandedSubBandedMatrix{T,C,R,I1,I2}}, B::AbstractVector) where {T,C,R,I1<:AbstractUnitRange,I2<:AbstractUnitRange} =
    banded_lmul!(A,B)
lmul!(A::QRPackedQ{<:Any,<:BandedSubBandedMatrix{T,C,R,I1,I2}}, B::AbstractMatrix) where {T,C,R,I1<:AbstractUnitRange,I2<:AbstractUnitRange} =
    banded_lmul!(A,B)
lmul!(adjA::AdjointQ{T,<:QRPackedQ{T,<:BandedSubBandedMatrix{T,C,R,I1,I2,t}}}, B::AbstractVector) where {T,C,R,I1<:AbstractUnitRange,I2<:AbstractUnitRange,t} =
    banded_lmul!(adjA,B)
lmul!(adjA::AdjointQ{T,<:QRPackedQ{T,<:BandedSubBandedMatrix{T,C,R,I1,I2,t}}}, B::AbstractMatrix) where {T,C,R,I1<:AbstractUnitRange,I2<:AbstractUnitRange,t} =
    banded_lmul!(adjA,B)
# rmul!(A::AbstractMatrix, adjQ::AdjointQ{<:Any,<:QRPackedQ{<:Any,<:AbstractBandedMatrix}}) = banded_rmul!(A, adjA)
# rmul!(A::StridedMatrix, adjQ::AdjointQ{<:Any,<:QRPackedQ{<:Any,<:AbstractBandedMatrix}}) = banded_rmul!(A, adjA)
rmul!(A::StridedVecOrMat{T}, Q::QRPackedQ{T,B}) where {T<:BlasFloat,B<:AbstractBandedMatrix{T}} = banded_rmul!(A, Q)
rmul!(A::StridedVecOrMat{T}, adjQ::AdjointQ{<:Any,<:QRPackedQ{T,B}}) where {T<:BlasComplex,B<:AbstractBandedMatrix{T}} = banded_rmul!(A, adjQ)
rmul!(A::StridedVecOrMat{T}, adjQ::AdjointQ{<:Any,<:QRPackedQ{T,B}}) where {T<:BlasReal,B<:AbstractBandedMatrix{T}} = banded_rmul!(A, adjQ)


function _banded_widerect_ldiv!(A::QR{T}, B) where T
    error("Not implemented")
end
function _banded_longrect_ldiv!(A::QR, B)
    m, n = size(A)
    R = A.factors
    lmul!(adjoint(A.Q), B)
    B̃ = view(B, 1:n, :)
    B̃ .= Ldiv(UpperTriangular(view(R, 1:n, 1:n)), B̃)
    B
end
function _banded_square_ldiv!(A::QR, B)
    R = A.factors
    lmul!(adjoint(A.Q), B)
    B .= Ldiv(UpperTriangular(R), B)
    B
end

const UpperLayoutMatrix{T} = UpperTriangular{T,<:LayoutMatrix{T}}

for  BTyp in (:AbstractBandedMatrix, :BandedSubBandedMatrix), Typ in (:StridedVector, :StridedMatrix, :AbstractVecOrMat, :UpperLayoutMatrix, :LayoutMatrix)
    @eval function ldiv!(A::QR{T,<:$BTyp}, B::$Typ{T}) where T
        m, n = size(A)
        if m == n
            _banded_square_ldiv!(A, B)
        elseif n > m
            _banded_widerect_ldiv!(A, B)
        else
            _banded_longrect_ldiv!(A, B)
        end
    end
end



materialize!(M::Lmul{<:QRPackedQLayout{<:AbstractBandedLayout}}) = banded_qr_lmul!(M.A,M.B)
materialize!(M::Lmul{<:AdjQRPackedQLayout{<:AbstractBandedLayout}}) = banded_qr_lmul!(M.A,M.B)

materialize!(M::Rmul{<:Any,<:QRPackedQLayout{<:AbstractBandedLayout}}) = banded_qr_rmul!(M.A,M.B)
materialize!(M::Rmul{<:Any,<:AdjQRPackedQLayout{<:AbstractBandedLayout}}) = banded_qr_rmul!(M.A,M.B)

module DocstringTests

import BandedMatrices
using Documenter
using Test

if v"1.10" <= VERSION < v"1.11.0-"
    DocMeta.setdocmeta!(BandedMatrices, :DocTestSetup, :(using BandedMatrices))
    @testset "doctests" begin
        doctest(BandedMatrices)
    end
end

end

module TestBandedLU

using BandedMatrices, LinearAlgebra, Test, Random
import BandedMatrices: _BandedMatrix

# set prng to some value that avoids test failure
Random.seed!(0)
struct _foo <: Number end


@testset "Banded A\\b" begin
    @testset "banded" begin
        A = brand(5, 1, 1)
        b = Float64[1, 2, 3, 4, 5]

        # dense storage
        Af = Matrix(A)
        bf = copy(b)

        @test Af\bf ≈ A\b

        # check A\b has not overwritten b, but has made a copy
        @test b == [1, 2, 3, 4, 5]
    end

    @testset "advanced interface" begin
        # banded
        A = brand(5, 1, 1)
        b = rand(5)

        # dense storage
        Af = Matrix(A)
        bf = copy(b)
        L,U,p = lu(A)
        Lf,Uf,pf = lu(Af)
        @test L ≈ Lf # storage format is different
        @test U ≈ Uf
        @test p ≈ pf
        lua = lu(A)
        @test lu(lua) === lua
        @test Factorization{Float64}(lua) === lua
        @test Matrix(Factorization{Float32}(lua)) ≈ convert(Matrix{Float32}, Af)
        @test Matrix(copy(lua)) ≈ Af
        @test issuccess(lua)

        # note lu makes copies; these need revision
        # once the lapack storage is built in to a BandedMatrix
        @test Af\bf ≈ lu(A)\copy(b)
        @test Af\bf ≈ ldiv!(A, copy(b))
        @test Af\bf ≈ ldiv!(lu(A), copy(b))
        @test transpose(Af)\bf ≈ transpose(lu(A))\copy(b)
        @test adjoint(Af)\bf ≈ adjoint(lu(A))\copy(b)
    end

    @testset "conversion of inputs if needed" begin
        # factorisation performs conversion
        Ai = _BandedMatrix(rand(1:10, 3, 5), 5, 1, 1)
        @test eltype(lu(Ai)) == Float64

        # no op
        Af = _BandedMatrix(rand(Float32, 3, 5), 5, 1, 1)
        @test eltype(lu(Af)) == Float32

        # linear systems of integer data imply promotion
        Ai = _BandedMatrix(rand(1:10, 3, 5), 5, 1, 1)
        bi = collect(1:5)
        @test eltype(Ai\bi) == Float64
        # this code                     ≈ julia base
        @test Ai\bi                     ≈ Matrix(Ai)\copy(bi)
        @test lu(Ai)\bi             ≈ Matrix(Ai)\copy(bi)

        # check A\b makes a copy of b
        Ai = _BandedMatrix(rand(1:10, 3, 5), 5, 1, 1)
        bi = collect(1:5)
        Ai\bi
        @test bi == [1, 2, 3, 4, 5]
    end

    @testset "matrix must be square error" begin
        for (n, m) in zip([7, 5], [5, 7])
            A = brand(m, n, 1, 1)
            b = rand(m)
            @test_throws DimensionMismatch lu(A)\b
            @test_throws DimensionMismatch ldiv!(A, b)
            @test_throws DimensionMismatch ldiv!(lu(A), b)
        end
    end

    @testset "transposed algorithm" begin
        # banded
        A = brand(5, 1, 1)
        b = rand(5)

        # dense storage
        Af = Matrix(A)
        bf = copy(b)

        # note lu makes copies; these need revision
        # once the lapack storage is built in to a BandedMatrix
        @test Af'\bf ≈ ldiv!(transpose(lu(A)),  copy(b))
        @test Af'\bf ≈ ldiv!(lu(A'), copy(b))
    end

    @testset "complex input" begin
        # banded
        A = brand(5, 1, 1) + brand(5, 1, 1)*im
        b = rand(5) + rand(5)*im

        # dense storage
        Af = Matrix(A)
        bf = copy(b)

        # note lu makes copies; these need revision
        # once the lapack storage is built in to a BandedMatrix
        @test Af\bf  ≈ A\copy(b)
        @test Af\bf  ≈ lu(A)\copy(b)
        @test Af'\bf ≈ A'\copy(b)
        @test Af'\bf ≈ lu(A')\copy(b)
        @test Af\bf  ≈ ldiv!(lu(A),  copy(b))
        @test Af'\bf ≈ ldiv!(lu(A'), copy(b))
        @test transpose(Af)\bf ≈ ldiv!(transpose(lu(A)),  copy(b))
        @test adjoint(Af)\bf ≈ ldiv!(lu(A'), copy(b))
        @test adjoint(Af)\bf ≈ ldiv!(lu(A)', copy(b))
    end

    @testset "multiple rhs" begin
        # banded
        A = brand(5, 1, 1)
        b = rand(5, 10)

        # dense storage
        Af = Matrix(A)
        bf = copy(b)

        # note lu makes copies; these need revision
        # once the lapack storage is built in to a BandedMatrix
        @test Af\bf  ≈ A\copy(b)
        @test Af\bf  ≈ lu(A)\copy(b)
        @test Af'\bf ≈ A'\copy(b)
        @test Af'\bf ≈ lu(A')\copy(b)
        @test Af\bf  ≈ ldiv!(lu(A),  copy(b))
        @test Af'\bf ≈ ldiv!(lu(A'), copy(b))
        @test Af'\bf ≈ ldiv!(transpose(lu(A)),  copy(b))
        @test Af'\bf ≈ ldiv!(lu(A'), copy(b))
    end

    @testset "properties of factorisation" begin
        BLU = lu(brand(5, 4, 1, 1))
        @test size(BLU) == (5, 4)
        @test size(BLU, 1) == 5
        @test size(BLU, 2) == 4
        @test size(BLU, 3) == 1
        @test_throws BoundsError size(BLU, -1)
        @test_throws BoundsError size(BLU,  0)
    end

    @testset "zero matrix" begin
        for A in (BandedMatrix{Float64}(undef, (0,0), (1,1)),
                  BandedMatrix{Float64}(undef, (0,3), (1,1)),
                  BandedMatrix{Float64}(undef, (0,0), (-1,-2)))
            @test lu(A).factors == zeros(size(A)...)
            @test lu(A) \ zeros(0) == zeros(0)
        end
    end
end

end # module

module TestCat

using BandedMatrices, LinearAlgebra, Test, Random, FillArrays, SparseArrays

@testset "vcat" begin
    @testset "banded matrices" begin
        a = BandedMatrix(0 => 1:2)
        @test vcat(a) == a

        b = BandedMatrix(0 => 1:3,-1 => 1:2, -2 => 1:1)
        @test_throws DimensionMismatch vcat(a,b)

        c = BandedMatrix(0 => [1.0, 2.0, 3.0], 1 => [1.0, 2.0], 2 => [1.0])
        @test eltype(vcat(b, c)) == Float64
        @test vcat(b, c) == vcat(Matrix(b), Matrix(c))

        for i in ((1,2), (-3,4), (0,-1))
            a = BandedMatrix(ones(Float64, rand(1:10), 5), i)
            b = BandedMatrix(ones(Int64, rand(1:10), 5), i)
            c = BandedMatrix(ones(Int32, rand(1:10), 5), i)
            d = vcat(a, b, c)
            sd = vcat(sparse(a), sparse(b), sparse(c))
            @test eltype(d) == Float64
            @test d == sd
            @test bandwidths(d) == bandwidths(sd)
        end
    end

    @testset "one element" begin
        n = rand(3:20)
        x,y = OneElement(1, (1,1), (1,n)), OneElement(1, (1,n), (1,n))
        b = BandedMatrix((0 => ones(n-2), 1 => -2ones(n - 2), 2 => ones(n - 2)), (n-2, n))
        @test vcat(x,b,y) == Tridiagonal([ones(n - 2); 0], [1 ; -2ones(n - 2); 1], [0; ones(n - 2)])
    end
end

end

import LinearAlgebra.BLAS.@blasfunc


for (fname, elty) in ((:dgbmv_,:Float64),
                      (:sgbmv_,:Float32),
                      (:zgbmv_,:ComplexF64),
                      (:cgbmv_,:ComplexF32))
    @eval begin
             # SUBROUTINE DGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
             # *     .. Scalar Arguments ..
             #       DOUBLE PRECISION ALPHA,BETA
             #       INTEGER INCX,INCY,KL,KU,LDA,M,N
             #       CHARACTER TRANS
             # *     .. Array Arguments ..
             #       DOUBLE PRECISION A(LDA,*),X(*),Y(*)
        function gbmv!(trans::Char, m::Int, n::Int, kl::Int, ku::Int, alpha::($elty),
                       A::Ptr{$elty}, st::Int,
                       x::Ptr{$elty}, incx::Int, beta::($elty), y::Ptr{$elty}, incy::Int)
            ccall((@blasfunc($fname), libblas), Nothing,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                 Ref{BlasInt}, Ref{$elty}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ref{$elty}, Ptr{$elty},
                 Ref{BlasInt}),
                 trans, m, n, kl,
                 ku, alpha, A, st,
                 x, incx, beta, y, incy)
            y
        end
    end
end




for (fname, elty) in ((:dsbmv_,:Float64),
                      (:ssbmv_,:Float32),
                      (:zsbmv_,:ComplexF64),
                      (:csbmv_,:ComplexF32))
    @eval begin
                # SUBROUTINE DSBMV(UPLO, N, K, ALPHA, A, LDA,
                # X, INCX, BETA, Y, INCY)
                # DOUBLE PRECISION ALPHA,BETA
                # INTEGER INCX,INCY,K,LDA,N
                # CHARACTER*1 UPLO
                # DOUBLE PRECISION A(LDA,*), X(*), Y(*)

        function sbmv!(uplo::Char, n::Int, k::Int, alpha::($elty),
                       A::Ptr{$elty}, lda::Int,
                       x::Ptr{$elty}, incx::Int, beta::($elty), y::Ptr{$elty}, incy::Int)
            ccall((@blasfunc($fname), libblas), Nothing,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                 Ref{$elty}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ref{$elty},
                 Ptr{$elty}, Ref{BlasInt}),
                 uplo, n, k,
                 alpha, A, lda,
                 x, incx, beta,
                 y, incy)
            y
        end
    end
end

sbmv!(uplo::Char, k::Int, alpha::T,
      A::AbstractMatrix{T}, x::AbstractVector{T}, beta::T, y::AbstractVector{T}) where {T<:BlasFloat} =
    sbmv!(uplo,size(A,2),k,alpha,pointer(A),max(1,stride(A,2)),x,stride(x,1),beta,y,stride(y,1))


## Triangular *

function tbmv! end

for (fname, elty) in ((:dtbmv_,:Float64),
                        (:stbmv_,:Float32),
                        (:ztbmv_,:ComplexF64),
                        (:ctbmv_,:ComplexF32))
    @eval begin
                #       SUBROUTINE DTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
                # *     .. Scalar Arguments ..
                #       INTEGER INCX,LDA,N
                #       CHARACTER DIAG,TRANS,UPLO
                # *     .. Array Arguments ..
                #       DOUBLE PRECISION A(LDA,*),X(*)
        function tbmv!(uplo::AbstractChar, trans::AbstractChar, diag::AbstractChar,
                       m::Int, k::Int, A::AbstractMatrix{$elty}, x::AbstractVector{$elty})
            require_one_based_indexing(A, x)
            n = size(A,2)
            size(A,1) ≥ k+1 || throw(ArgumentError("triangular banded data missing"))
            n == m || throw(DimensionMismatch("matrix is not square: dimensions are $n, $m"))
            if n != length(x)
                throw(DimensionMismatch("size of A is $n != length(x) = $(length(x))"))
            end
            chkstride1(A)
            ccall((@blasfunc($fname), libblas), Cvoid,
                (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}),
                 uplo, trans, diag, m, k,
                 A, max(1,stride(A,2)), x, max(1,stride(x, 1)))
            x
        end
        function tbmv(uplo::AbstractChar, trans::AbstractChar, diag::AbstractChar, m::Int, k::Int,
                      A::AbstractMatrix{$elty}, x::AbstractVector{$elty})
            tbmv!(uplo, trans, diag, m, k, A, copy(x))
        end
    end
end

## Triangular \

function tbsv end

for (fname, elty) in ((:dtbsv_,:Float64),
                        (:stbsv_,:Float32),
                        (:ztbsv_,:ComplexF64),
                        (:ctbsv_,:ComplexF32))
    @eval begin
                #       SUBROUTINE DTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
                #       .. Scalar Arguments ..
                #       INTEGER INCX,LDA,N
                #       CHARACTER DIAG,TRANS,UPLO
                #       .. Array Arguments ..
                #       DOUBLE PRECISION A(LDA,*),X(*)
        function tbsv!(uplo::AbstractChar, trans::AbstractChar, diag::AbstractChar,
                        m::Int, k::Int, A::AbstractMatrix{$elty}, x::AbstractVector{$elty})
            require_one_based_indexing(A, x)
            n = size(A,2)
            size(A,1) ≥ k+1 || throw(ArgumentError("triangular banded data missing"))
            n == m || throw(DimensionMismatch("matrix is not square: dimensions are $n, $m"))
            if n != length(x)
                throw(DimensionMismatch("size of A is $n != length(x) = $(length(x))"))
            end
            chkstride1(A)
            if n ≠ 0 # avoid empty warning message
                ccall((@blasfunc($fname), libblas), Cvoid,
                    (Ref{UInt8}, Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt},
                    Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}),
                    uplo, trans, diag, m, k,
                    A, max(1,stride(A,2)), x, stride(x, 1))
            end
            x
        end
        function tbsv(uplo::AbstractChar, trans::AbstractChar, diag::AbstractChar,
                        m::Int, k::Int, A::AbstractMatrix{$elty}, x::AbstractVector{$elty})
            tbsv!(uplo, trans, diag, m, k, A, copy(x))
        end
    end
end

## Banded LU decomposition

# This file is based on a part of Julia. License is MIT: https://julialang.org/license

####################
# Banded LU Factorization #
# This is like LU but factors does not actually
# permute the rows.
####################
struct BandedLU{T,S<:AbstractMatrix{T}} <: Factorization{T}
    factors::S
    ipiv::Vector{BlasInt}
    info::BlasInt

    function BandedLU{T,S}(factors, ipiv, info) where {T,S<:AbstractMatrix{T}}
        require_one_based_indexing(factors)
        new{T,S}(factors, ipiv, info)
    end
end
function BandedLU(factors::AbstractMatrix{T}, ipiv::Vector{BlasInt}, info::BlasInt) where {T}
    BandedLU{T,typeof(factors)}(factors, ipiv, info)
end
function BandedLU{T}(factors::AbstractMatrix, ipiv::AbstractVector{<:Integer}, info::Integer) where {T}
    BandedLU(convert(AbstractMatrix{T}, factors),
       convert(Vector{BlasInt}, ipiv),
       BlasInt(info))
end

# iteration for destructuring into components
Base.iterate(S::BandedLU) = (S.L, Val(:U))
Base.iterate(S::BandedLU, ::Val{:U}) = (S.U, Val(:p))
Base.iterate(S::BandedLU, ::Val{:p}) = (S.p, Val(:done))
Base.iterate(S::BandedLU, ::Val{:done}) = nothing

transpose(F::BandedLU) = TransposeFact(F)

lu(S::BandedLU) = S

function BandedLU{T}(F::BandedLU) where T
    M = convert(AbstractMatrix{T}, F.factors)
    BandedLU{T,typeof(M)}(M, F.ipiv, F.info)
end
BandedLU{T,S}(F::BandedLU) where {T,S} = BandedLU{T,S}(convert(S, F.factors), F.ipiv, F.info)
Factorization{T}(F::BandedLU{T}) where {T} = F
Factorization{T}(F::BandedLU) where {T} = BandedLU{T}(F)

copy(A::BandedLU{T,S}) where {T,S} = BandedLU{T,S}(copy(A.factors), copy(A.ipiv), A.info)

size(A::BandedLU)    = size(getfield(A, :factors))
size(A::BandedLU, i) = size(getfield(A, :factors), i)

Base.propertynames(F::BandedLU, private::Bool=false) =
    (:L, :U, :p, :P, (private ? fieldnames(typeof(F)) : ())...)

LinearAlgebra.issuccess(F::BandedLU) = F.info == 0

function show(io::IO, mime::MIME{Symbol("text/plain")}, F::BandedLU)
    if issuccess(F)
        summary(io, F); println(io)
        println(io, "L factor:")
        show(io, mime, F.L)
        println(io, "\nU factor:")
        show(io, mime, F.U)
    else
        print(io, "Failed factorization of type $(typeof(F))")
    end
end


/(B::AbstractMatrix, A::BandedLU) = copy(transpose(transpose(A) \ transpose(B)))

# Conversions
AbstractMatrix(F::BandedLU) = (F.L * F.U)[invperm(F.p),:]
AbstractArray(F::BandedLU) = AbstractMatrix(F)
Matrix(F::BandedLU) = Array(AbstractArray(F))
Array(F::BandedLU) = Matrix(F)

##
"""
    lu!(A::BandedMatrix, pivot = Val(true); check = true)

Compute the LU factorization of a banded matrix `A` inplace, overwriting the matrix.
This factorization requires `A` to have extra storage, and in particular if the banded
matrix of interest has bandwidths `(l, u)` then `A` should have bandwidths `(l, l+u)`
and contain the desired matrix along with zeros in the additional entries.

When `check = true`, an error is thrown if the factorization fails. When `check = false`
it is the user's responsibility for checking the validity of the factorization.
"""
function lu!(A::BandedMatrix{T}, pivot::Union{Val{false}, Val{true}} = Val(true);
             check::Bool = true) where T<:BlasFloat
    if pivot === Val(false)
        return banded_lufact!(A, pivot; check = check)
    end
    m= size(A,1)
    l,u = bandwidths(A) # l of the bands are ignored and overwritten
    if !iszero(m)
        _, ipiv = LAPACK.gbtrf!(l, u-l, m, bandeddata(A))
    else
        ipiv = Int[]
    end
    return BandedLU{T,typeof(A)}(A, ipiv, zero(BlasInt))
end

_lu!(::AbstractBandedLayout, axes, A, pivot::Union{Val{false}, Val{true}} = Val(true); check::Bool = true) =
    banded_lufact!(A, pivot; check = check)

function _lu(::AbstractBandedLayout, axes, A, pivot::Union{Val{false}, Val{true}} = Val(true); check::Bool = true)
    l,u = bandwidths(A)
    lu!(BandedMatrix{float(eltype(A))}(A,(l,l+u)), pivot; check = check)
end

# Jesus christ someone loves to write "StridedMatrix" for no reason in Base!
function getproperty(F::BandedLU{T}, d::Symbol) where T
    m, n = size(F)
    if d == :L
        # not clear how to get it from F.factors so we
        # form it in the most insane way possible
        Ai = F\Matrix(I,n,m)
        tril!((F.P/Ai)/F.U)
    elseif d == :U
        return triu!(getfield(F, :factors)[1:min(m,n), 1:n])
    elseif d == :p
        return ipiv2perm(getfield(F, :ipiv), m)
    elseif d == :P
        return Matrix{T}(I, m, m)[:,invperm(F.p)]
    else
        getfield(F, d)
    end
end

# function banded_lufact!(A::AbstractMatrix{T}, ::Val{Pivot} = Val(true);
#                          check::Bool = true) where {T,Pivot}
#     m, n = size(A)
#     l, u = bandwidths(A)
#     minmn = min(m,n)
#     info = 0
#     ipiv = Vector{BlasInt}(undef, minmn)
#     @inbounds begin
#         for k = 1:minmn
#             # find index max
#             kp = k
#             if Pivot
#                 amax = abs(zero(T))
#                 for i = k:min(k+l,m)
#                     absi = abs(A[i,k])
#                     if absi > amax
#                         kp = i
#                         amax = absi
#                     end
#                 end
#             end
#             ipiv[k] = kp
#             if !iszero(A[kp,k])
#                 if k != kp
#                     # Interchange
#                     for i = rowrange(A,k)
#                         tmp = A[k,i]
#                         A[k,i] = A[kp,i]
#                         A[kp,i] = tmp
#                     end
#                 end
#                 # Scale first column
#                 Akkinv = inv(A[k,k])
#                 for i = k+1:min(k+l,m)
#                     A[i,k] *= Akkinv
#                 end
#             elseif info == 0
#                 info = k
#             end
#             # Update the rest
#             for j = k+1:min(k+u,n)
#                 for i = k+1:min(k+l,m)
#                     A[i,j] -= A[i,k]*A[k,j]
#                 end
#             end
#         end
#     end
#     check && checknonsingular(info)
#     return BandedLU{T,typeof(A)}(A, ipiv, convert(BlasInt, info))
# end


_apply_ipiv_rows!(A::BandedLU, B::AbstractVecOrMat) = _ipiv_rows!(A, 1 : length(A.ipiv), B)
_apply_inverse_ipiv_rows!(A::BandedLU, B::AbstractVecOrMat) = _ipiv_rows!(A, length(A.ipiv) : -1 : 1, B)

function _ipiv_rows!(A::BandedLU, order::OrdinalRange, B::AbstractVecOrMat)
    for i = order
        if i != A.ipiv[i]
            _swap_rows!(B, i, A.ipiv[i])
        end
    end
    B
end

function _swap_rows!(B::AbstractVector, i::Integer, j::Integer)
    B[i], B[j] = B[j], B[i]
    B
end

function _swap_rows!(B::AbstractMatrix, i::Integer, j::Integer)
    for col = 1 : size(B, 2)
        B[i,col], B[j,col] = B[j,col], B[i,col]
    end
    B
end

module TestMisc

using BandedMatrices, LinearAlgebra, FillArrays, Test, SparseArrays
import BandedMatrices: _BandedMatrix, DefaultBandedMatrix

@testset "misc tests" begin
    @testset "Diagonal of banded" begin
        D = Diagonal([BandedMatrix(Eye(5),(2,3)), BandedMatrix(Eye(6),(1,1))])
        @test @inferred(D[1,1]) == I
        @test @inferred(D[1,2]) == zeros(5,6)
        @test bandwidths(D[1,2]) == (2,1)
    end

    @time @testset "BandedMatrix of BandedMatrix" begin
        A = BandedMatrix{DefaultBandedMatrix{Float64}}(undef, (1, 2), (0, 1))
        A[1,1] = BandedMatrix(Eye(1),(0,1))
        A[1,2] = BandedMatrix(Zeros(1,2),(0,1))
        A[1,2][1,1] = -1/3
        A[1,2][1,2] = 1/3
        B = BandedMatrix{DefaultBandedMatrix{Float64}}(undef, (2, 1), (1, 1))
        B[1,1] = 0.2BandedMatrix(Eye(1),(0,1))
        B[2,1] = BandedMatrix(Zeros(2,1), (1,0))
        B[2,1][1,1] = -2/30
        B[2,1][2,1] = 1/3

        @test (A*B)[1,1][1,1] ≈ 1/3

        A = BandedMatrix(Diagonal([randn(2,3), randn(3,4)]), (0,0))
        @test @inferred(A[1,2]) == zeros(2,4)

        A = BandedMatrix(Diagonal([brand(5,6,2,1), brand(7,8,1,1)]), (0,0))
        @test @inferred(A[1,2]) == zeros(5,8)
    end

    @time @testset "dense overrides" begin
        A = rand(10,11)
        @test bandwidths(A) == (9,10)
        A = rand(10)
        @test bandwidths(A) == (9,0)
        @test bandwidths(A') == (0,9)
    end

    @time @testset "sparse overrides" begin
        for (l,u) = [(0,0), (1,0), (0,1), (3,3), rand(0:10,2)]
            A = brand(10, 10, l, u)
            sA = sparse(A)
            @test sA isa SparseMatrixCSC
            @test bandwidths(sA) == min.((l,u),9)
            bA = BandedMatrix(sA)
            @test bA isa BandedMatrix
            @test bA == A
            @test bandwidths(bA) == min.((l,u),9)
            v = sparsevec(brand(10, 1, l, u))
            @test bandwidths(v) == (l, min(0, u))
        end

        l, u = -1, 0
        A = brand(10, 10, l, u)
        sA = sparse(A)
        @test bandwidths(sA) == bandwidths(Zeros(1))
        v = sparsevec(brand(10, 1, l, u))
        @test bandwidths(v) == bandwidths(Zeros(1))

        for diags = [(-1 => ones(Int, 5),),
                     (-2 => ones(Int, 5),),
                     (2 => ones(Int, 5),),
                     (-1 => ones(Int, 5), 1 => 2ones(Int, 5))]
            A = BandedMatrix(diags...)
            l,u = bandwidths(A)

            sA = sparse(A)
            @test sA isa SparseMatrixCSC
            @test bandwidths(sA) == (l,u)
            bA = BandedMatrix(sA)
            @test bA isa BandedMatrix
            @test bA == A
            @test bandwidths(bA) == (l,u)
        end
    end

    @time @testset "trivial convert routines" begin
        A = brand(3,4,1,2)
        @test isa(BandedMatrix{Float64}(A), BandedMatrix{Float64})
        @test isa(AbstractMatrix{Float64}(A), BandedMatrix{Float64})
        @test isa(AbstractArray{Float64}(A), BandedMatrix{Float64})
        @test isa(BandedMatrix(A), BandedMatrix{Float64})
        @test isa(AbstractMatrix(A), BandedMatrix{Float64})
        @test isa(AbstractArray(A), BandedMatrix{Float64})
        @test isa(BandedMatrix{ComplexF16}(A), BandedMatrix{ComplexF16})
        @test isa(AbstractMatrix{ComplexF16}(A), BandedMatrix{ComplexF16})
        @test isa(AbstractArray{ComplexF16}(A), BandedMatrix{ComplexF16})
    end

    @time @testset "show" begin
        @test occursin("10×10 BandedMatrix{Float64} with bandwidths (3, 3)",
         sprint() do io
            show(io, MIME"text/plain"(), brand(10, 10, 3, 3))
         end)
        needle = "1.0  0.0   ⋅ \n 0.0  1.0  0.0\n  ⋅   0.0  1.0"
        @test occursin(needle, sprint() do io
             show(io, MIME"text/plain"(), BandedMatrix(Eye(3),(1,1)))
          end)
        B = BandedMatrix(-1=>1:4, 0=>1:5, 1=>1:4)
        Bshowstr = sprint(show, B)
        @test Bshowstr == "BandedMatrix($(-1=>[1:4;]), $(0=>[1:5;]), $(1=>[1:4;]))"

        B = BandedMatrix(-3=>1:4, 3=>1:4);
        @test sprint(show, B) == sprint(show, B, context=:limit=>true)
        B = BandedMatrix(-5=>1:1, 5=>1:1)
        expstr = "BandedMatrix(-5 => [1], -4 => [0, 0], -3 => [0, 0, 0], -2 => [0, 0, 0, 0]"*
                    "  …  2 => [0, 0, 0, 0], 3 => [0, 0, 0], 4 => [0, 0], 5 => [1])"
        @test sprint(show, B, context=:limit=>true) == expstr

        B = BandedMatrix(0=>1:3)
        sout = sprint(show, to_indices(B, (band(0),))[1])
        @test occursin(repr(diagind(B)), sout)
        @test occursin(repr(Band(0)), sout)
    end
    @time @testset "Issue #27" begin
        A=brand(1,10,0,9)
        B=brand(10,10,255,255)
        @test Matrix(A*B)  ≈ Matrix(A)*Matrix(B)
    end

    @testset "defaultdot" begin
        A = randn(5)
        @test BandedMatrices.dot(A,A) ≡ LinearAlgebra.dot(A,A)
    end

    @testset "Offset axes" begin
        A = _BandedMatrix(Ones((Base.OneTo(3),Base.Slice(-5:5),)), Base.Slice(-4:2), 1,1)
        @test size(A) == (7,11)
        @test A[-4,-5] == 1
        @test A[-4,-5+2] == 1
        @test A[-4,-5+3] == 0
        @test_throws BoundsError A[-5,-5+3]
    end
end

end # module

isbanded(A::AbstractTriangular) = isbanded(parent(A))
bandwidths(A::Union{UpperTriangular,UnitUpperTriangular}) =
    (min(0,bandwidth(parent(A),1)), bandwidth(parent(A),2))
bandwidths(A::Union{LowerTriangular,UnitLowerTriangular}) =
    (bandwidth(parent(A),1), min(0,bandwidth(parent(A),2)))

triangularlayout(::Type{Tri}, ::ML) where {Tri,ML<:BandedColumns} = Tri{ML}()
triangularlayout(::Type{Tri}, ::ML) where {Tri,ML<:BandedRows} = Tri{ML}()
triangularlayout(::Type{Tri}, ::ML) where {Tri,ML<:ConjLayout{<:BandedRows}} = Tri{ML}()

sublayout(::TriangularLayout{UPLO,UNIT,ML}, inds) where {UPLO,UNIT,ML} = sublayout(ML(), inds)

getuplo(::Type{<:TriangularLayout{UPLO}}) where {UPLO} = UPLO
getunit(::Type{<:TriangularLayout{<:Any,UNIT}}) where {UNIT} = UNIT
getbwdim(uplo::Char) = uplo == 'U' ? 2 : 1

function bandeddata(::TriLayout, A) where {TriLayout<:TriangularLayout}
    B = triangulardata(A)
    l,u = bandwidths(B)
    D = bandeddata(B)
    uplo = getuplo(TriLayout)
    rowinds = uplo == 'U' ? (1:u+1) : (u+1:l+u+1)
    view(D, rowinds, :)
end

# function bandedrowsdata(::TriangularLayout{'U'}, A)
#     B = triangulardata(A)
#     l,u = bandwidths(B)
#     D = bandedrowsdata(B)
#     view(D, :, l+1:l+u+1)
# end

# function bandeddata(::TriangularLayout{'L'}, A)
#     B = triangulardata(A)
#     l,_ = bandwidths(B)
#     D = bandedrowsdata(B)
#     view(D, :, 1:l+1)
# end

# Mul

copy(M::Lmul{<:TriangularLayout{uplo,trans,<:AbstractBandedLayout},<:AbstractBandedLayout}) where {uplo,trans} =
    ArrayLayouts.lmul!(M.A, BandedMatrix(M.B, bandwidths(M)))

@inline function materialize!(M::BlasMatLmulVec{<:TriLayout,
        <:AbstractStridedLayout}) where {UNIT, TriLayout<:TriangularLayout{<:Any,UNIT,<:BandedColumnMajor}}

    A,x = M.A,M.B
    uplo = getuplo(TriLayout)
    bwdim = getbwdim(uplo)
    tbmv!(uplo, 'N', UNIT, size(A,1), bandwidth(A,bwdim), bandeddata(A), x)
end

# @inline function materialize!(M::BlasMatLmulVec{<:TriangularLayout{'U',UNIT,<:BandedRowMajor},
#                                                 <:AbstractStridedLayout}) where UNIT
#     A,x = M.A,M.B
#     tbmv!('U', 'T', UNIT, size(A,1), bandwidth(A,2), bandedrowsdata(A), x)
# end

# @inline function materialize!(M::BlasMatLmulVec{<:TriangularLayout{'L',UNIT,<:BandedRowMajor},
#                                                 <:AbstractStridedLayout}) where UNIT
#     A,x = M.A,M.B
#     tbmv!('L', 'T', UNIT, size(A,1), bandwidth(A,1), bandeddata(transpose(parent(A))), x)
# end

# @inline function materialize!(M::BlasMatLmulVec{<:TriangularLayout{UPLO,UNIT,<:ConjLayout{<:BandedRowMajor}},
#                                                 <:AbstractStridedLayout}) where {UPLO,UNIT}
#     A,x = M.A,M.B
#     tbmv!(UPLO, 'C', UNIT, bandeddata(A)', dest)
# end

# Ldiv
@inline function materialize!(M::BlasMatLdivVec{<:TriLayout,
        <:AbstractStridedLayout}) where {TriLayout<:TriangularLayout{<:Any,<:Any,<:BandedColumnMajor}}

    uplo = getuplo(TriLayout)
    unit = getunit(TriLayout)
    bwdim = getbwdim(uplo)
    A,x = M.A,M.B
    tbsv!(uplo, 'N', unit, size(A,1), bandwidth(A,bwdim), bandeddata(A), x)
end

@inline function materialize!(M::BlasMatLdivVec{<:TriLayout,
        <:AbstractStridedLayout}) where {TriLayout<:TriangularLayout{<:Any,<:Any,<:BandedRowMajor}}

    U,x = M.A,M.B
    A = triangulardata(U)
    uplo = getuplo(TriLayout)
    uploT = uplo == 'U' ? 'L' : 'U'
    unit = getunit(TriLayout)
    bwdim = getbwdim(uplo)
    LUT = uplo == 'U' ? LowerTriangular : UpperTriangular
    tbsv!(uploT, 'T', unit, size(A,1), bandwidth(A,bwdim), bandeddata(LUT(A')), x)
end


rot180(A::UpperTriangular{<:Any,<:AbstractBandedMatrix}) = LowerTriangular(rot180(parent(A)))
rot180(A::UnitUpperTriangular{<:Any,<:AbstractBandedMatrix}) = UnitLowerTriangular(rot180(parent(A)))
rot180(A::LowerTriangular{<:Any,<:AbstractBandedMatrix}) = UpperTriangular(rot180(parent(A)))
rot180(A::UnitLowerTriangular{<:Any,<:AbstractBandedMatrix}) = UnitUpperTriangular(rot180(parent(A)))

# AbstractBandedMatrix must implement

abstract type AbstractBandedMatrix{T} <: LayoutMatrix{T} end


"""
    bandeddata(A)

returns a matrix containing the data of a banded matrix, in the
BLAS format.

This is required for gbmv! support
"""
bandeddata(A) = bandeddata(MemoryLayout(A), A)
bandeddata(_, A) = error("Override bandeddata(::$(typeof(A)))")

"""
    bandwidths(A)

Returns a tuple containing the lower and upper bandwidth of `A`, in order.
"""
bandwidths(A::AbstractVecOrMat) = bandwidths(MemoryLayout(A), A)
bandwidths(_, A) = (size(A,1)-1 , size(A,2)-1)

"""
    bandwidth(A,i)

Returns the lower bandwidth (`i==1`) or the upper bandwidth (`i==2`).
"""
bandwidth(A, k::Integer) = bandwidths(A)[k]

"""
    bandrange(A)

Returns the range `-bandwidth(A,1):bandwidth(A,2)`.
"""
bandrange(A) = -bandwidth(A,1):bandwidth(A,2)



"""
    colstart(A, i::Integer)

Return the starting row index of the filled bands in the `i`-th column,
bounded by the actual matrix size.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> BandedMatrices.colstart(A, 3)
2

julia> BandedMatrices.colstart(A, 4)
3
```
"""
@inline colstart(A, i::Integer) = clamp(i-bandwidth(A,2),  firstindex(A,1), lastindex(A,1)+1)

"""
    colstop(A, i::Integer)

Return the stopping row index of the filled bands in the `i`-th column,
bounded by the actual matrix size.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> BandedMatrices.colstop(A, 3)
3

julia> BandedMatrices.colstop(A, 4)
4
```
"""
@inline colstop(A, i::Integer) = clamp(i+bandwidth(A,1), firstindex(A,1)-1, lastindex(A,1)) # we clamp the bottom for existing code

"""
    rowstart(A, i::Integer)

Return the starting column index of the filled bands in the `i`-th row,
bounded by the actual matrix size.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> BandedMatrices.rowstart(A, 2)
2

julia> BandedMatrices.rowstart(A, 3)
3
```
"""
@inline rowstart(A, i::Integer) = clamp(i-bandwidth(A,1), firstindex(A,2), lastindex(A,2)+1)

"""
    rowstop(A, i::Integer)

Return the stopping column index of the filled bands in the `i`-th row,
bounded by the actual matrix size.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> BandedMatrices.rowstop(A, 2)
3

julia> BandedMatrices.rowstop(A, 4)
4
```
"""
@inline rowstop(A, i::Integer) = clamp(i+bandwidth(A,2), firstindex(A,2)-1, lastindex(A,2))

"""
    colrange(A, i::Integer)

Return the range of rows in the `i`-th column that correspond to filled bands.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> colrange(A, 1)
1:1

julia> colrange(A, 3)
2:3
```
"""
@inline colrange(A, i::Integer) = colstart(A,i):colstop(A,i)

"""
    rowrange(A, i::Integer)

Return the range of columns in the `i`-th row that correspond to filled bands.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> rowrange(A, 1)
1:2

julia> rowrange(A, 4)
4:4
```
"""
@inline rowrange(A, i::Integer) = rowstart(A,i):rowstop(A,i)


"""
    collength(A, i::Integer)

Return the number of filled bands in the `i`-th column.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> BandedMatrices.collength(A, 1)
1

julia> BandedMatrices.collength(A, 2)
2
```
"""
@inline collength(A, i::Integer) = length(colrange(A, i))

"""
    rowlength(A, i::Integer)

Return the number of filled bands in the `i`-th row.

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7)
4×4 BandedMatrix{Int64} with bandwidths (0, 1):
 1  5  ⋅  ⋅
 ⋅  2  6  ⋅
 ⋅  ⋅  3  7
 ⋅  ⋅  ⋅  4

julia> BandedMatrices.rowlength(A, 1)
2

julia> BandedMatrices.rowlength(A, 4)
1
```
"""
@inline rowlength(A, i::Integer) = length(rowrange(A, i))

@inline banded_colsupport(A, j::Integer) = colrange(A, j)
@inline banded_rowsupport(A, j::Integer) = rowrange(A, j)

@inline banded_rowsupport(A, j) = isempty(j) ? (1:0) : rowstart(A,minimum(j)):rowstop(A,maximum(j))
@inline banded_colsupport(A, j) = isempty(j) ? (1:0) : colstart(A,minimum(j)):colstop(A,maximum(j))

@inline colsupport(::AbstractBandedLayout, A, j) = banded_colsupport(A, j)
@inline rowsupport(::AbstractBandedLayout, A, j) = banded_rowsupport(A, j)

"""
    isbanded(A)

returns true if a matrix implements the banded interface.
"""
isbanded(A) = isbanded(MemoryLayout(A), A)
isbanded(::AbstractBandedLayout, A) = true
isbanded(@nospecialize(::Any), @nospecialize(::Any)) = false

# override bandwidth(A,k) for each AbstractBandedMatrix
# override inbands_getindex(A,k,j)


# return id of first empty diagonal intersected along row k
function _firstdiagrow(A::AbstractMatrix, k::Int)
    a, b = rowstart(A, k), rowstop(A, k)
    c = a == 1 ? b+1 : a-1
    c-k
end

# return id of first empty diagonal intersected along column j
function _firstdiagcol(A::AbstractMatrix, j::Int)
    a, b = colstart(A, j), colstop(A, j)
    r = a == 1 ? b+1 : a-1
    j-r
end

function Base.maximum(B::AbstractBandedMatrix)
    m=zero(eltype(B))
    for j = 1:size(B,2), k = colrange(B,j)
        m=max(B[k,j],m)
    end
    m
end

function tril!(A::AbstractBandedMatrix{T}, k::Integer) where T
    for b = max(k+1,-bandwidth(A,1)):bandwidth(A,2)
        A[band(b)] .= zero(T)
    end
    A
end

function triu!(A::AbstractBandedMatrix{T}, k::Integer) where T
    for b = -bandwidth(A,1):min(k-1,bandwidth(A,2))
        A[band(b)] .= zero(T)
    end
    A
end

function isdiag(B::AbstractBandedMatrix)
    l, u = bandwidths(B)
    l + u < 0 || (iszero(l) && iszero(u))
end
function istriu(B::AbstractBandedMatrix, k::Integer)
    l, u = bandwidths(B)
    l + u < 0 || min(l, size(B,1)-1) <= -k
end
function istril(B::AbstractBandedMatrix, k::Integer)
    l, u = bandwidths(B)
    l + u < 0 || min(u, size(B,2)-1) <= k
end


## @inbands

function inbands_process_args!(e)
    if e.head == :ref
        e.head = :call
        pushfirst!(e.args, :(BandedMatrices.inbands_getindex))
    elseif e.head == :call && e.args[1] == :getindex
        e.args[1] = :(BandedMatrices.inbands_getindex)
    end
    e
end


function inbands_process_args_recursive!(expr)
    for (i,e) in enumerate(expr.args)
        if e isa Expr
            inbands_process_args_recursive!(e)
        end
    end
    inbands_process_args!(expr)
    expr
end

macro inbands(expr)
    esc(inbands_process_args!(expr))
end


####
# AdjOrTrans
####

bandwidths(A::AdjOrTrans{T,S}) where {T,S} = reverse(bandwidths(parent(A)))
copy(A::Adjoint{T,<:AbstractBandedMatrix}) where T = copy(parent(A))'
copy(A::Transpose{T,<:AbstractBandedMatrix}) where T = transpose(copy(parent(A)))


function sum!(ret::AbstractArray, A::AbstractBandedMatrix)
    #Behaves similarly to Base.sum!
    fill!(ret, zero(eltype(ret)))
    n,m = size(A)
    s = size(ret)
    l = length(s)
    #Check for singleton dimension and perform respective sum
    if s[1] == 1 && (l == 1 || s[2]==1)
        for j = 1:m, i = colrange(A, j)
            ret .+= A[i, j]
        end
    elseif s[1] == n && (l == 1 || s[2]==1)
        for i = 1:n, j = rowrange(A, i)
            ret[i, 1] += A[i, j]
        end
    elseif s[1] == 1 && s[2] == m
        for j = 1:m, i = colrange(A, j)
            ret[1, j] += A[i, j]
        end
    elseif s[1] == n && s[2] == m
        copyto!(ret,A)
    else
        throw(DimensionMismatch("reduction on matrix of size ($n, $m) with output size $s"))
    end
    #return the value to mimic Base.sum!
    ret
end

function sum(A::AbstractBandedMatrix; dims=:)
    if dims isa Colon
        l, u = bandwidths(A)
        ret = zero(eltype(A))
        if l + u < 0
            return ret
        end
        n, m = size(A)
        for j = 1:m, i = colrange(A, j)
            ret += A[i, j]
        end
        ret
    elseif dims > 2
        A
    elseif dims == 2
        l, u = bandwidths(A)
        n, m = size(A)
        ret = zeros(eltype(A), n, 1)
        if l + u < 0
            return ret
        end
        sum!(ret, A)
        ret
    elseif dims == 1
        l, u = bandwidths(A)
        n, m = size(A)
        ret = zeros(eltype(A), 1, m)
        if l + u < 0
            return ret
        end
        sum!(ret, A)
        ret
    else
        throw(ArgumentError("dimension must be ≥ 1, got $dims"))
    end
end

###
# vcat
###

function Base.vcat(x::AbstractBandedMatrix...)
    #avoid unnecessary steps for singleton
    if length(x) == 1
        return x[1]
    end

    #instantiate the returned banded matrix with zeros and required bandwidths/dimensions
    m = size(x[1], 2)
    l,u = -m, typemin(Int)
    n = 0
    isempty = true

    #Check for dimension error and calculate bandwidths
    for A in x
        if size(A, 2) != m
            sizes = Tuple(size(b, 2) for b in x)
            throw(DimensionMismatch("number of columns of each matrix must match (got $sizes)"))
        end

        l_A, u_A = bandwidths(A)
        if l_A + u_A >= 0
            isempty = false
            u = max(u, min(m - 1, u_A) - n)
            l = max(l, min(size(A, 1) - 1, l_A) + n)
        end

        n += size(A, 1)
    end

    type = promote_type(eltype.(x)...)
    if isempty
        return BandedMatrix{type}(undef, (n, m), bandwidths(Zeros(1)))
    end
    ret = BandedMatrix(Zeros{type}(n, m), (l, u))

    #Populate the banded matrix
    row_offset = 0
    for A in x
        n_A = size(A, 1)

        for i = 1:n_A, j = rowrange(A, i)
            ret[row_offset + i, j] = A[i, j]
        end

        row_offset += n_A
    end

    ret
end

using PrecompileTools

@setup_workload begin
	vs = ([1.0], ComplexF64[1.0])
	Bs = Any[BandedMatrix(0 => v) for v in vs]
	@compile_workload begin
		for B in Bs, op in (+, -, *)
			op(B, B)
		end
		for (v, B) in zip(vs, Bs)
			B * v
		end
	end
end

versioninfo()

#gc_enable(false)

using BandedMatrices

A = brand(10000,10000,2,3)
B = brand(1000,1000,200,300)
E = brand(10000,10000,-2,2)
C = rand(1000, 1000)
D = rand(10000, 1000)
V = view(brand(10000,10000,2,3), :, :)
tD = D'
v=rand(10000)
w=rand(1000)

print("A*A:")
A*A;
@time for k=1:100
    A*A
end

print("V*V:")
V*V;
@time for k=1:100
    V*V
end

print("A*D:")
A*D;
@time for k=1:10
    A*D
end

print("D*A:")
tD*A;
@time for k=1:10
    tD*A
end

print("A*E:")
A*E
@time for k=1:10
    A*E
end

print("E*D:")
E*D
@time for k=1:10
    E*D
end

print("B*B:")
B*B;
@time for k=1:10
    B*B
end

print("B*C:")
B*C;
@time for k=1:10
    B*C
end

print("C*B:")
C*B;
@time for k=1:10
    C*B
end

print("A*v:")
A*v;
@time for k=1:1000
    A*v
end

print("B*w:")
B*w;
@time for k=1:100
    B*w
end

#gc_enable(true)

# benchmark pure julia routine vs BLAS routine

# Banded * Dense

julia(A, D) = BandedMatrices._banded_generic_matmatmul!(Matrix{Float64}(size(A, 1), size(D, 2)), 'N', 'N', A, D)
blas(A, D) = BandedMatrices.gbmm!('N', 'N', one(Float64), A, D, zero(Float64), Matrix{Float64}(size(A, 1), size(D, 2)))
dense(A, D) = Array(A)*Array(D)

for n in [100, 1000, 10000, 100000]
    for b in [1, 50, 200, 500]
        A, D = brand(n, n, b, b), rand(n, 2)
        println("n = $n, b = $b")
        if b == 1 && n ≤ 10000
            print("dense")
            @time dense(A, D)
        end
        print("julia")
        @time julia(A, D);
        print("blas ")
        @time blas(A, D);
    end
end

# Banded * Banded

julia(A) = BandedMatrices._banded_generic_matmatmul!(
    BandedMatrix{Float64}(undef, size(A), (2*bandwidth(A, 1), 2*bandwidth(A, 2))), 'N', 'N', A, A)
blas(A) = BandedMatrices.gbmm!(
    'N', 'N', one(Float64), A, A, zero(Float64), BandedMatrix{Float64}(undef, size(A), (2*bandwidth(A, 1), 2*bandwidth(A, 2))))
dense(A) = (B=Array(A); B*B)

for n in [100, 1000, 10000]
    for b in [1, 50, 200, 500]
        A = brand(n, n, b, b)
        println("n = $n, b = $b")
        if b == 1 && n ≤ 1000
            print("dense")
            @time dense(A)
        end
        print("julia")
        @time julia(A);
        print("blas ")
        @time blas(A);
    end
end

# println("Large dimension QR solve")
# A=brand(100000,100000,3,4)
# b=rand(size(A,1))
# @time Q,R=qr(A)
# @time R\(Q'*b)

# println("Time should be   0.030149 seconds (23 allocations: 17.548 MB)")
# println("Time should be   0.008210 seconds (29 allocations: 8.012 MB)")


# A=brand(2000,2000,400,400)
# b=rand(size(A,1))
# @time Q,R=qr(A)
# @time R\(Q'*b)


# println("Time should be   0.401671 seconds (24 allocations: 36.665 MB)")
# println("Time should be   0.009276 seconds (30 allocations: 12.262 MB

nothing

##
# Represent a banded matrix
# [ a_11 a_12
#   a_21 a_22 a_23
#   a_31 a_32 a_33 a_34
#        a_42 a_43 a_44  ]
# ordering the data like  (columns first)
#       [ *      a_12   a_23    a_34
#         a_11   a_22   a_33    a_44
#         a_21   a_32   a_43    *
#         a_31   a_42   *       *       ]
###

function _BandedMatrix end

struct BandedMatrix{T, CONTAINER, RAXIS} <: AbstractBandedMatrix{T}
    data::CONTAINER  # l+u+1 x n (# of columns)
    raxis::RAXIS # axis for rows (col axis comes from data)
    l::Int # lower bandwidth (possibly negative)
    u::Int # upper bandwidth (possibly negative)
    global function _BandedMatrix(data::AbstractMatrix{T}, raxis::AbstractUnitRange, l, u) where {T}
        if size(data,1) ≠ l+u+1  && !(size(data,1) == 0 && -l > u)
           error("Data matrix must have number rows equal to number of bands")
        else
            new{T, typeof(data), typeof(raxis)}(data, raxis, l, u)
        end
    end
end

_BandedMatrix(data::AbstractMatrix, m::Integer, l, u) = _BandedMatrix(data, oneto(m), l, u)

Base.parent(B::BandedMatrix) = B.data
Base.dataids(B::BandedMatrix) = (Base.dataids(B.data)..., Base.dataids(B.raxis)...)

const DefaultBandedMatrix{T} = BandedMatrix{T,Matrix{T},OneTo{Int}}

bandedcolumns(_) = BandedColumns{UnknownLayout}()
bandedcolumns(::ML) where ML<:AbstractStridedLayout = BandedColumns{ML}()
bandedcolumns(::ML) where ML<:AbstractFillLayout = BandedColumns{ML}()

MemoryLayout(A::Type{BandedMatrix{T,Cont,Axes}}) where {T,Cont,Axes} = bandedcolumns(MemoryLayout(Cont))


## Constructors

"""
    BandedMatrix{T}(undef, (n, m), (l, u))

returns an uninitialized `n`×`m` banded matrix of type `T` with bandwidths `(l,u)`.
"""
BandedMatrix{T, C, OneTo{Int}}(::UndefInitializer, (n,m)::NTuple{2,Integer}, (a,b)::NTuple{2,Integer}) where {T<:BlasFloat, C<:AbstractMatrix{T}} =
    _BandedMatrix(C(undef,max(0,b+a+1),m), n, a, b)
BandedMatrix{T, C, OneTo{Int}}(::UndefInitializer, (n,m)::NTuple{2,Integer}, (a,b)::NTuple{2,Integer}) where {T, C<:AbstractMatrix{T}} =
    _BandedMatrix(C(undef,max(0,b+a+1),m),n,a,b)
BandedMatrix{T, C, OneTo{Int}}(::UndefInitializer, (n,m)::NTuple{2,Integer}, (a,b)::NTuple{2,Integer})  where {T<:Number, C<:AbstractMatrix{T}} =
    _BandedMatrix(fill!(similar(C, max(0,b+a+1),m), zero(T)),n,a,b)

BandedMatrix{T, C}(::UndefInitializer, (n,m)::NTuple{2,Integer}, (a,b)::NTuple{2,Integer}) where {T<:BlasFloat, C<:AbstractMatrix{T}} =
    _BandedMatrix(C(undef,max(0,b+a+1),m), n, a, b)
BandedMatrix{T, C}(::UndefInitializer, (n,m)::NTuple{2,Integer}, (a,b)::NTuple{2,Integer}) where {T, C<:AbstractMatrix{T}} =
    _BandedMatrix(C(undef,max(0,b+a+1),m),n,a,b)
BandedMatrix{T, C}(::UndefInitializer, (n,m)::NTuple{2,Integer}, (a,b)::NTuple{2,Integer})  where {T<:Number, C<:AbstractMatrix{T}} =
    _BandedMatrix(fill!(convert(C, similar(C, max(0,b+a+1),m)), zero(T)),n,a,b)

BandedMatrix{T}(::UndefInitializer, nm::NTuple{2,Integer}, ab::NTuple{2,Integer}) where T =
BandedMatrix{T, Matrix{T}}(undef,nm,ab)
BandedMatrix{T}(::UndefInitializer, nm::NTuple{2,OneTo{Int}}, ab::NTuple{2,Integer}) where T =
    BandedMatrix{T}(undef, length.(nm), ab)

@deprecate BandedMatrix{T, C}(::UndefInitializer, n::Integer, ::Colon, a::Integer, b::Integer)  where {T, C<:AbstractMatrix{T}} BandedMatrix{T,C}(undef,n,n+b,a,b)
@deprecate BandedMatrix{T, C}(::UndefInitializer, n::Integer, m::Integer, a::Integer, b::Integer) where {T, C<:AbstractMatrix{T}} BandedMatrix{T, C}(undef, (n,m), (a,b))
@deprecate BandedMatrix{T}(::UndefInitializer, n::Integer, m::Integer, a::Integer, b::Integer)  where {T} BandedMatrix{T}(undef,(n,m),(a,b))
@deprecate BandedMatrix{T}(::UndefInitializer, n::Integer, ::Colon, a::Integer, b::Integer)  where {T} BandedMatrix{T}(undef,(n,n+b),(a,b))

BandedMatrix{V}(M::BandedMatrix) where {V} = _BandedMatrix(AbstractMatrix{V}(M.data), M.raxis, M.l, M.u)
BandedMatrix(M::BandedMatrix{V}) where {V} = _BandedMatrix(AbstractMatrix{V}(M.data), M.raxis, M.l, M.u)

function BandedMatrix{T, C, Ax}(A::UniformScaling, nm::NTuple{2,Integer}, (l,u)::NTuple{2,Integer}=(0,0)) where {T,C,Ax}
    ret = BandedMatrix{T, C, Ax}(undef, nm, (l,u))
    zero!(ret.data)
    ret.data[u+1,:] .= A.λ
    ret
end
BandedMatrix{T,C}(A::UniformScaling, nm::NTuple{2,Integer}, ab::NTuple{2,Integer}=(0,0)) where {T,C} = 
    BandedMatrix{T, C, OneTo{Int}}(A, nm, ab)
BandedMatrix{T}(A::UniformScaling, nm::NTuple{2,Integer}, ab::NTuple{2,Integer}=(0,0)) where T = 
    BandedMatrix{T, Matrix{T}}(A, nm, ab)
BandedMatrix(A::UniformScaling, nm::NTuple{2,Integer}, ab::NTuple{2,Integer}=(0,0)) = 
    BandedMatrix{eltype(A)}(A, nm, ab)


convert(::Type{BandedMatrix{V}}, M::BandedMatrix{V}) where {V} = M
convert(::Type{BandedMatrix{V}}, M::BandedMatrix) where {V} =
        _BandedMatrix(convert(AbstractMatrix{V}, M.data), M.raxis, M.l, M.u)
convert(::Type{BandedMatrix}, M::BandedMatrix) = M

convert(BM::Type{BandedMatrix{T,C}}, M::BandedMatrix{T,C}) where {T,C<:AbstractMatrix{T}} = M
convert(BM::Type{BandedMatrix{T,C,AXIS}}, M::BandedMatrix{T,C,AXIS}) where {T,C<:AbstractMatrix{T},AXIS} = M
convert(BM::Type{BandedMatrix{T,C,OneTo{Int}}}, M::BandedMatrix{T,C,OneTo{Int}}) where {T,C<:AbstractMatrix{T}} = M

function convert(::Type{BandedMatrix{<:, C}}, M::BandedMatrix) where C
    M.data isa C && return M
    _BandedMatrix(convert(C, M.data), M.raxis, M.l, M.u)
end
function convert(BM::Type{BandedMatrix{T, C}}, M::BandedMatrix) where {T, C <: AbstractMatrix{T}}
    M.data isa C && return M
    _BandedMatrix(convert(C, M.data), M.raxis, M.l, M.u)
end
convert(BM::Type{BandedMatrix{T, C, AXIS}}, M::BandedMatrix) where {T, C <: AbstractMatrix{T}, AXIS} =
    _BandedMatrix(convert(C, M.data), convert(AXIS, M.raxis), M.l, M.u)
convert(BM::Type{BandedMatrix{T, C, OneTo{Int}}}, M::BandedMatrix) where {T, C <: AbstractMatrix{T}} =
    _BandedMatrix(convert(C, M.data), convert(OneTo{Int}, M.raxis), M.l, M.u)

for MAT in (:AbstractBandedMatrix, :AbstractMatrix, :AbstractArray)
    @eval begin
        convert(::Type{$MAT{T}}, M::BandedMatrix) where {T} = convert(BandedMatrix{T}, M)
        convert(::Type{$MAT{T}}, M::BandedMatrix{T}) where {T} = convert(BandedMatrix{T}, M)
        convert(::Type{$MAT}, M::BandedMatrix) = M
        $MAT{T}(M::BandedMatrix) where {T} = BandedMatrix{T}(M)
        $MAT(M::BandedMatrix{T}) where {T} = BandedMatrix{T}(M)
    end
end

function copyto_bandeddata!(B::BandedMatrix, M::AbstractMatrix)
    copyto_bandeddata!(B, MemoryLayout(B), M, MemoryLayout(M))
end
function copyto_bandeddata!(B, ::BandedColumns{DenseColumnMajor},
        M, ::Union{BandedColumns{DenseColumnMajor}, DiagonalLayout{DenseColumnMajor}})
    copyto!(B.data, bandeddata(M))
    return B
end
copyto_bandeddata!(B, @nospecialize(_), M, @nospecialize(_)) = copyto!(B, M)

@inline function _convert_common(T, Container, M)
    B = BandedMatrix{T, Container}(undef, size(M), bandwidths(M))
    copyto_bandeddata!(B, M)
end

function convert(::Type{BandedMatrix{<:,C,OneTo{Int}}}, M::AbstractMatrix) where {C}
    Container = typeof(convert(C, similar(M, 0, 0)))
    T = eltype(Container)
    _convert_common(T, Container, M)
end

@inline function _convert_common_container(T, C, M)
    Container = typeof(convert(C, similar(M, T, 0, 0)))
    _convert_common(T, Container, M)
end

function convert(::Type{BandedMatrix{T,C,OneTo{Int}}}, M::AbstractMatrix) where {T, C}
    _convert_common_container(T, C, M)
end

function convert(::Type{BandedMatrix{T,C,OneTo{Int}}}, M::AbstractMatrix) where {T, C<:AbstractMatrix{T}}
    _convert_common_container(T, C, M)
end

convert(::Type{BandedMatrix{<:, C}}, M::AbstractMatrix) where {C} = convert(BandedMatrix{<:,C,OneTo{Int}}, M)
convert(::Type{BandedMatrix{T,C}}, M::AbstractMatrix) where {T, C} = convert(BandedMatrix{T,C,OneTo{Int}}, M)

convert(::Type{BandedMatrix{T}}, M::AbstractMatrix) where {T} =
    convert(BandedMatrix{T, typeof(similar(M, T, 0, 0))}, M)

convert(::Type{BandedMatrix}, M::AbstractMatrix) = convert(BandedMatrix{eltype(M)}, M)
convert(::Type{DefaultBandedMatrix}, M::AbstractMatrix{T}) where T = convert(DefaultBandedMatrix{T}, M)

copy(B::BandedMatrix) = _BandedMatrix(copy(B.data), B.raxis, B.l, B.u)


copymutable_oftype_layout(::BandedColumns, B, ::Type{S}) where S =
    _BandedMatrix(LinearAlgebra.copymutable_oftype(bandeddata(B), S), axes(B,1), bandwidths(B)...)

copymutable_oftype_layout(::BandedRows, B, ::Type{S}) where S =
    dualadjoint(B)(LinearAlgebra.copymutable_oftype(parent(B), S))

copymutable_oftype_layout(::AbstractBandedLayout, B, ::Type{S}) where S =
    copyto!(BandedMatrix{S}(undef, axes(B), bandwidths(B)), B)


promote_rule(::Type{BandedMatrix{T1, C1}}, ::Type{BandedMatrix{T2, C2}}) where {T1,C1, T2,C2} =
    BandedMatrix{promote_type(T1,T2), promote_type(C1, C2)}


for (op,bop) in ((:rand,:brand), (:randn,:brandn))
    @eval begin
        $bop(::Type{T},n::Integer,m::Integer,a::Integer,b::Integer) where {T} =
            _BandedMatrix($op(T,max(0,b+a+1),m),n,a,b)
        $bop(::Type{T},n::Integer,a::Integer,b::Integer) where {T} = $bop(T,n,n,a,b)
        $bop(::Type{T},n::Integer,::Colon,a::Integer,b::Integer) where {T} = $bop(T,n,n+b,a,b)
        $bop(::Type{T},::Colon,m::Integer,a::Integer,b::Integer) where {T} = $bop(T,m+a,m,a,b)
        $bop(n::Integer,m::Integer,a::Integer,b::Integer) = $bop(Float64,n,m,a,b)
        $bop(n::Integer,a::Integer,b::Integer) = $bop(n,n,a,b)

        $bop(::Type{T},n::Integer,m::Integer,a) where {T} = $bop(T,n,m,-a[1],a[end])
        $bop(::Type{T},n::Number,::Colon,a) where {T} = $bop(T,n,:,-a[1],a[end])
        $bop(::Type{T},::Colon,m::Integer,a) where {T} = $bop(T,:,m,-a[1],a[end])
        $bop(::Type{T},n::Integer,a) where {T} = $bop(T,n,-a[1],a[end])
        $bop(n::Integer,m::Integer,a) = $bop(Float64,n,m,-a[1],a[end])
        $bop(n::Integer,a) = $bop(n,-a[1],a[end])

        $bop(B::AbstractMatrix) =
            $bop(eltype(B),size(B,1),size(B,2),bandwidth(B,1),bandwidth(B,2))
    end
end


"""
    brand(T,n,m,l,u)

Creates an `n×m` banded matrix  with random numbers in the bandwidth of type `T` with bandwidths `(l,u)`
"""
brand

"""
    brandn(T,n,m,l,u)

Creates an `n×m` banded matrix  with random normals in the bandwidth of type `T` with bandwidths `(l,u)`
"""
brandn

## Conversions from AbstractArrays, we include FillArrays in case `zeros` is ever faster
BandedMatrix{T}(A::AbstractMatrix, bnds::NTuple{2,Integer}) where T =
    BandedMatrix{T, Matrix{T}}(A, bnds)
function BandedMatrix{T, C}(A::AbstractMatrix, bnds::NTuple{2,Integer}) where {T, C <: AbstractMatrix{T}}
    (n,m) = size(A)
    (l,u) = bnds
    ret = BandedMatrix{T, C}(undef, (n, m), (l, u))
    @inbounds for j = 1:m, k = max(1,j-u):min(n,j+l)
        inbands_setindex!(ret, A[k,j], k, j)
    end
    ret
end

BandedMatrix(A::AbstractMatrix{T}, bnds::NTuple{2,Integer}) where T =
    BandedMatrix{T}(A, bnds)


BandedMatrix{V,C}(Z::Zeros{T,2}, bnds::NTuple{2,Integer}) where {T,C,V} =
    _BandedMatrix(C(Zeros{T}(max(0,sum(bnds)+1),size(Z,2))),size(Z,1),bnds...)

BandedMatrix{V,C,Base.OneTo{Int}}(Z::Zeros{T,2}, bnds::NTuple{2,Integer}) where {T,C,V} =
    _BandedMatrix(C(Zeros{T}(max(0,sum(bnds)+1),size(Z,2))),size(Z,1),bnds...)

BandedMatrix{V}(Z::Zeros{T,2}, bnds::NTuple{2,Integer}) where {T,V} =
    _BandedMatrix(zeros(V,max(0,sum(bnds)+1),size(Z,2)),size(Z,1),bnds...)

BandedMatrix(E::RectDiagonal{T}, bnds::NTuple{2,Integer}) where T = BandedMatrix{T}(E, bnds)
function BandedMatrix{T}(E::RectDiagonal, bnds::NTuple{2,Integer}) where T
    ret = BandedMatrix(Zeros{T}(E), bnds)
    ret[band(0)] .= E.diag
    ret
end

BandedMatrix{T,C}(A::AbstractMatrix) where {T, C<:AbstractMatrix{T}} =
    copyto_bandeddata!(BandedMatrix{T, C}(undef, size(A), bandwidths(A)), A)
BandedMatrix{T}(A::AbstractMatrix) where T =
    copyto_bandeddata!(BandedMatrix{T}(undef, size(A), bandwidths(A)), A)


_BandedMatrix(_, A::AbstractMatrix) = BandedMatrix(A, bandwidths(A))
BandedMatrix(A::AbstractMatrix) = _BandedMatrix(MemoryLayout(A), A)


## specialised
# use bandeddata if possible
_BandedMatrix(::BandedColumns, A::AbstractMatrix) = _BandedMatrix(copy(bandeddata(A)), axes(A,1), bandwidths(A)...)
function _BandedMatrix(::BandedRows, A::AbstractMatrix)
    bdata = bandedrowsdata(A)
    u, ℓ = bandwidths(A)
    m, n = size(A)
    data_new = similar(bdata, eltype(bdata), size(bdata, 2), n)
    for i in axes(bdata, 2)
        d = u + 1 - i
        row_new = ℓ + 1 + d
        k_start = max(1, 1 - d)
        k_end = min(n, m - d)
        if k_start ≤ k_end
            col_start_A = k_start + d
            col_end_A = k_end + d
            copyto!(view(data_new, row_new, k_start:k_end), view(bdata, col_start_A:col_end_A, i))
        end
    end
    return _BandedMatrix(data_new, axes(A, 1), u, ℓ)
end
function _BandedMatrix(::DiagonalLayout, A::AbstractMatrix{T}) where T
    m,n = size(A)
    dat = Matrix{T}(undef, 1, n)
    copyto!(vec(dat), diagonaldata(A))
    _BandedMatrix(dat, m, 0, 0)
end
function _BandedMatrix(::BidiagonalLayout, A::AbstractMatrix{T}) where T
    m,n = size(A)
    dat = Matrix{T}(undef, 2, n)
    if bidiagonaluplo(A) == 'L'
        copyto!(view(dat, 1, :), diagonaldata(A))
        copyto!(view(dat, 2, 1:n-1), subdiagonaldata(A))
        _BandedMatrix(dat, m, 1, 0)
    else # u
        copyto!(view(dat, 1, 2:n), supdiagonaldata(A))
        copyto!(view(dat, 2, :), diagonaldata(A))
        _BandedMatrix(dat, m, 0, 1)
    end
end

function _BandedMatrix(::AbstractTridiagonalLayout, A::AbstractMatrix{T}) where T
    m,n = size(A)
    dat = Matrix{T}(undef, 3, n)

    copyto!(view(dat, 1, 2:n), supdiagonaldata(A))
    copyto!(view(dat, 2, :), diagonaldata(A))
    copyto!(view(dat, 3, 1:n-1), subdiagonaldata(A))
    _BandedMatrix(dat, m, 1, 1)
end


"""
    BandedMatrix{T}(kv::Pair, (m,n), (l,u))

Construct a m × n BandedMatrix with bandwidths (l,u)
from `Pair`s of diagonals and vectors.
Vector `kv.second` will be placed on the `kv.first` diagonal.
"""
function BandedMatrix{T}(kv::Tuple{Vararg{Pair{<:Integer,<:AbstractVector}}},
                         mn::NTuple{2,Integer},
                         lu::NTuple{2,Integer}) where T
    m,n = mn
    l,u = lu
    data = zeros(T, u+l+1, n)
    for (k,v) in kv
        p = length(v)
        if k ≤ 0
            data[u-k+1,1:p] = v
        else
            data[u-k+1,k+1:k+p] = v
        end
    end

    return _BandedMatrix(data, m, l, u)
end

BandedMatrix(kv::Tuple{Vararg{Pair{<:Integer,<:AbstractVector}}},
                         mn::NTuple{2,Integer},
                         lu::NTuple{2,Integer}) =
    BandedMatrix{promote_type(map(x -> eltype(x.second), kv)...)}(kv, mn, lu)



function BandedMatrix{T}(kv::Tuple{Vararg{Pair{<:Integer,<:AbstractVector}}},
                         nm::NTuple{2,Integer}) where T
    u = mapreduce(x -> x.first, max, kv)
    l = -mapreduce(x -> x.first, min, kv)
    BandedMatrix{T}(kv, nm, (l,u))
end

BandedMatrix(kv::Tuple{Vararg{Pair{<:Integer,<:AbstractVector}}}, nm::NTuple{2,Integer}) =
    BandedMatrix{promote_type(map(x -> eltype(x.second), kv)...)}(kv, nm)



function BandedMatrix{T}(kv::Pair{<:Integer,<:AbstractVector}...) where T
    n = mapreduce(x -> length(x.second) + abs(x.first), max, kv)
    u = mapreduce(x -> x.first, max, kv)
    l = -mapreduce(x -> x.first, min, kv)
    BandedMatrix{T}(kv, (n,n), (l,u))
end

"""
    BandedMatrix(kv::Pair{<:Integer,<:AbstractVector}...)

Construct a square matrix from `Pair`s of diagonals and vectors.
Vector `kv.second` will be placed on the `kv.first` diagonal.
"""
BandedMatrix(kv::Pair{<:Integer,<:AbstractVector}...) =
    BandedMatrix{promote_type(map(x -> eltype(x.second), kv)...)}(kv...)



"""
    similar(bm::BandedMatrix, [T::Type], [n::Integer, m::Integer, [l::Integer, u::Integer]])
    similar(bm::BandedSubBandedMatrix, [T::Type], [n::Integer, m::Integer, [l::Integer, u::Integer]])

Creates a banded matrix similar in type to the input. Where the eltype `T`, the
sizes `n`, and `m`, the band limits `l`, and `u` are not provided, they default
to the values in the input banded matrix.
"""
function similar(bm::BandedMatrix, T::Type=eltype(bm),
                      n::Integer=size(bm, 1), m::Integer=size(bm, 2),
                      l::Integer=bandwidth(bm, 1), u::Integer=bandwidth(bm, 2))
    data = similar(bm.data, T, max(0, u+l+1), m)
    _BandedMatrix(data, n, l, u)
end

similar(bm::AbstractBandedMatrix, n::Integer, m::Integer) = similar(bm, eltype(bm), n, m)
similar(bm::AbstractBandedMatrix, n::Integer, m::Integer, l::Integer, u::Integer) =
    similar(bm, eltype(bm), m, n, l, u)
similar(bm::AbstractBandedMatrix, nm::Tuple{<:Integer,<:Integer}) = similar(bm, nm...)




## Abstract Array Interface

axes(A::BandedMatrix) = (A.raxis, axes(A.data,2))
size(A::BandedMatrix) = (length(A.raxis), size(A.data,2))


## banded matrix interface
bandeddata(A::BandedMatrix) = A.data
bandwidths(A::BandedMatrix) = (A.l , A.u)

# ~~ getindex ~~

# fast method used below
@propagate_inbounds inbands_getindex(data::AbstractMatrix, u::Integer, k::Integer, j::Integer) =
    data[u + k - j + 1, j]

@propagate_inbounds function inbands_getindex(A::BandedMatrix, k::Integer, j::Integer)
    inbands_getindex(A.data, A.u, k, j)
end

# work around for Any matrices
_offband_zero(::AbstractMatrix{T}, _, _, _, _) where T = zero(T)
_offband_zero(::AbstractMatrix{Any}, _, _, _, _) = nothing
_offband_zero(data::AbstractMatrix{<:AbstractMatrix}, l, u, k, j) =
    diagzero(Diagonal(view(data,u+1,:)), k, j)
diagzero(D::Diagonal{B}, i, j) where B<:BandedMatrix =
    B(Zeros{eltype(B)}(size(D.diag[i], 1), size(D.diag[j], 2)), (bandwidth(D.diag[i],1), bandwidth(D.diag[j],2)))

# banded get index, used for banded matrices with other data types
@propagate_inbounds function banded_getindex(data::AbstractMatrix, l::Integer, u::Integer, k::Integer, j::Integer)
    if -l ≤ j-k ≤ u
        inbands_getindex(data, u, k, j)
    else
        _offband_zero(data, l, u, k, j)
    end
end


# Int - Int
@inline function getindex(A::BandedMatrix, k::Int, j::Int)
    @boundscheck checkbounds(A, k, j)
    @inbounds r = banded_getindex(A.data, A.l, A.u, k, j)
    r
end

# BandRange - Int
@propagate_inbounds function getindex(A::BandedMatrix, ::BandRangeType, j::Int)
    @boundscheck checkbounds(A, colrange(A, j), j)
    A.data[data_colrange(A,j)]
end

# Colon - Int
@propagate_inbounds function getindex(A::BandedMatrix, ::Colon, j::Int)
    @boundscheck checkbounds(A, axes(A,1), j)
    r = similar(A, axes(A,1))
    r[firstindex(r):min(size(A, 1), colstart(A,j)-1)] .= zero(eltype(r))
    # broadcasted assignment is currently faster than setindex
    # see https://github.com/JuliaLang/julia/issues/40962#issuecomment-1921340377
    # may need revisiting in the future
    r[colrange(A,j)] .= @view A.data[data_colrange(A,j)]
    r[colstop(A,j)+1:end] .= zero(eltype(r))
    return r
end

# Int - BandRange
@propagate_inbounds function getindex(A::BandedMatrix, k::Int, j::BandRangeType)
    @boundscheck checkbounds(A, k, rowrange(A, k))
    A.data[data_rowrange(A,k)]
end

# Int - Colon
@propagate_inbounds function getindex(A::BandedMatrix, k::Int, ::Colon)
    @boundscheck checkbounds(A, k, axes(A,2))
    r = similar(A, axes(A,2))
    r[firstindex(r):min(size(A, 2), rowstart(A,k)-1)] .= zero(eltype(r))
    r[rowrange(A,k)] = @view A.data[data_rowrange(A,k)]
    r[rowstop(A,k)+1:end] .= zero(eltype(r))
    return r
end

# ~ indexing along a band
# we reduce it to converting a View


"""
    BandedMatrixBand

Type to represent a view of a band of a `BandedMatrix`

# Examples
```jldoctest
julia> B = BandedMatrix(0=>1:3);

julia> view(B, band(0)) isa BandedMatrices.BandedMatrixBand
true
```
"""
const BandedMatrixBand{T} = Union{
                                SubArray{T, 1, <:ReshapedArray{T,1,
                                    <:Union{BandedMatrix{T}, SubArray{T,2,<:BandedMatrix{T},
                                    <:NTuple{2, AbstractUnitRange{Int}}}}}, <:Tuple{BandSlice{<:Integer}}},
                                SubArray{T, 1, <:BandedMatrix{T}, <:Tuple{BandSlice{<:CartesianIndex{2}}}}}


band(V::BandedMatrixBand) = first(parentindices(V)).band.i


"""
    dataview(V::BandedMatrices.BandedMatrixBand)

Forward a view of a band of a `BandedMatrix` to the parent's data matrix.

!!! warn
    This will error if the indexing is out-of-bounds for the data matrix, even if it is inbounds
    for the parent `BandedMatrix`

# Examples
```jldoctest
julia> A = BandedMatrix(0=>1:4, 1=>5:7, -1=>8:10)
4×4 BandedMatrix{Int64} with bandwidths (1, 1):
 1  5   ⋅  ⋅
 8  2   6  ⋅
 ⋅  9   3  7
 ⋅  ⋅  10  4

julia> v = view(A, band(1));

julia> BandedMatrices.dataview(v)
3-element view(::Matrix{Int64}, 1, 2:4) with eltype Int64:
 5
 6
 7
```
"""
function dataview(V::BandedMatrixBand)
    A = parent(parent(V))
    b = band(V)
    m,n = size(A)
    u = bandwidth(A,2)
    view(bandeddata(A), u - b + 1, max(b,0)+1:min(n,m+b))
end

@propagate_inbounds function getindex(B::BandedMatrixBand, i::Int)
    A = parent(parent(B))
    b = band(B)
    l, u = bandwidths(A)
    if -l ≤ band(B) ≤ u
        dataview(B)[i]
    else
        @boundscheck checkbounds(B, i)
        zero(eltype(B))
    end
end

# B[band(i)]
@inline function copyto!(v::AbstractVector, B::BandedMatrixBand)
    A = parent(parent(B))
    l, u = bandwidths(A)
    if -l ≤ band(B) ≤ u
        copyto!(v, dataview(B))
    else
        Binds = axes(B,1)
        v[firstindex(v)-1 .+ Binds] .= 0
    end
    return v
end

# B[band(i)] .= x::Number
@inline function fill!(Bv::BandedMatrixBand, x)
    b = band(Bv)
    A = parent(parent(Bv))
    l, u = bandwidths(A)
    if -l <= b <= u
        fill!(dataview(Bv), x)
    elseif !iszero(x)  # allow setting outside bands to zero
        throw(BandError(A,b))
    end
    Bv
end

@noinline throwdm(destaxes, srcaxes) =
    throw(DimensionMismatch("destination axes $destaxes do not match source axes $srcaxes"))

# more complicated broadcating
# e.g. B[band(i)] .= a .* x .+ v
@inline function copyto!(dest::BandedMatrixBand, bc::Broadcasted{Nothing})
    axes(dest) == axes(bc) || throwdm(axes(dest), axes(src))

    A = parent(parent(dest))
    if -A.l ≤ band(dest) ≤ A.u
        copyto!(dataview(dest), bc)
    else
        all(iszero, bc) || throw(BandError(A, band(dest)))
    end
    return dest
end

# ~ indexing along a row



# give range of data matrix corresponding to colrange/rowrange
data_colrange(A::BandedMatrix{T}, i::Integer) where {T} =
    (max(1,A.u+2-i):min(size(A,1)+A.u-i+1,size(A.data,1))) .+
                                ((i-1)*size(A.data,1))

function data_rowrange(A::BandedMatrix, rowind::Integer)
    StepRangeLen(rowind ≤ 1+A.l ? A.u+rowind : (rowind-A.l)*size(A.data,1),
        size(A.data,1)-1,
        length(rowrange(A,rowind))
    )
end

# ~~ setindex! ~~

# ~ Special setindex methods ~

# fast method used below
@propagate_inbounds function inbands_setindex!(data::AbstractMatrix, u::Integer, v, k::Integer, j::Integer)
    data[u + k - j + 1, j] = v
end

# slow fall back method
@propagate_inbounds function inbands_setindex!(A::BandedMatrix, v, k::Integer, j::Integer)
    inbands_setindex!(A.data, A.u, v, k, j)
end

@propagate_inbounds function banded_setindex!(data::AbstractMatrix, l::Integer, u::Integer, v, k::Integer, j::Integer)
    if -l ≤ j-k ≤ u
        inbands_setindex!(data, u, v, k, j)
    elseif !iszero(v)  # allow setting outside bands to zero
        throw(BandError(data,j-k))
    else # v == 0
        v
    end
end

# scalar - integer - integer
@inline function setindex!(A::BandedMatrix, v, k::Integer, j::Integer)
    @boundscheck checkbounds(A, k, j)
    @inbounds banded_setindex!(A.data, A.l, A.u, v, k ,j)
    A
end

# matrix - colon - colon
@inline function setindex!(A::BandedMatrix{T}, v::AbstractMatrix, kr::Colon, jr::Colon) where {T}
    @boundscheck checkdimensions(size(A), size(v))
    @boundscheck checkbandmatch(A, v, kr, jr)

    data = A.data
    l,u = bandwidths(A)

    for j=rowsupport(A), k=colrange(A,j)
        @inbounds inbands_setindex!(data, u, v[k,j], k, j)
    end
    A
end

@propagate_inbounds function setindex!(A::BandedMatrix{T}, v::AbstractVector, ::Colon) where {T}
    A[:, :] = reshape(v,size(A))
    A
end


# ~ indexing along a band

# vector - band - colon
@inline function setindex!(A::BandedMatrix{T}, V::AbstractVector, b::Band) where {T}
    @boundscheck checkband(A, b)
    @boundscheck checkdimensions(diaglength(A, b), V)
    row = A.u - b.i + 1
    data, i = A.data, max(b.i + 1, 1)
    for v in V
        @inbounds data[row, i] = v
        i += 1
    end
    A
end


# ~ indexing along columns
# vector - colon - integer -- A[:, 1] = [1, 2, 3] - not allowed
@propagate_inbounds function setindex!(A::BandedMatrix{T}, V::AbstractVector, kr::Colon, j::Integer) where {T}
    @boundscheck checkbounds(A, kr, j)
    @boundscheck checkdimensions(1:size(A,1), V)
    @boundscheck checkbandmatch(A,V,:,j)

    A.data[data_colrange(A,j)] = @view V[colrange(A,j)]
    A
end

# vector - BandRange - integer -- A[BandRange, 1] = [1, 2, 3]
@propagate_inbounds function setindex!(A::BandedMatrix, V::AbstractVector, ::BandRangeType, j::Integer)
    kr = colrange(A, j)
    @boundscheck checkbounds(A, kr, j)
    @boundscheck checkdimensions(kr, V)

    data, u = A.data, A.u
    for i in eachindex(kr, V)
        inbands_setindex!(data, u, V[i], kr[i], j)
    end
    A
end

# vector - range - integer -- A[1:3, 1] = [1, 2, 3]
@propagate_inbounds function setindex!(A::BandedMatrix, V::AbstractVector, kr::AbstractRange, j::Integer)
    @boundscheck checkbounds(A, kr, j)
    @boundscheck checkdimensions(kr, V)
    @boundscheck checkbandmatch(A, V, kr, j)

    a = colstart(A, j)
    b = colstop(A, j)

    data, u, i = A.data, A.u, 0
    for v in V
        k = kr[i+=1]
        if a ≤ k ≤ b
            inbands_setindex!(data, u, v, k, j)
        end
    end
    A
end


# ~ indexing along a row

# vector - integer - colon -- A[1, :] = [1, 2, 0] -- out-of-band values must be zeros
@propagate_inbounds function setindex!(A::BandedMatrix{T}, V::AbstractVector, k::Integer, jr::Colon) where {T}
    @boundscheck if k < 1 || k > size(A,1)
        throw(BoundsError(A, (k, jr)))
    end
    @boundscheck if size(A,2) ≠ length(V)
        throw(DimensionMismatch("tried to assign $(length(V)) vector to $(size(A,1)) destination"))
    end
    @boundscheck checkbandmatch(A, V, k, jr)

    A.data[data_rowrange(A,k)] = @view V[rowrange(A,k)]
    A
end

# vector - integer - BandRange -- A[1, BandRange] = [1, 2, 3]
@propagate_inbounds function setindex!(A::BandedMatrix, V::AbstractVector, k::Integer, ::BandRangeType)
    jr = rowrange(A, k)
    @boundscheck checkbounds(A, k, jr)
    @boundscheck checkdimensions(jr, V)

    data, u = A.data, A.u
    for i in eachindex(jr, V)
        inbands_setindex!(data, u, V[i], k, jr[i])
    end
    A
end

# vector - integer - range -- A[1, 2:3] = [3, 4]
@propagate_inbounds function setindex!(A::BandedMatrix, V::AbstractVector, k::Integer, jr::AbstractRange)
    @boundscheck checkbounds(A, k, jr)
    @boundscheck checkdimensions(jr, V)
    @boundscheck checkbandmatch(A, V, k, jr)

    a = rowstart(A, k)
    b = rowstop(A, k)

    data, u, i = A.data, A.u, 0
    for v in V
        j = jr[i+=1]
        if a ≤ j ≤ b
            inbands_setindex!(data, u, v, k, j)
        end
    end
    A
end

# ~ indexing over a rectangular block

# matrix - range - range
@propagate_inbounds function setindex!(A::BandedMatrix, V::AbstractMatrix, kr::AbstractRange, jr::AbstractRange)
    @boundscheck checkbounds(A, kr, jr)
    @boundscheck checkdimensions(kr, jr, V)
    @boundscheck checkbandmatch(A, V, kr, jr)
    copyto!(view(A, kr, jr), V)
    A
end

# ~~ end setindex! ~~



function convert(::Type{Matrix}, A::BandedMatrix)
    ret=zeros(eltype(A), size(A))
    for j = rowsupport(A), k = colrange(ret,j)
        @inbounds ret[k,j] = A[k,j]
    end
    ret
end

function _banded_colval(B::AbstractMatrix)
    data = bandeddata(B)
    j = Vector{Int}(undef, length(data))
    n,m = size(data)
    for κ=1:n, ℓ=1:m
        j[κ+n*(ℓ-1)] = ℓ
    end
    j
end

function _banded_rowval(B::AbstractMatrix)
    data = bandeddata(B)
    i = Vector{Int}(undef, length(data))
    n,m = size(data)
    Bn = size(B,1)
    l,u = bandwidths(B)
    for κ=1:n, ℓ=1:m
        ii=κ+ℓ-u-1
        i[κ+n*(ℓ-1)] = min(max(ii,1),Bn)
    end
    i
end

function _banded_nzval(B::AbstractMatrix)
    data = bandeddata(B)
    i = Vector{Int}(undef, length(data))
    n,m = size(data)
    Bn = size(B,1)
    vb = copy(vec(data))
    l,u = bandwidths(B)
    for κ=1:n, ℓ=1:m
        ii=κ+ℓ-u-1
        if ii <1 || ii > Bn
            vb[κ+n*(ℓ-1)] = 0
        end
    end
    vb
end




function _bidiagonalize!(A::AbstractMatrix{T}, M::BandedColumnMajor) where T
    m, n = size(A)
    mn = min(m, n)
    d = Vector{T}(undef, mn)
    e = Vector{T}(undef, mn-1)
    Q = Matrix{T}(undef, 0, 0)
    Pt = Matrix{T}(undef, 0, 0)
    C = Matrix{T}(undef, 0, 0)
    work = Vector{T}(undef, 2*max(m, n))
    gbbrd!('N', m, n, 0, bandwidth(A, 1), bandwidth(A, 2), bandeddata(A), d, e, Q, Pt, C, work)
    Bidiagonal(d, e, :U)
end

function _bidiagonalize!(A::AbstractMatrix{T}, M::BandedColumnMajor) where T <: Complex
    m, n = size(A)
    mn = min(m, n)
    d = Vector{real(T)}(undef, mn)
    e = Vector{real(T)}(undef, mn-1)
    Q = Matrix{T}(undef, 0, 0)
    Pt = Matrix{T}(undef, 0, 0)
    C = Matrix{T}(undef, 0, 0)
    work = Vector{T}(undef, 2*max(m, n))
    rwork = Vector{real(T)}(undef, 2*max(m, n))
    gbbrd!('N', m, n, 0, bandwidth(A, 1), bandwidth(A, 2), bandeddata(A), d, e, Q, Pt, C, work, rwork)
    Bidiagonal(d, e, :U)
end

bidiagonalize!(A::AbstractMatrix) = _bidiagonalize!(A, MemoryLayout(typeof(A)))
bidiagonalize(A::AbstractMatrix) = bidiagonalize!(copy(A))

svdvals!(A::BandedMatrix) = svdvals!(bidiagonalize!(A))
svdvals(A::BandedMatrix) = svdvals!(copy(A))

# We turn off bound checking to allow nicer syntax without branching
#setindex!(A::BandedMatrix,v,k::Integer,j::Integer)=((A.l≤j-k≤A.u)&&k≤A.n)?ussetindex!(A,v,k,j):throw(BoundsError())
#setindex!(A::BandedMatrix,v,kr::AbstractRange,j::Integer)=(A.l≤j-kr[end]≤j-kr[1]≤A.u&&kr[end]≤A.n)?ussetindex!(A,v,kr,j):throw(BoundsError())


## ALgebra and other functions

"""
allinbands(A)

returns true if there are no entries outside the bands.
"""
function allinbands(A)
    m,n = size(A)
    l,u = bandwidths(A)
    m ≤ l+1 && n ≤ u+1
end

function fill!(A::BandedMatrix, x)
    iszero(x) || allinbands(A) || throw(BandError(A))
    fill!(A.data, x)
    A
end

function LinearAlgebra.fillband!(A::BandedMatrix{T}, x, l, u) where T
    fill!(view(A.data, max(A.u+1-u,1):min(A.u+1-l,size(A.data,1)), :), x)
    A
end

diag(A::BandedMatrix, k::Integer = 0) = A[band(k)]

## BandedSubBandedMatrix routines

# gives the band which is diagonal for the parent
bandshift(a::Base.IdentityUnitRange, b::AbstractRange, pa, pb) = first(pa)-first(b)
bandshift(a::AbstractRange, b::Base.IdentityUnitRange, pa, pb) = first(a)-first(pb)
bandshift(a::Base.IdentityUnitRange, b::Base.IdentityUnitRange, pa, pb) = first(pa)-first(pb)
bandshift(a::AbstractRange, b::AbstractRange, _...) = first(a)-first(b)
bandshift(::Slice{OneTo{Int}}, b::AbstractRange, _...) = 1-first(b)
bandshift(a::AbstractRange, ::Slice{OneTo{Int}}, _...) = first(a)-1
bandshift(::Slice{OneTo{Int}}, b::Slice{OneTo{Int}}, _...) = 0
bandshift(S) = bandshift(parentindices(S)[1], parentindices(S)[2], axes(parent(S))...)




# BandedMatrix with unit range indexes is also banded
const BandedSubBandedMatrix{T, C, R, I1<:AbstractUnitRange, I2<:AbstractUnitRange, t} =
    SubArray{T,2,BandedMatrix{T, C, R},Tuple{I1,I2},t}

isbanded(::BandedSubBandedMatrix) = true
sublayout(::AbstractBandedLayout, ::Type{<:NTuple{2,AbstractUnitRange}}) = BandedLayout()
sublayout(::BandedColumns{L}, ::Type{<:Tuple{AbstractUnitRange,J}}) where {L,J<:AbstractUnitRange} =
    bandedcolumns(sublayout(L(),Tuple{Slice{OneTo{Int}},J}))
sublayout(::BandedRows{L}, ::Type{<:Tuple{J,AbstractUnitRange}}) where {L,J<:AbstractUnitRange} =
    transposelayout(bandedcolumns(sublayout(L(),Tuple{Slice{OneTo{Int}},J})))

Base.permutedims(A::Symmetric{<:Any,<:AbstractBandedMatrix}) = A
Base.permutedims(A::BandedMatrix{<:Number}) = transpose(A) # temp
Base.permutedims(A::Adjoint{<:Real,<:BandedMatrix}) = A' # temp
Base.permutedims(A::Transpose{<:Number,<:BandedMatrix}) = transpose(A) # temp
Base.permutedims(A::BandedMatrix) = PermutedDimsArray(A, (2,1))
bandwidths(A::PermutedDimsArray{<:Any,2,(2,1),(2,1)}) = reverse(bandwidths(parent(A)))

function _shift(bm::BandedSubBandedMatrix)
    kr,jr=parentindices(bm)
    kr[1]-jr[1]
end

function similar(bm::BandedSubBandedMatrix, T::Type=eltype(bm),
                      n::Integer=size(bm, 1), m::Integer=size(bm, 2),
                      l::Integer=max(0, bandwidth(parent(bm), 1) - _shift(bm)),
                      u::Integer=max(0, bandwidth(parent(bm), 2) + _shift(bm)))
    similar(bm.parent, T, n, m, l, u)
end

function bandeddata(V::SubArray)
    l,u = bandwidths(V)
    L,U = bandwidths(parent(V)) .+ (-1,1) .* bandshift(V)
    view(bandeddata(parent(V)), U-u+1:U+l+1, parentindices(V)[2])
end

bandwidths(S::SubArray{T,2,<:AbstractMatrix,I}) where {T,I<:Tuple{Vararg{AbstractUnitRange}}} =
    min.(size(S) .- 1, bandwidths(parent(S)) .+ (-1,1) .* bandshift(S))

@propagate_inbounds function inbands_getindex(S::BandedSubBandedMatrix{T}, k::Integer, j::Integer) where {T}
    inbands_getindex(parent(S), reindex(parentindices(S), (k, j))...)
end

@propagate_inbounds function inbands_setindex!(S::BandedSubBandedMatrix{T}, v, k::Integer, j::Integer) where {T}
    inbands_setindex!(parent(S), v, reindex(parentindices(S), (k, j))...)
end



function convert(::Type{BandedMatrix}, S::BandedSubBandedMatrix)
    A=parent(S)
    kr,jr=parentindices(S)
    shft=kr[1]-jr[1]
    l,u=bandwidths(A)
    if -u ≤ shft ≤ l
        data = A.data[:, jr]
    elseif shft > l
        # need to add extra zeros at top since negative bandwidths not supported
        # new bandwidths = (0,u+shft)
        data = fill!(similar(A.data,u+shft+1,length(jr)), zero(eltype(A.data)))
        data[1:l+u+1,:] = A.data[:,jr]
    else  # shft < -u
        data = fill!(similar(A.data,l-shft+1,length(jr)), zero(eltype(A.data)))
        data[-shft-u+1:end,:] = A.data[:,jr]  # l-shft+1 - (-shft-u) == l+u+1
    end
    _BandedMatrix(data,length(kr),max(0, l-shft),max(0, u+shft))
end

_banded_summary(io, B::BandedMatrix{T}, inds) where T = print(io, Base.dims2string(length.(inds)), " BandedMatrix{$T} with bandwidths $(bandwidths(B))")
Base.array_summary(io::IO, B::DefaultBandedMatrix, inds::Tuple{Vararg{OneTo}}) = _banded_summary(io, B, inds)
function Base.array_summary(io::IO, B::BandedMatrix, inds::Tuple{Vararg{OneTo}})
    _banded_summary(io, B, inds)
    print(io, " with data ")
    summary(io, B.data)
end
function Base.array_summary(io::IO, B::BandedMatrix, inds)
    _banded_summary(io, B, inds)
    print(io, " with data ")
    summary(io, B.data)
    print(io, " with indices ", Base.inds2string(inds))
end

## Broadcast style
# allow special casing


bandedbroadcaststyle(_) = BandedStyle()
BroadcastStyle(::Type{<:BandedMatrix{<:Any,Dat}}) where Dat = bandedbroadcaststyle(BroadcastStyle(Dat))

function banded_axpy!(a::Number, X::BandedMatrix, Y::BandedMatrix)
    bx = bandwidths(X)
    by = bandwidths(Y)
    if bx == by
        axpy!(a, X.data, Y.data)
    else
        banded_generic_axpy!(a, X, Y)
    end
    return Y
end

# show
function show(io::IO, B::BandedMatrix)
    print(io, "BandedMatrix(")
    l, u = bandwidths(B)
    limit = get(io, :limit, true)
    br = limit ? intersect(-l:u, range(-l,length=4)) : -l:u
    for (ind, b) in enumerate(br)
        r = @view B[band(b)]
        show(io, b => r)
        b == last(br) || print(io, ", ")
    end
    if limit && br != -l:u
        br2 = max(maximum(br)+1, u-3):u
        if minimum(br2) == maximum(br)+1
            print(io, ", ")
        else
            print(io, "  …  ")
        end
        for (ind, b) in enumerate(br2)
            r = @view B[band(b)]
            show(io, b => r)
            b == u || print(io, ", ")
        end
    end
    print(io, ")")
end


###
# resize
###

function resize(A::BandedMatrix, n::Integer, m::Integer)
    l,u = bandwidths(A)
    _BandedMatrix(reshape(resize!(vec(bandeddata(A)), (l+u+1)*m), l+u+1, m), n, l,u)
end
function resize(A::BandedSubBandedMatrix, n::Integer, m::Integer)
    l,u = bandwidths(A)
    _BandedMatrix(reshape(resize!(vec(copy(bandeddata(A))), (l+u+1)*m), l+u+1, m), n, l,u)
end

###
# one
###

function one(A::BandedMatrix)
    m,n = size(A)
    m==n || throw(DimensionMismatch("multiplicative identity defined only for square matrices"))
    typeof(A)(I, (m,n))
end

function Base.unaliascopy(B::BandedMatrix)
    _BandedMatrix(Base.unaliascopy(B.data), Base.unaliascopy(B.raxis), B.l, B.u)
end

module BandedMatrices
using Base, FillArrays, ArrayLayouts, LinearAlgebra

using Base: require_one_based_indexing, reindex, checkbounds, @propagate_inbounds,
            oneto, promote_op, OneTo, ReshapedArray, Slice
import Base: axes, axes1, getproperty, getindex, setindex!, *, +, -, ==, <, <=, >,
               >=, /, \, adjoint, transpose, showerror, convert, size, view,
               unsafe_indices, first, last, size, length, unsafe_length, step, to_indices,
               to_index, show, fill!, similar, copy, promote_rule, real, imag,
               copyto!, Array, sum, sum!, one, AbstractMatrix, Matrix, AbstractArray

using Base.Broadcast: AbstractArrayStyle, DefaultArrayStyle, Broadcasted
import Base.Broadcast: BroadcastStyle, broadcasted

import Base: rot180

import LinearAlgebra: _apply_inverse_ipiv_rows!, _apply_ipiv_rows!, _chol!, axpy!, cholcopy, diag, diagzero, dot, eigen,
                      eigen!, eigvals, eigvals!, factorize, isdiag, istril, istriu, ldiv!, ldlt, ldlt!, lmul!,
                      logabsdet, lu, lu!, mul!, qr, qr!, rmul!, svdvals, svdvals!, tril!, triu!

using LinearAlgebra: AbstractTriangular, AdjOrTrans, BlasComplex, BlasFloat, BlasInt, BlasReal, Givens, HermOrSym,
                     QRPackedQ, RealHermSymComplexHerm, StructuredMatrixStyle, checksquare, chkstride1, ipiv2perm, AdjointQ

using LinearAlgebra.LAPACK

using LinearAlgebra.LAPACK: chkuplo

import ArrayLayouts: AbstractTridiagonalLayout, BidiagonalLayout, BlasMatLdivVec, BlasMatLmulVec,
                     BlasMatMulMatAdd, BlasMatMulVecAdd, MatMulMatAdd, MatMulVecAdd, MemoryLayout,
                     _copy_oftype, _copyto!, _factorize, _lu, _lu!, _qr, _qr!, bidiagonaluplo, checkdimensions,
                     colsupport, conjlayout, copymutable_oftype_layout, diagonaldata, dualadjoint, hermitiandata,
                     hermitianlayout, materialize, materialize!, reflector!, reflectorApply!, rowsupport,
                     sub_materialize, subdiagonaldata, sublayout, supdiagonaldata, symmetricdata, symmetriclayout,
                     symmetricuplo, transposelayout, triangulardata, triangularlayout, zero!,
                     QRPackedQLayout, AdjQRPackedQLayout, LayoutVecOrMats

import FillArrays: AbstractFill, getindex_value, _broadcasted_zeros, unique_value, OneElement, RectDiagonal, OneElementMatrix, OneElementVector, ZerosMatrix, ZerosVector

const libblas = LinearAlgebra.BLAS.libblas
const liblapack = LinearAlgebra.BLAS.liblapack
const AdjointFact = isdefined(LinearAlgebra, :AdjointFactorization) ?
    LinearAlgebra.AdjointFactorization :
    Adjoint
const TransposeFact = isdefined(LinearAlgebra, :TransposeFactorization) ?
    LinearAlgebra.TransposeFactorization :
    Transpose

export BandedMatrix,
       bandrange,
       brand,
       brandn,
       bandwidth,
       BandError,
       band,
       symrcm,
       Band,
       BandRange,
       bandwidths,
       colrange,
       rowrange,
       Zeros,
       Fill,
       Ones,
       Eye


include("blas.jl")
include("lapack.jl")

include("generic/AbstractBandedMatrix.jl")
include("generic/broadcast.jl")
include("generic/matmul.jl")
include("generic/Band.jl")
include("generic/utils.jl")
include("generic/indexing.jl")


include("banded/BandedMatrix.jl")
include("banded/BandedLU.jl")
include("banded/bandedqr.jl")
include("banded/gbmm.jl")
include("banded/linalg.jl")
include("banded/dot.jl")

include("symbanded/symbanded.jl")
include("symbanded/ldlt.jl")
include("symbanded/BandedCholesky.jl")
include("symbanded/SplitCholesky.jl")
include("symbanded/bandedeigen.jl")
include("symbanded/tridiagonalize.jl")
include("symbanded/symrcm.jl")

include("tribanded.jl")

include("interfaceimpl.jl")

include("precompile.jl")



end #module

module TestLinalg

using ArrayLayouts
using BandedMatrices
using FillArrays
using LinearAlgebra
using Quaternions
using Test

import BandedMatrices: BandedColumns, _BandedMatrix

@testset "Linear Algebra" begin
    @testset "Matrix types" begin
        A = brand(5,5,1,2)
        x = randn(5)

        @test A*x ≈ Matrix(A)*x

        @test A*A == A^2 ≈ Matrix(A)^2
        @test A*A isa BandedMatrix
        @test A^2 isa BandedMatrix
        @test bandwidths(A^2) == (2,4)

        @test A*A' isa BandedMatrix
        @test A*A' ≈ Matrix(A)*Matrix(A)'
        @test bandwidths(A*A') == (3,3)

        @test A'*A isa BandedMatrix
        @test A'*A ≈ Matrix(A)'*Matrix(A)
        @test bandwidths(A'*A) == (3,3)

        @test MemoryLayout(typeof(Symmetric(A))) == SymmetricLayout{BandedColumns{DenseColumnMajor}}()
        @test Symmetric(A)*A isa BandedMatrix
        @test Symmetric(A)*A ≈ Symmetric(Matrix(A))*Matrix(A)
        @test bandwidths(Symmetric(A)*A) == (3,4)

        @test Hermitian(A)*A isa BandedMatrix
        @test Hermitian(A)*A ≈ Hermitian(Matrix(A))*Matrix(A)
        @test bandwidths(Hermitian(A)*A) == (3,4)

        B = A+im*A
        @test Hermitian(B)*A isa BandedMatrix
        @test Hermitian(B)*A ≈ Hermitian(Matrix(B))*Matrix(A)
        @test bandwidths(Hermitian(B)*A) == (3,4)

        @test UpperTriangular(A)*A isa BandedMatrix
        @test UpperTriangular(A)*A ≈ UpperTriangular(Matrix(A))*Matrix(A)
        @test bandwidths(UpperTriangular(A)*A) == (1,4)
    end

    @testset "BandedMatrix * dense" begin
        @testset for T in [Float64, Int]
            cmp = T <: Integer ? (==) : (≈)
            B = BandedMatrix(Symmetric(BandedMatrix{T}(0=>1:10, 1=>11:19, 2=>21:28)))
            M = Matrix(B)

            _v = T[1:10;]
            _v2 = T[1:20;]
            for v in Any[_v, view(_v, :), view(_v, axes(_v)...), view(_v2, axes(_v)...)]
                Bv = M * _v
                @test cmp(B * v, Bv)
                w = similar(Bv)
                @test cmp(mul!(w, B, v), Bv)
                @test cmp(mul!(w, B, v, true, false), Bv)
                w .= 1
                mul!(w, B, v, true, true)
                @test cmp(w, Bv + ones(T, size(w)))
                w .= 2
                mul!(w, B, v, false, true)
                @test cmp(w, fill(T(2), size(w)))
                w .= 1
                mul!(w, B, v, oneunit(T), oneunit(T))
                @test cmp(w, Bv + ones(T, size(w)))
            end

            _X = reshape(T[1:100;], 10, 10)
            _X2 = reshape(T[1:15^2;], 15, 15)
            for X in Any[_X, view(_X, :, :), view(_X, axes(_X)...), view(_X, :, axes(_X,2)), view(_X, axes(_X,1), :),
                        view(_X2, axes(_X)...),
                        _X', view(_X', :, :), view(_X', axes(_X')...),
                        view(_X2', axes(_X)...)]
                BX = M * X
                @test cmp(B * X, BX)
                Y = similar(BX)
                @test cmp(mul!(Y, B, X), BX)
                @test cmp(mul!(Y, B, X, true, false), BX)
                Y .= 1
                mul!(Y, B, X, true, true)
                @test cmp(Y, BX + ones(T, size(Y)))
                Y .= 2
                mul!(Y, B, X, false, true)
                @test cmp(Y, fill(T(2), size(Y)))
                Y .= 1
                mul!(Y, B, X, oneunit(T), oneunit(T))
                @test cmp(Y, BX + ones(T, size(Y)))
            end
        end
        @testset "Banded * strided" begin
            n = 100
            B = BandedMatrix{Float64}(-1=>1:n, 1=>11:n+10, 2=>21:n+19)
            M = view(randn(2n+1,2n+1),1:2:2n+1,1:2:2n+1)
            @test B*M ≈ Matrix(B)*M
            @test M*B ≈ M*Matrix(B)
        end
        @testset "non-commutative" begin
            B1 = BandedMatrix(0 => [quat(rand(4)...) for i in 1:3])
            v = [quat(rand(4)...) for i in 1:3]
            α, β = quat(0,1,1,0), quat(1,0,0,1)
            @test mul!(zero(v), B1, v, α, β) ≈ mul!(zero(v), Array(B1), v, α, β)

            D = Diagonal(Fill(quat(rand(4)...), size(B1,2)))
            @test mul!(D * B1, D, B1, α, β) ≈ mul!(D * Array(B1), D, Array(B1), α, β)
            @test mul!(B1 * D, B1, D, α, β) ≈ mul!(Array(B1) * D, Array(B1), D, α, β)
        end
    end

    @testset "BandedMatrix * sparse" begin
        B = brand(6,6,2,2)
        x = OneElement(2, 4, 6)
        y = Array(x)
        @test B * x ≈ B * y
        @test B' * x ≈ B' * y

        C = brand(Complex{Int8}, 6,6,2,2)
        @test C' * x == C' * y

        O = OneElement(2, (4,4), size(B))
        OA = Array(O)
        @test B * O ≈ B * OA
        @test B' * O ≈ B' * OA
        @test O * B ≈ OA * B
        @test O * B' ≈ OA * B'

        @test C' * O == C' * OA
        @test O * C' == OA * C'
    end

    @testset "gbmm!" begin
        @testset "gbmm! subpieces step by step and column by column" begin
            for n in (1,5,50), ν in (1,5,50), m in (1,5,50),
                            Al in (0,1,2,30), Au in (0,1,2,30),
                            Bl in (0,1,2,30), Bu in (0,1,2,30)
                A=brand(n,ν,Al,Au)
                B=brand(ν,m,Bl,Bu)
                α,β,T=0.123,0.456,Float64
                C=brand(Float64,n,m,A.l+B.l,A.u+B.u)
                a=pointer(A.data)
                b=pointer(B.data)
                c=pointer(C.data)
                sta=max(1,stride(A.data,2))
                stb=max(1,stride(B.data,2))
                stc=max(1,stride(C.data,2))

                sz=sizeof(T)

                mr=1:min(m,1+B.u)
                exC=(β*Matrix(C)+α*Matrix(A)*Matrix(B))
                for j=mr
                    BandedMatrices.A11_Btop_Ctop_gbmv!(α,β,
                                                    n,ν,m,j,
                                                    sz,
                                                    a,A.l,A.u,sta,
                                                    b,B.l,B.u,stb,
                                                    c,C.l,C.u,stc)
                end
                @test C[:,mr] ≈ exC[:,mr]

                mr=1+B.u:min(1+C.u,ν+B.u,m)
                exC=(β*Matrix(C)+α*Matrix(A)*Matrix(B))
                for j=mr
                    BandedMatrices.Atop_Bmid_Ctop_gbmv!(α,β,
                                                    n,ν,m,j,
                                                    sz,
                                                    a,A.l,A.u,sta,
                                                    b,B.l,B.u,stb,
                                                    c,C.l,C.u,stc)
                end
                if !isempty(mr)
                    @test C[:,mr] ≈ exC[:,mr]
                end

                mr=1+C.u:min(m,ν+B.u,n+C.u)
                exC=(β*Matrix(C)+α*Matrix(A)*Matrix(B))
                for j=mr
                    BandedMatrices.Amid_Bmid_Cmid_gbmv!(α,β,
                                                    n,ν,m,j,
                                                    sz,
                                                    a,A.l,A.u,sta,
                                                    b,B.l,B.u,stb,
                                                    c,C.l,C.u,stc)
                end
                if !isempty(mr)
                    @test C[:,mr] ≈ exC[:,mr]
                end

                mr=ν+B.u+1:min(m,n+C.u)
                exC=(β*Matrix(C)+α*Matrix(A)*Matrix(B))
                for j=mr
                    BandedMatrices.Anon_Bnon_C_gbmv!(α,β,
                                                    n,ν,m,j,
                                                    sz,
                                                    a,A.l,A.u,sta,
                                                    b,B.l,B.u,stb,
                                                    c,C.l,C.u,stc)
                end
                if !isempty(mr)
                    @test C[:,mr] ≈ exC[:,mr]
                end
            end
        end

        for n in (1,5,50), ν in (1,5,50), m in (1,5,50), Al in (0,1,2,30), Au in (0,1,2,30), Bl in (0,1,2,30), Bu in (0,1,2,30)
            A=brand(n,ν,Al,Au)
            B=brand(ν,m,Bl,Bu)
            α,β,T=0.123,0.456,Float64
            C=brand(Float64,n,m,A.l+B.l,A.u+B.u)
            Cold = deepcopy(C)
            exC=α*Matrix(A)*Matrix(B)+β*Matrix(C)
            BandedMatrices.gbmm!('N','N', α,A,B,β,C)

            @test Matrix(exC) ≈ Matrix(C)
        end
    end

    @testset "Negative bands fills with zero" begin
        A = brand(10,10,2,2)
        B = brand(10,10,-2,2)
        C = BandedMatrix(Fill(NaN,10,10),(0,4))
        mul!(C,A,B)
        AB = Matrix(A)*Matrix(B)
        @test C ≈ AB
        mul!(C,A,B,true,false)
        @test C ≈ AB

        A = brand(10,10,-2,2)
        B = brand(10,10,-2,2)
        C = BandedMatrix(Fill(NaN,10,10),(-4,4))
        mul!(C,A,B)
        @test C ≈ Matrix(A)*Matrix(B)

        A = brand(10,10,-2,2)
        B = brand(10,10,2,2)
        C = BandedMatrix(Fill(NaN,10,10),(0,4))
        mul!(C,A,B)
        @test C ≈ Matrix(A)*Matrix(B)

        A = brand(10,10,2,2)
        B = brand(10,10,2,-2)
        C = BandedMatrix(Fill(NaN,10,10),(4,0))
        mul!(C,A,B)
        @test C ≈ Matrix(A)*Matrix(B)

        A = brand(10,10,2,-2)
        B = brand(10,10,2,-2)
        C = BandedMatrix(Fill(NaN,10,10),(4,-4))
        mul!(C,A,B)
        @test C ≈ Matrix(A)*Matrix(B)

        A = brand(10,10,2,-2)
        B = brand(10,10,2,2)
        C = BandedMatrix(Fill(NaN,10,10),(4,0))
        mul!(C,A,B)
        @test C ≈ Matrix(A)*Matrix(B)

        A = brand(30,1,0,0)
        B = brand(1,30,17,17)
        C = BandedMatrix(Fill(NaN, 30,30), (17,17))
        mul!(C,A,B)
        @test C ≈ Matrix(A)*Matrix(B)
    end

    @testset "Not enough bands" begin
        A = BandedMatrix(Zeros(10,10), (1,1))
        A[band(0)] .= randn(10)
        B = BandedMatrix(randn(10,10), (1,1))
        C = BandedMatrix(Zeros(10,10), (1,1))

        mul!(C,A,B)

        AB = A*B
        @test C == AB

        mul!(C,A,B,true,false)
        @test C == AB

        A[band(1)] .= randn(9)
        @test_throws BandError mul!(C,A,B)

        A = BandedMatrix(randn(2,1), (2,0))
        A[1,1] = 0
        B = BandedMatrix(randn(1,1), (1,1))
        C = BandedMatrix(randn(2,1), (2,0))
        D = A * B + C
        @test BandedMatrices.gbmm!('N','N', 1.0 , A, B, 1.0, C) ≈ D
    end

    @testset "BandedMatrix{Int} * Vector{Vector{Int}}" begin
        A, x =  [1 2; 3 4] , [[1,2],[3,4]]
        @test BandedMatrix(A)*x == A*x
    end

    @testset "Sym * Banded bug" begin
        A = SymTridiagonal(randn(10),randn(9))
        B = BandedMatrix((-1 => Ones{Int}(8),), (10,8))

        M = MulAdd(A,B)
        C = Matrix{Float64}(undef,10,8)
        fill!(C,NaN)
        C .= M
        @test C == A*B == Matrix(A)*Matrix(B)
        @test A*B isa BandedMatrix
    end

    @testset "Overwrite NaN" begin
        B = BandedMatrix{Float64}(undef,(2,2),(-1,-1))
        @test copyto!(fill(NaN,2), MulAdd(B,ones(2))) == [0.0,0.0]
    end

    @testset "NaN Bug" begin
        C = BandedMatrix{Float64}(undef, (1,2), (0,2)); C.data .= NaN;
        A = brand(1,1,0,1)
        B = brand(1,2,0,2)
        muladd!(1.0,A,B,0.0,C)
        @test C == A*B
    end

    @testset "x' ambiguity (#102)" begin
        x = randn(10)
        A = brand(10,10,1,1)
        @test x'A ≈ x'Matrix(A) ≈ transpose(x)A
    end

    @testset "mismatched dimensions (#118)" begin
        m = BandedMatrix(Eye(3), (0,0))
        @test_throws DimensionMismatch m * [1,2]
        @test_throws DimensionMismatch m * [1, 2, 3, 4]
        @test_throws DimensionMismatch m \ [1, 2]
    end

    @testset "Banded * Diagonal" begin
        for (l,u) in ((1,1), (0,0), (-2,1), (-1,1), (1,-1))
            A = brand(4,4,l,u)
            D = Diagonal(rand(size(A,2)))
            AD = A * D
            @test AD isa BandedMatrix
            @test AD ≈ Matrix(A) * D
            DA = D * A
            @test DA isa BandedMatrix
            @test DA ≈ D * Matrix(A)

            DAadj = D*A'
            @test DAadj isa BandedMatrix
            @test DAadj ≈ D * Matrix(A')
            AadjD = A'D
            @test AadjD isa BandedMatrix
            @test AadjD ≈ Matrix(A') * D
        end
    end

    @testset "Banded * Diagonal * Banded" begin
        for (l,u) in ((1,1), (0,0), (-2,1), (-1,1), (1,-1))
            A = brand(4,4,l,u)
            D = Diagonal(rand(size(A,2)))
            ADA = A * D * A
            @test ADA isa BandedMatrix
            @test ADA ≈ Matrix(A)*D*Matrix(A)
            @test A'*D*A isa BandedMatrix
            @test  A'*D*A ≈ Matrix(A)'*D*Matrix(A)
        end
    end

    @testset "muladd! throws error" begin
        A = _BandedMatrix(Ones(3,10), 10, 1, 1)
        @test_throws ArgumentError muladd!(1.0, A, A, 1.0, Zeros(10,10))
    end

    @testset "Diagonal issue (#188)" begin
        W = diagm(0=>-(1:10.0))
        B = brand(Float64, 10, 10, 0, 2)
        @test W\B == W\Matrix(B)
    end

    @testset "rect backslash" begin
        A = brand(6,5,2,1)
        b = randn(6)
        @test factorize(A) isa QR
        @test A \ b ≈ Matrix(A) \ b
    end

    @testset "diag" begin
        for B in [BandedMatrix(1=>ones(5), 2=>ones(4)),
                    BandedMatrix(-1=>ones(5), -2=>ones(4))]
            @test all(iszero, diag(B))
        end
        for B in [BandedMatrix(0=>[1:6;], 2=>fill(2,4)),
                    BandedMatrix(0=>[1:6;], -2=>fill(2,4))]
            @test diag(B) == 1:6
        end
        @testset "kth diagonal" begin
            n = 6
            B = BandedMatrix([k=>rand(n-abs(k)) for k in -2:2]...)
            M = Matrix(B)
            @testset for k in -n:n
                @test diag(B, k) == diag(M, k)
            end
        end
    end

    @testset "isdiag/istril/istriu" begin
        @testset "no bands" begin
            B = brand(3,2,-2,1)
            for k in -5:5
                @test istriu(B, k)
                @test istril(B, k)
                @test isdiag(B)
            end
        end

        @testset "one band" begin
            B = brand(3,3,-1,1)
            A = Array(B)
            @test !isdiag(B)
            @test all(k -> istril(B,k), 1:5)
            @test all(k -> !istril(B,k), -5:0)
            @test all(k -> istriu(B,k), -5:1)
            @test all(k -> !istriu(B,k), 2:5)
            @test all(k -> istriu(A,k) == istriu(B,k), -5:5)
            @test all(k -> istril(A,k) == istril(B,k), -5:5)

            B = brand(3,3,1,-1)
            A = Array(B)
            @test !isdiag(B)
            @test all(k -> istril(B,k), -1:5)
            @test all(k -> !istril(B,k), -5:-2)
            @test all(k -> istriu(B,k), -5:-1)
            @test all(k -> !istriu(B,k), 0:5)
            @test all(k -> istriu(A,k) == istriu(B,k), -5:5)
            @test all(k -> istril(A,k) == istril(B,k), -5:5)

            B = brand(3,3,0,0)
            A = Array(B)
            @test isdiag(B)
            @test all(k -> istril(B,k), 0:5)
            @test all(k -> !istril(B,k), -5:-1)
            @test all(k -> istriu(B,k), -5:0)
            @test all(k -> !istriu(B,k), 1:5)
            @test all(k -> istriu(A,k) == istriu(B,k), -5:5)
            @test all(k -> istril(A,k) == istril(B,k), -5:5)
        end

        @testset "multiple bands" begin
            B = brand(3,6,1,2)
            A = Array(B)
            @test !isdiag(B)
            @test all(k -> istril(B,k), 2:5)
            @test all(k -> !istril(B,k), -5:1)
            @test all(k -> istriu(B,k), -5:-1)
            @test all(k -> !istriu(B,k), 0:-5)
            @test all(k -> istriu(A,k) == istriu(B,k), -5:5)
            @test all(k -> istril(A,k) == istril(B,k), -5:5)

            for B in (brand(3,3,3,3), brand(3,3,2,2), brand(3,3,4,4))
                A = Array(B)
                @test !isdiag(B)
                @test all(k -> istril(B,k), 2:5)
                @test all(k -> !istril(B,k), -5:1)
                @test all(k -> istriu(B,k), -5:-2)
                @test all(k -> !istriu(B,k), -1:-5)
                @test all(k -> istriu(A,k) == istriu(B,k), -5:5)
                @test all(k -> istril(A,k) == istril(B,k), -5:5)
            end
        end
    end

    @testset "mul with α = 0" begin
        A = randn(5,5)
        B = brand(5,5,1,2)
        @test muladd!(0.0, A, B, 2.0, copy(A)) == 2A
        @test muladd!(0.0, B, A, 2.0, copy(A)) == 2A
    end
end

end # module

using Documenter, BandedMatrices

DocMeta.setdocmeta!(BandedMatrices, :DocTestSetup, :(using BandedMatrices); recursive=true)
makedocs(;
    modules = [BandedMatrices],
    pages = [
        "Home" => "index.md",
    ],
    sitename = "BandedMatrices.jl",
    authors = "Sheehan Olver, Mikael Slevinsky, and contributors.",
    warnonly = :missing_docs,
)


deploydocs(;
    repo   = "github.com/JuliaLinearAlgebra/BandedMatrices.jl.git"
    )

## eigvals routine

# the symmetric case uses lapack throughout
eigvals(A::Symmetric{T,<:BandedMatrix{T}}) where T<:BlasReal =
    eigvals!(copy(A))
eigvals(A::Symmetric{T,<:BandedMatrix{T}}, irange::UnitRange) where T<:BlasReal =
    eigvals!(copy(A), irange)
eigvals(A::Symmetric{T,<:BandedMatrix{T}}, vl::Real, vu::Real) where T<:BlasReal =
    eigvals!(copy(A), vl, vu)

eigvals(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}) =
    eigvals!(tridiagonalize(A))
eigvals(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}, irange::UnitRange) =
    eigvals!(tridiagonalize(A), irange)
eigvals(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}, vl::Real, vu::Real) =
    eigvals!(tridiagonalize(A), vl, vu)

# This isn't eigvals!(A, args...) to avoid incorrect dispatches
# This is a cautious approach at the moment
eigvals!(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}) = _eigvals!(A)
eigvals!(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}, irange::UnitRange) = _eigvals!(A, irange)
eigvals!(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}, vl::Real, vu::Real) = _eigvals!(A, vl, vu)

_eigvals!(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}, args...) =
    eigvals!(tridiagonalize!(A), args...)

function _copy_bandedsym(A, B)
    if bandwidth(A) >= bandwidth(B)
        copy(A)
    else
        copyto!(similar(B), A)
    end
end

function eigvals(A::HermOrSym{<:Any,<:BandedMatrix}, B::HermOrSym{<:Any,<:BandedMatrix})
    AA = _copy_bandedsym(A, B)
    eigvals!(AA, copy(B))
end

function eigvals!(A::HermOrSym{T,<:BandedMatrix{T}}, B::HermOrSym{T,<:BandedMatrix{T}}) where T<:BlasReal
    n = size(A, 1)
    @assert n == size(B, 1)
    @assert A.uplo == B.uplo
    # compute split-Cholesky factorization of B.
    kb = bandwidth(B)
    B_data = symbandeddata(B)
    pbstf!(B.uplo, n, kb, B_data)
    # convert to a regular symmetric eigenvalue problem.
    ka = bandwidth(A)
    A_data = symbandeddata(A)
    X = Array{T}(undef,0,0)
    work = Vector{T}(undef,2n)
    sbgst!('N', A.uplo, n, ka, kb, A_data, B_data, X, work)
    # compute eigenvalues of symmetric eigenvalue problem.
    eigvals!(A)
end

function eigvals!(A::Hermitian{T,<:BandedMatrix{T}}, B::Hermitian{T,<:BandedMatrix{T}}) where T<:BlasComplex
    n = size(A, 1)
    @assert n == size(B, 1)
    @assert A.uplo == B.uplo
    # compute split-Cholesky factorization of B.
    kb = bandwidth(B)
    B_data = hermbandeddata(B)
    pbstf!(B.uplo, n, kb, B_data)
    # convert to a regular symmetric eigenvalue problem.
    ka = bandwidth(A)
    A_data = hermbandeddata(A)
    X = Array{T}(undef,0,0)
    work = Vector{T}(undef,n)
    rwork = Vector{real(T)}(undef,n)
    hbgst!('N', A.uplo, n, ka, kb, A_data, B_data, X, work, rwork)
    # compute eigenvalues of symmetric eigenvalue problem.
    eigvals!(A)
end

abstract type AbstractBandedEigenvectors{T} <: AbstractMatrix{T} end

getindex(B::AbstractBandedEigenvectors, i, j) = Matrix(B)[i,j]
function _getindex_vec(B, j)
    z1 = _get_scratch(B)
    z2 = OneElement(one(eltype(B)), j, size(B,2))
    mul!(z1, B, z2)
end
function getindex(B::AbstractBandedEigenvectors, i::Union{Int, Colon, AbstractVector{Int}}, j::Int)
    z = _getindex_vec(B, j)
    z[i]
end
function getindex(B::AbstractBandedEigenvectors, ::Colon, jr::AbstractVector{Int})
    M = similar(B, size(B,1), length(jr))
    for (ind, j) in enumerate(jr)
        M[:, ind] = _getindex_vec(B, j)
    end
    return M
end

# V = G Q
struct BandedEigenvectors{T} <: AbstractBandedEigenvectors{T}
    G::Vector{Givens{T}}
    Q::Matrix{T}
    z1::Vector{T} # scratch space, used in indexing
end

size(B::BandedEigenvectors) = size(B.Q)
_get_scratch(B::BandedEigenvectors) = B.z1

# V = S⁻¹ Q W
struct BandedGeneralizedEigenvectors{T,M<:AbstractMatrix{T}} <: AbstractBandedEigenvectors{T}
    S::SplitCholesky{T,M}
    Q::Vector{Givens{T}}
    W::BandedEigenvectors{T}
end

size(B::BandedGeneralizedEigenvectors) = size(B.W)
_get_scratch(B::BandedGeneralizedEigenvectors) = _get_scratch(B.W)

convert(::Type{Eigen{T, T, Matrix{T}, Vector{T}}}, F::Eigen{T, T, BandedEigenvectors{T}, Vector{T}}) where T = Eigen(F.values, Matrix(F.vectors))
convert(::Type{GeneralizedEigen{T, T, Matrix{T}, Vector{T}}}, F::GeneralizedEigen{T, T, BandedGeneralizedEigenvectors{T}, Vector{T}}) where T = GeneralizedEigen(F.values, Matrix(F.vectors))

compress(F::Eigen{T, T, BandedEigenvectors{T}, Vector{T}}) where T = convert(Eigen{T, T, Matrix{T}, Vector{T}}, F)
compress(F::GeneralizedEigen{T, T, BandedGeneralizedEigenvectors{T}, Vector{T}}) where T = convert(GeneralizedEigen{T, T, Matrix{T}, Vector{T}}, F)

eigen(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}) = eigen!(copy(A))
eigen(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}, irange::UnitRange) = eigen!(copy(A), irange)
eigen(A::RealHermSymComplexHerm{<:Real,<:BandedMatrix}, vl::Real, vu::Real) = eigen!(copy(A), vl, vu)

function eigen(A::HermOrSym{T,<:BandedMatrix{T}}, B::HermOrSym{T,<:BandedMatrix{T}}) where T
    AA = _copy_bandedsym(A, B)
    eigen!(AA, copy(B))
end

eigen!(A::HermOrSym{T,<:BandedMatrix{T}}) where T<:BlasFloat = _eigen!(A)
eigen!(A::HermOrSym{T,<:BandedMatrix{T}}, irange::UnitRange) where T<:BlasFloat = _eigen!(A, irange)
eigen!(A::HermOrSym{T,<:BandedMatrix{T}}, vl::Real, vu::Real) where T<:BlasFloat = _eigen!(A, vl, vu)

function _eigen!(A::HermOrSym{T,<:BandedMatrix{T}}, args...) where T<:BlasReal
    N = size(A, 1)
    KD = bandwidth(A)
    D = Vector{T}(undef, N)
    E = Vector{T}(undef, N-1)
    G = Vector{Givens{T}}(undef, 0)
    WORK = Vector{T}(undef, N)
    AB = symbandeddata(A)
    sbtrd!('V', A.uplo, N, KD, AB, D, E, G, WORK)
    Λ, Q = eigen!(SymTridiagonal(D, E), args...)
    Eigen(Λ, BandedEigenvectors(G, Q, similar(Q, size(Q,1))))
end

function _eigen!(A::Hermitian{T,<:BandedMatrix{T}}, args...) where T <: BlasComplex
    N = size(A, 1)
    KD = bandwidth(A)
    D = Vector{real(T)}(undef, N)
    E = Vector{real(T)}(undef, N-1)
    Q = Matrix{T}(undef, N, N)
    WORK = Vector{T}(undef, N)
    AB = hermbandeddata(A)
    hbtrd!('V', A.uplo, N, KD, AB, D, E, Q, WORK)
    Λ, W = eigen!(SymTridiagonal(D, E), args...)
    Eigen(Λ, Q * W)
end

function eigen!(A::HermOrSym{T,<:BandedMatrix{T}}, B::HermOrSym{T,<:BandedMatrix{T}}) where T <: BlasReal
    isdiag(A) || isdiag(B) || symmetricuplo(A) == symmetricuplo(B) || throw(ArgumentError("uplo of matrices do not match"))
    S = splitcholesky!(B)
    N = size(A, 1)
    KA = bandwidth(A)
    KB = bandwidth(B)
    Q = Vector{Givens{T}}(undef, 0)
    WORK = Vector{T}(undef, 2*N)
    AB = symbandeddata(A)
    BB = symbandeddata(B)
    sbgst!('V', A.uplo, N, KA, KB, AB, BB, Q, WORK)
    any(isnan, A) && throw(ArgumentError("NaN found in the standard form of A"))
    Λ, W = eigen!(A)
    GeneralizedEigen(Λ, BandedGeneralizedEigenvectors(S, Q, W))
end

function eigen!(A::Hermitian{T,<:BandedMatrix{T}}, B::Hermitian{T,<:BandedMatrix{T}}) where T <: BlasComplex
    isdiag(A) || isdiag(B) || symmetricuplo(A) == symmetricuplo(B) || throw(ArgumentError("uplo of matrices do not match"))
    splitcholesky!(B)
    N = size(A, 1)
    KA = bandwidth(A)
    KB = bandwidth(B)
    X = Matrix{T}(undef, N, N)
    WORK = Vector{T}(undef, N)
    RWORK = Vector{real(T)}(undef, N)
    AB = hermbandeddata(A)
    BB = hermbandeddata(B)
    hbgst!('V', A.uplo, N, KA, KB, AB, BB, X, WORK, RWORK)
    any(isnan, A) && throw(ArgumentError("NaN found in the standard form of A"))
    Λ, W = eigen!(A)
    GeneralizedEigen(Λ, X * W)
end

function Matrix(B::BandedEigenvectors)
    Q = copy(B.Q)
    G = B.G
    for k in length(G):-1:1
        lmul!(G[k], Q)
    end
    return Q
end

function Matrix(B::BandedGeneralizedEigenvectors)
    V = Matrix(B.W)
    Q = B.Q
    for k in length(Q):-1:1
        lmul!(Q[k], V)
    end
    ldiv!(B.S, V)
    return V
end


function compress!(F::Eigen{T, T, BandedEigenvectors{T}, Vector{T}}) where T
    Q = F.vectors.Q
    G = F.vectors.G
    for k in length(G):-1:1
        lmul!(G[k], Q)
        pop!(G)
    end
    F
end

const AdjTrans{T,M} = Union{Adjoint{T,M}, Transpose{T,M}}
const AdjTransStridedArray{T,N} = Union{StridedArray{T,N}, AdjTrans{T, <:StridedArray{T,N}}}

const AdjTransStridedVec{T} = AdjTransStridedArray{T,1}
const AdjTransStridedMat{T} = AdjTransStridedArray{T,2}
const AdjTransStridedVecOrMat{T} = Union{AdjTransStridedVec{T}, AdjTransStridedMat{T}}

const OneElementVecOrMat{T} = Union{OneElement{T,1}, OneElement{T,2}}

const AdjTransStridedOrOneElVecOrMat{T} = Union{AdjTransStridedVecOrMat{T}, OneElementVecOrMat{T}}

_adjtransfn(::Transpose) = transpose
_adjtransfn(::Adjoint) = adjoint

function mul!(y::AdjTransStridedVecOrMat{T}, B::BandedEigenvectors{T}, x::AdjTransStridedOrOneElVecOrMat{T}) where {T}
    mul!(y, B.Q, x)
    G = B.G
    for k in length(G):-1:1
        lmul!(G[k], y)
    end
    y
end

function mul!(y::AdjTransStridedVecOrMat{T}, B::AdjTrans{T,BandedEigenvectors{T}}, x::AdjTransStridedVecOrMat{T}) where {T}
    Q = B.parent.Q
    G = B.parent.G
    if length(G) > 0
        z = copy(x)
        for k in 1:length(G)
            lmul!(G[k]', z)
        end
        mul!(y, _adjtransfn(B)(Q), z)
    else
        mul!(y, _adjtransfn(B)(Q), x)
    end
    y
end

function mul!(y::AdjTransStridedVecOrMat{T}, B::BandedGeneralizedEigenvectors{T}, x::AdjTransStridedOrOneElVecOrMat{T}) where {T}
    mul!(y, B.W, x)
    Q = B.Q
    for k in length(Q):-1:1
        lmul!(Q[k], y)
    end
    ldiv!(B.S, y)
end

function mul!(y::AdjTransStridedVecOrMat{T}, B::Adjoint{T,<:BandedGeneralizedEigenvectors{T}}, x::AdjTransStridedVecOrMat{T}) where {T}
    z = copy(x)
    ldiv!(B.parent.S', z)
    Q = B.parent.Q
    for k in 1:length(Q)
        lmul!(Q[k]', z)
    end
    mul!(y, B.parent.W', z)
end

function ldiv!(y::AdjTransStridedVecOrMat{T}, B::BandedGeneralizedEigenvectors{T}, x::AdjTransStridedVecOrMat{T}) where {T}
    z = copy(x)
    lmul!(B.S, z)
    Q = B.Q
    for k in 1:length(Q)
        lmul!(Q[k]', z)
    end
    mul!(y, B.W', z)
end

function mul!(y::AdjTransStridedVecOrMat{T}, x::AdjTransStridedVecOrMat{T}, B::BandedEigenvectors{T}) where {T}
    mul!(y', B', x')
    y
end

function mul!(y::AdjTransStridedVecOrMat{T}, x::AdjTransStridedVecOrMat{T}, B::BandedGeneralizedEigenvectors{T}) where {T}
    mul!(y', B', x')
    y
end



#
# The following is a Julia translation of *SBTRD.f in LAPACK that allows
# extraction of the Givens rotations.
#
#  Definition:
#  ===========
#
#       SUBROUTINE DSBTRD( VECT, UPLO, N, KD, AB, LDAB, D, E, Q, LDQ,
#                          WORK, INFO )
#
#       .. Scalar Arguments ..
#       CHARACTER          UPLO, VECT
#       INTEGER            INFO, KD, LDAB, LDQ, N
#       ..
#       .. Array Arguments ..
#       DOUBLE PRECISION   AB( LDAB, * ), D( * ), E( * ), Q( LDQ, * ),
#      $                   WORK( * )
#       ..
function sbtrd!(VECT::Char, UPLO::Char,
                N::Int, KD::Int, AB::AbstractMatrix{T},
                D::AbstractVector{T}, E::AbstractVector{T}, Q::Vector{Givens{T}},
                WORK::AbstractVector{T}) where T
    require_one_based_indexing(AB)
    chkstride1(AB)
    chkuplo(UPLO)
    chkvect(VECT)
    M    = size(AB,2)
    M ≠ N && throw(ArgumentError("Matrix must be square"))
    size(AB,1) < KD+1 && throw(ArgumentError("Not enough bands"))

    # In Julia, pointers to entries of a SubArray ignore stride.
    # For example, if `A = view(Matrix{Float64}(I, 10, 10), 1:2:9, 1:2:9)`,
    # then `unsafe_load(pointer(A, 3+5*2)) == 1`, even if `stride(A, 2) == 20.`
    # Beyond the use of `LDAB` in Julia pointers, there are two uses of the
    # actual (Fortran) `LDABF` for increment-setting in the LAPACK calls.
    LDAB = size(AB, 1)
    LDABF = max(1, stride(AB, 2))

    ZERO = zero(T)
    TEMP1 = Ref{T}()
    TEMP2 = Ref{T}()
    TEMP3 = Ref{T}()
    KD1 = KD + 1
    KDM1 = KD - 1
    INCX = LDABF - 1

    INCA = KD1*LDABF
    KDN = min(N-1, KD)

    UPPER = UPLO == 'U'
    WANTQ = true

    if UPPER
        if KD > 1
            # Reduce to tridiagonal form, working with upper triangle
            NR = 0
            J1 = KDN + 2
            J2 = 1
            for I = 1:N-2
                # Reduce i-th row of matrix to tridiagonal form
                for K = KDN+1:-1:2
                    J1 = J1 + KDN
                    J2 = J2 + KDN
                    if NR > 0
                        # generate plane rotations to annihilate nonzero
                        # elements which have been created outside the band
                        largv!(NR, pointer(AB, 1+LDAB*(J1-2)), INCA, pointer(WORK, J1), KD1, pointer(D, J1), KD1)
                        # apply rotations from the right
                        # Dependent on the the number of diagonals either
                        # DLARTV or DROT is used
                        if NR ≥ 2*KD-1
                            for L = 1:KD-1
                                lartv!(NR, pointer(AB, L+1+LDAB*(J1-2)), INCA, pointer(AB, L+LDAB*(J1-1)), INCA, pointer(D, J1), pointer(WORK, J1), KD1)
                            end
                        else
                            JEND = J1 + (NR-1)*KD1
                            for JINC = J1:KD1:JEND
                                rot!(KDM1, pointer(AB, 2+LDAB*(JINC-2)), 1, pointer(AB, 1+LDAB*(JINC-1)), 1, D[JINC], WORK[JINC])
                            end
                        end
                    end

                    if K > 2
                        if K ≤ N-I+1
                            # generate plane rotation to annihilate a(i,i+k-1)
                            # within the band
                            lartg!(AB[KD-K+3, I+K-2], AB[KD-K+2, I+K-1], TEMP1, TEMP2, TEMP3)
                            D[I+K-1] = TEMP1[]
                            WORK[I+K-1] = TEMP2[]
                            AB[KD-K+3, I+K-2] = TEMP3[]
                            # apply rotation from the right
                            rot!(K-3, pointer(AB, KD-K+4+LDAB*(I+K-3)), 1, pointer(AB, KD-K+3+LDAB*(I+K-2)), 1, D[I+K-1], WORK[I+K-1])
                        end
                        NR = NR + 1
                        J1 = J1 - KDN - 1
                    end

                    # apply plane rotations from both sides to diagonal
                    # blocks
                    if NR > 0
                        lar2v!(NR, pointer(AB, KD1+LDAB*(J1-2)), pointer(AB, KD1+LDAB*(J1-1)), pointer(AB, KD+LDAB*(J1-1)), INCA, pointer(D, J1), pointer(WORK, J1), KD1)
                    end
                    # apply plane rotations from the left
                    if NR > 0
                        if 2*KD-1 < NR
                            # Dependent on the the number of diagonals either
                            # DLARTV or DROT is used
                            for L = 1:KD-1
                                if J2+L > N
                                    NRT = NR - 1
                                else
                                    NRT = NR
                                end
                                if NRT > 0
                                    lartv!(NRT, pointer(AB, KD-L+LDAB*(J1+L-1)), INCA, pointer(AB, KD-L+1+LDAB*(J1+L-1)), INCA, pointer(D, J1), pointer(WORK, J1), KD1)
                                end
                            end
                        else
                            J1END = J1 + KD1*( NR-2 )
                            if J1END ≥ J1
                                for JIN = J1:KD1:J1END
                                    rot!(KDM1, pointer(AB, KDM1+LDAB*JIN), INCX, pointer(AB, KD+LDAB*JIN), INCX, D[JIN], WORK[JIN])
                                end
                            end
                            LEND = min( KDM1, N-J2 )
                            LAST = J1END + KD1
                            if LEND > 0
                                rot!(LEND, pointer(AB, KDM1+LDAB*LAST), INCX, pointer(AB, KD+LDAB*LAST), INCX, D[LAST], WORK[LAST])
                            end
                        end
                    end

                    if WANTQ
                        for J = J1:KD1:J2
                            push!(Q, Givens(J-1, J, D[J], -WORK[J]))
                        end
                    end
                    if J2+KDN > N
                        # adjust J2 to keep within the bounds of the matrix
                        NR = NR - 1
                        J2 = J2 - KDN - 1
                    end

                    for J = J1:KD1:J2
                        # create nonzero element a(j-1,j+kd) outside the band
                        # and store it in WORK
                        WORK[J+KD] = WORK[J]*AB[1, J+KD]
                        AB[1, J+KD] = D[J]*AB[1, J+KD]
                    end
                end
            end
        end # if

        if KD > 0
            # copy off-diagonal elements to E
            for I = 1:N-1
                E[I] = AB[KD, I+1]
            end
        else
            # set E to zero if original matrix was diagonal
            for I = 1:N-1
                E[I] = ZERO
            end
        end
        # copy diagonal elements to D
        for I = 1:N
            D[I] = AB[KD1, I]
        end
    else # if UPPER
        if KD > 1
            # Reduce to tridiagonal form, working with lower triangle
            NR = 0
            J1 = KDN + 2
            J2 = 1
            for I = 1:N-2
                # Reduce i-th column of matrix to tridiagonal form
                for K = KDN+1:-1:2
                    J1 = J1 + KDN
                    J2 = J2 + KDN
                    if NR > 0
                        # generate plane rotations to annihilate nonzero
                        # elements which have been created outside the band
                        largv!(NR, pointer(AB, KD1+LDAB*(J1-KD1-1)), INCA, pointer(WORK, J1), KD1, pointer(D, J1), KD1)
                        # apply plane rotations from one side
                        # Dependent on the the number of diagonals either
                        # DLARTV or DROT is used
                        if NR > 2*KD-1
                            for L = 1:KD-1
                                lartv!(NR, pointer(AB, KD1-L+LDAB*(J1-KD1+L-1)), INCA, pointer(AB, KD1-L+1+LDAB*(J1-KD1+L-1)), INCA, pointer(D, J1), pointer(WORK, J1), KD1)
                            end
                        else
                            JEND = J1 + KD1*(NR-1)
                            for JINC = J1:KD1:JEND
                                rot!(KDM1, pointer(AB, KD+LDAB*(JINC-KD1)), INCX, pointer(AB, KD1+LDAB*(JINC-KD1)), INCX, D[JINC], WORK[JINC])
                            end
                        end
                    end

                    if K > 2
                        if K ≤ N-I+1
                            # generate plane rotation to annihilate a(i+k-1,i)
                            # within the band
                            lartg!(AB[K-1, I], AB[K, I], TEMP1, TEMP2, TEMP3)
                            D[I+K-1] = TEMP1[]
                            WORK[I+K-1] = TEMP2[]
                            AB[K-1, I] = TEMP3[]
                            # apply rotation from the right
                            rot!(K-3, pointer(AB, K-2+LDAB*I), INCX, pointer(AB, K-1+LDAB*I), INCX, D[I+K-1], WORK[I+K-1])
                        end
                        NR = NR + 1
                        J1 = J1 - KDN - 1
                    end

                    # apply plane rotations from both sides to diagonal
                    # blocks
                    if NR > 0
                        lar2v!(NR, pointer(AB, 1+LDAB*(J1-2)), pointer(AB, 1+LDAB*(J1-1)), pointer(AB, 2+LDAB*(J1-2)), INCA, pointer(D, J1), pointer(WORK, J1), KD1)
                    end
                    # apply plane rotations from the right
                    # Dependent on the the number of diagonals either
                    # DLARTV or DROT is used

                    if NR > 0
                        if NR > 2*KD-1
                            for L = 1:KD-1
                                if J2+L > N
                                    NRT = NR - 1
                                else
                                    NRT = NR
                                end
                                if NRT > 0
                                    lartv!(NRT, pointer(AB, L+2+LDAB*(J1-2)), INCA, pointer(AB, L+1+LDAB*(J1-1)), INCA, pointer(D, J1), pointer(WORK, J1), KD1)
                                end
                            end
                        else
                            J1END = J1 + KD1*(NR-2)
                            if J1END ≥ J1
                                for J1INC = J1:KD1:J1END
                                    rot!(KDM1, pointer(AB, 3+LDAB*(J1INC-2)), 1, pointer(AB, 2+LDAB*(J1INC-1)), 1, D[J1INC], WORK[J1INC])
                                end
                            end
                            LEND = min(KDM1, N-J2)
                            LAST = J1END + KD1
                            if LEND > 0
                                rot!(LEND, pointer(AB, 3+LDAB*(LAST-2)), 1, pointer(AB, 2+LDAB*(LAST-1)), 1, D[LAST], WORK[LAST])
                            end
                        end
                    end

                    if WANTQ
                        for J = J1:KD1:J2
                            push!(Q, Givens(J-1, J, D[J], -WORK[J]))
                        end
                    end

                    if J2+KDN > N
                        # adjust J2 to keep within the bounds of the matrix
                        NR = NR - 1
                        J2 = J2 - KDN - 1
                    end

                    for J = J1:KD1:J2
                        # create nonzero element a(j+kd,j-1) outside the band
                        # and store it in WORK
                        WORK[J+KD] = WORK[J]*AB[KD1, J]
                        AB[KD1, J] = D[J]*AB[KD1, J]
                    end
                end
            end
        end # if
        if KD > 0
            # copy off-diagonal elements to E
            for I = 1:N-1
                E[I] = AB[2, I]
            end
        else
            # set E to zero if original matrix was diagonal
            for I = 1:N-1
                E[I] = ZERO
            end
        end
        # copy diagonal elements to D
        for I = 1:N
            D[I] = AB[1, I]
        end
    end # if UPPER
end


#
# The following is a Julia translation of *SBGST.f in LAPACK that allows
# extraction of the Givens rotations.
#
#  Definition:
#  ===========
#
#       SUBROUTINE DSBGST( VECT, UPLO, N, KA, KB, AB, LDAB, BB, LDBB, X,
#                          LDX, WORK, INFO )
#
#       .. Scalar Arguments ..
#       CHARACTER          UPLO, VECT
#       INTEGER            INFO, KA, KB, LDAB, LDBB, LDX, N
#       ..
#       .. Array Arguments ..
#       DOUBLE PRECISION   AB( LDAB, * ), BB( LDBB, * ), WORK( * ),
#      $                    X( LDX, * )
#       ..
function sbgst!(VECT::Char, UPLO::Char,
                N::Int, KA::Int, KB::Int, AB::AbstractMatrix{T},
                BB::AbstractMatrix{T}, X::Vector{Givens{T}},
                WORK::AbstractVector{T}) where T
    require_one_based_indexing(AB)
    require_one_based_indexing(BB)
    chkstride1(AB)
    chkstride1(BB)
    chkuplo(UPLO)
    chkvect(VECT)
    size(AB,2) == size(BB,2) == N || throw(ArgumentError("Matrices must be square"))
    size(AB,1) < KA+1 && throw(ArgumentError("Not enough bands in AB"))
    size(BB,1) < KB+1 && throw(ArgumentError("Not enough bands in BB"))

    # In Julia, pointers to entries of a SubArray ignore stride.
    # For example, if `A = view(Matrix{Float64}(I, 10, 10), 1:2:9, 1:2:9)`,
    # then `unsafe_load(pointer(A, 3+5*2)) == 1`, even if `stride(A, 2) == 20.`
    # Beyond the use of `LDAB` in Julia pointers, there are two uses of the
    # actual (Fortran) `LDABF` for increment-setting in the LAPACK calls.
    LDAB = size(AB, 1)
    LDABF = max(1, stride(AB, 2))

    ZERO = zero(T)
    TEMP1 = Ref{T}()
    TEMP2 = Ref{T}()
    TEMP3 = Ref{T}()
    KA1 = KA + 1
    KB1 = KB + 1
    INCA = LDABF*KA1
    M = ( N+KB ) ÷ 2

    UPPER = UPLO == 'U'
    WANTX = true

    UPDATE = true
    I = N + 1
    @label L10
    if UPDATE
        I = I - 1
        KBT = min( KB, I-1 )
        I0 = I - 1
        I1 = min( N, I+KA )
        I2 = I - KBT + KA1
        if I < M+1
            UPDATE = false
            I = I + 1
            I0 = M
            if KA == 0
                @goto L480
            end
            @goto L10
        end
    else
        I = I + KA
        if I > N-1
            @goto L480
        end
    end

    if UPPER
        # Transform A, working with the upper triangle
        if UPDATE
            # Form inv(S(i))**T * A * inv(S(i))
            BII = BB[KB1, I]
            for J = I:I1
                AB[I-J+KA1, J] = AB[I-J+KA1, J] / BII
            end
            for J = max(1, I-KA):I
                AB[J-I+KA1, I] = AB[J-I+KA1, I] / BII
            end
            for K = I-KBT:I-1
                for J = I-KBT:K
                    AB[J-K+KA1, K] = AB[J-K+KA1, K] - BB[J-I+KB1, I]*AB[K-I+KA1, I] - BB[K-I+KB1, I]*AB[J-I+KA1, I] + AB[KA1, I]*BB[J-I+KB1, I]*BB[K-I+KB1, I]
                end
                for J = max(1, I-KA):I-KBT-1
                    AB[J-K+KA1, K] = AB[J-K+KA1, K] - BB[K-I+KB1, I]*AB[J-I+KA1, I]
                end
            end
            for J = I:I1
                for K = max(J-KA, I-KBT):I-1
                    AB[K-J+KA1, J] = AB[K-J+KA1, J] - BB[K-I+KB1, I]*AB[I-J+KA1, J]
                end
            end
            # store a(i,i1) in RA1 for use in next loop over K
            RA1 = AB[I-I1+KA1, I1]
        end
        # Generate and apply vectors of rotations to chase all the
        # existing bulges KA positions down toward the bottom of the
        # band
        for K = 1:KB-1
            if UPDATE
                # Determine the rotations which would annihilate the bulge
                # which has in theory just been created
                if I-K+KA < N && I-K > 1
                    # generate rotation to annihilate a(i,i-k+ka+1)
                    lartg!(AB[K+1, I-K+KA], RA1, TEMP1, TEMP2, TEMP3)
                    WORK[N+I-K+KA-M] = TEMP1[]
                    WORK[I-K+KA-M] = TEMP2[]
                    RA = TEMP3[]
                    # create nonzero element a(i-k,i-k+ka+1) outside the
                    # band and store it in WORK(i-k)
                    t = -BB[KB1-K, I]*RA1
                    WORK[I-K] = WORK[N+I-K+KA-M]*t - WORK[I-K+KA-M]*AB[1, I-K+KA]
                    AB[1, I-K+KA] = WORK[I-K+KA-M]*t + WORK[N+I-K+KA-M]*AB[1, I-K+KA]
                    RA1 = RA
                end
            end
            J2 = I - K - 1 + max(1, K-I0+2)*KA1
            NR = ( N-J2+KA ) ÷ KA1
            J1 = J2 + ( NR-1 )*KA1
            if UPDATE
                J2T = max( J2, I+2*KA-K+1 )
            else
                J2T = J2
            end
            NRT = ( N-J2T+KA ) ÷ KA1
            for J = J2T:KA1:J1
                # create nonzero element a(j-ka,j+1) outside the band
                # and store it in WORK(j-m)
                WORK[J-M] = WORK[J-M]*AB[1, J+1]
                AB[1, J+1] = WORK[N+J-M]*AB[1, J+1]
            end
            # generate rotations in 1st set to annihilate elements which
            # have been created outside the band
            if NRT > 0
                largv!(NRT, pointer(AB, 1+LDAB*(J2T-1)), INCA, pointer(WORK, J2T-M), KA1, pointer(WORK, N+J2T-M), KA1)
            end
            if NR > 0
                # apply rotations in 1st set from the right
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, KA1-L+LDAB*(J2-1)), INCA, pointer(AB, KA-L+LDAB*J2), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
                end
                # apply rotations in 1st set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, KA1+LDAB*(J2-1)), pointer(AB, KA1+LDAB*J2), pointer(AB, KA+LDAB*J2), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
            end
            # start applying rotations in 1st set from the left
            for L = KA-1:-1:KB-K+1
                NRT = ( N-J2+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J2+KA1-L-1)), INCA, pointer(AB, L+1+LDAB*(J2+KA1-L-1)), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 1st set
                for J = J2:KA1:J1
                    push!(X, Givens(J, J+1, WORK[N+J-M], -WORK[J-M]))
                end
            end
        end

        if UPDATE
            if I2 ≤ N && KBT > 0
                # create nonzero element a(i-kbt,i-kbt+ka+1) outside the
                # band and store it in WORK(i-kbt)
                WORK[I-KBT] = -BB[KB1-KBT, I]*RA1
            end
        end

        for K = KB:-1:1
            if UPDATE
                J2 = I - K - 1 + max( 2, K-I0+1 )*KA1
            else
                J2 = I - K - 1 + max( 1, K-I0+1 )*KA1
            end
            # finish applying rotations in 2nd set from the left
            for L = KB-K:-1:1
                NRT = ( N-J2+KA+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J2-L)), INCA, pointer(AB, L+1+LDAB*(J2-L)), INCA, pointer(WORK, N+J2-KA), pointer(WORK, J2-KA), KA1)
                end
            end
            NR = ( N-J2+KA ) ÷ KA1
            J1 = J2 + ( NR-1 )*KA1
            for J = J1:-KA1:J2
                WORK[J] = WORK[J-KA]
                WORK[N+J] = WORK[N+J-KA]
            end
            for J = J2:KA1:J1
                # create nonzero element a(j-ka,j+1) outside the band
                # and store it in WORK(j)
                WORK[J] = WORK[J]*AB[1, J+1]
                AB[1, J+1] = WORK[N+J]*AB[1, J+1]
            end
            if UPDATE
                if I-K < N-KA && K ≤ KBT
                    WORK[I-K+KA] = WORK[I-K]
                end
            end
        end

        for K = KB:-1:1
            J2 = I - K - 1 + max( 1, K-I0+1 )*KA1
            NR = ( N-J2+KA ) ÷ KA1
            J1 = J2 + ( NR-1 )*KA1
            if NR > 0
                # generate rotations in 2nd set to annihilate elements
                # which have been created outside the band
                largv!(NR, pointer(AB, 1+LDAB*(J2-1)), INCA, pointer(WORK, J2), KA1, pointer(WORK, N+J2), KA1)
                # apply rotations in 2nd set from the right
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, KA1-L+LDAB*(J2-1)), INCA, pointer(AB, KA-L+LDAB*J2), INCA, pointer(WORK, N+J2), pointer(WORK, J2), KA1)
                end
                # apply rotations in 2nd set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, KA1+LDAB*(J2-1)), pointer(AB, KA1+LDAB*J2), pointer(AB, KA+LDAB*J2), INCA, pointer(WORK, N+J2), pointer(WORK, J2), KA1)
            end
            # start applying rotations in 2nd set from the left
            for L = KA-1:-1:KB-K+1
                NRT = ( N-J2+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J2+KA1-L-1)), INCA, pointer(AB, L+1+LDAB*(J2+KA1-L-1)), INCA, pointer(WORK, N+J2), pointer(WORK, J2), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 2nd set
                for J = J2:KA1:J1
                    push!(X, Givens(J, J+1, WORK[N+J], -WORK[J]))
                end
            end
        end

        for K = 1:KB-1
            J2 = I - K - 1 + max( 1, K-I0+2 )*KA1
            for L = KB-K:-1:1
                NRT = ( N-J2+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J2+KA1-L-1)), INCA, pointer(AB, L+1+LDAB*(J2+KA1-L-1)), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
                end
            end
        end

        if KB > 1
            for J = N-1:-1:I-KB+2*KA+1
                WORK[N+J-M] = WORK[N+J-KA-M]
                WORK[J-M] = WORK[J-KA-M]
            end
        end
    else
        # Transform A, working with the lower triangle
        if UPDATE
            # Form inv(S(i))**T * A * inv(S(i))
            BII = BB[1, I]
            for J = I:I1
                AB[J-I+1, I] = AB[J-I+1, I] / BII
            end
            for J = max(1,I-KA):I
                AB[I-J+1, J] = AB[I-J+1, J] / BII
            end
            for K = I-KBT:I-1
                for J = I-KBT:K
                    AB[K-J+1,J] = AB[K-J+1, J] - BB[I-J+1, J]*AB[I-K+1, K] - BB[I-K+1, K]*AB[I-J+1, J] + AB[1, I]*BB[I-J+1, J]*BB[I-K+1, K]
                end
                for J = max(1, I-KA):I-KBT-1
                    AB[K-J+1, J] = AB[K-J+1, J] - BB[I-K+1, K]*AB[I-J+1, J]
                end
            end
            for J = I:I1
                for K = max(J-KA, I-KBT):I-1
                    AB[J-K+1, K] = AB[J-K+1, K] - BB[I-K+1, K]*AB[J-I+1, I]
                end
            end
            # store a(i1,i) in RA1 for use in next loop over K
            RA1 = AB[I1-I+1, I]
        end
        # Generate and apply vectors of rotations to chase all the
        # existing bulges KA positions down toward the bottom of the
        # band
        for K = 1:KB-1
            if UPDATE
                # Determine the rotations which would annihilate the bulge
                # which has in theory just been created
                if I-K+KA < N && I-K > 1
                    # generate rotation to annihilate a(i-k+ka+1,i)
                    lartg!(AB[KA1-K, I], RA1, TEMP1, TEMP2, TEMP3)
                    WORK[N+I-K+KA-M] = TEMP1[]
                    WORK[I-K+KA-M] = TEMP2[]
                    RA = TEMP3[]
                    t = -BB[K+1, I-K]*RA1
                    WORK[I-K] = WORK[N+I-K+KA-M]*t - WORK[I-K+KA-M]*AB[KA1, I-K]
                    AB[KA1, I-K] = WORK[I-K+KA-M]*t + WORK[N+I-K+KA-M]*AB[KA1, I-K]
                    RA1 = RA
                end
            end
            J2 = I - K - 1 + max( 1, K-I0+2 )*KA1
            NR = ( N-J2+KA ) ÷ KA1
            J1 = J2 + ( NR-1 )*KA1
            if UPDATE
                J2T = max( J2, I+2*KA-K+1 )
            else
                J2T = J2
            end
            NRT = ( N-J2T+KA ) ÷ KA1
            for J = J2T:KA1:J1
                # create nonzero element a(j+1,j-ka) outside the band
                # and store it in WORK(j-m)
                WORK[J-M] = WORK[J-M]*AB[KA1, J-KA+1]
                AB[KA1, J-KA+1] = WORK[N+J-M]*AB[KA1, J-KA+1]
            end
            # generate rotations in 1st set to annihilate elements which
            # have been created outside the band
            if NRT > 0
                largv!(NRT, pointer(AB, KA1+LDAB*(J2T-KA-1)), INCA, pointer(WORK, J2T-M), KA1, pointer(WORK, N+J2T-M), KA1)
            end
            if NR > 0
                # apply rotations in 1st set from the left
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, L+1+LDAB*(J2-L-1)), INCA, pointer(AB, L+2+LDAB*(J2-L-1)), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
                end
                # apply rotations in 1st set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, 1+LDAB*(J2-1)), pointer(AB, 1+LDAB*J2), pointer(AB, 2+LDAB*(J2-1)), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
            end
            # start applying rotations in 1st set from the right
            for L = KA-1:-1:KB-K+1
                NRT = ( N-J2+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J2-1)), INCA, pointer(AB, KA1-L+LDAB*J2), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 1st set
                for J = J2:KA1:J1
                    push!(X, Givens(J, J+1, WORK[N+J-M], -WORK[J-M]))
                end
            end
        end

        if UPDATE
            if I2 ≤ N && KBT > 0
                # create nonzero element a(i-kbt+ka+1,i-kbt) outside the
                # band and store it in WORK(i-kbt)
                WORK[I-KBT] = -BB[KBT+1, I-KBT]*RA1
            end
        end

        for K = KB:-1:1
            if UPDATE
                J2 = I - K - 1 + max( 2, K-I0+1 )*KA1
            else
                J2 = I - K - 1 + max( 1, K-I0+1 )*KA1
            end
            # finish applying rotations in 2nd set from the right
            for L = KB-K:-1:1
                NRT = ( N-J2+KA+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J2-KA-1)), INCA, pointer(AB, KA1-L+LDAB*(J2-KA)), INCA, pointer(WORK, N+J2-KA), pointer(WORK, J2-KA), KA1)
                end
            end
            NR = ( N-J2+KA ) ÷ KA1
            J1 = J2 + ( NR-1 )*KA1
            for J = J1:-KA1:J2
                WORK[J] = WORK[J-KA]
                WORK[N+J] = WORK[N+J-KA]
            end
            for J = J2:KA1:J1
                # create nonzero element a(j+1,j-ka) outside the band
                # and store it in WORK(j)
                WORK[J] = WORK[J]*AB[KA1, J-KA+1]
                AB[KA1, J-KA+1] = WORK[N+J]*AB[KA1, J-KA+1]
            end
            if UPDATE
                if I-K < N-KA && K ≤ KBT
                    WORK[I-K+KA] = WORK[I-K]
                end
            end
        end

        for K = KB:-1:1
            J2 = I - K - 1 + max( 1, K-I0+1 )*KA1
            NR = ( N-J2+KA ) ÷ KA1
            J1 = J2 + ( NR-1 )*KA1
            if NR > 0
                # generate rotations in 2nd set to annihilate elements
                # which have been created outside the band
                largv!(NR, pointer(AB, KA1+LDAB*(J2-KA-1)), INCA, pointer(WORK, J2), KA1, pointer(WORK, N+J2), KA1)
                # apply rotations in 2nd set from the left
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, L+1+LDAB*(J2-L-1)), INCA, pointer(AB, L+2+LDAB*(J2-L-1)), INCA, pointer(WORK, N+J2), pointer(WORK, J2), KA1)
                end
                # apply rotations in 2nd set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, 1+LDAB*(J2-1)), pointer(AB, 1+LDAB*J2), pointer(AB, 2+LDAB*(J2-1)), INCA, pointer(WORK, N+J2), pointer(WORK, J2), KA1)
            end
            # start applying rotations in 2nd set from the right
            for L = KA-1:-1:KB-K+1
                NRT = ( N-J2+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J2-1)), INCA, pointer(AB, KA1-L+LDAB*J2), INCA, pointer(WORK, N+J2), pointer(WORK, J2), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 2nd set
                for J = J2:KA1:J1
                    push!(X, Givens(J, J+1, WORK[N+J], -WORK[J]))
                end
            end
        end

        for K = 1:KB-1
            J2 = I - K - 1 + max( 1, K-I0+2 )*KA1
            # finish applying rotations in 1st set from the right
            for L = KB-K:-1:1
                NRT = ( N-J2+L ) ÷ KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J2-1)), INCA, pointer(AB, KA1-L+LDAB*J2), INCA, pointer(WORK, N+J2-M), pointer(WORK, J2-M), KA1)
                end
            end
        end

        if KB > 1
            for J = N-1:-1:I-KB+2*KA+1
                WORK[N+J-M] = WORK[N+J-KA-M]
                WORK[J-M] = WORK[J-KA-M]
            end
        end
    end
    @goto L10
    @label L480

    UPDATE = true
    I = 0
    @label L490
    if UPDATE
        I = I + 1
        KBT = min( KB, M-I )
        I0 = I + 1
        I1 = max( 1, I-KA )
        I2 = I + KBT - KA1
        if I > M
            UPDATE = false
            I = I - 1
            I0 = M + 1
            if KA == 0
                return
            end
            @goto L490
        end
    else
        I = I - KA
        if I < 2
            return
        end
    end

    if I < M - KBT
        NX = M
    else
        NX = N
    end

    if UPPER
        # Transform A, working with the upper triangle
        if UPDATE
            # Form inv(S(i))**T * A * inv(S(i))
            BII = BB[KB1, I]
            for J = I1:I
                AB[J-I+KA1, I] = AB[J-I+KA1, I] / BII
            end
            for J = I:min(N, I+KA)
                AB[I-J+KA1, J] = AB[I-J+KA1, J] / BII
            end
            for K = I+1:I+KBT
                for J = K:I+KBT
                    AB[K-J+KA1, J] = AB[K-J+KA1, J] - BB[I-J+KB1, J]*AB[I-K+KA1, K] - BB[I-K+KB1, K]*AB[I-J+KA1, J] + AB[KA1, I]*BB[I-J+KB1, J]*BB[I-K+KB1, K]
                end
                for J = I+KBT+1:min(N, I+KA)
                    AB[K-J+KA1, J] = AB[K-J+KA1, J] - BB[I-K+KB1, K]*AB[I-J+KA1, J]
                end
            end
            for J = I1:I
                for K = I+1:min(J+KA, I+KBT)
                    AB[J-K+KA1, K] = AB[J-K+KA1, K] - BB[I-K+KB1, K]*AB[J-I+KA1, I]
                end
            end
            # store a(i1,i) in RA1 for use in next loop over K
            RA1 = AB[I1-I+KA1, I]
        end

        for K = 1:KB-1
            if UPDATE
                # Determine the rotations which would annihilate the bulge
                # which has in theory just been created
                if I+K-KA1 > 0 && I+K < M
                    # generate rotation to annihilate a(i+k-ka-1,i)
                    lartg!(AB[K+1, I], RA1, TEMP1, TEMP2, TEMP3)
                    WORK[N+I+K-KA] = TEMP1[]
                    WORK[I+K-KA] = TEMP2[]
                    RA = TEMP3[]
                    # create nonzero element a(i+k-ka-1,i+k) outside the
                    # band and store it in WORK(m-kb+i+k)
                    t = -BB[KB1-K, I+K]*RA1
                    WORK[M-KB+I+K] = WORK[N+I+K-KA]*t - WORK[I+K-KA]*AB[1, I+K]
                    AB[1, I+K] = WORK[I+K-KA]*t + WORK[N+I+K-KA]*AB[1, I+K]
                    RA1 = RA
                end
            end
            J2 = I + K + 1 - max( 1, K+I0-M+1 )*KA1
            NR = ( J2+KA-1 ) ÷ KA1
            J1 = J2 - ( NR-1 )*KA1
            if UPDATE
                J2T = min(J2, I-2*KA+K-1)
            else
                J2T = J2
            end
            NRT = ( J2T+KA-1 ) ÷ KA1
            for J = J1:KA1:J2T
                # create nonzero element a(j-1,j+ka) outside the band
                # and store it in WORK(j)
                WORK[J] = WORK[J]*AB[1, J+KA-1]
                AB[1, J+KA-1] = WORK[N+J]*AB[1, J+KA-1]
            end
            # generate rotations in 1st set to annihilate elements which
            # have been created outside the band

            if NRT > 0
                largv!(NRT, pointer(AB, 1+LDAB*(J1+KA-1)), INCA, pointer(WORK, J1), KA1, pointer(WORK, N+J1), KA1)
            end
            if NR > 0
                # apply rotations in 1st set from the left
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, KA1-L+LDAB*(J1+L-1)), INCA, pointer(AB, KA-L+LDAB*(J1+L-1)), INCA, pointer(WORK, N+J1), pointer(WORK, J1), KA1)
                end
                # apply rotations in 1st set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, KA1+LDAB*(J1-1)), pointer(AB, KA1+LDAB*(J1-2)), pointer(AB, KA+LDAB*(J1-1)), INCA, pointer(WORK, N+J1), pointer(WORK, J1), KA1)
            end
            # start applying rotations in 1st set from the right
            for L = KA-1:-1:KB-K+1
                NRT = ( J2+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J1T-1)), INCA, pointer(AB, L+1+LDAB*(J1T-2)), INCA, pointer(WORK, N+J1T), pointer(WORK, J1T), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 1st set
                for J = J1:KA1:J2
                    push!(X, Givens(J, J-1, WORK[N+J], -WORK[J]))
                end
            end
        end

        if UPDATE
            if I2 > 0 && KBT > 0
                # create nonzero element a(i+kbt-ka-1,i+kbt) outside the
                # band and store it in WORK(m-kb+i+kbt)
                WORK[M-KB+I+KBT] = -BB[KB1-KBT, I+KBT]*RA1
            end
        end

        for K = KB:-1:1
            if UPDATE
                J2 = I + K + 1 - max( 2, K+I0-M )*KA1
            else
                J2 = I + K + 1 - max( 1, K+I0-M )*KA1
            end
            # finish applying rotations in 2nd set from the right
            for L = KB-K:-1:1
                NRT = ( J2+KA+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J1T+KA-1)), INCA, pointer(AB, L+1+LDAB*(J1T+KA-2)), INCA, pointer(WORK, N+M-KB+J1T+KA), pointer(WORK, M-KB+J1T+KA), KA1)
                end
            end
            NR = ( J2+KA-1 ) ÷ KA1
            J1 = J2 - ( NR-1 )*KA1
            for J = J1:KA1:J2
                WORK[M-KB+J] = WORK[M-KB+J+KA]
                WORK[N+M-KB+J] = WORK[N+M-KB+J+KA]
            end
            for J = J1:KA1:J2
                # create nonzero element a(j-1,j+ka) outside the band
                # and store it in WORK(m-kb+j)
                WORK[M-KB+J] = WORK[M-KB+J]*AB[1, J+KA-1]
                AB[1, J+KA-1] = WORK[N+M-KB+J]*AB[1, J+KA-1]
            end
            if UPDATE
                if I+K > KA1 && K ≤ KBT
                    WORK[M-KB+I+K-KA] = WORK[M-KB+I+K]
                end
            end
        end

        for K = KB:-1:1
            J2 = I + K + 1 - max( 1, K+I0-M )*KA1
            NR = ( J2+KA-1 ) ÷ KA1
            J1 = J2 - ( NR-1 )*KA1
            if NR > 0
                # generate rotations in 2nd set to annihilate elements
                # which have been created outside the band
                largv!(NR, pointer(AB, 1+LDAB*(J1+KA-1)), INCA, pointer(WORK, M-KB+J1), KA1, pointer(WORK, N+M-KB+J1), KA1)
                # apply rotations in 2nd set from the left
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, KA1-L+LDAB*(J1+L-1)), INCA, pointer(AB, KA-L+LDAB*(J1+L-1)), INCA, pointer(WORK, N+M-KB+J1), pointer(WORK, M-KB+J1), KA1)
                end
                # apply rotations in 2nd set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, KA1+LDAB*(J1-1)), pointer(AB, KA1+LDAB*(J1-2)), pointer(AB, KA+LDAB*(J1-1)), INCA, pointer(WORK, N+M-KB+J1), pointer(WORK, M-KB+J1), KA1)
            end
            # start applying rotations in 2nd set from the right
            for L = KA-1:-1:KB-K+1
                NRT = ( J2+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J1T-1)), INCA, pointer(AB, L+1+LDAB*(J1T-2)), INCA, pointer(WORK, N+M-KB+J1T), pointer(WORK, M-KB+J1T), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 2nd set
                for J = J1:KA1:J2
                    push!(X, Givens(J, J-1, WORK[N+M-KB+J], -WORK[M-KB+J]))
                end
            end
        end

        for K = 1:KB-1
            J2 = I + K + 1 - max( 1, K+I0-M+1 )*KA1
            # finish applying rotations in 1st set from the right
            for L = KB-K:-1:1
                NRT = ( J2+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, L+LDAB*(J1T-1)), INCA, pointer(AB, L+1+LDAB*(J1T-2)), INCA, pointer(WORK, N+J1T), pointer(WORK, J1T), KA1)
                end
            end
        end

        if KB > 1
            for J = 2:min(I+KB, M)-2*KA-1
                WORK[N+J] = WORK[N+J+KA]
                WORK[J] = WORK[J+KA]
            end
        end
    else
        # Transform A, working with the lower triangle
        if UPDATE
            # Form inv(S(i))**T * A * inv(S(i))
            BII = BB[1, I]
            for J = I1:I
                AB[I-J+1, J] = AB[I-J+1, J] / BII
            end
            for J = I:min(N, I+KA)
                AB[J-I+1, I] = AB[J-I+1, I] / BII
            end
            for K = I+1:I+KBT
                for J = K:I+KBT
                    AB[J-K+1, K] = AB[J-K+1, K] - BB[J-I+1, I]*AB[K-I+1, I] - BB[K-I+1, I]*AB[J-I+1, I] + AB[1, I]*BB[J-I+1, I]*BB[K-I+1, I]
                end
                for J = I+KBT+1:min(N,I+KA)
                    AB[J-K+1, K] = AB[J-K+1, K] - BB[K-I+1, I]*AB[J-I+1, I]
                end
            end
            for J = I1:I
                for K = I+1:min(J+KA, I+KBT)
                    AB[K-J+1, J] = AB[K-J+1, J] - BB[K-I+1, I]*AB[I-J+1, J]
                end
            end
            # store a(i,i1) in RA1 for use in next loop over K
            RA1 = AB[I-I1+1, I1]
        end
        # Generate and apply vectors of rotations to chase all the
        # existing bulges KA positions up toward the top of the band
        for K = 1:KB-1
            if UPDATE
                # Determine the rotations which would annihilate the bulge
                # which has in theory just been created
                if I+K-KA1 > 0 && I+K < M
                    # generate rotation to annihilate a(i,i+k-ka-1)
                    lartg!(AB[KA1-K, I+K-KA], RA1, TEMP1, TEMP2, TEMP3)
                    WORK[N+I+K-KA] = TEMP1[]
                    WORK[I+K-KA] = TEMP2[]
                    RA = TEMP3[]
                    # create nonzero element a(i+k,i+k-ka-1) outside the
                    # band and store it in WORK(m-kb+i+k)
                    t = -BB[K+1, I]*RA1
                    WORK[M-KB+I+K] = WORK[N+I+K-KA]*t - WORK[I+K-KA]*AB[KA1, I+K-KA]
                    AB[KA1, I+K-KA] = WORK[I+K-KA]*t + WORK[N+I+K-KA]*AB[KA1, I+K-KA]
                    RA1 = RA
                end
            end
            J2 = I + K + 1 - max( 1, K+I0-M+1 )*KA1
            NR = ( J2+KA-1 ) ÷ KA1
            J1 = J2 - ( NR-1 )*KA1
            if UPDATE
                J2T = min( J2, I-2*KA+K-1 )
            else
                J2T = J2
            end
            NRT = ( J2T+KA-1 ) ÷ KA1
            for J = J1:KA1:J2T
                # create nonzero element a(j+ka,j-1) outside the band
                # and store it in WORK(j)
                WORK[J] = WORK[J]*AB[KA1, J-1]
                AB[KA1, J-1] = WORK[N+J]*AB[KA1, J-1]
            end
            # generate rotations in 1st set to annihilate elements which
            # have been created outside the band
            if NRT > 0
                largv!(NRT, pointer(AB, KA1+LDAB*(J1-1)), INCA, pointer(WORK, J1), KA1, pointer(WORK, N+J1), KA1)
            end
            if NR > 0
                # apply rotations in 1st set from the right
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, L+1+LDAB*(J1-1)), INCA, pointer(AB, L+2+LDAB*(J1-2)), INCA, pointer(WORK, N+J1), pointer(WORK, J1), KA1)
                end
                # apply rotations in 1st set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, 1+LDAB*(J1-1)), pointer(AB, 1+LDAB*(J1-2)), pointer(AB, 2+LDAB*(J1-2)), INCA, pointer(WORK, N+J1), pointer(WORK, J1), KA1)
            end
            # start applying rotations in 1st set from the left
            for L = KA-1:-1:KB-K+1
                NRT = ( J2+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J1T-KA1+L-1)), INCA, pointer(AB, KA1-L+LDAB*(J1T-KA1+L-1)), INCA, pointer(WORK, N+J1T), pointer(WORK, J1T), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 1st set
                for J = J1:KA1:J2
                    push!(X, Givens(J, J-1, WORK[N+J], -WORK[J]))
                end
            end
        end

        if UPDATE
            if I2 > 0 && KBT > 0
                # create nonzero element a(i+kbt,i+kbt-ka-1) outside the
                # band and store it in WORK(m-kb+i+kbt)
                WORK[M-KB+I+KBT] = -BB[KBT+1, I]*RA1
            end
        end

        for K = KB:-1:1
            if UPDATE
                J2 = I + K + 1 - max( 2, K+I0-M )*KA1
            else
                J2 = I + K + 1 - max( 1, K+I0-M )*KA1
            end
            # finish applying rotations in 2nd set from the left
            for L = KB-K:-1:1
                NRT = ( J2+KA+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J1T+L-2)), INCA, pointer(AB, KA1-L+LDAB*(J1T+L-2)), INCA, pointer(WORK, N+M-KB+J1T+KA), pointer(WORK, M-KB+J1T+KA), KA1)
                end
            end
            NR = ( J2+KA-1 ) ÷ KA1
            J1 = J2 - ( NR-1 )*KA1
            for J = J1:KA1:J2
                WORK[M-KB+J] = WORK[M-KB+J+KA]
                WORK[N+M-KB+J] = WORK[N+M-KB+J+KA]
            end
            for J = J1:KA1:J2
                # create nonzero element a(j+ka,j-1) outside the band
                # and store it in WORK(m-kb+j)
                WORK[M-KB+J] = WORK[M-KB+J]*AB[KA1, J-1]
                AB[KA1, J-1] = WORK[N+M-KB+J]*AB[KA1, J-1]
            end
            if UPDATE
                if I+K > KA1 && K ≤ KBT
                    WORK[M-KB+I+K-KA] = WORK[M-KB+I+K]
                end
            end
        end

        for K = KB:-1:1
            J2 = I + K + 1 - max( 1, K+I0-M )*KA1
            NR = ( J2+KA-1 ) ÷ KA1
            J1 = J2 - ( NR-1 )*KA1
            if NR > 0
                # generate rotations in 2nd set to annihilate elements
                # which have been created outside the band
                largv!(NR, pointer(AB, KA1+LDAB*(J1-1)), INCA, pointer(WORK, M-KB+J1), KA1, pointer(WORK, N+M-KB+J1), KA1)
                # apply rotations in 2nd set from the right
                for L = 1:KA-1
                    lartv!(NR, pointer(AB, L+1+LDAB*(J1-1)), INCA, pointer(AB, L+2+LDAB*(J1-2)), INCA, pointer(WORK, N+M-KB+J1), pointer(WORK, M-KB+J1), KA1)
                end
                # apply rotations in 2nd set from both sides to diagonal
                # blocks
                lar2v!(NR, pointer(AB, 1+LDAB*(J1-1)), pointer(AB, 1+LDAB*(J1-2)), pointer(AB, 2+LDAB*(J1-2)), INCA, pointer(WORK, N+M-KB+J1), pointer(WORK, M-KB+J1), KA1)
            end
            # start applying rotations in 2nd set from the left
            for L = KA-1:-1:KB-K+1
                NRT = ( J2+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J1T-KA1+L-1)), INCA, pointer(AB, KA1-L+LDAB*(J1T-KA1+L-1)), INCA, pointer(WORK, N+M-KB+J1T), pointer(WORK, M-KB+J1T), KA1)
                end
            end

            if WANTX
                # post-multiply X by product of rotations in 2nd set
                for J = J1:KA1:J2
                    push!(X, Givens(J, J-1, WORK[N+M-KB+J], -WORK[M-KB+J]))
                end
            end
        end

        for K = 1:KB-1
            J2 = I + K + 1 - max( 1, K+I0-M+1 )*KA1
            # finish applying rotations in 1st set from the left
            for L = KB-K:-1:1
                NRT = ( J2+L-1 ) ÷ KA1
                J1T = J2 - ( NRT-1 )*KA1
                if NRT > 0
                    lartv!(NRT, pointer(AB, KA1-L+1+LDAB*(J1T-KA1+L-1)), INCA, pointer(AB, KA1-L+LDAB*(J1T-KA1+L-1)), INCA, pointer(WORK, N+J1T), pointer(WORK, J1T), KA1)
                end
            end
        end

        if KB > 1
            for J = 2:min(I+KB,M)-2*KA-1
                WORK[N+J] = WORK[N+J+KA]
                WORK[J] = WORK[J+KA]
            end
        end
    end
    @goto L490
end

module CliqueTreesExt

using BandedMatrices
using Base.Sort: Algorithm
using CliqueTrees: CliqueTrees, permutation, RCMGL
using CliqueTrees.SparseArrays
using LinearAlgebra

function BandedMatrices.symrcm(matrix::AbstractMatrix, alg::Algorithm)
    BandedMatrices.symrcm(sparse(matrix), alg)
end

function BandedMatrices.symrcm(matrix::SparseMatrixCSC{T}, alg::Algorithm) where T
    order, index = permutation(matrix; alg=RCMGL(alg))
    lower = tril!(permute(matrix, order, order))
    
    bandwidth = maximum(axes(lower, 2)) do j
        p = last(nzrange(lower, j))
        return rowvals(lower)[p] - j
    end
    
    banded = BandedMatrix{T}(undef, size(lower), (bandwidth, 0))
    fill!(banded.data, zero(T))
    
    @inbounds for j in axes(lower, 2)
        for p in nzrange(lower, j)
            i = rowvals(lower)[p]
            banded.data[i - j + 1, j] = nonzeros(lower)[p]
        end
    end
    
    return Symmetric(banded, :L), order, index
end

end

# check dimensions of inputs
checkdimensions(sizedest::Tuple{Int, Vararg{Int}}, sizesrc::Tuple{Int, Vararg{Int}}) =
    (sizedest == sizesrc ||
        throw(DimensionMismatch("tried to assign $(sizesrc) sized " *
                                "array to $(sizedest) destination")) )

checkdimensions(dest::AbstractVector, src::AbstractVector) =
    checkdimensions(size(dest), size(src))

checkdimensions(ldest::Int, src::AbstractVector) =
    checkdimensions((ldest, ), size(src))

checkdimensions(kr::AbstractRange, jr::AbstractRange, src::AbstractMatrix) =
    checkdimensions((length(kr), length(jr)), size(src))


# return the bandwidths of A*B
prodbandwidths(A) = bandwidths(A)
prodbandwidths() = (0,0)
prodbandwidths(A...) = broadcast(+, bandwidths.(A)...)

# helper functions in matrix addition routines
function sumbandwidths(A::AbstractMatrix, B::AbstractMatrix)
    max(bandwidth(A, 1), bandwidth(B, 1)), max(bandwidth(A, 2), bandwidth(B, 2))
end


_fill_lmul!(β, A::AbstractArray, Azero=false) = iszero(β) ? (Azero ? A : zero!(A)) : lmul!(β, A)
_fill_rmul!(A::AbstractArray, β, Azero=false) = iszero(β) ? (Azero ? A : zero!(A)) : rmul!(A, β)
_fill_rmul!(M::MulAdd, β) = _fill_rmul!(M.C, β, M.Czero)

# fallbacks for inbands_getindex and inbands_setindex!
@inline function inbands_getindex(x::AbstractArray, i::Integer, j::Integer)
    @inbounds r = getindex(x, i, j)
    r
end
@inline function inbands_setindex!(x::AbstractArray, v, i::Integer, j::Integer)
    @inbounds r = setindex!(x, v, i, j)
    r
end

inbands_getindex(x::Adjoint, i::Integer, j::Integer) =
    inbands_getindex(parent(x), j, i)'
inbands_getindex(x::Transpose, i::Integer, j::Integer) =
    transpose(inbands_getindex(parent(x), j, i))
inbands_setindex!(x::Adjoint, v, i::Integer, j::Integer) =
    inbands_setindex!(parent(x), v', j, i)
inbands_setindex!(x::Transpose, v, i::Integer, j::Integer) =
    inbands_setindex!(parent(x), transpose(v), j, i)

###
# Lazy getindex
# this uses a layout-materialize idiom to construct a matrix based
# on the memory layout
# BandedMatrix requires the columns to be Base.OneTo
###

sub_materialize(::AbstractBandedLayout, V, ::NTuple{2,Base.OneTo{Int}}) = BandedMatrix(V)
sub_materialize(::AbstractBandedLayout, V, ::Tuple{<:Any,Base.OneTo{Int}}) = BandedMatrix(V)
sub_materialize(::AbstractBandedLayout, V, ::Tuple{Base.OneTo{Int},<:Any}) = BandedMatrix(V')'

@inline getindex(A::AbstractMatrix, b::Band) = layout_getindex(A, b)
@inline getindex(A::AbstractMatrix, kr::BandRangeType, j::Integer) = layout_getindex(A, kr, j)
@inline getindex(A::AbstractMatrix, k::Integer, jr::BandRangeType) = layout_getindex(A, k, jr)

function _dot(x::AbstractVector, A::AbstractBandedMatrix, y::AbstractVector)
    require_one_based_indexing(x, y)
    # This should include a message but matches LinearAlgebra.dot
    (axes(x)..., axes(y)...) == axes(A) || throw(DimensionMismatch())
    l,u = bandwidths(A)
    M = size(A,1)
    T = typeof(dot(first(x), first(A), first(y)))
    s = zero(T)
    i₁ = first(eachindex(x))
    x₁ = first(x)
    @inbounds for j in colsupport(y)
        yj = y[j]
        if !iszero(yj)
            temp = zero(adjoint(A[i₁,j]) * x₁)
            @simd for i in max(1,j-u):min(M,j+l)
                temp += adjoint(A[i,j]) * x[i]
            end
            s += dot(temp, yj)
        end
    end
    s
end

dot(x::AbstractVector, A::AbstractBandedMatrix, y::AbstractVector) =
    _dot(x, A, y)

function dot(x::AbstractVector, A::BandedMatrix{<:Any,<:AbstractFill}, y::AbstractVector)
    require_one_based_indexing(x, y)
    l,u = bandwidths(A)
    l == -u || return _dot(x, A, y)

    # This should include a message but matches LinearAlgebra.dot
    (axes(x)..., axes(y)...) == axes(A) || throw(DimensionMismatch())
    T = typeof(dot(first(x), first(A), first(y)))
    Av = unique_value(A.data)
    iszero(Av) && return zero(T)

    M,N = size(A)
    @inbounds begin
        xv = view(x, max(1,l+1):min(M,N+l))
        yv = view(y, max(1,u+1):min(M+u,N))

        Av*dot(xv, yv)
    end
end

module TestSum

using Test, BandedMatrices, Random

Random.seed!(0)
r = brand(rand(1:10_000),rand(1:10_000),rand(-20:100),rand(-20:100))
empty_r = brand(rand(1:1_000),rand(1:1_000),rand(1:100),rand(-200:-101))
n,m = size(empty_r)
matr = Matrix(r)
@testset "sum" begin
    @test sum(empty_r) == 0
    @test sum(empty_r; dims = 2) == zeros(n,1)
    @test sum(empty_r; dims = 1) == zeros(1,m)

    @test sum(r) ≈ sum(matr) rtol = 1e-10
    @test sum(r; dims=2) ≈ sum(matr; dims=2) rtol = 1e-10
    @test sum(r; dims=1) ≈ sum(matr; dims=1) rtol = 1e-10
    @test sum(r; dims=3) == r
    @test_throws ArgumentError sum(r; dims=0)

    v = [1.0]
    sum!(v, r)
    @test v == sum!(v, Matrix(r))
    n2, m2 = size(r)
    v = ones(n2)
    @test sum!(v, r) == sum!(v, Matrix(r))
    V = zeros(1,m2)
    @test sum!(V, r) === V ≈ sum!(zeros(1,m2), Matrix(r))
    V = zeros(n2,m2)
    @test sum!(V, r) === V == r
    @test_throws DimensionMismatch sum!(zeros(Float64, n2 + 1, m2 + 1), r)
end

end

# BandedMatrices.jl Documentation


## Creating banded matrices

```@docs
BandedMatrix
```

```@docs
brand
```

```@docs
brandn
```

```@meta
DocTestSetup = quote
    using BandedMatrices
end
```

To create a banded matrix of all zeros, identity matrix, or with a constant value
use the following constructors:
```jldoctest
julia> BandedMatrix(Zeros(5,5), (1,2))
5×5 BandedMatrix{Float64} with bandwidths (1, 2):
 0.0  0.0  0.0   ⋅    ⋅
 0.0  0.0  0.0  0.0   ⋅
  ⋅   0.0  0.0  0.0  0.0
  ⋅    ⋅   0.0  0.0  0.0
  ⋅    ⋅    ⋅   0.0  0.0

julia> BandedMatrix(Eye(5), (1,2))
5×5 BandedMatrix{Float64} with bandwidths (1, 2):
 1.0  0.0  0.0   ⋅    ⋅
 0.0  1.0  0.0  0.0   ⋅
  ⋅   0.0  1.0  0.0  0.0
  ⋅    ⋅   0.0  1.0  0.0
  ⋅    ⋅    ⋅   0.0  1.0

julia> BandedMatrix(Ones(5,5), (1,2))
5×5 BandedMatrix{Float64} with bandwidths (1, 2):
 1.0  1.0  1.0   ⋅    ⋅
 1.0  1.0  1.0  1.0   ⋅
  ⋅   1.0  1.0  1.0  1.0
  ⋅    ⋅   1.0  1.0  1.0
  ⋅    ⋅    ⋅   1.0  1.0
```
To create a banded matrix of a given size with constant bands (such as the classical finite difference approximation of the one-dimensional Laplacian on the unit interval [0,1]), you can use the following:
```julia
n = 128
h = 1/n
A = BandedMatrix{Float64}(undef, (n,n), (1,1))
A[band(0)] .= -2/h^2
A[band(1)] .= A[band(-1)] .= 1/h^2
```

Creating a large banded matrix from a dense matrix should be avoided because that costs time and memory:
```julia
julia> @time BandedMatrix(ones(10000,10000),(0,0));
0.775120 seconds (10 allocations: 763.016 MiB, 28.04% gc time)
```
Try to use structured matrices to get around this:
```julia
julia> @time BandedMatrix(Ones(10000,10000),(0,0));
0.000074 seconds (9 allocations: 78.469 KiB)
```

Another example:
```julia
julia> @time BandedMatrix([Ones(10000,5000) Zeros(10000,5000)],(1,1));
0.346918 seconds (22 allocations: 763.169 MiB, 8.38% gc time)

julia> using LazyArrays
julia> @time BandedMatrix(Hcat(Ones(10000,5000),Zeros(10000,5000)),(1,1));
0.012627 seconds (30.01 k allocations: 1.374 MiB, 92.24% gc time)
```

See [LazyArrays](https://github.com/JuliaArrays/LazyArrays.jl), [FillArrays](https://github.com/JuliaArrays/FillArrays.jl) for other implemented structured matrices.

## Accessing banded matrices

```@docs
bandwidths
```

```@docs
bandwidth
```

```@docs
bandrange
```

```@docs
band
```

```@docs
Band
```

```@docs
BandError
```

```@docs
BandRange
```

```@docs
BandedMatrices.isbanded
```

```@docs
BandedMatrices.BandSlice
```

```@docs
BandedMatrices.colstart
```

```@docs
BandedMatrices.colstop
```

```@docs
BandedMatrices.colrange
```

```@docs
BandedMatrices.collength
```

```@docs
BandedMatrices.rowstart
```

```@docs
BandedMatrices.rowstop
```

```@docs
BandedMatrices.rowrange
```

```@docs
BandedMatrices.rowlength
```

```@docs
BandedMatrices.bandeddata
```

```@docs
BandedMatrices.BandedMatrixBand
```

```@docs
BandedMatrices.dataview
```

To loop over the nonzero elements of a BandedMatrix, you can use `colrange(A, c)` and `rowrange(A, r)`.



## Creating symmetric banded matrices

Use `Symmetric(::BandedMatrix)` to work with symmetric banded matrices.

## Bandwidth minimization

The [reverse Cuthill-McKee algorithm](https://en.wikipedia.org/wiki/Cuthill–McKee_algorithm) permutes a symmetric matrix into a band matrix with small bandwidth.
This algorithm is implemented by the function `symrcm`.

```julia
julia> using BandedMatrices, CliqueTrees

julia> matrix = [
           1 0 1 0 0 0 0 1 1
           0 1 1 0 0 1 1 1 0
           1 1 1 0 0 0 0 0 0
           0 0 0 1 0 0 0 1 1
           0 0 0 0 1 0 1 1 0
           0 1 0 0 0 1 1 0 0
           0 1 0 0 1 1 1 0 0
           1 1 0 1 1 0 0 1 0
           1 0 0 1 0 0 0 0 1
       ];

julia> bandedmatrix, perm, invp = symrcm(matrix);

julia> bandedmatrix
9×9 LinearAlgebra.Symmetric{Int64, BandedMatrix{Int64, Matrix{Int64}, Base.OneTo{Int64}}}:
 1  1  1  0  ⋅  ⋅  ⋅  ⋅  ⋅
 1  1  1  1  0  ⋅  ⋅  ⋅  ⋅
 1  1  1  0  1  1  ⋅  ⋅  ⋅
 0  1  0  1  0  1  0  ⋅  ⋅
 ⋅  0  1  0  1  0  1  0  ⋅
 ⋅  ⋅  1  1  0  1  1  1  0
 ⋅  ⋅  ⋅  0  1  1  1  0  1
 ⋅  ⋅  ⋅  ⋅  0  1  0  1  1
 ⋅  ⋅  ⋅  ⋅  ⋅  0  1  1  1

julia> bandedmatrix == matrix[perm, perm]
true
```

## Banded matrix interface

Banded matrices go beyond the type `BandedMatrix`: one can also create
matrix types that conform to the _banded matrix interface_, in which case
many of the utility functions in this package are available. The banded matrix
interface consists of the following:

| Required methods | Brief description |
| :--------------- | :--------------- |
| `bandwidths(A)` | Returns a tuple containing the sub-diagonal and super-diagonal bandwidth |
| `BandedMatrices.isbanded(A)`    | Override to return `true` |

| Optional methods | Brief description |
| :--------------- | :--------------- |
| `inbands_getindex(A, k, j)` | Unsafe: return `A[k,j]`, without the need to check if we are inside the bands |
| `inbands_setindex!(A, v, k, j)` | Unsafe: set `A[k,j] = v`, without the need to check if we are inside the bands |
| `BandedMatrices.MemoryLayout(A)` | Override to get banded lazy linear algebra, e.g. `y .= Mul(A,x)` |
| `BandedMatrices.bandeddata(A)` | Override to return a matrix of the entries in BLAS format. Required if `MemoryLayout(A)` returns `BandedColumnMajor` |
| `BandedMatrices.bandedrowsdata(A)` | Override to return a matrix of the entries reshaped to a row-major format. Required if `MemoryLayout(A)` returns `BandedRowsMajor` |

Note that certain `SubArray`s of `BandedMatrix` are also banded matrices.
The banded matrix interface is implemented for such `SubArray`s to take advantage of this.


## Eigenvalues
To compute efficiently a selection of eigenvalues for a `BandedMatrix`, you may use any Krylov method that relies on a sequence of matrix * vector operations. For instance, using the package [KrylovKit](https://github.com/Jutho/KrylovKit.jl):
```julia
using KrylovKit
A = BandedMatrix(Eye(5), (1, 1))
KrylovKit.eigsolve(A, 1, :LR)
```


## Implementation

Currently, only column-major ordering is supported: a banded matrix `B`
```julia
[ a_11 a_12  ⋅    ⋅
  a_21 a_22 a_23  ⋅
  a_31 a_32 a_33 a_34
   ⋅   a_42 a_43 a_44  ]
```
is represented as a `BandedMatrix` with a field `B.data` representing the matrix as
```julia
[ ⋅     a_12   a_23    a_34
 a_11   a_22   a_33    a_44
 a_21   a_32   a_43    ⋅
 a_31   a_42   ⋅       ⋅       ]
```        
`B.l` gives the number of subdiagonals (2) and `B.u` gives the number of super-diagonals (1).  Both `B.l` and `B.u` must be non-negative at the moment.
